Package: aplpack
Title: Another Plot Package: 'Bagplots', 'Iconplots', 'Summaryplots',
        Slider Functions and Others
Version: 1.3.3
Date: 2019-07-26
Author: Hans Peter Wolf [aut, cre]
Maintainer: Hans Peter Wolf <pwolf@wiwi.uni-bielefeld.de>
Depends: R (>= 3.0.0)
Suggests: tkrplot, jpeg, png, splines, utils, tcltk
Description: Some functions for drawing some special plots:
   The function 'bagplot' plots a bagplot,
   'faces' plots chernoff faces,
   'iconplot' plots a representation of a frequency table or a data matrix,
   'plothulls' plots hulls of a bivariate data set,
   'plotsummary' plots a graphical summary of a data set,
   'puticon' adds icons to a plot,
   'skyline.hist' combines several histograms of a one dimensional data set in one plot,
   'slider' functions supports some interactive graphics,
   'spin3R' helps an inspection of a 3-dim point cloud,
   'stem.leaf' plots a stem and leaf plot,
   'stem.leaf.backback' plots back-to-back versions of stem and leaf plot.
License: GPL (>= 2)
URL:
        http://www.wiwi.uni-bielefeld.de/lehrbereiche/statoekoinf/comet/wolf/wolf_aplpack
NeedsCompilation: no
Packaged: 2019-07-26 14:02:15 UTC; pwolf
Repository: CRAN
Date/Publication: 2019-07-29 07:50:12 UTC

##define [[iconplot]]:##
#2:
iconplot <- function( data
  
#10:
##arguments of [[iconplot]]:##
#3:
##argument for xy-grouping:##
, grp.xy = 2 ~ 1
##:argument for xy-grouping##
#:3
#4:
##arguments for color and pictogram grouping:##
, grp.color = NULL
, grp.icon = NULL
##:arguments for color and pictogram grouping##
#:4
#36:
##argument for defining the set of colors:##
, colors
##:argument for defining the set of colors##
#:36
#38:
##argument for defining the set of pictograms:##
, icons 
##:argument for defining the set of pictograms##
#:38
#5:
##argument for transformation:##
, vars.to.factors
##:argument for transformation##
#:5
#33:
##argument for reversing y labeling:##
, panel.reverse.y = FALSE
##:argument for reversing y labeling##
#:33
#48:
##argument for panel space ratio:##
, panel.space.factor = 0.05
##:argument for panel space ratio##
#:48
#60:
##argument for panels proportional to sizes:##
, panel.prop.to.size = c(FALSE, FALSE)
##:argument for panels proportional to sizes##
#:60
#103:
##argument for panel margin:##
, panel.margin = 0.03
##:argument for panel margin##
#:103
#85:
##argument for panel frames:##
, panel.frame = TRUE
##:argument for panel frames##
#:85
#54:
##argument for panel adjustment:##
, panel.adjust = c(0.5, 0.5)
##:argument for panel adjustment##
#:54
#67:
##arguments to specify pictogram layout:##
, icon.horizontal = TRUE
, icon.stack.type = c("lt","lb","rt","rb")[1]
##:arguments to specify pictogram layout##
#:67
#77:
##arguments to specify pictogram layout:##
, icon.cex = NA
, icon.aspect = 1 # NA
, icon.stack.len = NA
##:arguments to specify pictogram layout##
#:77
#78:
##arguments to specify pictogram layout:##
, icon.space.factor = .3
, icon.grey.levels = 2
##:arguments to specify pictogram layout##
#:78
#115:
##arguments to specify pictogram layout:##
, icon.frame = TRUE
, icon.draft = TRUE
##:arguments to specify pictogram layout##
#:115
#104:
##argument to specify labels:##
, lab.side   = c("bl","br","tl","tr")[1]
##:argument to specify labels##
#:104
#118:
##argument to specify labels:##
, lab.parallel = c(TRUE, TRUE)
, lab.cex = 1
, lab.boxes = 2
, lab.color = c("#CCCCCC", "white")
, lab.type = c("expanded", "compact")[2]
##:argument to specify labels##
#:118
#127:
##argument to specify labels:##
, lab.n.max = c(20, 30)
##:argument to specify labels##
#:127
#132:
##argument to specify labels:##
, lab.legend = c("cols","rows","skewed","horizontal","vertical")[2]
##:argument to specify labels##
#:132
#9:
##argument to specify icons packer:##
, packer = c("icons", "numbers", "panel.legend", "stars")[1]
, panel.text = NULL
##:argument to specify icons packer##
#:9
#96:
##argument to specify graphics parameter:##
, mar = rep(1, 4)   # R default for mar: .1 + c(5, 4, 4, 2)
##:argument to specify graphics parameter##
#:96
#112:
##argument to specify graphics parameter:##
, main
##:argument to specify graphics parameter##
#:112
#6:
##argument for debugging:##
, verbose = !TRUE
##:argument for debugging##
#:6
, ...
##:arguments of [[iconplot]]##
#:10
){
  
#8:
##body of [[iconplot]]:##
#7:
##check arguments of [[iconplot]]:##
if(missing(data)){ 
  
#152:
##show arguments of [[iconplot]]:##
h <- noquote(cbind("arg names" = names(formals(iconplot)),
                   "default values" = as.character(formals(iconplot))))
h <- substring(h[ seq(h[,1]), ], 1, 56); rownames(h) <- rep(" ",nrow(h))
arg.list <- h
# old<-options(width = 95)
# print(noquote(cbind("\\\\ \\tt", arg.list[,1], "&", arg.list[,2])))
# options(old)
##:show arguments of [[iconplot]]##
#:152
 
  
#1:
##show info about version and arguments of [[iconplot()]]:##
cat("iconplot, version 170815, list of arguments")
#152:
##show arguments of [[iconplot]]:##
h <- noquote(cbind("arg names" = names(formals(iconplot)),
                   "default values" = as.character(formals(iconplot))))
h <- substring(h[ seq(h[,1]), ], 1, 56); rownames(h) <- rep(" ",nrow(h))
arg.list <- h
# old<-options(width = 95)
# print(noquote(cbind("\\\\ \\tt", arg.list[,1], "&", arg.list[,2])))
# options(old)
##:show arguments of [[iconplot]]##
#:152
 (144)
print(arg.list)
##:show info about version and arguments of [[iconplot()]]##
#:1
  return()
}
args <- list(...)
##:check arguments of [[iconplot]]##
#:7
#18:
##check arguments of [[iconplot]]:##
limit <- 9999 
limit.msg <- paste("error in iconplot: number of observations of table exceeds",
                   "the limit of", limit)
if(is.table(data) && limit < sum(data) ){
  print(limit.msg); return("sorry, no graphical output")
}
if(!is.table(data) && ( is.matrix(data) | is.data.frame(data) ) && 
   limit < nrow(data) ){
     print(limit.msg); return("sorry, no graphical output")
}
if(!is.table(data) && !( is.matrix(data) | is.data.frame(data) )&& 
   limit < sum(data) ){
     print(limit.msg); return("sorry, no graphical output")
}
##:check arguments of [[iconplot]]##
#:18
#128:
##check arguments of [[iconplot]]:##
if(1 == length(lab.n.max)) lab.n.max <- c(lab.n.max, 30) #add number of margin level names
if(2 == length(lab.n.max)) lab.n.max <- c(lab.n.max, 20) #add number of legend labels
if(missing(lab.legend) && 3 == length(lab.parallel)){ 
  lab.legend <- c("cols", "rows")[2] 
} # to be compatible to older versions
lab.parallel <- rep(lab.parallel, 2)[1:2]
##:check arguments of [[iconplot]]##
#:128
#133:
##check arguments of [[iconplot]]:##
if( is.numeric(lab.legend) ){
  lab.legend <- max(1, min(5, lab.legend[1]))
  lab.legend <- c("cols","rows","skewed","horizontal","vertical")[lab.legend]
}
##:check arguments of [[iconplot]]##
#:133
#154:
##check arguments of [[iconplot]]:##
if( missing(data) ){ 
  
#152:
##show arguments of [[iconplot]]:##
h <- noquote(cbind("arg names" = names(formals(iconplot)),
                   "default values" = as.character(formals(iconplot))))
h <- substring(h[ seq(h[,1]), ], 1, 56); rownames(h) <- rep(" ",nrow(h))
arg.list <- h
# old<-options(width = 95)
# print(noquote(cbind("\\\\ \\tt", arg.list[,1], "&", arg.list[,2])))
# options(old)
##:show arguments of [[iconplot]]##
#:152
  return(arg.list)
}
data.call <- deparse(substitute(data))
if(!missing(grp.color)){
  grp.color.call <- as.character(substitute(grp.color))
  ## cat("grp.color.call:", grp.color.call)
  grp.color <- as.character(grp.color.call)
  ## cat("grp.color", grp.color)
} else grp.color.call <- NULL
if(!missing(grp.icon  )){
  grp.icon <- as.character(substitute(grp.icon)) 
}
arguments <- c( #  data = deparse(substitute(data)),
  grp.xy = as.character(grp.xy), # colors = as.character(colors),
  grp.color = as.character(grp.color.call), # icons = as.character(icons),
  pa.space = paste(collapse = ",",as.character(panel.space.factor)),
  panel.adj = panel.adjust,
  stacks = paste(collapse = ",", 
                 c(icon.stack.type, c("hori","verti")[2-icon.horizontal])),
  cex = icon.cex,
  asp = icon.aspect,
  space = paste(icon.space.factor, collapse=","),
  panel.margin = paste(panel.margin, collapse=","),
  labels = paste(collapse = ",", c(lab.side, 
                 c("parallel", "upright")[2-lab.parallel[1]],
                 c("parallel", "upright")[2-lab.parallel[2]]))
)
arguments <- paste(names(arguments), as.vector(arguments), sep = " : ")
if((length(arguments) %% 2) == 1) arguments <- c(arguments, " ")
arguments <- matrix(arguments, ncol = 2, byrow = !TRUE)
arguments <- paste( arguments[,1], arguments[,2], sep = "  //  ")
arguments <- paste( arguments, collapse = "\n")
if(verbose) cat("=======\n", arguments, "=======\n")
##:check arguments of [[iconplot]]##
#:154
#14:
##define local functions:##
#13:
##define find.xy.groupings:##
find.xy.groupings <- function(groupings, verbose = FALSE){
  g.o <- grps <- groupings
  if(verbose){ cat("----- input:", as.character(groupings)) }
  if(is.character(grps) && 0 < length(names(grps)) 
      && all(names(grps) %in% c("x","y")) ){ # convert named char vec to list   
    x <- unlist(strsplit(grps["x"], "[+*]")); if(any(is.na(x))) x <- "0"
    y <- unlist(strsplit(grps["y"], "[+*]")); if(any(is.na(y))) y <- "0"
    grps <- list( x = as.vector(x), y = as.vector(y) ) 
    grps <- lapply( grps, function(x) gsub(" ","",x))
  } 
  if(is.list(grps)){ # argument is in the desired form
    if( 0 == length(grps) || ! all(names(grps) %in% c("x","y")) ){ 
      print(paste("no correct definition of groups:",g.o)); return(NULL) 
    } else { "ok" }
  } else { # cases: formal maybe as character
    if( is.character(grps) ){ # formal in char form
      if( 0 == length(grep("[~]", grps))){ 
        print(paste("no correct formula:",g.o)); return(NULL)
      }
      grps <- unlist(strsplit(grps, "[~]"))
      grps[ grps == "" ] <- "0"
      if( 2 == length(grps)){ grps <- c("~", grps) 
      } else { print(paste("no correct formula:",g.o)); return(NULL) }     
    } 
    grps <- gsub(" ","", as.character( grps ))
    grps <- if( length(grps) == 2 ) c(grps[2], "0") else grps[3:2];  
    grps <-  strsplit(grps, "[+*]"); names(grps) <- c("x", "y")
  }
  if(verbose){ cat("----- result:"); print(grps) }
  grps
} #; find.xy.groupings("0 ~ Mean+Penalty+Region")# "0~asdfa+br")
##:define find.xy.groupings##
#:13
##:define local functions##
#:14
#16:
##define local functions:##
expand.table.short <- function(x){
   combinations <- expand.grid(dimnames(x)); num <- as.vector( x )
   # if(0 == length(num)||any(is.na(num))||any(num<0)||all(round(num)==0))
   #   return(NULL)
   combinations <- combinations[rep(seq(along = num), num),, drop=FALSE]
   rownames(combinations) <- seq( nrow(combinations) )
   combinations
} # ; expand.table.short(as.table(12))
##:define local functions##
#:16
#43:
##define local functions:##
#280:
##define [[transform.color.to.rgb.integer()]]:##
transform.color.to.rgb.integer <- function(x, to = c("#rrggbb", "rgb"), 
                                           debug = FALSE){
  dim.x <- n <- length(x)
  # if(is.matrix(x)) rasterImage(t(x), 5, 5, 15, 15)
  if( 0 < length( h <- dim(x) ) ) dim.x <- h
  if( is.numeric(x[1]) ){
    if( all( x %in% 0:8 ) ){
          from <- "color.code"      # col = 3
          xx <- t(col2rgb(palette("default")[x]))
    } else {
      if( all(x <= 1) ){            # 
          from <- "rgb.decimal"     # col = c(0.3, 0.5, 0.6 )
          xx <- floor( x * 255 ) 
      } else { 
        if( any( 1 < x ) & all(x == floor(x)) ){
          from <- "rgb.integer"     # col = c( 13, 25, 254 )
          xx <- x
        }
      }
    }
  } else {
    if( is.character(x[1]) ){
      from <- "color.name.or.char"  # col = "red" or col = "#1304FF"
      xx <- t(col2rgb(x))           # t?
    } 
  }
  if( (3 * n) == length(xx) ){ 
    xx <- array( xx, c(rev(dim.x), 3)) 
    if( length(dim(xx)) == 3 ) xx <- aperm(xx, c(2,1,3))
  }
  if(debug) cat("dim.x", dim.x, "from = ", from, "::", x, "->", (xx))
  xx
}
##:define [[transform.color.to.rgb.integer()]]##
#:280
##:define local functions##
#:43
#47:
##define local functions:##
find.n.intervals <- function(ints, props = FALSE, vmin = 0, vmax = 1,
                             panel.space.factor = 0.1){ 
  # print(ints); print(props) # 161212
  ints <- pmax(ints, .03 * max(1, sum(ints)))  # limit for security .1* #161212
  props <- if( 0 < props ) ints^props else rep(1, ints[1])       # props is 
    # a number of intervals or a vector of proportions of the desired sizes
  cum.rel.dist <- cumsum(props / sum(props))
  n <- length(props); space <- (vmax - vmin)
  p.margins <- (space / n) * panel.space.factor / 2
  space <- space - 2 * n * p.margins
  lims <- c(vmin, vmin + cum.rel.dist * space + 2 * p.margins * ( 1:n ) )
  mids <- 0.5 * (lims[-1] + lims[-(n+1)]); sizes <- diff(lims)
  mins <- lims[-(n+1)] + p.margins;        maxs <- lims[ -1   ] - p.margins
  return(cbind(mins = mins, maxs = maxs, mids = mids, p.margins = p.margins,
               sizes = sizes, lo.limit = lims[-(n+1)], up.limit = lims[-1]))
} #;  find.n.intervals(1, FALSE, 1, 2, .9)
if(!exists("raster.to.greys")){ 
#233:
##define [[raster.to.greys()]]:##
raster.to.greys <- function(pic, grey.levels = c(0.05, 0.95),  # 2 :: black + white  
                            reduce = TRUE, n.icons = 1){
  
#234:
##prepare [[mat]] for coloring:##
d.mat <- dim(pic)
if( 3 == length(d.mat) ){ 
  mat <- apply(pic, 1:2, sum)  ; dim(mat) <- d.mat <- d.mat[1:2] 
} else {
  mat <- as.matrix(pic); d.mat <- dim(mat)
  mat <- col2rgb(mat, 7 < nchar(mat[1]))
  mat <- colMeans(mat)
}
mat   <- mat/max(1,mat) # /255 # shifted from else statements #180417 
mat <- matrix(mat, ncol = d.mat[2])
##:prepare [[mat]] for coloring##
#:234
  if( 2 == length(grey.levels) ){
    limits <- grey.levels
    
#241:
##find levels if the two [[limits]] are in (0,1):##
#235:
##reduce size of [[mat]]:##
if(reduce > 0 ){
  if(is.logical(reduce)) {
    # pixel.per.pic.plan <- width.of.picture * pixel.per.mm / n.icons^0.5
    pixel.per.pic <- 120 * 5 / n.icons^0.5 
    # reduction.factor <- pixel.per.pic.real / pixel.per.pic.plan
    reduce <- ceiling( max(d.mat) / pixel.per.pic )
  }
  if(reduce > 1){
    dim.mat.new <- reduce * (floor(d.mat/reduce))
    mat.new <- mat[1:dim.mat.new[1], 1:dim.mat.new[2]]
    mat.new <- array(mat.new, rbind(reduce, dim.mat.new/reduce))
    mat.new <- apply(mat.new, c(2,4), mean)
    d.mat <- dim(mat.new); mat <- pmin(1,mat.new); dim(mat) <- d.mat 
  }
}
##:reduce size of [[mat]]##
#:235
# generate matrix of levels
levs <- 1 + (limits[1] < mat) + (limits[2] < mat)   
dim(levs) <- d.mat  
##:find levels if the two [[limits]] are in (0,1)##
#:241
    return(levs)
  }
  
#235:
##reduce size of [[mat]]:##
if(reduce > 0 ){
  if(is.logical(reduce)) {
    # pixel.per.pic.plan <- width.of.picture * pixel.per.mm / n.icons^0.5
    pixel.per.pic <- 120 * 5 / n.icons^0.5 
    # reduction.factor <- pixel.per.pic.real / pixel.per.pic.plan
    reduce <- ceiling( max(d.mat) / pixel.per.pic )
  }
  if(reduce > 1){
    dim.mat.new <- reduce * (floor(d.mat/reduce))
    mat.new <- mat[1:dim.mat.new[1], 1:dim.mat.new[2]]
    mat.new <- array(mat.new, rbind(reduce, dim.mat.new/reduce))
    mat.new <- apply(mat.new, c(2,4), mean)
    d.mat <- dim(mat.new); mat <- pmin(1,mat.new); dim(mat) <- d.mat 
  }
}
##:reduce size of [[mat]]##
#:235
  if( 1 == length(grey.levels) && 0 == (grey.levels %% 1) ){ # number of levels given
    # find greys by number of greys
    n.greys <- max(round(grey.levels), 2)
    mat <- unclass(mat); min.mat <- min(mat); max.mat <- max(mat)
    grey.levels <- seq(min.mat, max.mat, length = n.greys + 1)[-(n.greys+1)][-1]
    p <- c(min.mat, mat[ min.mat < mat & mat < max.mat], max.mat )
    greys <- c(min.mat, quantile(p, grey.levels))
    greys <- unique(greys[ !is.na(greys) ])
  } else {                   # find greys by quantiles of grey rates
    grey.levels <- unique( pmin(1, pmax(0, sort(c(0, grey.levels, 1)))) )
    greys       <- unique( quantile(mat, grey.levels) )
    if( (h <- length(greys)) > 2 ) greys <- greys[ -h ]
  }  # generate matrix of levels:
  levs <- sapply( mat, function(x) sum( x >= greys ) ) 
  if(max(levs) == 2) levs <- levs + 1 # if 2 cols only use one color and white
  if( 2 == length(h <- unique(levs)) ) levs <- 2 + ( levs == max(h) ) 
  dim(levs) <- d.mat; return(levs)
} 
##:define [[raster.to.greys()]]##
#:233
 }
##:define local functions##
#:47
#71:
##define local functions:##
size.usr.to.mm <- function(size, horizontal = TRUE){
  # transforms x- or y-length to mm
  # usr <- par()$usr; pin <- par()$pin      # exists globally
  usr <- usr[(3:4) - 2 * horizontal]
  mm  <- size / (usr[2]-usr[1]) * pin[2 - horizontal] * 25.4
}
size.mm.to.usr <- function(mm, horizontal = TRUE){
  # transforms mm to x- or y-length 
  # usr <- par()$usr; pin <- par()$pin      # exists globally
  usr <- usr[(3:4) - 2 * horizontal]
  size <- mm * (usr[2]-usr[1]) / pin[2 - horizontal] / 25.4
}
##:define local functions##
#:71
#86:
##define local functions:##
place.icons <- function( job, dm.of.job 
  , icon.stack.type = c("l", "b", "r", "t")[1:2], icon.stack.len
  , verbose = TRUE, frame = FALSE
){
  n.items <- nrow(dm.of.job) # -------------- find number of icons 
  # find x and y values of icons
  if( !any(c("t", "b") %in% icon.stack.type)){
    icon.stack.type <- c("b", icon.stack.type)  
  }
  if( !any(c("r", "l") %in% icon.stack.type)){
    icon.stack.type <- c( "l",  icon.stack.type)  
  }
  if(icon.horizontal){ # ------------------------- icon.horizontal stacks
    # x : fill from left or right
    x <- ((0:(n.items-1)) %% icon.stack.len) * dx.pic.area
    if("l" %in% icon.stack.type){ x <- job[,"xmins"] + x; xfac <-  1 
    } else {                     x <- job[,"xmaxs"] - x; xfac <- -1  }
    # y : fill from top or bottom
    y <- floor((0:(n.items-1)) / icon.stack.len) * dy.pic.area
    if("b" %in% icon.stack.type){ y <- job[,"ymins"] + y; yfac <-  1
    } else {                     y <- job[,"ymaxs"] - y; yfac <- -1  }
  } else { # -------------------------------- vertical stacks
    # y : fill from top or bottom
    y <- ((0:(n.items-1)) %% icon.stack.len) * dy.pic.area
    if("b" %in% icon.stack.type){ y <- job[,"ymins"] + y; yfac <-  1  
    } else {                     y <- job[,"ymaxs"] - y; yfac <- -1  }
    # x : fill from left or right
    x <- floor((0:(n.items-1)) / icon.stack.len) * dx.pic.area
    if("l" %in% icon.stack.type){ x <- job[,"xmins"] + x; xfac <-  1
    } else {                     x <- job[,"xmaxs"] - x; xfac <- -1  }
  }
  if( verbose ){ 
#88:
##debugging statements for [[place.icons()]]:##
show.frame <- TRUE; show.number <- TRUE # - for debugging
if(show.frame)  rect(job[,"xmins"], job[,"ymins"],
                     job[,"xmaxs"], job[,"ymaxs"])
if(show.number) text(job[,"xmaxs"], job[,"ymins"],
                     as.character(n.items), 
                     adj = c(1, 0), col = "blue", cex = 1)
if(show.number) text(job[,"xmins"], job[,"ymins"],
                     paste("j:", job[,".job.no"]), 
                     adj = c(0, 0), col = "blue", cex = 1)
##:debugging statements for [[place.icons()]]##
#:88
  }
  if(frame) rect(job[,"xmins"], job[,"ymins"], job[,"xmaxs"], job[,"ymaxs"]) 
  x <- cbind(x,  x + xfac * dx.pic); y <- cbind(y, y + yfac * dy.pic)
  
#87:
##modify because of fractional part of [[place.icons]]:##
x0 <- pmin(x[,1], x[,2]); x1 <- pmax(x[,1], x[,2])
y0 <- pmin(y[,1], y[,2]); y1 <- pmax(y[,1], y[,2])
f  <- dm.of.job[, ".fraction"]^0.5
if( !icon.horizontal & "b" %in% icon.stack.type){
  if("s" %in% icon.stack.type){ ### || is.matrix(icons[[1]])){ 
    y1 <- y0 + (y1 - y0) * f          # "s"hrinking rectangle 
    if("r" %in% icon.stack.type) x0 <- x1 - (x1 - x0) * f else
                                x1 <- x0 + (x1 - x0) * f
  } else { y1 <- y0 + (y1 - y0) * f^2 }
}
if( !icon.horizontal & "t" %in% icon.stack.type){
  if("s" %in% icon.stack.type){ ### || is.matrix(icons[[1]])){ 
    y0 <- y1 - (y1 - y0) * f          # "s"hrinking rectangle 
    if("r" %in% icon.stack.type) x0 <- x1 - (x1 - x0) * f else
                                x1 <- x0 + (x1 - x0) * f
  } else { y0 <- y1 - (y1 - y0) * f^2 }
}
if(  icon.horizontal & "l" %in% icon.stack.type){ # "s"hrinking rectangle 
  if("s" %in% icon.stack.type){ ### || is.matrix(icons[[1]])){  
    x1 <- x0 + (x1 - x0) * f
    if("t" %in% icon.stack.type) y0 <- y1 - (y1 - y0) * f  else 
                                y1 <- y0 + (y1 - y0) * f
  } else { x1 <- x0 + (x1 - x0) * f^2 }
}
if(  icon.horizontal & "r" %in% icon.stack.type){  # "s"hrinking rectangle 
  if("s" %in% icon.stack.type){ ### || is.matrix(icons[[1]])){ 
    x0 <- x1 - (x1 - x0) * f
    if("t" %in% icon.stack.type) y0 <- y1 - (y1 - y0) * f  else 
                                y1 <- y0 + (y1 - y0) * f
  } else { x0 <- x1 - (x1 - x0) * f^2 }
}
##:modify because of fractional part of [[place.icons]]##
#:87
  return(data.frame(.x0 = x0, .y0 = y0, .x1 = x1, .y1 = y1,
                 .color = dm.of.job[, ".color"], .pic = dm.of.job[, ".icon"]))
}
##:define local functions##
#:86
#109:
##define local functions:##
#238:
##define [[greys.to.col.pic()]]:##
greys.to.col.pic <- function(levs, col, invert = FALSE, 
                             set.black.and.white = FALSE, simple = FALSE){
  d.mat <- dim(levs); n <- max(levs) #; cat("simple", simple)
  if(simple){
    
#242:
##find pic if [[simple]] is set:##
# set colors based on col
colors <- c("#000000", col, "#FFFFFF")
# build pictogram  
pic <- matrix(colors[levs], ncol = d.mat[2]) 
##:find pic if [[simple]] is set##
#:242
    return(as.raster(pic))
  } #;  cat("greys.to.col.pic")
  # inversion of levels
  if(invert) levs <- n + 1 - levs
  # find colors based on col
  rgb.col1 <- col2rgb(col)/255; rgb.col2 <- 1 - rgb.col1
  n1 <- round(n/2) ; n2 <- n - n1 # n1 <- round(mean(rgb.col1) * n)
  f1 <- ((1:n1) - 1/2)/n1; f2 <- ((n2:1) - 1/2)/n2
  rgb.col1 <-     cbind(f1 * rgb.col1[1], f1 * rgb.col1[2], f1 * rgb.col1[3])
  rgb.col2 <- 1 - cbind(f2 * rgb.col2[1], f2 * rgb.col2[2], f2 * rgb.col2[3])
  rgb.col <- rbind(rgb.col1, rgb.col2)
  colors <- rgb(rgb.col)
  if(0 < set.black.and.white){
    if(set.black.and.white <= 1) colors[1]              <- "#000000"
    if(1 <= set.black.and.white) colors[length(colors)] <- "#FFFFFF"
  } ; # build pictogram  
  pic <- matrix(colors[levs], ncol = d.mat[2]); as.raster(pic)
} 
##:define [[greys.to.col.pic()]]##
#:238
##:define local functions##
#:109
#141:
##define local functions:##
find.xlab.coor <- function(labs, y0, skip = 0){
  # global variables: cin, lab.legend, x.per.row, dx, dy, x0
  idx <- which( lab.legend == c("rows", "skewed", "horizontal"))
  cos.fac <- c(1, 0.7071, 0)[idx]^2
  width.labs <- (max( strwidth(labs, cex = lab.cex) ) + dx/2) * cos.fac 
  if(idx == 2) width.labs <- (strwidth("MM", cex = lab.cex) + dx/2) * cos.fac 
  width.labs <- rep(width.labs, length(labs) ) 
  lab.idx <- seq(n <- length(labs)) - 1
  xr0 <- x0 + ( lab.idx * 1.2 * dx + c(0, cumsum(width.labs))[-(n+1)] ) / (1 + skip)
  xr1 <- xr0 + dx; yr1 <- y0 + dy
  xlab <- xr0 + 1.5 * x.per.row
  xlab <- xr0 + c(-0.7071 * dx, dx/2, dx)[idx]
  xlab <- xlab + 2 * dx * cos.fac # x.per.row * (1 - cos.fac) 
  ylab <- y0 + c(0, 0.6, 0.9)[idx] * y.per.row # horizontal old: 0.8 instead of 0.9
  if( missing(y0) ) { usr <- par()$usr; y0 <- usr[3] - 0.1 * diff(usr[3:4]) }
  cbind(xr0 = xr0, yr0 = y0, xr1 = xr1, yr1 = yr1, xlab = xlab, ylab = ylab)
}       
##:define local functions##
#:141
#153:
##define local functions:##
show.obj <- function(x){ 
  name <- deparse(substitute(x))
  if(is.list(x) || is.matrix(x)) {
    cat(name,":"); print(x)
  } else { cat(name,":", x) }
}
##:define local functions##
#:153
#361:
##define local functions:##
#353:
##define [[call.icon.generator()]]:##
call.icon.generator <- function(icons, xy = c(0,0), dxy = c(1, 0.5)[1], 
                               color = "red", pic.args = 50, ...){
  # check structure of xy and dxy
  xy <- xy[1:2]; dxy <- c(dxy, 1)[1:2]
  if(is.character(icons)){  # case: name of an internal icon generator
    
#354:
##look for internal generator in [[call.icon.generator()]]:##
  
#315:
##define [[BI()]]:##
BI <- function(){
  result <- list()
  res <- cbind( x = c(0, 25, 25, 0), y = c(0, 0, 61, 61), color = NA)
  class(res) <- "polygon"
  result <- c(result, list(res))
  res <- cbind( x = c(72, 57, 57, 72), y = c(0, 0, 61, 61), color = NA)
  class(res) <- "polygon"
  result <- c(result, list(res))
  res <- cbind( x = c( 0, 72,  72,  56, 56, 44,  44,  29, 29, 16,  16,   0), 
                y = c(72, 72, 100, 100, 87, 87, 100, 100, 87, 87, 100, 100), color = NA)
  class(res) <- "polygon"
  result <- c(result, list(res))
  res <- rbind( c(19.0, 43, 24,   43, lwd.mm = 36, color = NA),
                c(19.0, 18, 30.5, 18, lwd.mm = 36, color = NA),
                c(12, 43, 21, 43, lwd.mm = 11, 0),
                c(12, 18, 27, 18, lwd.mm = 11, 0) )
  colnames(res) <- c("x0", "y0", "x1", "y1", "lwd.mm", "color")
  class(res) <- "segments"
  result <- c(result, list(res))
  res <- cbind( x = c(0, 15, 15, 0), y = c(0, 0, 61, 61), color = NA)
  class(res) <- "polygon"
  result <- c(result, list(res))
  result
}
##:define [[BI()]]##
#:315
  
#318:
##define [[TL()]]:##
TL <- function(L = c("AB", "DT", "PW", "NV", "Hello")[1], t.cex.mm = 10, 
               startx, starty, delx, dely, Lcolors,
               pointx = 90, pointy = 90, pointsize = 8, pointcolor = "red" ){
  # L               letters to be used
  # t.cex.mm        letter size: a 'W' will have a width of 'text.cex.mm' mm 
  # startx, starty  x coordinate of first letter in mm
  # delx, dely      shift in x and in y between letters in mm
  # Lcolors         colors of the letters to be used
  # pointx, pointy  x and y coordinate of point
  # pointsize       size of the point
  # pointcolor      color of the point
  if(is.factor(L) || is.numeric(L) ) L <- as.character(L)
  L <- unlist(strsplit(L,""))
  n <- length(L)
  check.num <- function(x, n = 2){
    if(is.factor(x)) x <- as.character(x); x <- as.numeric(x); x <- rep(x, n)[1:n] 
  }
  if(missing(startx)) startx <- 50 / n; if(missing(delx)) delx <- 100 / n  
  if(missing(starty)) starty <- 50 / n; if(missing(dely)) dely <- 100 / n 
  if(missing(t.cex.mm))  t.cex.mm  <- 100 / n 
  if(missing(pointx))   pointx <- 100 - min(60, 5 + n * 2.5)
  if(missing(pointy)){  pointy <-       min(40, 5 + n * 2.5)
                        if(starty[1] > 50) pointy <- 100 - pointy }
  if(missing(pointsize)) pointsize <- min(40, 10 + n * 2.5)
  if(missing(Lcolors)) Lcolors <- 1; Lcolors <- rep(Lcolors, n)[1:n]
  startx <- check.num(startx, n); starty <- check.num(starty, n) 
  delx <- cumsum(c(0, check.num(delx, n - 1))); dely <- cumsum(c(0, check.num(dely, n - 1)))
  startx <- (startx + delx) %% 100; starty <- (starty + dely) %% 100
  result <- list()
  res <- data.frame( x = c(0, 0, 100, 100), y = c(0, 100, 100, 0), color = NA) 
  class(res) <- c( class(res), "polygon"); result <- c(result, list(res))  # box of the icon
  res <- data.frame(x0 = pointx, y0 = pointy, x1 = pointx, y1 = pointy, 
                    lwd.mm = pointsize, color = pointcolor)
  class(res) <- c( class(res), "segments"); result <- c(result, list(res)) # special point
  res <- data.frame(x = startx, y = starty, L = L, text.cex.mm = t.cex.mm, color = Lcolors)
  class(res) <- c( class(res), "text"); result <- c(result, list(res))     # letters
  result
} # ; show.icon.design(TL) #; TL()
##:define [[TL()]]##
#:318
  
#325:
##define [[cross.simple()]]:##
cross.simple <- function(){  # print("in cross")
  res <- rbind( c( 05, 05, 95, 95, lwd.mm = 10, NA), 
                c( 05, 95, 95, 05, lwd.mm = 10, NA),
                c( 50, 50, 50, 50, lwd.mm = 30, 2) ) 
  colnames(res) <- c("x0", "y0", "x1", "y1", "lwd.mm", "color")
  class(res) <- "segments"; res
}
##:define [[cross.simple()]]##
#:325
  
#326:
##define [[cross()]]:##
cross <- function(z = 0.30){ # print("in cross")
  if(is.factor(z)){ z <- as.numeric(z); z <- 0.5 * z / length(levels(z)) } 
  z <- z * 100; eps <- 1 # *0.7
  z <- min(100, max(0, z))
  result <- list()
  res <- cbind( x = c(z, 100 - z, 100 - z, z), 
                y = c(0, 0, 100 - z, 100 - z), 
                color = 5) 
  class(res) <- "polygon"
  result <- c(result, list(res))
  res <- rbind( c(eps*c( 5,   5, 95, 95, lwd.mm = 10), NA), 
                c(eps*c( 5,  95, 95,  5, lwd.mm = 10), NA),
                c(eps*c( 50, 50, 50, 50, lwd.mm = 30), 3) ) 
  colnames(res) <- c("x0", "y0", "x1", "y1", "lwd.mm", "color")
  class(res) <- "segments"
  result <- c(result, list(res))
  result
}
##:define [[cross()]]##
#:326
  
#327:
##define [[circle.simple()]]:##
circle.simple <- function(){ # print("in circle.simple")
  res <- rbind( c( 50, 50, 50, 50, lwd.mm = 100, NA)) 
  colnames(res) <- c("x0", "y0", "x1", "y1", "lwd.mm", "color")
  class(res) <- "segments"; res
}
##:define [[circle.simple()]]##
#:327
  
#328:
##define [[circle()]]:##
circle <- function(whole = 0.50){     # print("in circle")
  if(is.factor(whole)){ 
    whole <- as.numeric(whole); whole <- 0.50 * whole / length(levels(whole))
  }
  whole <- min(1, whole)
  res <- rbind( c( 50, 50, 50, 50, lwd.mm = 100,          NA), 
                c( 50, 50, 50, 50, lwd.mm = whole * 100,  0)) 
  colnames(res) <- c("x0", "y0", "x1", "y1", "lwd.mm", "color")
  class(res) <- "segments"; res
}
##:define [[circle()]]##
#:328
  
#331:
##define [[car.simple()]]:##
car.simple <- function(){ # print("in cross")
  res0 <- cbind(t(cbind( 0.6* c( 05, 05, 95, 95), 0.6* c( 05, 95, 95, 05),
                         0.6* c( 50, 50, 50, 50)) + c(2.7,2.2)) ,
                lwd.mm = c(10,10,30), color =  c(2,5,7) ) 
  colnames(res0) <- c("x0", "y0", "x1", "y1", "lwd.mm", "color")
  class(res0) <- "segments"
  res1 <- cbind( x = c(10, 90, 85, 75, 70, 45, 40, 20, 10), # car polygon
                 y = c(10, 10, 30, 30, 45, 45, 30, 30, 10))
  class(res1) <- "polygon"
  res2 <- cbind(t(cbind( 0.3* c( 05, 05, 95, 95), 0.3* c( 05, 95, 95, 05),
                         0.3* c( 50, 50, 50, 50)) + c(43, 10)) ,
                lwd.mm = 0.3 * c(10,10,30), # cross on door
                color =  c(4,6,2) ) 
  colnames(res2) <- c("x0", "y0", "x1", "y1", "lwd.mm", "color")
  class(res2) <- "segments"
  res3 <- rbind( c(25, 10, 25, 10, 15, 1), c(75, 10, 75, 10, 15, 1)) # wheel
  colnames(res3) <- c("x0", "y0", "x1", "y1", "lwd.mm", "color")
  class(res3) <- "segments"
  list(res1, res1, res2, res3)
} # ; car.simple()
##:define [[car.simple()]]##
#:331
  
#332:
##define [[car()]]:##
car <- function(width = .5, height = .0){ # print("in cross")
  width  <- (width  * 2   + 2) / 3.2; height <- (height * 5.0 + 1) / 3.2
  x <- c(-40,  40, 35, 25, 20,-05,-10,-30, -40) * width  + 50
  y <- c(-20, -20,  0,  5, 20, 20,  5,  0, -20) * height + 50
  wheel.size <- height * 10 + 5
  ymin <- min(y); xmin <- min(x); xmax <- max(x)
  res1 <- cbind( x, y) # car polygon
  class(res1) <- "polygon"
  res2 <- rbind( c(h <- 0.75*xmin + 0.25*xmax, ymin, h, ymin, wheel.size, 1), 
                 c(100 - h, ymin, 100 - h, ymin, wheel.size, 1)) # wheel
  colnames(res2) <- c("x0", "y0", "x1", "y1", "lwd.mm", "color")
  class(res2) <- "segments"; list(res1, res2)
} # ; car()
##:define [[car()]]##
#:332
  
#334:
##define [[nabla()]]:##
nabla <- function(){ 
  res <- rbind( c( 05, 95, 50, 05, 10), c( 50, 05, 95, 95, 10),
                c( 95, 95, 05, 95, 10) );  class(res) <- "segments"
  colnames(res) <- c("x0", "y0", "x1", "y1", "lwd.mm"); res
} # ; nabla()
##:define [[nabla()]]##
#:334
  
#363:
##define [[walkman()]]:##
walkman <- function( balpha = 70, col = NA, 
           ll1alpha =  -80, ll2alpha = -120, lr1alpha = -45, lr2alpha = -100,
           al1alpha = -170, al2alpha = -100, ar1alpha = -60, ar2alpha =  +20 ){
  # generates a walking man in a device of pin-sizes: 10cm x 10 cm and lwd = 10 mm
  # col <- sample(1:10, size = 1)
  xy <- c(0,0); dxq <- 10; dyq <- 10; size <- 10; lwd <- 10.5; lw.unit <- 1
  segs.set <- NULL; col.set <- NULL
  scale.xy <- 2.54 
  balpha   <- balpha   / 180 * pi
  ll1alpha <- ll1alpha / 180 * pi;  ll2alpha <- ll2alpha / 180 * pi
  lr1alpha <- lr1alpha / 180 * pi;  lr2alpha <- lr2alpha / 180 * pi
  al1alpha <- al1alpha / 180 * pi;  al2alpha <- al2alpha / 180 * pi
  ar1alpha <- ar1alpha / 180 * pi;  ar2alpha <- ar2alpha / 180 * pi
  
#364:
##define body of [[walkman]]:##
  x <- c(cos(balpha), sin(balpha)) * scale.xy
  ba <- c(0,0); be <- ba + x
  bal <- lwd * lw.unit * 1.7; bac <- col 
  seg.mat <- cbind(a=ba[1], b=ba[2], c=be[1], d=be[2], e=bal)
  segs.set <- rbind(segs.set, seg.mat); col.set <- c(col.set, bac)
##:define body of [[walkman]]##
#:364
  
#366:
##define head of [[walkman]]:##
  h <- be + ( be - ba) * .75; hl <- lwd * lw.unit * 1.6; hc <- col
  seg.mat <- cbind(a=h[1], b=h[2], c=h[1], d=h[2], e=hl)
  segs.set <- rbind(segs.set, seg.mat); col.set <- c(col.set, hc)
##:define head of [[walkman]]##
#:366
  
#365:
##define legs of [[walkman]]:##
  lbecken <- 0.19; llength <- 1; ll <- lwd * lw.unit * 0.85
  ll1a <- ba +   c(cos(balpha+pi/2), sin(balpha+pi/2)) * scale.xy * lbecken
  ll1e <- ll1a + c(cos(ll1alpha),    sin(ll1alpha))    * scale.xy * llength
  lr1a <- ba +   c(cos(balpha-pi/2), sin(balpha-pi/2)) * scale.xy * lbecken
  lr1e <- lr1a + c(cos(lr1alpha), sin(lr1alpha))  * scale.xy * llength
  ll2a <- ll1e 
  ll2e <- ll2a + c(cos(ll2alpha), sin(ll2alpha)) * scale.xy * llength
  lr2a <- lr1e 
  lr2e <- lr2a + c(cos(lr2alpha), sin(lr2alpha)) * scale.xy * llength
  l <- rbind(cbind(ll1a[1], ll1a[2], ll1e[1], ll1e[2])
            ,cbind(lr1a[1], lr1a[2], lr1e[1], lr1e[2])
            ,cbind(ll2a[1], ll2a[2], ll2e[1], ll2e[2])
            ,cbind(lr2a[1], lr2a[2], lr2e[1], lr2e[2]) )
  seg.mat <- cbind(l, e=ll)
  segs.set <- rbind(segs.set, seg.mat); col.set <- c(col.set, hc)
##:define legs of [[walkman]]##
#:365
  
#367:
##define arms of [[walkman]]:##
  aschulter <- 0.19; alength <- 0.7; al <- lwd * lw.unit * 0.85
  al1a <- be +   c(cos(balpha+pi/2), sin(balpha+pi/2)) * scale.xy * aschulter
  al1e <- al1a + c(cos(al1alpha), sin(al1alpha))       * scale.xy * alength
  ar1a <- be +   c(cos(balpha-pi/2), sin(balpha-pi/2)) * scale.xy * aschulter
  ar1e <- ar1a + c(cos(ar1alpha), sin(ar1alpha))       * scale.xy * alength
  al2a <- al1e 
  al2e <- al2a + c(cos(al2alpha), sin(al2alpha)) * scale.xy * alength
  ar2a <- ar1e 
  ar2e <- ar2a + c(cos(ar2alpha), sin(ar2alpha)) * scale.xy * alength
  a <- rbind( cbind(al1a[1], al1a[2], al1e[1], al1e[2]), 
              cbind(ar1a[1], ar1a[2], ar1e[1], ar1e[2]),
              cbind(al2a[1], al2a[2], al2e[1], al2e[2]),
              cbind(ar2a[1], ar2a[2], ar2e[1], ar2e[2]) )
  seg.mat <- cbind(a, e=al)
  segs.set <- rbind(segs.set, seg.mat); col.set <- c(col.set, hc)
##:define arms of [[walkman]]##
#:367
  segs.set[, 1:4] <- segs.set[, 1:4] + 5 # shift to the center
  segs.set <- cbind(as.data.frame(segs.set), f = col) # set color
  class(segs.set) <- c(class(segs.set), "segments")
  segs.set[, 1:4] <- segs.set[, 1:4] * 10
  colnames(segs.set) <- c("x0", "y0", "x1", "y1", "lwd.mm", "color")
  return(segs.set)
} #; show.icon.design(walkman, balpha = 90) # ; 
# plot(1:10, type = "n", axes = FALSE, xlab = "", ylab = "")
# puticon(5, 5.5, icon = walkman, icon.cex = 160, balpha = 80)
# walkman()
##:define [[walkman()]]##
#:363
  
#371:
##define [[smiley.blueeye()]]:##
smiley.blueeye <- function(){
  # output: x0, y0, x1, y1, lwd, col 
  circle <- function(x0 = 1, y0 = 1, a = 3, lwd.mm = 5, # a == radius
                     time.0 = 0, time.1 = 12, n = 30){
    # function to draw a part of a circle line
    alpha <- seq(time.0, time.1, length = n); alpha <- alpha * (2*pi/12)
    x <- a * sin(alpha) + x0; y <- a * cos(alpha) + y0
    cbind(x[-n],y[-n], x[-1],y[-1], lwd.mm)
  }
  res <- NULL
  #                               x0   y0   radius lwd.mm
  res <- rbind( res, cbind(circle(50, 49.5, 23,    50), col.code = NA) ) # face
  res <- rbind( res, cbind(       50, 45,   50,    50,  15,         1) ) # nose
  res <- rbind( res, cbind(circle(50, 49.5, 47.5,   5), 1) ) # margin
  res <- rbind( res, cbind(circle(35, 65,  2.5,    10), 4) ) # eye left
  res <- rbind( res, cbind(circle(65, 65,  2.5,    10), 1) ) # eye right
  res <- rbind( res, cbind(circle(50, 50,   27,     8,  7.50, 4.50), 3) ) # mouth
  colnames(res) <- c("x0", "y0", "x1", "y1", "lwd.mm", "color")
  class(res) <- "segments"; res
} # ; show.icon.design(smiley.blueeye) # ; smiley.blueeye()
##:define [[smiley.blueeye()]]##
#:371
  
#372:
##define [[smiley.normal()]]:##
smiley.normal <- function(){
  # output: x0, y0, x1, y1, lwd, col 
  circle <- function(x0 = 1, y0 = 1, a = 3, lwd.mm = 5, # a = radius
                     time.0 = 0, time.1 = 12, n = 30){
    # function to draw a part of a circle line
    alpha <- seq(time.0, time.1, length = n); alpha <- alpha * (2*pi/12)
    x <- a * sin(alpha) + x0; y <- a * cos(alpha) + y0
    cbind(x[-n],y[-n], x[-1],y[-1], lwd.mm)
  }
  res <- NULL # res <- rbind( res, cbind( 50, 45, 50, 50, 15,      1) ) # nose
  res <- rbind( res, cbind(circle(50, 49.5, 23,   50), col.code = NA) ) # face
  res <- rbind( res, cbind(circle(50, 49.5, 47.5,  5), 1) ) # rand
  res <- rbind( res, cbind(circle(35, 60.5,  3.0, 10), 1) ) # eye
  res <- rbind( res, cbind(circle(65, 60.5,  3.0, 10), 1) ) # eye 
  res <- rbind( res, cbind(circle(50, 50,   27,    8, 7.50, 4.50),1) ) # mouth
  colnames(res) <- c("x0", "y0", "x1", "y1", "lwd.mm", "color")
  class(res) <- "segments"; res
} #; show.icon.design(smiley.normal)
##:define [[smiley.normal()]]##
#:372
  
#377:
##define [[smiley()]]:##
smiley <- function(smile = 0.8){
  if(is.factor(smile)) smile <- as.numeric(smile) / length(levels(smile))
  circle <- function(x0 = 1, y0 = 1, a = 3, lwd = 5, 
                     time.0 = 0, time.1 = 12, n = 60){
    alpha <- seq(time.0, time.1, length = n); alpha <- alpha * (2*pi/12)
    x <- a * sin(alpha) + x0;               y <- a * cos(alpha) + y0
    cbind(x[-n],y[-n], x[-1],y[-1], lwd)
  }
  res <- NULL
  # res <- rbind( res, cbind(circle(50, 49.5,23,   50), col.code = NA) ) # face
  # res <- rbind( res, cbind(circle(50, 49.5,47,   60),  1) )            # rand
  res <- rbind( res, cbind(         50, 50,  50,   50, 100, 1 ))         # face+rand
  res <- rbind( res, cbind         (50, 50,  50,   50,  88, NA))         # face 
  res <- rbind( res, cbind(circle(  35, 60.5, 3.0, 10),  1) )            # eye
  res <- rbind( res, cbind(circle(  65, 60.5, 3.0, 10),  1) )            # eye 
  if(is.na(smile)){
    res <- rbind( res, cbind(circle(50, 50, 27,  7.5, 7.50, 4.50),1) ) # mouth
  } else {
    #             x0  y0            a lwd time.0  time.1
    # hs <- circle(50,50,         27,  10,   7.5,    4.5) # mouth laughing
    # hn <- circle(50,10,         27,  10,  10.5,   13.5) # mouth not laughing    
    hs <- circle( 50, 40,         17,  10,   8.5,    3.5) # mouth laughing
    hn <- circle( 50, 20,         17,  10,   9.5,   14.5) # mouth not laughing    
    s <- smile; n <- 1 - s
    h <- cbind( hs[,1], s*hs[,2]+n*hn[,2], hs[,3], s*hs[,4]+n*hn[,4], hs[,5])
    res <- rbind( res, cbind(h, 1) )                      # mouth
  }
  class(res) <- "segments"; res
  return(res)
}
##:define [[smiley()]]##
#:377
  
#373:
##define [[smiley.sad()]]:##
smiley.sad <- function(){
  # output: x0, y0, x1, y1, lwd, col 
  circle <- function(x0 = 1, y0 = 1, a = 3, lwd.mm = 5, 
                     time.0 = 0, time.1 = 12, n = 30){
    # function to draw a part of a circle line
    alpha <- seq(time.0, time.1, length = n); alpha <- alpha * (2*pi/12)
    x <- a * sin(alpha) + x0; y <- a * cos(alpha) + y0
    cbind(x[-n],y[-n], x[-1],y[-1], lwd.mm)
  }
  res <- NULL #; res <- rbind( res, cbind(50, 45, 50, 50, 15,      1) ) # nose
  res <- rbind( res, cbind(circle(50, 49.5, 23,   50), col.code = NA) ) # face
  res <- rbind( res, cbind(circle(50, 49.5, 47.5,  5), 1) ) # rand
  res <- rbind( res, cbind(circle(35, 60.5,  3.0, 10), 1) ) # eye
  res <- rbind( res, cbind(circle(65, 60.5,  3.0, 10), 1) ) # eye 
  res <- rbind( res, cbind(circle(50, 10,   27,    8, 10.50, 13.50),1) ) # mouth
  colnames(res) <- c("x0", "y0", "x1", "y1", "lwd.mm", "color")
  class(res) <- "segments"; res
} # ; show.icon.design(smiley.sad)
##:define [[smiley.sad()]]##
#:373
  
#381:
##define [[mazz.man()]]:##
mazz.man <- function(Mean = 100, Penalty = 1, Region = "region:", 
                     expo = 1/(1:3)[3], Mean.max = 107, Mean.half = 90, 
                     Penalty.max = 5, Penalty.min = 0, 
                     x.text = 70, y.text = 10, text.cex.mm = 10){ 
  # bag.size %in% [0,1] # idea of the icon: Adriano Pareto, Matteo Mazziotta
  Mean.min <- Mean.half - (Mean.max - Mean.half) / ((h <- 2^(1/expo)) - 1)
  Mean.min <- min(Mean.min, Mean)
  fac      <- 0.95 * ((h * (Mean - Mean.min)) / Mean.max) ^ expo
  bag.size <- 0.80 * ((Penalty - Penalty.min) / Penalty.max )^expo /2
  res <- rbind(
    c(50,            77.5*fac + 5, 50,          77.5 *fac + 5), #head
    c(50,            35  *fac + 5, 50,          60   *fac + 5), #body
    c(50,            32  *fac + 5, 50,           0   *fac + 5), #leg in white
    c(50,            32  *fac + 5, 50,           0   *fac + 5), #leg
    c(50 + 30*fac,   55  *fac + 5, 50 + 25*fac, 75   *fac + 5), #tape2
    c(50 - 20*fac,   65  *fac + 5, 50 + 30*fac, 70   *fac + 5), #stick
    c(50,            64  *fac + 5, 50 - 15*fac, 45   *fac + 5), #arm one
    c(50 - 20*fac,   65  *fac + 5, 50 - 15*fac, 45   *fac + 5), #arm
    c(50 + 27.5*fac, 50  *fac + 5 - 20*bag.size ,
      50 + 27.5*fac, 50  *fac + 5 - 20*bag.size),               #bag
    c(50 + 25*fac,   55  *fac + 5, 50 + 30*fac, 75   *fac + 5)) #tape1
  colnames(res) <- c("x0", "y0", "x1", "y1")
  lwd.mm <-  c( c(17, 14, 12, 10, 2.5, 2, 6, 6) * fac / 0.927042
                ,   31 * bag.size / 0.2924, 2.5 * fac / 0.927042 ) 
  colors <- c("#3377BB", "white", "brown", "orange")[c(1,1,2,1,4,3,1,1,4,4)]
  res <- data.frame(res, lwd.mm = lwd.mm, color = colors)
  class(res) <- c(class(res), "segments"); result <- list(res)
  res <- data.frame(x = x.text, y = y.text, L = Region, text.cex.mm = text.cex.mm, color = 1) 
  class(res) <- c(class(res), "text"); res <- list(res) 
  result <- c(result, res)                   
  return(result)
} # ; show.icon.design(mazz.man) # Mazzi.Pareto
  # res1 <- rbind(c(0,0,100,100)); class(res1)<-c("segments"); res1 <- list(res1) 
  # res2 <- rbind(c(100,0,0,100)); class(res2)<-c("segments"); res2 <- list(res2) 
##:define [[mazz.man()]]##
#:381
  
#389:
##define [[bike()]]:##
bike <- function(){
   res.liste <- NULL; a <- 1.5
   res <- rbind( c(20, 20, 20,    20, 40, 1),  # wheel front
                 c(20, 20, 20,    20, 30, NA), # wheel front
                 c(80, 20, 80,    20, 40, 1),  # wheel back
                 c(80, 20, 80,    20, 30, NA), # wheel back
                 c(50, 20, 80,    20,  3*a, 1),  # ---
                 c(50, 20, 65,    50,  3*a, 1),  # /
                 c(80, 20, 32.5,  45,  3*a, 1),    # \
                 c(50, 20, 32.5,  45,  3*a, 1),    # \
                 c(60, 50, 70,    50,  5*a, 1),  # seat
                 c(20, 20, 40,    60,  3*a, 1),  # /
                 c(40, 60, 45,    60,  5*a, 1) # control
   )
   res[, c(2,4)] <- res[, c(2,4)] + 20; class(res) <- "segments"
   colnames(res) <- c("x0", "y0", "x1", "y1", "lwd.mm", "color")
   res.liste <- c(res.liste, list(res))
}
##:define [[bike()]]##
#:389
  
#390:
##define [[bike2()]]:##
bike2 <- function() {
   res.liste <- NULL; a <- 1.5
   res <- rbind( c(20, 20, 20,    20, 40, 1),  # wheel front
                 c(20, 20, 20,    20, 30, NA), # wheel front
                 c(80, 20, 80,    20, 40, 1),  # wheel back
                 c(80, 20, 80,    20, 30, NA), # wheel back
                 c(50, 20, 80,    20,3*a, 1),  # ---
                 c(50, 20, 65,    50,3*a, 1),  # /
                 c(80, 20, 32.5,  45,3*a, 1),  # \
                 c(50, 20, 32.5,  45,3*a, 1),  # \
                 c(60, 50, 70,    50,5*a, 1),  # seat
                 c(20, 20, 40,    60,3*a, 1),  # /
                 c(40, 60, 45,    60,5*a, 1))  # control  
   res[, c(2,4)] <- (res[, c(2,4)] - 9.3) * 10/5.3; class(res) <- "segments"
   colnames(res) <- c("x0", "y0", "x1", "y1", "lwd.mm", "color")
   res.liste <- c(res.liste, list(res))
}
##:define [[bike2()]]##
#:390
  
#391:
##define [[heart()]]:##
heart <- function(txt = "xy"){
   txt <- substring(paste(txt, " "), 1:2, 1:2)
   res1 <- cbind( x = c(50, 80, 90, 70, 50, 50, 30, 10, 20, 50),
                  y = c(05, 30, 60, 85, 50, 50, 85, 60, 30, 05) + 05, color = NA)
   class(res1) <- c(class(res1), "polygon"); res1 <- list(res1)
   res2 <- cbind( x = c(50, 90, 70, 50, 50, 30, 10, 50),
                  y = c(05, 60, 85, 50, 50, 85, 60, 05) + 05)
   res2 <- data.frame( res2, lwd.mm = 19.5, color = NA)
   class(res2) <- c(class(res2), "spline"); res2 <- list(res2)
   res3 <- data.frame( x = c(27, 73), y = c(65, 65), txt = txt, 40, 1)
   class(res3) <- c(class(res3), "text");   res3 <- list(res3)
   result <- c(res1, res2, res3) 
} # ; show.icon.design(heart)()
##:define [[heart()]]##
#:391
  
#392:
##define [[bend.sign()]]:##
bend.sign <- function(txt = "xy"){
   txt <- substring(paste(txt, " "), 1:2, 1:2)
   ground <- 6; top <- 90; center <- 55.5; size <- 25
   res0o <- c(50, top, 50, ground + 3, 7, 1) # Pfahl outer
   res0i <- c(50, top, 50, ground + 2, 3, 3) # Pfahl inner
   res1  <- c(30, ground, 70, ground, 2, 1)  # Fundament
   res2  <- rbind( c(50, center+size, 50-size, center), c(50-size, center, 50, center-size),
                   c(50, center-size, 50+size, center), c(50+size, center, 50, center+size))
   res2 <- cbind(res2, lwd.mm = 15, color = 1)    # Schildrand
   size <- size - 0                               # Innenrand:
   res3 <- rbind( c(50, center+size, 50-size, center), c(50-size, center, 50, center-size),
                  c(50, center-size, 50+size, center), c(50+size, center, 50, center+size))
   res3 <- cbind(res3, lwd.mm = 10, color = 2)
   res <- rbind(res0o, res0i, res1, res2, res3); rownames(res) <- NULL
   res <- as.data.frame(res)
   colnames(res) <- c("x0", "y0", "x1", "y1", "lwd.mm", "color")
   res$color <- c("black", NA, "gray")[res$color]
   class(res) <- c(class(res), "segments"); res <- list(res)
   size <- size - 2
   res1b <- rbind( c(50, center+size), c(50-size, center),
                   c(50, center-size), c(50+size, center))
   res1b <- cbind(res1b, color = NA)
   class(res1b) <- c(class(res1b), "polygon"); res1b <- list(res1b) # Innenflaeche
   f <- size / 25
   res2b <- cbind( x = 50     + f*c( h <- c(- 9,  5, 12), rev(-h)),
                   y = center + f*c( h <- c( 16, 13,  6), rev(-h)), 
                   lwd.mm = f^0.6*6.5, color = 1)
   class(res2b) <- c(class(res2b), "spline"); res2b <- list(res2b)
   #res3 <- data.frame( x = c(27, 73), y = c(65, 65), txt = txt, 40, 1)
   #class(res3) <- c(class(res3), "text");   res3 <- list(res3)
   result <- c(res, res1b, res2b) #, res1) 
}  # ; show.icon.design(bike2)# bend.sign) #; bend.sign()
##:define [[bend.sign()]]##
#:392
  
#398:
##define [[fir.tree()]]:##
fir.tree <- function(height = 1, width = 1, txt = ".....", t.cex.mm = 10){ 
  fac.x <- width * 100/60; fac.y <- height * 100/70
  # build standardized elements of pictogram
  res <- data.frame( 
    x = c(20, 40, 25, 45, 35, 50, 65, 55, 75, 60, 80),
    y = c(20, 40, 40, 60, 60, 80, 60, 60, 40, 40, 20) + 5,
    color = NA)
  class(res) <- c(class(res), "polygon")
  res.liste <- c(list(res))
  res <- data.frame( 
    x = c(55, 55, 45, 45),
    y = c(20, 10, 10, 20) + 5 ,
    color = "brown")
  class(res) <- c(class(res), "polygon")
  res.liste <- c(res.liste, list(res))
  # integrate effects of arg1 and arg2
  res.liste <- lapply( res.liste, function(xyc){
                         xyc$x <- fac.x * (xyc$x - 50) + 50; xyc} )
  res.liste <- lapply( res.liste, function(xyc){
                         xyc$y <- fac.y * (xyc$y - 50) + 50; xyc} )
  # append text element # res <- data.frame( x = 20, y = 2, txt = txt, t.cex.mm, color = "1") 
  res <- data.frame( x =  fac.x * (30 - 50) + 50, y = fac.y * (10 - 50) + 50, 
                     txt = txt, t.cex.mm, color = "1") #180327
   class(res) <- c(class(res), "text")
  res.liste <- c(res.liste, list(res))
  res.liste
}  # ; show.icon.design(fir.tree)
##:define [[fir.tree()]]##
#:398
  if( icons %in% ls() ) icons <- get(icons)
  if( !is.function(icons) ) {
    cat("Error in call of call.icon.generator in iconplots():\n  ", 
        icons,"not implemented yet!")
    return()
  }
##:look for internal generator in [[call.icon.generator()]]##
#:354
  }
  if( is.function(icons) ){ # case: user defined generator function ---
    
#355:
##find set [[pic.sets]] by calling [[icons()]] in [[call.icon.generator()]]:##
    # check arguments of icons # print(pic.args)
    icon.gen.args  <- formals(icons); n.icon.gen.args <- length(icon.gen.args)
    # Are there some arguments of icons to modify the pictogram? -----------
    args <- list()                 # no additional args to concern -----------
    if( n.icon.gen.args > 0 ){     
      # at first check whether there are arguments in "..." to use for icons
      ppp.args <- list(...)
      if( 0 < length(ppp.args) ){ 
        # find args of "..." which can be used in icons()
        idx <- match(names(ppp.args), names(icon.gen.args))
        args <- ppp.args[!is.na(idx)]
        # remove args of icon.gen.args that have been found in "..."
        idx <- match(names(icon.gen.args), names(args))
        icon.gen.args <- icon.gen.args[is.na(idx)] 
      }
      # append args given via grp.design and stored in pic.args
      if( (h1 <- length(pic.args)) > 0 && (h2 <- length(icon.gen.args)) > 0 ){
        pic.args <- pic.args[1 : min(h1, h2)]
        args <- c( args, as.list(pic.args) )     
      } 
      if( 0 == length(args) ) args <- list() # explizit assignment of args if empty
    } # => relevant args found, expanded and stored in args
    # conversion of factors to numbers 
    for( i in seq(along = args)){ 
      h <- args[[i]]
      if(is.factor(h)){ # case: levels are numbers
        nums <- try(as.numeric(levels(h)))
        if( (!"try-error" == class(nums)) && (!any( is.na(nums) ) ) ){ # nums is number 
          args[[i]] <- nums[as.numeric(h)] 
        } else {  # case: levels are no numbers
                  # job of generator function: args[[i]] <- as.numeric(h) / length(levels(h))    
        }
      }
    }
    # call icons to build an concrete pictogram blank
    pic.sets <- try(do.call(icons, args)) 
    if("try-error" %in% class(pic.sets) ){ 
      cat("ERROR in call.icon.generator: generator function failed!\n"); return()
    }
    if( !is.list(pic.sets) || is.data.frame(pic.sets) ) pic.sets <- list(pic.sets)
##:find set [[pic.sets]] by calling [[icons()]] in [[call.icon.generator()]]##
#:355
  } 
  # now pic.sets stores the actual pictogram blank
  # check list structure of the pictogram to be build
  if( !is.list(pic.sets) || is.data.frame(pic.sets) ) pic.sets <- list(pic.sets)
  
#356:
##find parameters for constructing pictograms in [[call.icon.generator()]]:##
  colornames <- c("white", "black", "red", "green", "blue",
                  "lightblue", "magenta", "yellow", "grey")
  if(is.numeric(color)) color <- colornames[1 + color]
  h <- par(); usr <- h$usr; pin <- h$pin; cin <- h$cin 
  xwcoor.pmm <- diff(usr[1:2]) / pin[1] / 25.4 # xrange per mm of plot-region
  ywcoor.pmm <- diff(usr[3:4]) / pin[2] / 25.4 # yrange per inch of plot-region
  # correction because of uncorrect display sizes may by processed by:
  dev.fac <- c(0.8, 1, 1)[ c(dev.cur() == c("postscript", "pdf"), TRUE) ][1]
  aspect     <- xwcoor.pmm / ywcoor.pmm  # width / height concerning plot-region
  # if(length(icon.cex) < n.items) icon.cex <- rep(icon.cex, n.items)[1:n.items]
  # xrange of symbol of size because of 
  #   "xsize <- icon.cex * xwcoor.pmm" => "icon.cex == xsize / xwcoor.pmm dxy[1]" => 
  icon.cex <- dxy[1] / xwcoor.pmm;   xsize  <- icon.cex * xwcoor.pmm
  ysize  <- icon.cex * ywcoor.pmm         # yrange of symbol of size icon.cex 
  xwcoor.pcm <- 10 * xwcoor.pmm         # xrange per cm of plot-region 
  mm.to.lwd <- function(lwd.mm) lwd.mm * 3.787878 * dev.fac 
  mm.to.cex <- function(text.cex.mm) text.cex.mm / (cin[1] * 25.4)
##:find parameters for constructing pictograms in [[call.icon.generator()]]##
#:356
  type.set <- c("polygon", "segments", "text", "spline")
  for( pic.i in pic.sets ){ # loop along the elements of list "pic.sets"
    # plot segments, polygons and texts in [[call.icon.generator()]]
    
#357:
##add missing infos of [[pic.i]] in [[call.icon.generator()]]:##
# find type (last element of class vector) and dimensions of pic.i
type <- rev(class(pic.i))[1]; type <- type[ type %in% type.set ]
h <- dim(pic.i); rows.pic.i <- h[1]; cols.pic.i <- h[2] 
# add missing infos
if( type == "polygon" ){
  if( cols.pic.i < 3 ) pic.i <- cbind( pic.i, color.vec = NA )
}
if( type == "segments" ){
  if( cols.pic.i < 5 ) pic.i <- cbind( pic.i, lwd.mm = 10 )
  if( cols.pic.i < 6 ) pic.i <- cbind( pic.i, color.vec = NA )
}
if( type == "text" ){
  if( cols.pic.i < 4 ) pic.i <- cbind( pic.i, text.cex.mm = 10 )
  if( cols.pic.i < 5 ) pic.i <- cbind( pic.i, color.vec = NA )
}
if( type == "spline" ){
  if( cols.pic.i < 3 ) pic.i <- cbind( pic.i, lwd.mm = 10 )
  if( cols.pic.i < 4 ) pic.i <- cbind( pic.i, color.vec = NA )
}
##:add missing infos of [[pic.i]] in [[call.icon.generator()]]##
#:357
    
#358:
##prepare colors for use in [[call.icon.generator()]]:##
# extract color column: color.vec of group of descriptions
col.no <- c(3, 6, 5, 4)[ match( type, type.set ) ]
color.vec <- pic.i[, col.no]
# standardize format of color.vec
if(is.factor (color.vec)) color.vec <- as.character(color.vec)
if(is.numeric(color.vec)) color.vec <- colornames[1 + color.vec]
# replace NA entries by argument color of puticon call
res.color <- ifelse( is.na(color.vec), color, color.vec ) 
##:prepare colors for use in [[call.icon.generator()]]##
#:358
    
#359:
##transform coordinates in [[call.icon.generator()]]:##
n.cols <- c(2, 4, 2, 2)[ match(type, type.set) ]
adj.h <- matrix( 1, nrow(pic.i), n.cols, byrow = TRUE ) #180327
res <- # shift because of design size
       # (pic.i[, 1:n.cols] - 100 * adj) *
       (pic.i[, 1:n.cols] + 100 * (adj.h - 1)) *  #180327
       # scaling: rescaling design size 0..100 -> 0..1: factor = 0.01
       0.01 * matrix(c(xsize, ysize), rows.pic.i, n.cols, byrow = TRUE) + 
       # shift because of desired position
       matrix(xy,                     rows.pic.i, n.cols, byrow = TRUE)
##:transform coordinates in [[call.icon.generator()]]##
#:359
    
#360:
##construct and activate plotting commands in [[call.icon.generator()]]:##
## if(verbose){ cat("activate plotting commands"); print(res.color) }
switch(type, 
       "polygon"  = polygon (res[,1], res[,2], col = res.color, xpd = NA, border = NA),
       "segments" = segments(res[,1], res[,2], res[,3], res[,4], col = res.color, 
                              lwd = mm.to.lwd(pic.i[, 5]) * icon.cex / 100,
                              xpd = NA),
       "text"     = text(res[,1], res[,2], as.character(pic.i[,3]),
                         col = res.color, cex = mm.to.cex(pic.i[,4]) * icon.cex / 100, 
                         # adj = c(0,0), # adjust argument for text not implemented yet
                         xpd = NA),
       "spline"   = {
                       n.h <- length(res[,1]); z <- seq(n.h); n <- 10
                       xy.h <- cbind(spline( z, res[,1], n = n * n.h)$y, 
                                     spline( z, res[,2], n = n * n.h)$y)
                       lines(xy.h, col = res.color, 
                             lwd = mm.to.lwd(pic.i[,3]) * icon.cex / 100, 
                             xpd = NA)
        }
)
##:construct and activate plotting commands in [[call.icon.generator()]]##
#:360
  }
  return()
}
##:define [[call.icon.generator()]]##
#:353
##:define local functions##
#:361
#12:
##find positioning vars:##
if(verbose) cat("find positioning vars")
if(is.null(grp.xy)) grp.xy <- "0~0"
grp.xy <- find.xy.groupings(grp.xy)
##:find positioning vars##
#:12
#15:
##find pic vars:##
if(verbose) cat("grp.icon of call:", grp.icon)
grp.design <- NULL
if( !is.null(grp.icon) ){ # 170817
  grp.icon <- gsub(" ", "", grp.icon)             # remove blanks
  grp.icon <- unlist(strsplit(grp.icon, "[+]"))   # split string  
  grp.icon <- grp.icon[ grp.icon != "" ]          # remove empty entries
  if( 1 < length(grp.icon) ){                     # further specifications found
    grp.design <- grp.icon[-1]                   # extract specifications 
    grp.icon <- grp.icon[1]                       # extract pic choise variable 
  }
} 
if(verbose){ cat("grp.icon interpreted"); print(grp.icon); print(grp.design)}
##:find pic vars##
#:15
#19:
##build data matrix:##
if(verbose) cat("build data matrix")
if(length(data) == 0 || all(unlist(data) == 0)) return("nothing to do")
if(is.vector(data) && !is.table(data)){      # case 1
  data <- as.table(data)
  if( 1 == length(data) && (0 == length(grp.xy$x) || any(0 < grp.xy$x)) ) 
    grp.xy$x <- "0"
  if( 0 == length(grp.xy$y) || any(1 < grp.xy$y) ) grp.xy$y <- "0"  
}
if(is.table(data)){                          # case 2
  
#20:
##check and possibly set dim names of table and save them:##
data.mat.cn.orig <- names(dimnames(data)) # set dim names if missing:
if( 0 == length(data.mat.cn.orig) || any("" == data.mat.cn.orig) ){ 
  h <- length(dim(data))
  data.mat.cn.orig <- c(data.mat.cn.orig, rep("",h))[1:h]
  h <- paste("Var", 1:h, sep = "")
  data.mat.cn.orig <- ifelse(data.mat.cn.orig != "", data.mat.cn.orig, h)
  names(dimnames(data)) <- data.mat.cn.orig
  cat("Note: names for dims have been set:", data.mat.cn.orig, "!\n")
}
names(dimnames(data)) <- data.mat.cn <- make.names(data.mat.cn.orig, TRUE)
##:check and possibly set dim names of table and save them##
#:20
  
#21:
##replace numbers in grouping definitions:##
local.debug <- !TRUE
if(local.debug){  if(is.matrix(data)) print(data[1:2,]); 
  print(data.mat.cn); cat("length(grp.color)", length(grp.color))
  cat("grp.color", grp.color, "grp.icon", grp.icon); print(grp.xy) }
find.col.name <- function( cname, dims ){ # cat("csname"); print(cname)
  if(1 == length(cname) && 0 < length(grep("^[1-9][0-9]*$", cname)) &&   
    is.na(match(cname, dims)) ){ cname <- as.character(dims[ as.numeric(cname) ]) }
  return(cname) # as.character() # 180607
}  
if( 0 < length(grp.icon) ){ # must be of length 1
  grp.icon <- find.col.name(grp.icon[1], data.mat.cn)
}
if( 0 < length(grp.design) ){
  grp.design <- sapply( grp.design, find.col.name, data.mat.cn)
}
grp.color <- find.col.name(grp.color, data.mat.cn)
if( "0" != grp.xy$x[1] ) grp.xy$x <- sapply( grp.xy$x, find.col.name, data.mat.cn)
if( "0" != grp.xy$y[1] ) grp.xy$y <- sapply( grp.xy$y, find.col.name, data.mat.cn)
if(verbose){ 
  cat("grp.color",grp.color, "grp.icon", grp.icon); print(grp.design); print(grp.xy)}
##:replace numbers in grouping definitions##
#:21
  
#22:
##reduce data table if not all dimensions are used:##
vars.used <- unique(c(unlist(grp.xy), grp.color, grp.icon, grp.design))
if(verbose){ 
  cat("vars.used", vars.used, "dimnames(data)"); print(dimnames(data)) 
}
found <- match(vars.used, data.mat.cn)
h <- vars.used
h <- h[ is.na(found) & h != "|"]
h <- h[ h != "0" & h != ".sign"]
h <- h[ !is.na(h) ]
if( 0 < length(h) ) cat("Warning: grouping vars ", h, "not found -> ignored!")
found <- found[ !is.na(found) ]
if( 1 < length(found) ) found <- sort(found)
relevant.columns <- rep(FALSE, length(data.mat.cn))
relevant.columns[found] <- TRUE
if( length(found) < length(dimnames(data)) ){ 
  data <- margin.table(data, found); if(!is.table(data)) data <- as.table(data)
  data.mat.cn      <- data.mat.cn[found]
  data.mat.cn.orig <- data.mat.cn.orig[found]
  if( 0 == length(found)) data.mat.cn <- data.mat.cn.orig <- "Var1"
}
if(local.debug){ 
  print(grp.xy); print(grp.color); cat("vars.used"); print(vars.used)
  cat("found"); print(found); # str(data); print(data.mat.cn); print(data.mat.cn.orig)
}
##:reduce data table if not all dimensions are used##
#:22
  
#23:
##check and possibly create new dimension due to negative cell entries:##
if( any( data < 0 ) ){
  data1 <- - data * (data <= 0); data2 <- data * (0 <= data); h <- c("-1","+1")
  # data1 <- data * (0 <= data); data2 <- -data* (data <= 0); h <- c("+1","-1")
  data3 <- array(c(data1, data2), c(dim(data),2))
  dimnames(data3) <- c(dimnames(data), list(".sign" = h) )
  cat("Note: new dimension '.sign' constructed to separate \n", 
      "the absolute values of negative and positive entries!\n")
  data <- data3
}
##:check and possibly create new dimension due to negative cell entries##
#:23
  
#24:
##expand table to data matrix and add sign and fraction column:##
if( all(0<=data) & all(data<=1) ) data <- data*0.99999 # force rel.freq. to be < 1
if( any( 0 < (dat  <- floor(data)) ) ){ # some entries > 0 after rounding down
  data.mat <- cbind(expand.table.short(dat), .fraction = 1)
} else data.mat <- NULL                 # maybe relative frequencies only
if( any(data != dat) ){                 # fractional entries observed
  fs <- .5 + 0 * data; h <- as.vector(data - dat) 
  # h <- as.vector(aperm(f, rev(seq(along = dim(f))))) # alternative sorting
  # h <- h[h>0]                         # values greater 0 should be handled only
  d <- cbind(expand.table.short(ceiling(fs)), .fraction = h) 
  idx <- h > 0 | as.vector(data) == 0   # fractional part positive or cell entry 0
  if( h <- (!is.null(data.mat)) )  cn <- colnames(data.mat)
  data.mat <- rbind(data.mat, d[idx,, drop = FALSE])
  if(h) colnames(data.mat) <- cn
}
if( !(".sign" %in% colnames(data.mat)) ){
  data.mat <- cbind(data.mat[, -(h <- dim(data.mat)[2]), drop = FALSE], .sign = 1, 
                    .fraction = data.mat[, h])
}
data.mat <- data.mat[ data.mat[, ".fraction"] != 0, ]                ## 161215
data.mat.cn      <- c(data.mat.cn,      ".sign", ".fraction") 
data.mat.cn.orig <- c(data.mat.cn.orig, ".sign", ".fraction")
# in case of 1-dim tables there is no dimname so we set name "Var1"
# if( "" == colnames(data.mat)[1] ) colnames(data.mat)[1] <- "Var1"
data.mat <- data.frame(data.mat)
##:expand table to data matrix and add sign and fraction column##
#:24
 
} else {                                     # case 3
  
#25:
##check and possibly set col names of data matrix and save them:##
data.mat <- cbind(data) 
data.mat.cn.orig <- colnames(data.mat) # set col names if missing:
if( 0 == length(data.mat.cn.orig) || any("" == data.mat.cn.orig) ){       
  h <- dim(data)[2]
  data.mat.cn.orig <- c(data.mat.cn.orig, rep("",h))[1:h]
  h <- paste("Var", 1:h, sep = "")
  data.mat.cn.orig <- ifelse(data.mat.cn.orig != "", data.mat.cn.orig, h)
  colnames(data) <- data.mat.cn.orig
  cat("Warning: col names of data matrix have been set:",
      data.mat.cn.orig, "!\n")
}
data.mat.cn <- make.names(data.mat.cn.orig, TRUE)
##:check and possibly set col names of data matrix and save them##
#:25
  
#21:
##replace numbers in grouping definitions:##
local.debug <- !TRUE
if(local.debug){  if(is.matrix(data)) print(data[1:2,]); 
  print(data.mat.cn); cat("length(grp.color)", length(grp.color))
  cat("grp.color", grp.color, "grp.icon", grp.icon); print(grp.xy) }
find.col.name <- function( cname, dims ){ # cat("csname"); print(cname)
  if(1 == length(cname) && 0 < length(grep("^[1-9][0-9]*$", cname)) &&   
    is.na(match(cname, dims)) ){ cname <- as.character(dims[ as.numeric(cname) ]) }
  return(cname) # as.character() # 180607
}  
if( 0 < length(grp.icon) ){ # must be of length 1
  grp.icon <- find.col.name(grp.icon[1], data.mat.cn)
}
if( 0 < length(grp.design) ){
  grp.design <- sapply( grp.design, find.col.name, data.mat.cn)
}
grp.color <- find.col.name(grp.color, data.mat.cn)
if( "0" != grp.xy$x[1] ) grp.xy$x <- sapply( grp.xy$x, find.col.name, data.mat.cn)
if( "0" != grp.xy$y[1] ) grp.xy$y <- sapply( grp.xy$y, find.col.name, data.mat.cn)
if(verbose){ 
  cat("grp.color",grp.color, "grp.icon", grp.icon); print(grp.design); print(grp.xy)}
##:replace numbers in grouping definitions##
#:21
  
#26:
##reduce data frame if not all variables are used:##
vars.used <- unique(c(unlist(grp.xy), grp.color, grp.icon, grp.design,
                    ".fraction", ".icon")) #170818
found <- match(vars.used, data.mat.cn)
h <- vars.used
h <- h[ is.na(found) & h != "|"]
h <- h[ h != "0" & h != ".sign"]
h <- h[ !is.na(h) ]
hh <- h[ ! (h %in% c(".fraction", ".icon")) ] #170818
if( 0 < length(hh) ) cat("Warning: grouping vars ", hh, "not found -> ignored!")
found <- found[ !is.na(found) ]
if( 1 < length(found) ) found <- sort(found)
relevant.columns <- rep(FALSE, length(data.mat.cn))
relevant.columns[found] <- TRUE
if( length(found) < length(colnames(data)) ){ 
  data.mat <- data.mat[, found, drop = FALSE]
  data.mat.cn      <- data.mat.cn[found]
  data.mat.cn.orig <- data.mat.cn.orig[found]
} 
##:reduce data frame if not all variables are used##
#:26
  
#27:
##append fraction and sign column:##
if( !".sign" %in% colnames(data.mat) ){
  data.mat <- cbind(data.mat, .sign = 1)
  data.mat.cn      <- c(data.mat.cn,      ".sign")
  data.mat.cn.orig <- c(data.mat.cn.orig, ".sign")
}
if( !".fraction" %in% colnames(data.mat) ){
  data.mat <- cbind(data.mat, .fraction = 1)
  data.mat.cn      <- c(data.mat.cn,      ".fraction")
  data.mat.cn.orig <- c(data.mat.cn.orig, ".fraction")
}
colnames(data.mat) <- data.mat.cn
data.mat <- data.frame(data.mat) ## 160829
##:append fraction and sign column##
#:27
}
#28:
##check and possibly modify grouping definitions:##
rm.0 <- function(x) x[ x != "0" ]
grp.design <- rm.0(grp.design)
grp.icon <-   rm.0(grp.icon)
grp.color <-  rm.0(grp.color)
grp.x <-      rm.0(grp.xy$x)
grp.y <-      rm.0(grp.xy$y) # testet
h <- c(grp.x, grp.y, grp.icon, grp.color, grp.design)
grp.vars <- if( is.null(h) ) h else unique(sort(h)) # grp.vars show grouping vars
if(verbose) cat("after check\ngrp.icon:", grp.icon, "grp.design:", grp.design) 
if(verbose) cat("grp.x", grp.x, "grp.y", grp.y, "grp.color", grp.color)
# find original grouping variable names:
f <- function(obj) substring(obj, 1, pmin(nchar(obj), lab.n.max[1]))
grp.x.o <-     f(data.mat.cn.orig[ match(grp.x,     data.mat.cn) ])
grp.y.o <-     f(data.mat.cn.orig[ match(grp.y,     data.mat.cn) ])
grp.color.o <- f(data.mat.cn.orig[ match(grp.color, data.mat.cn) ])
grp.icon.o <-   f(data.mat.cn.orig[ match(grp.icon,   data.mat.cn) ])
grp.design.o <-f(data.mat.cn.orig[ match(grp.design,data.mat.cn) ])
##:check and possibly modify grouping definitions##
#:28
##:build data matrix##
#:19
#30:
##transform variables:##
if(verbose) cat("transform variables")
# remove rows with NA entries
if( any(is.na(data.mat)) ){ 
  idx <- apply(data.mat, 1, function(x) all( !is.na(x) ) )
  data.mat <- data.mat[ idx,, drop = FALSE ]
  cat("NA rows have been removed")
}    
if(missing(vars.to.factors)) 
  vars.to.factors <- rep(TRUE, length(relevant.columns))
if( any(0 < vars.to.factors) ){                 # prepair vars.to.factors
  if(is.null(h <- names(vars.to.factors))){
    # case: no names of variables given
    if( 0 < ( h <- length(relevant.columns) - length(vars.to.factors) ) ) 
      vars.to.factors <- c(vars.to.factors, rep(1, h)) # not (0,h) #170102
    vars.to.factors <- vars.to.factors[relevant.columns]
    v.idx <- seq(along=vars.to.factors)
  } else {
    v.idx <- match(names(vars.to.factors), colnames(data.mat))
    v.idx <- v.idx[!is.na(v.idx)]
  }
  for(i in seq(along = v.idx)){                 # perform transformation:
    if(!is.factor(v <- data.mat[, v.idx[i] ]) 
       && data.mat.cn[v.idx[i]] != ".fraction"){
      if(0 == vars.to.factors[i]) next
      if(1 > vars.to.factors[i]){
        b <- seq(0,1, 1/round(1/vars.to.factors[i]))[-1]
        if( .95 < b[h <- length(b)] ) b <- b[-h]
        mi <- min(v); ma <- max(v)
        b <- unique(c(mi - 0.01*(ma - mi), quantile(v, b, na.rm = TRUE), ma))        
        v <- cut(v, breaks = b)
      }
      if(1 == vars.to.factors[i]) v <- factor(v)
      if(1 < vars.to.factors[i])  v <- cut(v, vars.to.factors[i]) 
      data.mat[, v.idx[i] ] <- v
    }
  }
}
##:transform variables##
#:30
#31:
##transform variables:##
if( 0 < length(grp.y) ){ 
  for(j in seq(along = grp.y)){ # reverse y 
    d <- data.mat[[grp.y[j]]]
    if( panel.reverse.y && is.factor(d) && grp.y[j] != ".sign" ) {
      h <- rev(levels(d))
      d <- factor(1 + length(h) - as.numeric(d)); levels(d) <- h
      data.mat[[grp.y[j]]] <- d
    }
  } # data.mat <- data.frame(data.mat[, grp.vars, drop=FALSE])
}
##:transform variables##
#:31
#32:
##transform variables:##
if(verbose) cat("grp.x:",        grp.x,    " / grp.y:",  grp.y,
                " / grp.color:", grp.color," / grp.icon:",grp.icon,
                " / colnames(data.mat):",  colnames(data.mat), sep="|")
##:transform variables##
#:32
#34:
##transform variables:##
# find objects to transform variables
#   args <- list(...) in <check arguments of [[iconplot]]>
if( 0 < length( h <- grep("^transform[.]", names(args))) ){
  if(verbose) cat("transform variable", h)
  args.list <- args[h]
  var.names <- sub("^transform[.]", "", names(args.list))
  # extract var.names which are found in the data
  col.no <- match(var.names, colnames(data.mat))
  idx <- !is.na(col.no)
  args.list <- args.list[idx]
  var.names <- var.names[idx]
  col.no <- col.no[idx]
  # loop along the columns to be transformed
  for(i in seq(along = col.no)){
    f <- args.list[[i]]
    if( is.character(f) ){
      txt <- c( "f <- function(x){", f, "}")
      res <- try(eval(parse(text = txt)))
      if( class(res) == "try-error" ){
        cat("Error during transformation of", var.names[i], "by\n  ", txt)
        next
      }
    }
    res <- try( f( data.mat[, col.no[i]] ) )
    if( class(res) == "try-error" ){
      cat("Error during transformation of", var.names[i], "by\n  " ); print(f) 
      if( is.factor(var.names[i]) ) 
        cat("-- Remark:", var.names[i], "is a factor variable!")
      next
    } else {
      data.mat[, col.no[i]] <- res
      if( verbose ){ cat( var.names[i], "has been transformed by\n  " ); cat(" ", deparse(f)) }
    }
  }
}
##:transform variables##
#:34
#37:
##fix colors:##
if( 0 < length(grp.color) ){
  values <- data.mat[, grp.color]
  lev.color <- if(is.factor(values)) levels(values) else unique(sort(values)) 
  n.values <- length(lev.color) 
  if(missing(colors)) colors <- substring(rainbow(n.values),1,7)
  if( (h <- length(colors)) < n.values ) 
    colors <- c(colors, rep(colors, n.values))[1:n.values]
  Colors <- match(values, lev.color) # colors[ .. ]
  if(is.character(lev.color)) 
    lev.color <- substring(lev.color, 1, pmin(lab.n.max[1], nchar(lev.color)))
} else { 
  Colors <- rep(1, nrow(data.mat)); lev.color <- 1
  if(missing(colors)) colors <- 1
}
data.mat <- cbind(data.mat, .color = Colors)
##:fix colors##
#:37
#39:
##fix icons:##
if(verbose) print("fix icons -- begin -------------------")
if(!missing(icons)){ #170718
  # find set of icons to be used
  if(is.raster(icons)) icons <- list(icons)
  if( is.character(icons) ){
    h <- substring(h <- icons[[1]], nchar(h) - 3, nchar(h)) %in% 
       c(".jpg", ".JPG", "jpeg", "JPEG", ".pnm", ".PNM", ".png", ".PNG", ".ppm", ".PPM")
    if( h  ){
      
#42:
##read raster image if file names are given:##
if(is.character(icons)){ # names of files with images
  file.type <- rep("no file", length(icons))
  
#41:
##download file via internet:##
  # download files via internet
  download.list <- NULL
  for(i in seq(along = icons)){
    icon <- icons[i];  h <- nchar(icon)
    h1 <- substring(icon, 1, 4) == "http"
    h2 <- (icon.ext <- substring(icon, h - 3, h)) %in% 
            c(".jpg", ".JPG", "jpeg", "JPEG", ".pnm", ".PNM", ".png", ".PNG")
    if( icon.ext %in% c(".jpg", ".JPG", "jpeg", "JPEG") ) file.type[i] <- "jpg"
    if( icon.ext %in% c(".pnm", ".PNM", ".ppm", ".PPM") ) file.type[i] <- "pnm"
    if( icon.ext %in% c(".png", ".PNG") )                 file.type[i] <- "png"
    if( h1 && h2 ){ # file from internet
      fname <- sub(".*[.]", ".", icon)
      fname <- tempfile("icon-pic", fileext = fname)
      ok <- try( utils::download.file(url = icon, destfile = fname) )
      if( "error" %in% class(ok) ){ 
        cat("Error in iconplot: Download of file", icon, "failed.\n")
        return()
      } 
      download.list <- c(download.list, fname)
      icons[i] <- fname
    } 
  }
  if(verbose){ cat("files downloaded:\n"); print(download.list) }
##:download file via internet##
#:41
  if( any(file.type == "pnm") ){ 
#221:
##define [[get.pnm()]]:##
get.pnm <- function(filename, verbose = FALSE){
  
#222:
##find P* type of pnm file:##
nextline <- scan(filename, what="", n=1)
if( substring(nextline, 1, 1) != "P" || 
    ! ( PType <- substring(nextline, 2, 2) ) %in% as.character(1:6)) 
  return("ERROR: reading pnm file failed: no pnm file")
PType <- as.numeric(PType); if(verbose) cat("PType:", PType); skip <- 0
nextline <- scan(filename, what="", sep="\n", n=1, skip = skip, 
                 blank.lines.skip = FALSE)
nextline <- unlist( strsplit( nextline, "[ \t]"))[-1]
##:find P* type of pnm file##
#:222
  
#223:
##get width of pnm picture:##
#226:
##get next line that is not empty:##
idx <- 20
while(idx > 0 & 0 == length(nextline)){
  idx <- idx - 1; skip <- skip + 1
  nextline <- scan(filename, what="", sep="\n", n=1, skip = skip,
                   blank.lines.skip = FALSE)
  nextline <- sub("[#].*", "", nextline)
  nextline <- unlist( strsplit( nextline, "[ \t]"))
}
if( idx == 0 ) return("ERROR: reading pnm file failed: too many #-lines")
nextline <- as.numeric(nextline)
##:get next line that is not empty##
#:226
width <- nextline[1]; if(verbose) cat("width:",width)
nextline <- nextline[-1]
##:get width of pnm picture##
#:223
  
#224:
##get height of pnm picture:##
if( length(nextline) == 0 ){
  
#226:
##get next line that is not empty:##
idx <- 20
while(idx > 0 & 0 == length(nextline)){
  idx <- idx - 1; skip <- skip + 1
  nextline <- scan(filename, what="", sep="\n", n=1, skip = skip,
                   blank.lines.skip = FALSE)
  nextline <- sub("[#].*", "", nextline)
  nextline <- unlist( strsplit( nextline, "[ \t]"))
}
if( idx == 0 ) return("ERROR: reading pnm file failed: too many #-lines")
nextline <- as.numeric(nextline)
##:get next line that is not empty##
#:226
}
height <- nextline[1]; if(verbose) cat("height:", height)
nextline <- nextline[-1]
##:get height of pnm picture##
#:224
  
#225:
##get colors of pnm picture:##
if(PType == 1 || PType == 4) colors <- 1 else {
  if( length(nextline) == 0 ){
    
#226:
##get next line that is not empty:##
idx <- 20
while(idx > 0 & 0 == length(nextline)){
  idx <- idx - 1; skip <- skip + 1
  nextline <- scan(filename, what="", sep="\n", n=1, skip = skip,
                   blank.lines.skip = FALSE)
  nextline <- sub("[#].*", "", nextline)
  nextline <- unlist( strsplit( nextline, "[ \t]"))
}
if( idx == 0 ) return("ERROR: reading pnm file failed: too many #-lines")
nextline <- as.numeric(nextline)
##:get next line that is not empty##
#:226
  }
  colors <- nextline[1]
}; if(verbose){ cat("colors:", colors); cat("head processed") }
##:get colors of pnm picture##
#:225
  
#228:
##get decpixel of pnm picture:##
if(PType < 4){
  decpixel <- scan(filename, what="", sep="\n", skip = skip+1)
  decpixel <- paste(collapse=" ", decpixel)
  decpixel <- unlist( strsplit( decpixel, " +"))
  decpixel <- as.numeric(decpixel)
  decpixel <- matrix( decpixel, ncol = width, byrow = TRUE)
} else { # P4, P5, P6
  
#227:
##read picture data of P4, P5 or P6 pictures:##
tclcmds <- c('
  # https://de.wikipedia.org/wiki/Portable_Pixmap
  # set fname mm.pnm
  set fname FILENAME       
  set size [ file size $fname ]  
  # puts $size
  set fp [open $fname]
  # http://www.tek-tips.com/viewthread.cfm?qid=1477934  
  fconfigure $fp -translation binary 
  # scan [string range $contents i i] %c strA  
  set binpixel [read $fp $size]
  close $fp
  binary scan $binpixel cu* decpixel
')
tclcmds <- sub("FILENAME", filename, tclcmds)
#require(tcltk)
if( requireNamespace("tcltk") ){ 
  tcltk::.Tcl(tclcmds)
} else { 
  print("Error from get.pnm: tcltk not found!!"); return() 
}
decpixel <- as.character(tclvalue("decpixel"))
##:read picture data of P4, P5 or P6 pictures##
#:227
  decpixel <- unlist( strsplit( decpixel, " "))
  if( PType == 4){
    n.infos <- ceiling(width/8) * height 
    # if(verbose) cat("length(decpixel)", length(decpixel), "n.infos", n.infos)
    decpixel <- decpixel[ -(1 : ( length(decpixel) - n.infos )) ]
    encode <- function(number, base) {
      # simple version of APL-encode / APL-representation "T", pw 10/02
      # "encode" converts the numbers "number" using the radix vector "base"
      n.base <- length(base); result <- matrix(0, length(base), length(number))
      for(i in n.base:1){
        result[i,] <- if(base[i]>0) number %% base[i] else number
        number     <- ifelse(rep(base[i]>0,length(number)),
                             floor(number/base[i]), 0)
      }
      return( if(length(number)==1) result[,1] else result )
    }
    decpixel <- encode(as.numeric(decpixel), rep(2,8))
    decpixel <- matrix(decpixel, nrow = height, byrow = TRUE)[, 1:width]
    # decpixel <- matrix(decpixel, ncol = height, byrow = !TRUE)
    # decpixel <- t(decpixel[(1:width),])
  } else { # P5 or P6
    BigEndian <- colors > 255
    n.infos <- width * height * c(1,3)[1+(PType == 6)] * c(1,2)[1+BigEndian]   
    decpixel <- decpixel[ -(1 : ( length(decpixel) - n.infos )) ]
    if( BigEndian ){ # use the first byte of a pixel only
      decpixel <- matrix(decpixel, ncol = 2, byrow = TRUE)[,1] ### 1 or 2?
    }
    decpixel <- as.numeric(decpixel)
    decpixel <- matrix( decpixel, ncol = width * (1 + 2*(PType == 6)), byrow = TRUE)
  }
  PType <- PType - 3
}
##:get decpixel of pnm picture##
#:228
  
#229:
##define [[decpixel.to.raster()]]:##
decpixel.to.raster <- function(decpixel, PType, width, height, colors){
  HEX <- unlist(strsplit("0123456789ABCDEF",""))
  if(PType < 3){ # black and white or grey -- P1 or P2
    if(PType==1) decpixel <- colors - decpixel
    pixel <- decpixel / colors * 255
    first <- floor( pixel / 16 ); second <- pixel %% 16
    hexpixel <- paste(sep="", HEX[1 + first], HEX[1 + second])
    hexpixel <- paste(sep="", "#", hexpixel, hexpixel, hexpixel)
    hexpixel <- matrix(hexpixel, ncol = width)
  } else {       # colors -- P3
    decpixel <- array(t(decpixel), c(3, width, height))
    if( 255 < colors ) colors <- 255                                 # 160928
    pixel <- decpixel / colors * 255
    first <- floor(pixel / 16); second <- pixel %% 16
    hexpixel <- paste(sep="", HEX[1 + first], HEX[1 + second])
    hexpixel <- array(hexpixel, c(3, width, height))
    hexpixel <- paste(sep="", "#", hexpixel[1,,], hexpixel[2,,], hexpixel[3,,])
    hexpixel <- matrix(hexpixel, ncol = width, byrow = TRUE)
  }
  raster <- hexpixel
}
#table(decpixel.to.raster(a, 6, 724, 561, 65535))
#table(a)
##:define [[decpixel.to.raster()]]##
#:229
  as.raster(decpixel.to.raster(decpixel, PType, width, height, colors))
} #; dump("get.pnm", file = "get.pnm.R")
##:define [[get.pnm()]]##
#:221
 }
  n.icons <- dim(data.mat)[1]^0.5; p <- icons; icons <- NULL
  ok <- try(for(ip in seq(along = p)){
              if(file.type[ip] == "pnm") pic <- get.pnm(p[ip]) 
              if(file.type[ip] == "jpg"){
                if(!"package:jpeg" %in% search()){
                  print("iconplot() requires package jpeg")
                }
                pic <- jpeg::readJPEG(p[ip], native = !TRUE) #############
              } 
              if(file.type[ip] == "png"){
                if(!"package:png" %in% search()){
                  print("iconplot() requires package png")
                }
                pic <- png::readPNG(p[ip], native = !TRUE)  ##############
              }
              if(verbose){ cat("file has been read:", p[ip], "\n") }
              if(is.list(icon.grey.levels)){
                grey.levels <- icon.grey.levels[[ip]]
                if(is.null(grey.levels)) grey.levels <- icon.grey.levels[[1]]
              } else grey.levels <- icon.grey.levels 
              if( !is.null(grp.color) || !identical(1, colors) ){ 
                # don't transform, raster.to.grey, recolor if no grp.col or colors != 1
                pic <- transform.color.to.rgb.integer(pic)
                pic <- raster.to.greys(pic, 
                         grey.levels = grey.levels, # c(0.05, 0.7),
                         reduce = TRUE, n.icons = n.icons)
              } else pic <- as.raster(pic)
      icons <- c(icons, list(pic)); "ok"
  })
  if(0 < length(download.list)) file.remove(download.list)
  
#46:
##handle try reading error:##
  if(class(ok) == "try-error"){
    icons <- seq(along = p)
    cat("Warning: reading of file(s)", p[ip] ,"failed, plotting symbols will be used!\n")
  }
##:handle try reading error##
#:46
}
##:read raster image if file names are given##
#:42
    }
  } # other icons of mode char must store names of icons to be generated
  if(is.function(icons)) icons <- list(icons) else # otherwise build rect()-icons
    if( length(icons) == 0 || is.na(icons)[[1]] )  icons <- 0
  if(!is.list(icons)) icons <- split(icons, seq(along=icons)) 
}
if( 0 < length(grp.icon) ){ 
  # find levels for each of the vars of grp.icon
  values <- lapply(grp.icon, function(x) data.mat[, x])
  lev.pic <- lapply(values, function(x) 
               if(is.factor(x)) levels(x) else unique(sort(x))) 
  # find number of icons needed 
  n.values <- prod( lev.pic.len <- unlist(lapply(lev.pic, length)) )
  # find set of icons to be used
  if(missing(icons)){
    icons <- seq(n.values)
    if(!is.list(icons)) icons <- split(icons, seq(along=icons)) 
  }
  # expand icons to get n.values elements
  h <- length(icons); 
  if( h < n.values){
    if( h == 1 ) icons <- rep(icons, n.values) else # one element is repeated
      icons <- c(icons, rep(list(0), n.values - h)) # 0s are appended
  } else  icons <- icons[1:n.values]                                     #180312
  pic.legend.ok <- 1 < length(icons) # & h<=n.values: condition removed #180312
  # construct vector of pic no -----------------------------------------------
  pic.vec <- 1; h <- c(1, cumprod( lev.pic.len )) # last element unnecessary
  for(i in seq(along = grp.icon)) # array index formula
    pic.vec <- pic.vec + (match(values[[i]], lev.pic[[i]])-1) * h[i]
  # construct combinated level labels for the pic legend
  if( 1 < length(grp.icon) ) {
    h <- lev.pic; lev.pic <- lev.pic[[length(h)]]
    for(i in (length(h)-1):1) 
      lev.pic <- sapply(lev.pic, function(x) paste( h[[i]], x, sep = "*") )
  } else lev.pic <- unlist(lev.pic) 
  lev.pic <- as.vector(lev.pic)
  if(is.character(lev.pic)) 
    lev.pic <- substring(lev.pic, 1, pmin(lab.n.max[1], nchar(lev.pic)))
  # construct the combinated var labels for the pic legend
  grp.icon.o <- paste(grp.icon.o, collapse = "*")
} else {
  if(missing(icons)) icons <- 0; pic.legend.ok <- FALSE
  pic.vec <- rep(1, nrow(data.mat)); lev.pic <- 1 
}
##:fix icons##
#:39
#40:
##fix icons:##
data.mat <- cbind(data.mat, .icon = pic.vec); if(verbose) show.obj(grp.icon) 
if(verbose){ 
  cat("lev.pic"); print(lev.pic);  cat("pic.vec", pic.vec); cat("grp.icon.o", grp.icon.o)
  print("fix icons -- end --------------------")
}
##:fix icons##
#:40
 
#49:
##construct jobs by panel packer:##
if(verbose) cat("construct jobs by panel packer")
xmin <- 0; xmax <- 100; ymin <- 0; ymax <- 100   # initialization of limits
##:construct jobs by panel packer##
#:49
#50:
##construct jobs by panel packer:##
# "jobs" will store the jobs of printing panels of symbols
# no position grouping => one job
XINTS <- YINTS <- NULL; n.z <- n.s <- 1
XINTS <- if(0 == length(grp.x)) 
           list(cbind(0, xmin, xmax, mean(xmin + xmax)))
YINTS <- if(0 == length(grp.y)) 
           list(cbind(0, ymin, ymax, mean(ymin + ymax)))
if( 0 < length(c(grp.x, grp.y)) ){
  # idx <- match(unique(c(grp.x, grp.y)), data.mat.cn) # doesn't work
  idx <- match((c(grp.x, grp.y)), data.mat.cn) 
  h <- data.mat[, idx, drop=FALSE]; cn <- colnames(h)
  dm.df <- data.frame(h); names(dm.df) <- cn
  # find number of items of combinations of positioning variables
  dm.table      <- table     (dm.df) # contingency table of positioning vars
  dm.fraction <- data.mat[, ".fraction"]                                    ## 161212
  
#51:
##define [[table.freq()]]:##
table.freq <- function(DM.DF, freq = ".fraction"){ # 161214
  # DM.DF :: data frame of a data set
  # freq  :: vector showing the frequencies of the observations of DM.DF
  #                 or name of column of DM.DF of frequencies
  # uses: expand.table.short
  # pw 161213
  freq.name <- if( length(freq) == 1 ) freq else "no freq col"
  # extract frequencies from DM.DF
  if( freq.name %in% colnames(DM.DF) ){ 
    freq <- DM.DF[, freq.name]
    DM.DF <- DM.DF[, colnames(DM.DF) != freq.name, drop = FALSE ]
  } 
  if( length(freq) == 1 ) freq <- rep(1, length(DM.DF[,1]))
  # construct empty table DM.TABLE from data frame
  if( all(0 == ( freq %% 1)) ) return(table(DM.DF))  
  DM.TABLE <- do.call(table, DM.DF) * 0
  # find all combinations of levels
  level.comb <- cbind(expand.table.short(1 + DM.TABLE))
  # initialize new fraction vector
  counts2 <- rep(0, length(level.comb[,1]))
  # clear but to slow: 
  # for all rows of DM.DF do 
  #   find combination of levels that matches with row of data frame by:
  #   for all combinations of levels compare them with row of data frame
  #     if found add fraction of line i to frac.vec[ii]
  # counts <- rep(0, length(level.comb[,1]))
  # for(i in seq( along = DM.DF[,1])){
  #   for( ii in seq(along = level.comb[,1]) ){    
  #     if( any( DM.DF[i,] != level.comb[ii,] ) ) next
  #     counts[ii] <- counts[ii] + freq[i]; break
  #   }
  # }  # .. cat("DIFF", sum(counts- counts2))
  h.dmdf <- sapply(split(unlist(DM.DF),      row(DM.DF)),      paste, collapse = "|")
  h.lvlc <- sapply(split(unlist(level.comb), row(level.comb)), paste, collapse = "|")
  where <- match(h.dmdf, h.lvlc)
  for(i in 1:length(DM.DF[,1])) counts2[ where[i] ] <- counts2[ where[i] ] + freq[i]
  DM.TABLE <- DM.TABLE + counts2
  return( DM.TABLE ) 
}
##:define [[table.freq()]]##
#:51
  DM.TABLE.FREQ <- table.freq(dm.df, dm.fraction)                             ## 161213
## print(data.mat[ data.mat[, ".fraction"] < 1,])                             ## 161212
## DM.TABLE <<- dm.table; DM.DF <<- dm.df; FRAC <<- data.mat[ , ".fraction" ] ## 161213
## print(dm.table); print(dm.df)
  # set xmin, xmax, ymin, ymax in case of grouping 
  
#55:
##find x and y ranges in case of grouping by x or y:##
# according data type we choose ranges for x 
#53:
##set variables [[panel.adjust]] and [[panel.space.factor]]:##
panel.adjust       <- c(panel.adjust,       panel.adjust)   [1:2] 
panel.space.factor <- c(panel.space.factor, panel.space.factor)[1:2]
##:set variables [[panel.adjust]] and [[panel.space.factor]]##
#:53
if( 0 < length(grp.x) ){
  idx <- match(grp.x[1], names(dm.df))
  if(is.factor(h <- dm.df[[ idx ]])) { 
    xmin <- 1; xmax <- 1 + length(levels(h)) 
    xmin <- xmin - panel.adjust[1]
    xmax <- xmax - panel.adjust[1] 
  } else {
    hh <- panel.space.factor[1] * 0.5 * (max(h) - min(h))
    xmin <- min(h) - hh * 2 *      panel.adjust[1]
    xmax <- max(h) + hh * 2 * (1 - panel.adjust[1])
  }
}
##:find x and y ranges in case of grouping by x or y##
#:55
#56:
##find x and y ranges in case of grouping by x or y:##
# according data type we choose ranges for y
if( 0 < length(grp.y) ){
  idy <- match(grp.y[1], names(dm.df))
  if(is.factor(h <- dm.df[[ idy ]])) { 
    ymin <- 1; ymax <- 1 + length(levels(h))
    ymin <- ymin - panel.adjust[2]
    ymax <- ymax - panel.adjust[2] 
  } else {
    hh <- panel.space.factor[2] * 0.5 * (max(h) - min(h))
    ymin <- min(h) - hh * 2 *      panel.adjust[2]
    ymax <- max(h) + hh * 2 * (1 - panel.adjust[2])
  }
}
##:find x and y ranges in case of grouping by x or y##
#:56
 
  
#57:
##build job matrix jobs:##
if(verbose) cat("build job matrix") # initialize job matrix
jobs <- cbind(xmins = xmin, xmaxs = xmax, ymins = ymin, ymaxs = ymax) 
##:build job matrix jobs##
#:57
#58:
##build job matrix jobs:##
# find intervals for each of the x-grouping variables
panel.prop.to.size <- rep(panel.prop.to.size, 2)
if(0 < length(grp.x)){
  for(iv in seq(along=grp.x)){ # find new x partitions
    jobs.new <- NULL           # initialize new job matrix
    idx <- match(grp.x[iv], names(dm.df))
    if(0 < panel.prop.to.size[1]){
      ## freq.x <- margin.table(dm.table,1:iv)
      freq.x <- margin.table(DM.TABLE.FREQ,1:iv)                     # 161213
      d.freq.x <- dim(freq.x); l.d.freq.x <- length(d.freq.x)
       freq.x <- aperm(freq.x, l.d.freq.x:1)
       freq.x <- array(freq.x, c(d.freq.x[l.d.freq.x],prod(d.freq.x[-l.d.freq.x])))
    } else freq.x <- rbind(rep(dim(dm.table)[idx], nrow(jobs)))
    for( no in 1:nrow(jobs) ){ 
      # find intervals basing on the limits of big x-interval
      xints <- find.n.intervals( freq.x[,no], props = panel.prop.to.size[1], 
                                 jobs[no, 1], jobs[no, 2], 
                                 panel.space.factor[1] ) 
      XINTS <- c(XINTS, 
                 list(cbind(iv, rbind(xints[,c("mins", "maxs", "mids")]))))
      # add y coordinates to the new intervals found by "find.n.intervals"
      jobs.new <- rbind(jobs.new, 
                        cbind(xints[, c("mins", "maxs"), drop = FALSE],
                              jobs[no, 3], jobs[no, 4]))
    }
    jobs <- jobs.new     # store new job matrix in jobs
  } 
}
n.s <- dim(jobs)[1]
##:build job matrix jobs##
#:58
#59:
##build job matrix jobs:##
# find intervals for each of the y-grouping variables
if(0 < length(grp.y)){
  for(iv in seq(along=grp.y)){ # refine y range(s)
    jobs.new <- NULL     # initialize new job matrix
    idy <- match(grp.y[iv], names(dm.df))
    # print("HALLO"); print(dm.table) # 161212
    if(0 < panel.prop.to.size[2]){
      # freq.y <- margin.table(dm.table,(length(grp.x)+1):(length(grp.x)+iv))
      freq.y <- margin.table(DM.TABLE.FREQ,(length(grp.x)+1):(length(grp.x)+iv))
      d.freq.y <- dim(freq.y); l.d.freq.y <- length(d.freq.y)
      freq.y <- aperm(freq.y, l.d.freq.y:1)
      # print(freq.y) # 161212
      freq.y <- array(freq.y, c(d.freq.y[l.d.freq.y],prod(d.freq.y[-l.d.freq.y])))
    } else freq.y <- rbind(rep(dim(dm.table)[idy], nrow(jobs)))
    for( no in 1:nrow(jobs) ){ 
      yints <- find.n.intervals(freq.y[, 1 + ((no-1) %% dim(freq.y)[2])],
                                props = panel.prop.to.size[2], 
                                jobs[no, 3], jobs[no, 4],
                                panel.space.factor[2] )
      YINTS <- c(YINTS, 
                 list(cbind(iv, rbind(yints[,c("mins", "maxs", "mids")]))))
      jobs.new <- rbind(jobs.new, 
                        cbind(jobs[no,1], jobs[no,2], 
                              yints[, c("mins", "maxs"), drop = FALSE]))
    }
    jobs <- jobs.new     # store new job matrix in jobs
  } 
} #; cat("jobs"); print(head(jobs))
n.z <- dim(jobs)[1]/n.s
##:build job matrix jobs##
#:59
  colnames(jobs) <- c("xmins", "xmaxs", "ymins", "ymaxs")
} else {                                           # one job only:
  dm.df <- data.frame(rep(1, nrow(data.mat)))
  dm.table <- table(dm.df)  
  jobs <- cbind(xmins = xmin, xmaxs = xmax, ymins = ymin, ymaxs = ymax)
} # cat("jobs:"); print(jobs)
##:construct jobs by panel packer##
#:50
#61:
##link jobs to entries of the data matrix:##
if(verbose) cat("link jobs to data matrix by icons packer")
# find job number of each of the items and of each of the jobs of jobs
# step 1: find levels of xy grouping variables
levs <- dimnames(dm.table) #; cat("levs"); print(levs)
##:link jobs to entries of the data matrix##
#:61
#62:
##link jobs to entries of the data matrix:##
# step 2: find job.no of jobs of job matrix by restructing the row indices 
n.levs <- unlist(lapply(levs, length))          #; cat("n.levs", n.levs)
job.no.table <- array(seq(nrow(jobs)), n.levs)  # == 1:prod(n.levs)
if( 0 < length(job.no.table) ){
  job.no.table <- aperm(job.no.table,       rev(seq(along=n.levs)))
  counts       <- as.vector(aperm(dm.table, rev(seq(along=n.levs))))
} else { job.no.table <- 1; counts <- 0 } 
jobs <- cbind(jobs, .job.no = as.vector(job.no.table), counts = counts)
#; print(jobs)
z <- 1 + floor( (0:( n.s * n.z - 1 )) / n.s); z <- n.z + 1 - z
s <- 1 + ( 0:( n.s * n.z - 1) ) %% n.s
z <- as.vector(t(matrix(z, n.s, n.z)))
s <- as.vector(t(matrix(s, n.s, n.z)))
jobs <- cbind(jobs, "row" = z, "col" = s)
##:link jobs to entries of the data matrix##
#:62
#63:
##link jobs to entries of the data matrix:##
# step 3: find values of variables in level vectors and store position
pos.mat <- dm.df
for( co in seq(length(dm.df)) ){
  values <- dm.df[, co] # values <-> levels comparison
  pos.mat[,co] <- match(values, levs[[co]])
} 
##:link jobs to entries of the data matrix##
#:63
#64:
##link jobs to entries of the data matrix:##
# step 4: find job number of an item by recoding position infos
code <- cumprod(c(1, dim(dm.table)[ -length(dim(dm.table)) ]))
job.of.item <- apply(pos.mat, 1, function(it) 1 + sum((it - 1) * code))
if( 0 == length(job.of.item) ) job.of.item <- 1
data.mat <- cbind(data.mat, .job.no = job.of.item) 
##:link jobs to entries of the data matrix##
#:64
#93:
##construct raw plot and set graphics parameter:##
# find over all extrems of panels -----------------------------------
panel.margin <- rep(panel.margin,4)[1:4]
h <- if(!exists("XINTS")){
       c(min(jobs[, 1]), max(jobs[, 2]))
     } else {
       range(XINTS[[1]][, -1])
     }
xmin <- h[1] - panel.margin[2] * diff(h)
xmax <- h[2] + panel.margin[4] * diff(h)
h <- if(!exists("YINTS")){
       c(min(jobs[, 3]), max(jobs[, 4]))
     } else {
       range(YINTS[[1]][, -1])
     }
ymin <- h[1] - panel.margin[1] * diff(h)
ymax <- h[2] + panel.margin[3] * diff(h)
##:construct raw plot and set graphics parameter##
#:93
#94:
##construct raw plot and set graphics parameter:##
x.lab.side <- y.lab.side <- 0 # ; x.lab.side <- 1; y.lab.side <- 2
lab.side <- unlist(strsplit(lab.side,""))
if("b" %in% lab.side) x.lab.side <- 1; if("l" %in% lab.side) y.lab.side <- 2
if("t" %in% lab.side) x.lab.side <- 3; if("r" %in% lab.side) y.lab.side <- 4
##:construct raw plot and set graphics parameter##
#:94
#95:
##construct raw plot and set graphics parameter:##
# set inner margin and initialize raw plot --------------------------
oldpar <- par(no.readonly = TRUE) # 161012
not.save <- c("fig", "fin", "mfcol", "mfg", "mfrow", "oma", "omd", "omi")
idx <- ! (names(oldpar) %in% not.save)
oldpar <- oldpar[idx] # 161202
par(mar=mar)
plot(NULL, xlim = c(xmin, xmax), ylim = c(ymin, ymax),
     xlab="", ylab="", axes=FALSE)
par(usr = c(xmin, xmax, ymin, ymax))
# margin management needs some graphics parameters
pin <- par()$pin; cin <- par()$cin
##:construct raw plot and set graphics parameter##
#:95
#97:
##construct raw plot and set graphics parameter:##
# initialization of some variables
delta.rot <- lab.mar1 <- cols.icons.mar <- 0
legend.n.limit <- lab.n.max[3]    # limit legend up to 20
# number of color legend labels to great => number of labels to skip between two labels
legend.color.skip <- ceiling(length(colors) / legend.n.limit) - 1
# resulting number of color labels
legend.n.color <- ceiling(length(colors) / (1 + legend.color.skip))
legend.labels <- c(lev.color, lev.pic)
l.w <- max(strwidth (legend.labels, units = "inches")) / cin[2] # unit: lines
l.h <- max(strheight(legend.labels, units = "inches")) / cin[2] # unit: lines
# find inch height of a character
y.per.row.in <- cin[2] * lab.cex * 1.1          # slightly greater for savety  
##:construct raw plot and set graphics parameter##
#:97
#98:
##construct raw plot and set graphics parameter:##
# margin for var x labeling in lines: bottom or top -------------------------
lab.type <- if( substring(lab.type,1,1) == "c" ) "compact" else "expanded"
if( 0 < length(grp.x) ){
  if(lab.type != "compact"){ lab.mar1 <- length(grp.x) * 3 + 1 } else {
                             lab.mar1 <- length(grp.x) * 1 + 1 + 1 }
} # check whether legends are needed and length doesn't exceed legend.n.limit:
color.legend.ok <- 0 < length(grp.color) && 1 < length(colors)                  # CCL
pic.legend.ok   <- 0 < length(grp.icon)   && pic.legend.ok  && 
                   (!identical(icons[[1]],0)) && length(icons) <= legend.n.limit
# compute [[cols.icons.mar]]:  margin in text lines to be needed for legends
if(color.legend.ok || pic.legend.ok){ #               compute cols.icons.mar    
  if( lab.legend == "cols" ){ # legend vertical below plot: 1+number of items
    cols.icons.mar <- 1 + max( legend.n.color * color.legend.ok,                # CCL
                              length(icons)   * pic.legend.ok )
  }
  if( lab.legend %in% c("rows", "skewed", "horizontal") ){  # legend parallel
    
#99:
##compute [[delta.rot]] and [[cols.icons.mar]] for rotated legend texts:##
# additional space needed by rotation of label texts
if( lab.legend == "rows" ) # case 2: 2 lines: labels and var names per legend 
  cols.icons.mar <- 2 * (color.legend.ok + pic.legend.ok)
if( lab.legend == "skewed" ){ # case 3: 1 line for symbols per legend 
  delta.rot <- l.w * 0.7071 + l.h * 0.7071 # width*sin(pi/4)*height*cos(pi/4)
  delta.rot <- delta.rot - .2 - 1 # height -.2 space - 1 space of var name
  delta.rot <- max( 0, delta.rot) * 1.1 # to increase space a little bit
  cols.icons.mar <- (2 + delta.rot) * (color.legend.ok + pic.legend.ok) 
}
if( lab.legend == "horizontal" ){ # case 4: 1 line for symbols per legend 
  delta.rot <- l.w + 1 - 1 # string width + 1 space - 1 space of var name # 0.5 space
  delta.rot <- max( 0, delta.rot) 
  cols.icons.mar <- 2 + delta.rot
}
##:compute [[delta.rot]] and [[cols.icons.mar]] for rotated legend texts##
#:99
  
  }
  if( lab.legend == "vertical" ) "relax"                    # nothing to do
} # space for subtitle in cols.icons.mar in lines: 
space.sub <- if( x.lab.side == 3 ) space.sub <- 1.5 else 0
##:construct raw plot and set graphics parameter##
#:98
#100:
##construct raw plot and set graphics parameter:##
# y-space in inches = number of rows * height of row in inches
lab.mar1.in      <- lab.mar1      * y.per.row.in # margin labels (grp.x)
cols.icons.mar.in <- cols.icons.mar * y.per.row.in # margin legend
space.sub.in     <- space.sub     * y.per.row.in # margin subtitle
# mar in inches
mar1.in <- mar[1] * cin[2]    # additional margin bottom
mar3.in <- mar[3] * cin[2]    # additional margin top
# space for plotting: viewport in inches
# viewport.in   <- y-space for plot - margins - subtitle-space
viewport1.in    <- pin[2] - mar1.in - mar3.in - cols.icons.mar.in + 
                          - lab.mar1.in - space.sub.in
# factor to transform inches to user coordinates: (range of y)/(viewport.in)
fac.in.usr <- (ymax - ymin) / viewport1.in
# y-space in user coordinates
y.lab.mar1      <- lab.mar1.in      * fac.in.usr # margin labels (grp.x)
y.cols.icons.mar <- cols.icons.mar.in * fac.in.usr # margin legend
y.space.sub     <- space.sub.in     * fac.in.usr # margin subtitle
y.mar1          <- mar1.in          * fac.in.usr # additional margin
y.mar3          <- mar3.in          * fac.in.usr # additional margin
y.delta.rot     <- (delta.rot * y.per.row.in) * fac.in.usr
##:construct raw plot and set graphics parameter##
#:100
#101:
##construct raw plot and set graphics parameter:##
# (left or right) margin for var y labeling: left or right  
lab.mar2 <- 0 # space in lines used for labels left or right
if( 0 < length(grp.y) ){
  if(lab.type != "compact"){ lab.mar2 <- length(grp.y) * 3 + 1 } else {
                             lab.mar2 <- length(grp.y) + 1 }
}
x.per.row.in <- y.per.row.in # find inch height of a rotated character   
#        number of rows * height of row = margin in inches
lab.mar2.in <- lab.mar2 * x.per.row.in  
if( lab.legend == "vertical" ){ # have the legend occur on the right side?
  legend.right.in <- (l.w + 1) * cin[2] * lab.cex + 1 * x.per.row.in
  legend.right.in <- max(legend.right.in, strwidth(c(grp.icon.o, grp.color.o), 
                            units = "inches") * lab.cex - 0.5 * x.per.row.in)
} else legend.right.in <- 0
mar2.in <- mar[2] * cin[2]; mar4.in <- mar[4] * cin[2] 
viewport2.in <- (pin[1] - mar2.in - mar4.in - lab.mar2.in - legend.right.in)
fac.in.usr2 <- (xmax - xmin) / viewport2.in
# margin in usr (margin in inch) * fac.in.usr2
x.lab.mar2 <- lab.mar2.in * fac.in.usr2
x.legend.right <- legend.right.in * fac.in.usr2
x.mar2 <- mar2.in * fac.in.usr2; x.mar4 <- mar4.in * fac.in.usr2
##:construct raw plot and set graphics parameter##
#:101
#102:
##construct raw plot and set graphics parameter:##
# compute and set over all extremes 
gxmin <- xmin; gxmax <- xmax; gymin <- ymin; gymax <- ymax 
gymin <- gymin - y.mar1 - y.cols.icons.mar - y.space.sub
gymax <- gymax + y.mar3
gxmin <- gxmin - x.mar2             
gxmax <- gxmax + x.mar4 + x.legend.right
if(x.lab.side==1) gymin <- gymin - y.lab.mar1
if(x.lab.side==3) gymax <- gymax + y.lab.mar1
if(y.lab.side==2) gxmin <- gxmin - x.lab.mar2
if(y.lab.side==4) gxmax <- gxmax + x.lab.mar2
par(usr = c(gxmin, gxmax, gymin, gymax)) 
# get some graphics parameter that will be used later
mar <- par()$mar; mai <- par()$mai; usr <- par()$usr
pin <- par()$pin; cxy <- par()$cxy
# compute size of characters for text lines at the top or bottom side
y.per.row <- size.mm.to.usr(y.per.row.in * 25.4, FALSE) 
# compute size of characters left or right of vertical lines
x.per.row <- size.mm.to.usr(x.per.row.in * 25.4, TRUE ) 
##:construct raw plot and set graphics parameter##
#:102
if("icons" %in% packer){     
  
#82:
##pack icons by icons packer:##
if(verbose) cat("pack icons")
#114:
##find graphics parameters:##
# args <- list(...) # in (7) # 170612
if(any(h <- (!(names(args) %in% c("cex")))) ) 
  cat("Remark: '...'-arguments found:", paste(names(args)[h], collapse = " "), "\n")
cex.local <- if( "cex" %in% names(args) ) args$cex else 1 # 161012
##:find graphics parameters##
#:114
#68:
##find general pic parameter dependent on scaling case:##
#72:
##compute some general variables for finding the x.y.coordinates:##
panel.size <- cbind(x = jobs[, 2] - jobs[, 1], y = jobs[, 4] - jobs[, 3])
# if(!panel.prop.to.size) panel.size <- panel.size[1,,drop=FALSE]
panel.size.mm <- cbind(size.usr.to.mm(panel.size[,1], horizontal = TRUE),
                       size.usr.to.mm(panel.size[,2], horizontal = FALSE))
panel.size.mm[] <- ifelse(panel.size.mm[] < 1, 1, panel.size.mm[]) 
n.max <- max(dm.table)
if(any(0 < panel.prop.to.size)) n.max <- jobs[, "counts"] 
icon.space.factor <- c(icon.space.factor, icon.space.factor)[1:2]
# show.obj(panel.size); show.obj(panel.size.mm)
# show.obj(n.max); print(dm.table); # show.obj(icon.space.factor)
##:compute some general variables for finding the x.y.coordinates##
#:72
if( is.na(icon.aspect) ){ 
#79:
##try to compute asp by mean(icons.asp):##
if( !missing(icons )){ 
  if( !(is.numeric(icons) && is.vector(icons)) && 
      !is.function(icons[[1]]) ){ # should be a list
    if( !is.list(icons) ) icons <- list(icons)  # to be shure here
    if( 0 < length(icons) && is.matrix(icons[[1]])){
      d <- unlist(lapply(icons, function(x) dim(x)))
      d <- matrix(d, nrow = 2)
      icon.aspect <- mean(d[2,])/ mean(d[1,]) 
    }             # mean width / mean height
  }
}
##:try to compute asp by mean(icons.asp)##
#:79
 }
## case 1: ------------------------------ icon.cex defined: size of icons fix
if( !is.na(icon.cex)){                   if(verbose) cat("scaling case 1")
  if( is.na(icon.aspect) ) icon.aspect <- 1
  if( is.na(icon.stack.len) ){ 
    
#73:
##case 1: compute icon.stack.len by panel size and icon.cex:##
if(verbose) cat("scaling case 1")
div.factor <- (1 - icon.space.factor[2 - icon.horizontal]) * 
              (if(icon.horizontal) 1 else icon.aspect)
pic.extension.mm <- icon.cex / div.factor
panel.extension.mm <- panel.size.mm[, 2 - icon.horizontal] #  is vector
icon.stack.len <- pmax(1, floor(panel.extension.mm / pic.extension.mm))
# print(jobs)
# show.obj(panel.extension.mm); show.obj(pic.extension.mm)
# show.obj(icon.stack.len)
##:case 1: compute icon.stack.len by panel size and icon.cex##
#:73
  }
  n.stacks <- ceiling(n.max / icon.stack.len)
}
##:find general pic parameter dependent on scaling case##
#:68
#69:
##find general pic parameter dependent on scaling case:##
## case 2: ---- icon.cex undefined and icon.aspect defined:
##              size of icons scalable
if( is.na(icon.cex) && !is.na(icon.aspect) ){ 
  if(verbose) cat("scaling case 2")
  if( !is.na(icon.stack.len) ){ #   icon.stack.len defined
    n.stacks <- ceiling(n.max / icon.stack.len) 
    
#75:
##case 2: compute icon.cex by icon.stack.len and n.stacks:##
if(verbose) cat("case 2 -- not optim")
if(icon.horizontal){ # find icon.cex for x and y direction 
  cex.raw <- min(a1 <- panel.size.mm[, 1] / icon.stack.len, 
                 a2 <- panel.size.mm[, 2] / n.stacks     * icon.aspect
                       * (1 - icon.space.factor[2]) / (1 - icon.space.factor[1]))
} else {
  cex.raw <- min(panel.size.mm[, 2] / icon.stack.len      * icon.aspect
                       * (1 - icon.space.factor[2]) / (1 - icon.space.factor[1]),
                 panel.size.mm[, 1] / n.stacks)
}
icon.cex <- cex.raw * (1 - icon.space.factor[1])
##:case 2: compute icon.cex by icon.stack.len and n.stacks##
#:75
  } else { #                      icon.stack.len undefined
    
#74:
##case 2: compute icon.cex, icon.stack.len and n.stacks by optimization:##
if(verbose) cat("case 2 optim")
panel.size.mm[] <- ifelse(panel.size.mm[] < 1, 1, panel.size.mm[])
# ----- find initial icon.stack.len -----
if(icon.horizontal){                  # floor is more save than ceiling!
  icon.stack.len <- floor( sqrt( panel.size.mm[, 1] / panel.size.mm[, 2] 
                     * (1 - icon.space.factor[1]) / (1 - icon.space.factor[2]) 
                     / icon.aspect * n.max ) )
} else {
  icon.stack.len <- floor( sqrt( panel.size.mm[, 2] / panel.size.mm[, 1] 
                     * (1 - icon.space.factor[2]) / (1 - icon.space.factor[1]) 
                     * icon.aspect * n.max ) )
}
icon.stack.len <- pmax(1, icon.stack.len)
# ----- find suitable cex.raw -----
# floor() may be suboptimal, therefore check some icon.stack.len++ 
cex.raw <- 0
for(i in 1:5){ # 160930 old solution by exchange 5 by 2
  icon.stack.len <- icon.stack.len + (1 < i)
  n.stacks <- ceiling(n.max / icon.stack.len)
  if(icon.horizontal){ # find icon.cex for x and y direction and their minima
    cex.raw1 <- pmin(panel.size.mm[, 1] / icon.stack.len, 
                     panel.size.mm[, 2] / n.stacks     * icon.aspect 
                     * (1 - icon.space.factor[2]) / (1 - icon.space.factor[1])) 
  } else {
    cex.raw1 <- pmin(panel.size.mm[, 2] / icon.stack.len * icon.aspect
                     * (1 - icon.space.factor[2]) / (1 - icon.space.factor[1]),
                     panel.size.mm[, 1] / n.stacks)
  }
  cex.raw <- pmax(cex.raw, cex.raw1)
}
idx <- which.min(cex.raw)[1]  
icon.cex <- cex.raw[idx] * (1 - icon.space.factor[1]) * 0.999 # to be numerical safe
# ----- find final icon.stack.len -----
# now icon.cex is defined and icon.stack.len can be found as in case 1
#73:
##case 1: compute icon.stack.len by panel size and icon.cex:##
if(verbose) cat("scaling case 1")
div.factor <- (1 - icon.space.factor[2 - icon.horizontal]) * 
              (if(icon.horizontal) 1 else icon.aspect)
pic.extension.mm <- icon.cex / div.factor
panel.extension.mm <- panel.size.mm[, 2 - icon.horizontal] #  is vector
icon.stack.len <- pmax(1, floor(panel.extension.mm / pic.extension.mm))
# print(jobs)
# show.obj(panel.extension.mm); show.obj(pic.extension.mm)
# show.obj(icon.stack.len)
##:case 1: compute icon.stack.len by panel size and icon.cex##
#:73
n.stacks <- ceiling(n.max / icon.stack.len) 
if(verbose) cat("icon.cex", icon.cex, "idx", idx, icon.stack.len)
##:case 2: compute icon.cex, icon.stack.len and n.stacks by optimization##
#:74
  } 
}
##:find general pic parameter dependent on scaling case##
#:69
#70:
##find general pic parameter dependent on scaling case:##
## case 3: ------------------- icon.cex and icon.aspect undefined:
##                             x and y scalable
if( is.na(icon.cex) && is.na(icon.aspect) ){ 
  if(verbose) cat("scaling case 3")
  if( is.na(icon.stack.len) ) icon.stack.len <- pmax(1,n.max)
  n.stacks <- pmax(1,ceiling(n.max / icon.stack.len))
  
#76:
##case 3: compute icon.cex, asp:##
## cat("case 3")
if(icon.horizontal){ # find icon.cex for x and y direction 
  cex.raw   <- min(panel.size.mm[, 1]  / icon.stack.len)
  cex.y.raw <- min(panel.size.mm[, 2]  / n.stacks)
} else {
  cex.raw   <- min(panel.size.mm[, 1]  / n.stacks)
  cex.y.raw <- min(panel.size.mm[, 2]  / icon.stack.len)
}
icon.cex <- cex.raw * (1 - icon.space.factor[1])
icon.aspect  <- icon.cex / (cex.y.raw * (1 - icon.space.factor[2]))
##:case 3: compute icon.cex, asp##
#:76
}
##:find general pic parameter dependent on scaling case##
#:70
#83:
##compute x.y.coordinates according to space and panel.adjust:##
# step 1: find size of a standard picture element
dx.pic      <- size.mm.to.usr(icon.cex, horizontal = TRUE)  
dx.pic.area <- dx.pic / (1 - icon.space.factor[1]) 
dy.pic      <- size.mm.to.usr(icon.cex / icon.aspect, horizontal = FALSE)  
dy.pic.area <- dy.pic / (1 - icon.space.factor[2]) 
##:compute x.y.coordinates according to space and panel.adjust##
#:83
#84:
##compute x.y.coordinates according to space and panel.adjust:##
# step 2: loop over icons
sta.type <- icon.stack.type; job.plot.cmds <- NULL
data.mat <- cbind(data.mat, .x0 = 0, .y0 = 0, .x1 = 0, .y1 = 0)
data.mat <- data.frame(data.mat) #### !!!!!!!!!!!!!!!!!!!
for(no in seq(nrow(jobs))){
  idx <- data.mat[,".job.no"] == jobs[no,".job.no"] # find items of jobs.no
  if(1 < length(icon.stack.type)){ # if icon.stack.type is a vectir use one element
    sta.type <- icon.stack.type[1 + ((no-1) %% length(icon.stack.type))]
  } 
  sta.type <- unlist(strsplit(sta.type,""))
  if(any(idx)){                
    idx.icon.stack.len <- c(1,no)[1+(1 < length(icon.stack.len))]
    xy.color.icons <- place.icons(    # elements
          jobs[no,, drop = FALSE], 
          data.mat[idx, c(".icon", ".color", ".fraction"), drop = FALSE],
          icon.stack.type = sta.type,
          icon.stack.len = icon.stack.len[ idx.icon.stack.len ],
          frame = FALSE, verbose = verbose
    ) # verbose for debugging
    h <- list(xy.color.icons); names(h) <- as.character(jobs[,".job.no"][no])
    job.plot.cmds <- c(job.plot.cmds, h); h <- c(".x0",".y0",".x1",".y1")
    data.mat[idx, h] <- xy.color.icons[, h]
  } else { "create empty panel" }
}
idx <- 2 - icon.horizontal
h <- (dx.pic.area * cbind(icon.stack.len, n.stacks)[,idx]) >
     (panel.size[,1]*1.01); h <- h[!is.na(h)]
if( 0 < length(h) && any(h) ) 
      cat("WARNING: horizontal space of panels too small!\n")
h <- (dy.pic.area * cbind(n.stacks, icon.stack.len)[,idx]) >
     (panel.size[,2]*1.01); h <- h[!is.na(h)]
if( 0 < length(h) && any(h) ) 
      cat("WARNING: vertical space of panels too small!\n")
##:compute x.y.coordinates according to space and panel.adjust##
#:84
#106:
##execute plot statements of [[iconplot]]:##
#107:
##prepare set of pictograms for plotting: [[pic.tr.set]]:##
color.used <- if(0<length(grp.color)) unique(data.mat[,".color"]) else 1
pic.used   <- if(0<length(grp.icon))  unique(data.mat[,".icon"])  else 1
pic.tr.set <- NULL
if(is.numeric(icons) && !is.matrix(icons)) icons <- as.list(icons)
if(!is.list(icons)) icons <- list(icons)
for(ip in pic.used){ 
  pic <- NULL
  
#108:
##prepare [[pic]] for picture [[ip]]:##
if( is.matrix(icons[[ip]]) ){ # case: raster graphics of grey levels
  if(is.list(icon.grey.levels)){
    grey.levels <- icon.grey.levels[[ip]]
    if(is.null(grey.levels)) grey.levels <- icon.grey.levels[[1]]
  } else grey.levels <- icon.grey.levels 
  simple <- length(grey.levels) == 2 || 
            (length(grey.levels) == 1 && grey.levels <= 2)
  if( is.raster(icons[[ip]]) && # don't recolor if no grp.col and colors != 1:
      (!is.null(grp.color) || !identical(1, colors)) ) 
    icons[[ip]] <- raster.to.greys(icons[[ip]], grey.levels = grey.levels,
                    reduce = TRUE, n.icons = dim(data.mat)[1])
  for(icolor in color.used){ # don't recolor if no grp.col and colors != 1
    if( (!is.null(grp.color) || !identical(1, colors)) || 
        (is.numeric(icons[[ip]]) && 1 < max(icons[[ip]]))){ 
      p <- greys.to.col.pic(icons[[ip]], colors[icolor], 
                            set.black.and.white = 1.5, simple = simple)
    } else { p <- as.raster(icons[[ip]]) }
    pic <- c( pic, list( p ))
  } 
} 
if( is.numeric(icons[[ip]]) ){ # case of central symbols
  for(icolor in color.used)
    pic <- c( pic, list( c(icons[[ip]], colors[icolor]) ))
} 
if( is.function(icons[[ip]]) ){ # case of pic by generator function
  for(icolor in color.used){
    pic <- c(pic, list( c(icons[[ip]], colors[icolor]) ))
  }
}
if( is.character(icons[[ip]]) ){ # case element of set of icons to be used
  for(icolor in color.used){
    pic <- c( pic, list( c(icons[[ip]], colors[icolor]) ))
  }
} 
##:prepare [[pic]] for picture [[ip]]##
#:108
  pic.tr.set <- c( pic.tr.set, list(pic) )
}
##:prepare set of pictograms for plotting: [[pic.tr.set]]##
#:107
if(exists("job.plot.cmds")){
  for(i in seq(along=job.plot.cmds)){  pic.rect <- pic.color <- NULL
    cmds <- job.plot.cmds[[i]]; panel.no <- as.numeric(names(job.plot.cmds[i]))
    color.idx <- match(cmds$.color, color.used); pic.idx <- match(cmds$.pic, pic.used)
    for( pic.no in seq(along = cmds$.x0) ) { 
      pic <- pic.tr.set[[ pic.idx[pic.no] ]][[ color.idx[pic.no] ]]
      if(is.null(pic)) next
      if(is.raster(pic)){                     # case of raster graphics
        rasterImage(pic, cmds$.x0[pic.no], cmds$.y0[pic.no],
          cmds$.x1[pic.no], cmds$.y1[pic.no], interpolate = icon.draft) 
      } else {
        if( is.function( unlist( pic )[[1]] ) ){ # case generator >>fun<<
          
#352:
##generate icons by [[call.icon.generator()]]:##
pic <- unlist(pic); fn <- pic[[1]]; color <- pic[[2]]
dxy <- c(cmds$.x1[pic.no], cmds$.y1[pic.no]) - c(cmds$.x0[pic.no], cmds$.y0[pic.no])
idx <- which(data.mat[, ".job.no" ] == panel.no)[pic.no]
# additional infos for modifying
pic.args <- data.mat[idx, grp.design]; names(pic.args) <- NULL
# cat("==========="); print(grp.design); print(data.mat[idx, grp.design])
call.icon.generator(fn, xy = cbind(cmds$.x0[pic.no], cmds$.y0[pic.no]), dxy = dxy, 
                   color = color, pic.args = pic.args, ...)
##:generate icons by [[call.icon.generator()]]##
#:352
        } else {
          if( !(substring(unlist( pic )[1],1,1) %in% 0:9) ){# case generator >>name<<
            
#352:
##generate icons by [[call.icon.generator()]]:##
pic <- unlist(pic); fn <- pic[[1]]; color <- pic[[2]]
dxy <- c(cmds$.x1[pic.no], cmds$.y1[pic.no]) - c(cmds$.x0[pic.no], cmds$.y0[pic.no])
idx <- which(data.mat[, ".job.no" ] == panel.no)[pic.no]
# additional infos for modifying
pic.args <- data.mat[idx, grp.design]; names(pic.args) <- NULL
# cat("==========="); print(grp.design); print(data.mat[idx, grp.design])
call.icon.generator(fn, xy = cbind(cmds$.x0[pic.no], cmds$.y0[pic.no]), dxy = dxy, 
                   color = color, pic.args = pic.args, ...)
##:generate icons by [[call.icon.generator()]]##
#:352
           
          } else {                            #  case central symbol
            pic <- unlist(pic); pic.color <- c(pic.color, pic[2])
            pic.rect <- rbind(pic.rect,c(cmds$.x0[pic.no], cmds$.y0[pic.no],
              cmds$.x1[pic.no], cmds$.y1[pic.no], as.numeric(pic[1]))) 
          }
        }
      }
      if(icon.frame) rect(cmds$.x0[pic.no], cmds$.y0[pic.no],
                         cmds$.x1[pic.no], cmds$.y1[pic.no])
    }
    
#113:
##plot rectangles or symbols:##
if( 0 < length(pic.rect) ){ # plot boxes instead of raster images
  rect(pic.rect[,1],pic.rect[,2],pic.rect[,3],pic.rect[,4], 
       border = if(icon.frame) NULL else NA,
       col = ifelse( 0 == pic.rect[,5], pic.color, "white" ) )
  h <- abs( (pic.rect[,1] - pic.rect[,3]) / (pic.rect[,2] - pic.rect[,4] ))/
      icon.aspect * fac.in.usr/fac.in.usr2                 # 161010
  h <- pmin(h, 1/h)^0.5 # resizing of fractional elements # 161010
  points( 0.5 * (pic.rect[,1] + pic.rect[,3]),      # characters instead boxes
          0.5 * (pic.rect[,2] + pic.rect[,4]), col = pic.color,
          pch = 1 + ((pic.rect[,5] - 1) %% 18), # maximal 18 symbols available
          cex = ifelse( 0 == pic.rect[,5], 0, icon.cex/3 * h) ) #161012
}
## cat("fac.in", fac.in.usr, fac.in.usr2)
##:plot rectangles or symbols##
#:113
  }
}
##:execute plot statements of [[iconplot]]##
#:106
##:pack icons by icons packer##
#:82
}
if("numbers" %in% packer || "panel.legend" %in% packer || 0 < length(panel.text)){  
  
#89:
##pack numbers, legends or texts into panels:##
if(verbose) cat("pack numbers or text into panels by packers")
# find text positions of panels
n <- nrow(jobs) #; print(data.mat); print(jobs[1:3,])
x0 <- 0.5 * (jobs[, 1] + jobs[, 2]) 
y0 <- 0.5 * (jobs[, 3] + jobs[, 4])
sta.type <- unlist(strsplit(icon.stack.type[1],""))
if("b" %in% sta.type) y0 <- jobs[, 4]
if("t" %in% sta.type) y0 <- jobs[, 3]
if("l" %in% sta.type) x0 <- jobs[, 2]
if("r" %in% sta.type) x0 <- jobs[, 1]
job.text.cmds <- cbind(.x0=x0, .y0=y0)
txt <- NULL
# compute of numbers of panels
if( "numbers" %in% packer ){ 
  n.job <- 0 * x0
  for(no in seq(nrow(jobs))){
    idx <- data.mat[, ".job.no"] == jobs[no, ".job.no"]
    n.job[no] <- round(sum(data.mat[idx, ".fraction"]), digits = 2)
  }
  txt <- n.job
}
if( 0 < length(panel.text) ){
  p.text <- c(as.vector(panel.text), rep("", n))[1:n]
  txt <- paste(p.text, txt)
} 
if( "panel.legend" %in% packer ){ 
# compose labels combination of panels
  p.text <- "X"
  for( i in seq(along = grp.y) ){ 
    h <- substring(levels(data.mat[ , grp.y[i] ]), 1, lab.n.max[1])
    p.text <- as.vector(t(outer(p.text, h, FUN = paste, sep = "*" )))
  }
  for( i in seq(along = grp.x) ){ 
    h <- substring(levels(data.mat[ , grp.x[i] ]), 1, lab.n.max[1])
    p.text <- as.vector(t(outer( p.text, h, FUN = paste, sep = "*" )))
  }
  p.text <- substring(p.text, 3) # p.text <- letters[1:n]
  txt <- paste(p.text, txt)
} 
panel.text <- txt
#116:
##execute text statements of [[iconplot]]:##
#114:
##find graphics parameters:##
# args <- list(...) # in (7) # 170612
if(any(h <- (!(names(args) %in% c("cex")))) ) 
  cat("Remark: '...'-arguments found:", paste(names(args)[h], collapse = " "), "\n")
cex.local <- if( "cex" %in% names(args) ) args$cex else 1 # 161012
##:find graphics parameters##
#:114
  # 161012
adj <- c(0.5, 0.5)
#if("b" %in% sta.type) adj[2] <- 1; if("t" %in% sta.type) adj[2] <- 0
#if("l" %in% sta.type) adj[1] <- 1; if("r" %in% sta.type) adj[1] <- 0
if("b" %in% sta.type) adj[2] <- 0.2; if("t" %in% sta.type) adj[2] <- 0.8
if("l" %in% sta.type) adj[1] <- 0.5; if("r" %in% sta.type) adj[1] <- 0.5
if(exists("job.text.cmds") && 0 < length(job.text.cmds) ){ # pack panel.text
  if( 0 < length(panel.text) ){
    text(job.text.cmds[,".x0"], job.text.cmds[,".y0"], panel.text, 
         cex = cex.local, adj = adj)
    job.text.cmds <- NULL
  }
}
##:execute text statements of [[iconplot]]##
#:116
##:pack numbers, legends or texts into panels##
#:89
}
if("stars" %in% packer){
 
#91:
##pack stars only:##
if(verbose) cat("pack stars by stars packer")
# number of jobs
n <- nrow(jobs) 
# mids of panels
x0 <- 0.5 * (jobs[, 1] + jobs[, 2]); y0 <- 0.5 * (jobs[, 3] + jobs[, 4])
# sizes of panels in x and y
mm.h <- size.usr.to.mm(jobs[, 2] - jobs[, 1], horizontal = TRUE)
mm.v <- size.usr.to.mm(jobs[, 4] - jobs[, 3], horizontal = FALSE)
# suitable length of line segments
mm <- min( mm.h, mm.v ) * 0.5
if( is.na(icon.cex) ) icon.cex <- 1
usr.h <- size.mm.to.usr(mm, horizontal = TRUE)  * icon.cex
usr.v <- size.mm.to.usr(mm, horizontal = FALSE) * icon.cex
sta.type <- unlist(strsplit(icon.stack.type[1],""))
if("b" %in% sta.type) y0 <- jobs[, 3] + usr.v
if("t" %in% sta.type) y0 <- jobs[, 4] - usr.v
if("l" %in% sta.type) x0 <- jobs[, 1] + usr.h
if("r" %in% sta.type) x0 <- jobs[, 2] - usr.h
pi2 <- 2 * pi; shrink <- 1 - icon.space.factor
for(no in seq(nrow(jobs))){
  # find elements of panel
  idx <- data.mat[, ".job.no"] == jobs[no, ".job.no"]
  # find fracs
  fracs <- rev(data.mat[idx, ".fraction"])
  # next if nothing to do
  if( (n <- length(fracs)) == 0) next
  # end points of line segments
  x <- sin(- pi2 * (1:n)/n) * usr.h * shrink * fracs + x0[no]  
  y <- cos(  pi2 * (1:n)/n) * usr.v * shrink * fracs + y0[no]
  # color of line segments
  color.idx <- data.mat[idx, ".color"]
  # plot cmds
  segments(rep(x0[no], n), rep(y0[no], n), x, y, col = colors[color.idx])
  points(x0[no], y0[no], col = "black", cex = 1)
}
##:pack stars only##
#:91
 
}
#110:
##finish plot:##
if(verbose) cat("finish pictogram plot")
if(panel.frame)
  rect(jobs[,"xmins"], jobs[,"ymins"], jobs[,"xmaxs"], jobs[,"ymaxs"]) 
#111:
##add title:##
if( missing(main) )
  main <- paste(if("icons" %in% packer) "iconplot of", data.call)
# if( nchar(main) > 75 ) main <- substring(main,1,75) # 160927
if( x.lab.side == 3 ){
  mtext( main, side = 1, line = -0.5, 
         cex = 1.4 * (lab.cex + (lab.cex < 0.4)) ) 
} else { 
  title( paste("\n", sep = "", main )) # 160927
} 
##:add title##
#:111
if( 0.4 <= lab.cex ){
  
#119:
##add x labels:##
lab.color <- c(lab.color, lab.color)[1:2]
if( !is.null(XINTS) && x.lab.side %in% c(1,3)){
  # create matrix of intervals of separation levels 0, 1, ..
  INTS <- c(list(rbind(c(0, xmin, xmax, .5*(xmin+xmax)))), unique(XINTS))
  INTS <- matrix(unlist(lapply(INTS, t)), nrow=4)
  rownames(INTS) <- c("no", "mins", "maxs", "mids")
  ix.set <- rev(seq(along=grp.x))
  for(ix in ix.set){ # loop for labels over variables
    
#120:
##put variable name and labels of levels of [[var ix]]:##
# get x positions -------------------------------------
var.name  <- grp.x[ix]                                   # var name of      no ix
x.prior   <- INTS["mids", INTS["no",]==ix-1, drop=FALSE] # pos of var name: no ix-1
x.current <- INTS["mids", INTS["no",]==ix,   drop=FALSE] # pos of labels:   no ix
x.1.2     <- INTS[2:3,    INTS[1,]   ==ix-1, drop=FALSE] # separation lines of ix-1 
##:put variable name and labels of levels of [[var ix]]##
#:120
#121:
##put variable name and labels of levels of [[var ix]]:##
# get y positions: find line numbers and transform them
if(lab.type != "compact"){
  line.no <- lab.mar1 - 3 * ix + 1
} else {
  line.no <- lab.mar1 - ix + 1 - 1 
}
b.t.idx <- 1 + (x.lab.side == 3)
p.p.idx <- 1 + (0 == lab.parallel[1]) #161007
fac.side  <- c(-1, 1)[b.t.idx]
y         <- c(ymin, ymax)[b.t.idx] + fac.side * y.per.row * line.no
y.size.box.h   <- 1.1 * y.per.row
y.pos.var.name <- y + fac.side * y.per.row * 0.5 
y.pos.levels   <- y - fac.side * y.per.row * 0.5 * c(1, .3)[p.p.idx]
# find adjustments -------------------------------------
adj.var.name <- c(0.5, 0.5) 
if( lab.type == "expanded" & lab.parallel[1] == 0 & 1 < ix )
  adj.var.name[1] <- 1.3 # new adjust to prevent overlapping
rotate.levels <- lab.parallel[1] == 0 | 
                (lab.parallel[1] == 0.5 & length(ix.set) == ix)
adj.levels   <- c(c(0.5, c(0.0,1)[b.t.idx])[1 + rotate.levels], 0.5) 
## cat("X: adj.levels", adj.levels, "    rotate.levels", rotate.levels)
##:put variable name and labels of levels of [[var ix]]##
#:121
#123:
##put variable name and labels of levels of [[var ix]]:##
# plot light boxes -------------------------------------
if(1 <= lab.boxes && ix <= length(grp.x))
   rect(x.1.2[1,],     col = lab.color[1], border = 0, xpd=NA,
        y + fac.side * y.size.box.h * (ix == 1 | lab.type != "compact"),
        x.1.2[2,], y - fac.side * y.size.box.h * (2 <= lab.boxes))
##:put variable name and labels of levels of [[var ix]]##
#:123
#124:
##put variable name and labels of levels of [[var ix]]:##
# plot separation line ---------------------------------
if(ix <= length(grp.x))
   segments(x.1.2[1,], y, x.1.2[2,], y, xpd=NA, col=lab.color[2],
            lwd = if( 0 == (lab.boxes %% 1) ) 1 else 10*(lab.boxes%%1))
##:put variable name and labels of levels of [[var ix]]##
#:124
#125:
##put variable name and labels of levels of [[var ix]]:##
# plot var names ---------------------------------------
if( 0 < length(var.name) && !is.na(var.name)  && 
    ( ix == 1 | lab.type != "compact") ){ 
   txt <- if( lab.type == "compact" ) 
             paste(grp.x.o, collapse = " * ") else grp.x.o[ix]
   text(txt, x = x.prior, y = y.pos.var.name, # col = 2+ix-1, 
        cex = lab.cex, adj = adj.var.name, xpd=NA) 
} 
##:put variable name and labels of levels of [[var ix]]##
#:125
#126:
##put variable name and labels of levels of [[var ix]]:##
# plot labels of levels --------------------------------
if( 0 < length(var.name) && !is.na(var.name) ){ # find labels of var name 
  if(is.factor(h <- data.mat[, var.name])) lev <- levels(h) 
  else                               lev <- sort(unique(h))
  idx <- seq(1, (h <- length(x.current)), by = max(1, ceiling(h/lab.n.max[2])))
  lev.h <- rep(lev, ceiling(h/length(lev))) ### lab.char.max
  lev.h <- substring(lev.h, 1, pmin(lab.n.max[1], nchar(lev.h)))
  text(lev.h[idx], x = x.current[idx], y = y.pos.levels, adj = adj.levels, 
       srt = 90 * rotate.levels, xpd=NA, cex = lab.cex) ## , col = "red")
  # points(x = x.current[idx], x = rep(y.pos.levels, length(idx)))
}   
##:put variable name and labels of levels of [[var ix]]##
#:126
  }
}
##:add x labels##
#:119
  
#129:
##add y labels:##
if(!is.null(YINTS) && y.lab.side %in% c(2,4)){
  # create matrix of intervals of separation levels 0, 1, ..
  INTS <- c(list(rbind(c(0, ymin, ymax, .5*(ymin+ymax)))), unique(YINTS))
  INTS <- matrix(unlist(lapply(INTS, t)), nrow=4)
  rownames(INTS) <- c("no", "mins", "maxs", "mids")
  iy.set <- rev(seq(along=grp.y))
  for(iy in iy.set) {         # loop over number of variables for labels
    
#130:
##put var name and levels on left or right margin of [[var iy]]:##
# get y positions --------------------------------------
var.name  <- grp.y[iy]                                   # var name of      no iy
y.prior   <- INTS["mids", INTS["no",]==iy-1, drop=FALSE] # pos of var name: no iy-1
y.current <- INTS["mids", INTS["no",]==iy,   drop=FALSE] # pos of labels:   no iy
y.1.2     <- INTS[2:3, INTS[1,]      ==iy-1, drop=FALSE] # separation lines of iy-1 
if(lab.type != "compact"){
  line.no <- lab.mar2 - 3 * iy + 1
} else {  line.no <- lab.mar2 - iy + 1 - 1 } #???
l.r.idx   <- 1 + (y.lab.side == 4)
p.p.idx   <- 1 + (0 == lab.parallel[2])
fac.side  <- c(-1, 1)[l.r.idx]
x         <- c(xmin, xmax)[l.r.idx] + fac.side * x.per.row * line.no
x.size.box.h   <- 1.1 * x.per.row
x.pos.var.name <- x + fac.side * x.per.row * 0.5 
x.pos.levels   <- x - fac.side * x.per.row * 0.5 * c(1, .3)[p.p.idx]
# adjustments -----------------------------------------
adj.var.name   <- c(0.5, 0.5) 
if( lab.type == "expanded" & lab.parallel[2] == 0 & 1 < iy )
  adj.var.name[1] <- 1.3 # new adjust to prevent overlapping
horizontal.levels <- lab.parallel[2] == 0 | 
                    (lab.parallel[2] == 0.5 & length(iy.set) == iy)
adj.levels   <- c(c(0.5, c(0.0,1)[l.r.idx])[1 + horizontal.levels], 0.5) 
##:put var name and levels on left or right margin of [[var iy]]##
#:130
#131:
##put var name and levels on left or right margin of [[var iy]]:##
# plot light boxes ------------------------------------
if( 1 <= lab.boxes && iy <= length(grp.y)) 
   rect(           x + fac.side * x.size.box.h * 
                             (lab.type != "compact" | iy == 1),
        y.1.2[1,], x - fac.side * x.size.box.h * (2 <= lab.boxes), 
        y.1.2[2,], col = lab.color[1], border = 0, xpd=NA)
# plot white separation line --------------------------
if(iy <= length(grp.y)) 
   segments(x, y.1.2[1,], x, y.1.2[2,], xpd=NA, col=lab.color[2],
            lwd = if( 0 == (lab.boxes %% 1) ) 1 else 10 * (lab.boxes %% 1))
# plot var names --------------------------------------
if( 0 < length(var.name) && !is.na(var.name) &&
    ( iy == 1 | lab.type != "compact") ){ 
   txt <- if( lab.type == "compact" ) 
             paste(grp.y.o, collapse = " * ") else grp.y.o[iy]
   text(txt, y = y.prior, x = x.pos.var.name, # col = 2+iy-1, 
        cex = lab.cex, adj = adj.var.name, xpd=NA, srt = 90) 
} 
# plot labels of levels -------------------------------              
if( 0 < length(var.name) && !is.na(var.name)){  # put labels of levels
  if(is.factor(h <- data.mat[, var.name])) lev <- levels(h) 
  else                               lev <- sort(unique(h))
  idx <- seq(1, (h <- length(y.current)), by = max(1, ceiling(h/lab.n.max[2])))
  lev.h <- rep(lev, ceiling(h/length(lev)))
  lev.h <- substring(lev.h, 1, pmin(lab.n.max[1], nchar(lev.h)))
  text(lev.h[idx], y = y.current[idx], x = x.pos.levels, adj = adj.levels, 
       srt = 90 - 90 * horizontal.levels, xpd=NA, cex = lab.cex) # col=2+iy-1, 
  # points(y = y.current[idx], x = rep(x.pos.levels, length(idx)))
}    
##:put var name and levels on left or right margin of [[var iy]]##
#:131
  }
}
##:add y labels##
#:129
  
#134:
##add cols and icons legends:##
y0 <- ymin - y.lab.mar1 - y.mar1 # labels bottom side
if(x.lab.side == 3) y0 <- ymin - y.mar1              # level top side 
x0 <- gxmin + 2 * x.per.row; dx <- x.per.row * .7; dy <- y.per.row * .7
if( lab.legend == "vertical" ){
  y0 <- ymax - y.per.row; x0 <- xmax + x.per.row
  if(y.lab.side == 4)     x0 <- x0 + x.lab.mar2 + 0.5 * dx 
}
##:add cols and icons legends##
#:134
#135:
##add cols and icons legends:##
if( lab.legend %in% c("cols", "vertical") ){  # pic legend upright to x 
  if( pic.legend.ok ){                    
    # icons legend in case of  "cols" or "vertical" --------------------
    text(x0 - x.per.row, y0 - 0.5 * y.per.row, adj = c(0,0), grp.icon.o, 
         cex = lab.cex, xpd = NA)
    y <- y0.label.line <- y0 - 0.5 * y.per.row  
    if(length(icons) <= legend.n.limit){ 
      for(i in seq(along=icons)){
        if( is.na(lev.pic[i]) ) next
        pic <- icons[[ i ]]; y  <- y  - y.per.row
        
#136:
##plot symbol for pic legend, not parallel case:##
if(is.matrix(pic)){ # no recoloring
  if(!is.null(grp.color) || !identical(1, colors))
    pic <- greys.to.col.pic(pic, "#555555", simple = simple)
  rasterImage(pic, x0, y, x0+dx, y+dy, interpolate = icon.draft, xpd = NA)
} else {
  if( is.function( unlist(pic) ) || is.character( unlist(pic) )){ # pic by function
    pic <- unlist(pic); fn <- pic
    dxy <- c(dx, dy)
     # call.icon.generator(fn, xy = cbind(x0, y), dxy = dxy, color = "darkgrey") #180312 :
     call.icon.generator(fn, xy = cbind(x0, y), dxy = dxy, color = "grey", pic.args = pic.args) 
  } else { 
    pic <- unlist(pic)
    points( 0.5*(x0 + (x0 + dx)), 0.5 * (y + (y + dy)), xpd =NA,
            cex = 1*lab.cex, pch = as.numeric(pic[1]), col = "black" )
  } 
}
##:plot symbol for pic legend, not parallel case##
#:136
        text(x0 + 1 * x.per.row, y, adj = c(0,0), lev.pic[i],
             cex = lab.cex, xpd = NA)
        if(icon.frame) rect(x0, y, x0 + dx, y + dy, xpd=NA)  
      }
    }
    if( lab.legend == "cols") x0 <- (gxmin + gxmax) / 2 + x.per.row
    if( lab.legend == "vertical") y0 <- y0 - (2 + length(icons)) * y.per.row  
  }
  
#137:
##add color legend, not parallel case:##
# color legend in case of  "cols" or "vertical" ------------------------------
if(0 < length(grp.color) && color.legend.ok ){                        # color legend 
  text(x0 - x.per.row, y0 - 0.5 * y.per.row, adj = c(0,0), grp.color.o, 
       cex = lab.cex, xpd = NA)
  y <- y0.label.line  <- y0 - 0.5 * y.per.row  
  if( length(colors) > legend.n.color ) ## CCL
    cat("Remark: some color legend labels skipped\n")    
  color.labels.idx.set <- seq(1, length(colors), by = legend.color.skip + 1)    # CCL
  for(i in seq(along=colors)) {
    y  <- y - y.per.row / (1 + legend.color.skip)
    rect(x0, y, x0 + dx, y + dy, col = colors[i], xpd=NA, border = NA)
    if( is.na(lev.color[i]) ) next
    if( i %in% color.labels.idx.set )                                           # CCL
      text(x0 + 1 * x.per.row, y, adj = c(0,0), lev.color[i], cex = lab.cex, xpd = NA)
    if(icon.frame) rect(x0, y, x0 + dx, y + dy, xpd=NA)  
  } 
}
##:add color legend, not parallel case##
#:137
}
##:add cols and icons legends##
#:135
#138:
##add cols and icons legends:##
if( lab.legend %in% c("rows", "skewed", "horizontal") ){ # legend parallel
  if( pic.legend.ok ){                                   # icons labels
    if(length(icons) <= legend.n.limit){ 
      text(x0 - x.per.row, y0 - 0.5 * y.per.row, grp.icon.o, cex = lab.cex, 
           adj = c(0, 0), xpd = NA )                             # variable name
      y0.label.line  <- y0 - (y.delta.rot + y.per.row) - 0.5 * y.per.row 
      res <- find.xlab.coor( lev.pic, y0.label.line )
      xr0 <- res[,"xr0"]; xr1 <- res[,"xr1"]
      yr0 <- res[,"yr0"]; yr1 <- res[,"yr1"]
      xlab <- res[,"xlab"]; ylab <- res[,"ylab"]
      for(i in seq(along=icons)) {
        if( is.na(lev.pic[i]) ) next
        pic <- icons[[ i ]]
        
#139:
##plot symbol for pic legend, parallel layout:##
if(is.matrix(pic)){
  pic <- greys.to.col.pic(pic, "#555555", simple = simple)
  rasterImage(pic, xr0[i], yr0[i], xr1[i], yr1[i], interpolate = icon.draft)
} else {
  if( is.function( unlist(pic) ) || is.character( unlist(pic) ) ){
    pic <- unlist(pic); fn <- pic
    dxy <- c(dx, dy)
     # call.icon.generator(fn, xy = cbind(xr0[i], yr0[i]), dxy=dxy, color = "darkgrey") #180312 :
     call.icon.generator(fn, xy = cbind(xr0[i], yr0[i]), dxy = dxy, color = "grey", 
                        pic.args = pic.args) 
  } else {
    pic <- unlist(pic)
    points( 0.5*(xr0[i] + xr1[i]), 0.5 * (yr0[i] + yr1[i]), cex = 1*lab.cex,
            pch = as.numeric(pic[1]), col = "black")
  }
}
##:plot symbol for pic legend, parallel layout##
#:139
      }
      if(icon.frame) rect(xr0, yr0,  xr1, yr1, xpd=NA) 
    }
    srt <- c(0, 45, 90)[ which( lab.legend == c("rows","skewed","horizontal")) ]
    text(xlab, ylab, adj = c(0,0), xpd = NA, lev.pic, cex = lab.cex, srt = srt )
    # increment of x0 and y0 in case of a color legend
    if( lab.legend == "rows")       y0 <- y0               - y.per.row * 2   
    if( lab.legend == "skewed")     y0 <- y0 - y.delta.rot - y.per.row * 2
    if( lab.legend == "horizontal") 
      x0 <- xr1[length(icons)] + (1 + nchar(grp.icon.o)/3) * x.per.row 
  }
  
#140:
##add color legend, parallel layout:##
# color legend in case of  "rows", "skewed" or "horizontal"
if(0 < length(grp.color) && color.legend.ok ){    # color labs
  text(x0 - x.per.row, y0 - 0.5 * y.per.row, grp.color.o, cex = lab.cex,
       adj = c(0, 0), xpd = NA )                        # variable name
  y0.label.line  <- y0 - (y.delta.rot + y.per.row) - 0.5 * y.per.row 
  idx <- seq(1, length(colors), by = legend.color.skip + 1) 
  if( lab.legend == "rows"){
    res <- find.xlab.coor( lev.color[idx], y0.label.line, skip = 0 )
    xr0 <- res[,"xr0"]; xr1 <- res[,"xr1"]; yr0 <- res[,"yr0"]; yr1 <- res[,"yr1"]
    xlab <- res[,"xlab"]; ylab <- res[,"ylab"]
    rect(xr0, yr0, xr1, yr1, col = colors[idx], xpd=NA, border = NA)
    srt <- c(0, 45, 90)[ which( lab.legend == c("rows", "skewed", "horizontal")) ]
    text(xlab, ylab, adj = c(0,0), xpd = NA, lev.color[idx], cex = lab.cex,
         srt = srt)
  } else {
    res <- find.xlab.coor( lev.color, y0.label.line, skip = legend.color.skip )
    xr0 <- res[,"xr0"]; xr1 <- res[,"xr1"]; yr0 <- res[,"yr0"]; yr1 <- res[,"yr1"]
    xlab <- res[,"xlab"]; ylab <- res[,"ylab"]
    rect(xr0, yr0, xr1, yr1, col = colors, xpd=NA, border = NA)
    srt <- c(0, 45, 90)[ which( lab.legend == c("rows", "skewed", "horizontal")) ]
    text(xlab[idx], ylab[idx], adj = c(0,0), xpd = NA, lev.color[idx], cex = lab.cex,
         srt = srt)
  }
  if(icon.frame) rect(xr0, yr0, xr1, yr1, xpd=NA) 
  if( length(colors) > legend.n.color ) 
    cat("Remark: some color legend labels skipped\n")    
} 
##:add color legend, parallel layout##
#:140
} 
##:add cols and icons legends##
#:138
#155:
##add cols and icons legends:##
if(verbose) text( usr[2], usr[3], arguments, adj = c(1,0), xpd=NA, cex = 0.7)
##:add cols and icons legends##
#:155
}
#150:
##reinstall graphics old parameter:##
newpar <- par(no.readonly = TRUE) 
par(oldpar)
##:reinstall graphics old parameter##
#:150
##:finish plot##
#:110
#151:
##construct output:##
jobs <- jobs[order(jobs[,"col"]),,drop = FALSE]
jobs <- jobs[order(jobs[,"row"]),,drop = FALSE]; rownames(jobs) <- NULL
invisible(list(jobs = jobs, data.mat = data.mat, newpar = newpar))
##:construct output##
#:151
##:body of [[iconplot]]##
#:8
}
#:2
##:define [[iconplot]]##

boxplot2D<-function( xy, add.to.plot=TRUE, box.size=10, box.shift=0, angle=0,
                angle.type="0", tukey.style=TRUE, coef.out=1.5, coef.h.out=3, design="sl",
                na.rm=FALSE, ... ){
##########################################################################
# boxplot for scatterplots, pw 03/05                                     #
# xy:          2-col matrix                                              #
# add.to.plot: if TRUE => plot(xy,...)                                   #
# box.size:    height of box in mm                                       #
# box.shift:   shift of boxplot in mm                                    #
# angle:       direction of projection in units defined by angle.type    #
# angle.type:  "0"=     angle    , # angle in (0,2*pi)                   #
#              "1"=2*pi*angle/12,  # clock-like                          #
#              "2"=2*pi*angle/360, # angle in (0,360)                    #
#              "3"=arctan(angle)   # by fraction: delta.y/delta.x        #
# tukey.style: if TRUE outliers are defined as described in Tukey (1977): EDA
# coef.out=1.5  # outliers are defined outside coef.out*boxwidth
# coef.h.out=3   # heavy outliers are defined outside coef.h.out*boxwidth
# design:      if "sl" then parallelogram else box                       #
##########################################################################
if(any(is.na(xy))){
  if(na.rm){ xy<-xy[!apply(is.na(xy),1,any),,drop=FALSE]
    print("Warning: NAs elements have been removed!!")
  }else{
    xy.means<-colMeans(xy,na.rm=TRUE)
    for(j in 1:ncol(xy)) xy[is.na(xy[,j]),j]<-xy.means[j]
    print("Warning: NAs elements have been exchanged by mean values!!")
  }  
}
if(!add.to.plot) plot(xy,...)

if(is.numeric(angle.type)){
  angle.type<-as.character(angle.type)
  if(all(angle.type!=c("0","1","2","3"))) angle.type<-"0"
}
w <- switch(angle.type, "0"=     angle, "1"=2*pi*(3-angle)/12,
                        "2"=2*pi*angle/360, "3"=atan(angle) )
TM <- matrix(c(cos(w),sin(w),-sin(w),cos(w)),2,2)

xyt<- xy %*% TM
##ermittle empirsche Quantile##=
z  <- xyt[,1]
if(tukey.style){
  z.stats1 <- boxplot.stats(z,coef=coef.out)
  z.stats2 <- boxplot.stats(z,coef=coef.h.out)
  z<-c(min(z),z.stats1$stats,max(z))
  names(z) <- c("min","fence","hinge","median","hinge","fence","max")
  outlier.heavy <- z.stats2$out
  outlier <- z.stats1$out
  outlier <- outlier[! outlier %in% outlier.heavy ]
}else{
  z  <-     c(min(z),quantile(z,c(0.10, 0.25, 0.5, 0.75, 0.90)),max(z))
  names(z)<-c("min",              ".1", ".25",".5",".75",".9", "max")
}
xy.q <- cbind(z,median(xyt[,2])) %*% t(TM)
if(tukey.style){
  xy.out<-if(0<length(outlier)) cbind(outlier,median(xyt[,2])) %*% t(TM) else numeric(0)
  xy.out.heavy<-if(0<length(outlier.heavy))
                                     cbind(outlier.heavy,median(xyt[,2])) %*% t(TM) else numeric(0)
}

# d. steht fuer delta.:
d.xy <-apply(xy.q[c(1,7),],           2,diff)
d.usr<-apply(matrix(par()$usr,2,2),2,diff)
d.pmm<-par()$pin*25.4
if(design=="sl"){
    # d.xy.s.mm: bzgl. Welt-coor senkrechten Vektor in mm-coor
    d.xy.s.mm <- (c(-1,1)*rev(d.xy))/d.usr*d.pmm
    # d.xy.0.s: bzgl. mm-coor senkrechten Einheits-Vektor
    d.xy.mm.s <- c(-1,1)*rev( d.xy/d.usr*d.pmm )
    d.xy.0.s  <- d.xy.mm.s/(d.xy.mm.s%*%d.xy.mm.s)^0.5
    # Streckung von d.xy.s.mm so, dass Projektion auf d.xy.0.s von Laenge 1
    d.xy.s.mm.proj1 <- d.xy.s.mm / (d.xy.s.mm %*% d.xy.0.s)
    # Boxsize: in mm
    real.step.mm <- box.size * d.xy.s.mm.proj1
    # Darstellung in Welt-coor
    real.step <- real.step.mm/d.pmm*d.usr

}else{
    # Einheitsvektor zu d.xy in mm-coor
    d.xy.mm   <- d.xy/d.usr*d.pmm
    d.xy.mm.ev<- d.xy.mm/(d.xy.mm%*%d.xy.mm)^0.5
    # Konstruktion eines Boxhoehenvektors der Laenge box.size in mm
    mm.step   <- box.size*c(-1,1)*rev(d.xy.mm.ev)
    # Darstellung in Welt-coor
    real.step <- mm.step/d.pmm*d.usr # real.step fuer Boxdickenvektor

}

# Boxshift: in mm
real.shift<-box.shift*real.step/box.size
xy.q.orig <- xy.q
xy.q      <-cbind(xy.q[,1]+real.shift[1], xy.q[,2]+real.shift[2])
if(tukey.style){
  if(0<length(xy.out)) xy.out<-cbind(xy.out[,1]+real.shift[1], xy.out[,2]+real.shift[2])
  if(0<length(xy.out.heavy))
            xy.out.heavy<-cbind(xy.out.heavy[,1]+real.shift[1], xy.out.heavy[,2]+real.shift[2])
}


# Boxplotkonstruktion
hs<-real.step/2
xyxy <-c(
          #min:xy.q[1,1]-hs[1],xy.q[1,2]-hs[2],xy.q[1,1]+hs[1],xy.q[1,2]+hs[2],
          xy.q[2,1]      ,xy.q[2,2]      ,xy.q[3,1]      ,xy.q[3,2]      ,
          xy.q[3,1]-hs[1],xy.q[3,2]-hs[2],xy.q[5,1]-hs[1],xy.q[5,2]-hs[2],
          xy.q[3,1]-hs[1],xy.q[3,2]-hs[2],xy.q[3,1]+hs[1],xy.q[3,2]+hs[2],
          xy.q[4,1]-hs[1],xy.q[4,2]-hs[2],xy.q[4,1]+hs[1],xy.q[4,2]+hs[2],
          xy.q[5,1]-hs[1],xy.q[5,2]-hs[2],xy.q[5,1]+hs[1],xy.q[5,2]+hs[2],
          xy.q[3,1]+hs[1],xy.q[3,2]+hs[2],xy.q[5,1]+hs[1],xy.q[5,2]+hs[2],
          xy.q[6,1]      ,xy.q[6,2]      ,xy.q[5,1]      ,xy.q[5,2]
          #max ,xy.q[7,1]-hs[1],xy.q[7,2]-hs[2],xy.q[7,1]+hs[1],xy.q[7,2]+hs[2]
        )
xyxy<-matrix(xyxy,length(xyxy)/4,4,TRUE)
segments(xyxy[,1],xyxy[,2],xyxy[,3],xyxy[,4])
if(tukey.style){
  if(0<length(xy.out)) points(xy.out[,1],xy.out[,2],pch=1,cex=1.5)
  if(0<length(xy.out)) points(xy.out[,1],xy.out[,2],pch=18)
  if(0<length(xy.out.heavy)) points(xy.out.heavy[,1],xy.out.heavy[,2],pch=19,cex=1.5)
}else{
  points(xy.q[c(1,7),1],xy.q[c(1,7),2],pch=19)
}
} # end of boxplot2D

slider.zoom.plot.ts<-function(x,n.windows=1,...)
{ 
 x.name<-deparse(substitute(x))
 if(missing(x)||length(x)<2) return("Error: x must be a vector")
 y<-x; if(is.ts(x)) { x<-time(x) } else { x<-seq(x) }

 args<-list(...)
 tmin<-1; tmax<-length(x)
 refresh<-function(...){
 # initialization
   width <- slider(no=1); tstart1 <- slider(no=2); tend1 <- width+tstart1
   if(n.windows>1){
     tstart2 <- slider(no=3); tend2 <- width+tstart2
   }
 # plot
   par(mfrow=c(2+(n.windows>1),1),mai=c(.5,0.5,.1,0))
   # plot(x,y,type="l",bty="n",xlab="",ylab="")
   do.call("plot",c(alist(x,y,type="l",bty="n"),args))
   abline(v=c(x[tstart1],x[tend1]),col="red")
   lines(x[tstart1:tend1],y[tstart1:tend1],col="red",lty=2)
   if(n.windows>1){
     abline(v=c(x[tstart2],x[tend2]),col="blue")
     lines(x[tstart2:tend2],y[tstart2:tend2],col="blue",lty=3)
   }
   usr<-par()$usr
   ind<-tstart1:tend1
   plot(x[ind],y[ind],type="b",col="red",bty="n", # ylim=usr[3:4],
        xlim=c(x[tstart1],x[tstart1]+width*diff(x[1:2])))
   if(n.windows>1){
   ind<-tstart2:tend2
     plot(x[ind],y[ind],type="b",col="blue",bty="n", # ylim=usr[3:4],
        xlim=c(x[tstart2],x[tstart2]+width*diff(x[1:2])))
   }
   par(mfrow=c(1,1))
 }
 if(n.windows<2){
   slider(refresh,c("width of window","start of window"),
          c(1,1),c(tmax,tmax),c(1,1),c(ceiling(tmax/4),1))
 }else{
   slider(refresh,
      c("width of window","start window 1","start window 2"),
      c(1,1,1),c(tmax,tmax,tmax),c(1,1,1),c(ceiling(tmax/4),1,ceiling(tmax/2)))
 }
 refresh() 
 cat("select window and look at time series!\n")
}

slider.stem.leaf<-function(x,main=main){
  main<-if(missing(main)) deparse(substitute(x)) else main
  slider(obj.name="main",
         obj.value=paste("stem and leaf of",main))
  slider(obj.name="rule.line",obj.value="Dixon")
  repl<-function(...){
    rule.line<-slider(obj.name="rule.line")
    main<-c(slider(obj.name="main"), paste("rule:", rule.line))
    cex<-slider(no=1); m<-slider(no=2)

    res<-if(m>0) stem.leaf(x,m=m,rule.line=rule.line) else 
                 stem.leaf(x,rule.line=rule.line)
    stem<-rev(res$stem); stem <- paste(rev(res$depth), stem, rev(res$leaves))

    # x.max<-max(nchar(res$stem));  y.max<-length(res$stem)
    x.max<-max(nchar(stem));  y.max<-length(stem) #140922

    opar<-par(mai=c(0.5,0.2,0.5,0),oma=c(0,0,0,0), omi=c(0,0,0,0))
    plot(0,type="n",xlim=c(1,x.max),
         ylim=c(-1.5,y.max+2),ann=FALSE,axes=FALSE)

    text(1,-2,paste(res$info,collapse=","),cex=cex,adj=0,xpd=NA)
    if(!is.null(res$upper)){
      text(1,     -0.5,paste(res$upp,collapse=","),cex=cex,adj=0,xpd=NA)
    }
    if(!is.null(res$lower)) 
      text(1,y.max+1.5,paste(res$low,collapse=","),cex=cex,adj=0,xpd=NA)
    title(main,cex.main=cex)
    for(i in 1:y.max){
      n<-nchar(h<-stem[i]); h<-substring(h,1:n,1:n)
      text(1:n,i,h,cex=cex)
    }
    par(opar)
  } # end of repl
  b1<-function(...){
    slider(obj.name="rule.line",obj.value="Dixon")
    repl(); print(slider(obj.name="rule.line"))
  }
  b2<-function(...){
    slider(obj.name="rule.line",obj.value="Velleman")
    repl(); print(slider(obj.name="rule.line"))
  }
  b3<-function(...){
    slider(obj.name="rule.line",obj.value="Sturges")
    repl(); print(slider(obj.name="rule.line"))
  }
  sp<-function(...){
    din<-par()$din
    filename<-tkgetSaveFile(filetypes="{{Paper Files} {.ps|.jpg}}",
                          title="name of ps-/jpg-file?", initialdir=getwd(),
                          defaultextension=".ps", initialfile="stem-and-leaf")
    filename<-sub("\\.ps$","",sub("\\.jpg$","",filename))
    filename<-paste(filename,".ps",sep="")  
    dev.copy(postscript,filename,width=din[1],height=din[2],
             horizontal=FALSE); dev.off()
    filename<-sub(".ps",".jpg",filename) 
    dev.copy(jpeg,filename,units="in",res=95,width=din[1],height=din[2])
    dev.off()
  }
  nt <- slider(repl, # 140925
         c("character size","rows per unit, 0=by rule"),
         c(0.5,0),c(5,10),c(.1,1),c(1,0),
         c(b1,b2,b3,sp),c("Dixon rule","Velleman rule","Sturges rule",
          "save plot")     
  )
  tkwm.minsize(nt, "450", "110") # set width, height to prevent to small sizes
  repl()
  "choose layout by control widget"
} # slider.stem.leaf(c(co2,100,1000))

slider.brush.pairs<-function(x,...)
{
  args<-list(...)
  x.name<-deparse(substitute(x))
  if(missing(x)||length(x)<2) return("Error: x must be a vector")

  # preparation of data
  m<-dim(x)[2]; for(j in 1:m) x[,j]<-as.numeric(x[,j])
  mins<-apply(x,2,min); maxs<-apply(x,2,max)
  delta<-(maxs-mins)/100
  # initial plot
  varnames<-paste("var ",1:m,": ",colnames(x),sep="")
  dev.new(); par(mfrow=c(m,m),oma=c(0,0,0,0),mai=c(0,0,0,0),...)
  usr.array<-array(0,c(m,m,4)); axes<-FALSE
  for(i in 1:m){
    for(j in 1:m){
      # plot(x[,j],x[,i],axes=axes,type="p")
      do.call("plot",c(alist(x=x[,j],y=x[,i],type="p",axes=axes,xlab="",ylab=""),args))
      usr.array[i,j,] <- usr<-par()$usr
      if(i==j) text(usr[1],usr[4],varnames[i],adj=c(0,1),cex=5)
      rect(usr[1],usr[3],usr[2],usr[4])
    }
  }
  # update function
  refresh<-function(...){
    vmin<-slider(no=1)/100; vmax<-vmin+slider(no=2)/100
    vno <-slider(no=3)
    vmin<-mins[vno]*(1-vmin)+maxs[vno]*(vmin) 
    vmax<-mins[vno]*(1-vmax)+maxs[vno]*(vmax)
    ind <-vmin<=x[,vno] & x[,vno]<=vmax
    for(i in 1:m){
      for(j in 1:m){
        par(mfg=c(i,j),usr=usr.array[i,j,])
        points(x[ ,j],x[ ,i],col=0,cex=2,pch=19)
        points(x[ ind,j],x[ ind,i],col="red",pch=1)
        points(x[!ind,j],x[!ind,i],col="blue",pch=19)
      }
    }
  }
  # slider definition
  nt <- slider(refresh,
         c("lower limit (% of range)","width (% of range)", 
           paste("variable no: 1 ..",m)),
         c(0,0,1), c(100,100, m), c(1,1,1), c(0,30,1)
  )
  # tkwm.minsize(nt, "450", "150") # set width, height to prevent to small sizes
  refresh()
  cat("use sliders to select variable and interval width\n")
}

slider.smooth.plot.ts<-function(x,...)
{ 
 x.name<-deparse(substitute(x))
 if(missing(x)||length(x)<2) return("Error: x must be a vector")
 y<-x; if(is.ts(x)) { x<-time(x) } else { x<-seq(x) }

 t.x<-x; x<-y
 args<-list(...)
 kind<-c("3RS3R", "3RSS", "3RSR", "3R", "3", "S")
 slider(obj.name="nts",obj.value=x) 
 slider(obj.name="kind",obj.value="3")
 slider(obj.name="history.kind",obj.value="")
 refresh<-function(...){
 # initialization
   choice<-slider(obj.name="kind"); print(choice)
   history.kind<-slider(obj.name="history.kind")
   history.kind<-c(history.kind,choice)
   slider(obj.name="history.kind",obj.value=history.kind)
   xx<-slider(obj.name="nts") 
   xx<-smooth(xx,kind=choice)   
   # plot(t.x,x,type="l",lty=3,bty="n",xlab="",ylab="")
   do.call("plot",c(alist(t.x,x,type="l",lty=3,bty="n"),args))
   title(paste(history.kind,collapse="->"))
   points(t.x,xx,type="l",col="red") # lty=1+which(choice==kind))
   slider(obj.name="nts",obj.value=xx) 
 }
 reset<-function(...){
   slider(obj.name="nts",obj.value=x) 
   slider(obj.name="kind",obj.value="3")
   slider(obj.name="history.kind",obj.value="")
   refresh()
 }
 f1<-function(...){slider(obj.name="kind",obj.value="3RS3R");refresh()}
 f2<-function(...){slider(obj.name="kind",obj.value="3RSS"); refresh()}
 f3<-function(...){slider(obj.name="kind",obj.value="3RSR"); refresh()}
 f4<-function(...){slider(obj.name="kind",obj.value="3R");   refresh()}
 f5<-function(...){slider(obj.name="kind",obj.value="3");    refresh()}
 f6<-function(...){slider(obj.name="kind",obj.value="S");    refresh()}
 refresh()
 slider(but.functions=c(f1,f2,f3,f4,f5,f6),
        but.names=kind,reset.function=reset)
 cat("select type of smoothing a la Tukey and look the result!\n")
}

## ms <-
stem.leaf <- function(data, unit, m, Min, Max, 
     rule.line=c("Dixon", "Velleman", "Sturges"),
     style=c("Tukey", "bare"), trim.outliers=TRUE, depths=TRUE,
     reverse.negative.leaves=TRUE,na.rm=FALSE,printresult=TRUE){
  if(missing(data)){cat("Author:  Peter Wolf 05/2003,", 
                        "(modified slightly by J. Fox, 20 July 03)",
                        "03/2006 additional rounding to prevent misclasification",
                        "07/2008 counting of NA's, 04/2009 improvement of rounding",
                        "syntax: stem.leaf(data.set)\n",sep="\n")
                    return("Warning: no data set found by stem.leaf")
  }                  
  rule.line <- match.arg(rule.line)
  style <- match.arg(style)
  n.na  <- sum(is.na(data))
  if(0<n.na){
    data <- data[!is.na(data)]
    if(na.rm){ # data<-data[!is.na(data)]
      print("Warning: NA elements have been removed!!")
    }else{
  #   data[is.na(data)] <- mean(data,na.rm=TRUE)
  #   print("Warning: NA elements have been exchanged by the mean value!!")
    }  
  }


  if(0<length(h<-find("debug.cond")) && ".GlobalEnv" %in% h){
    debug.cond<-get("debug.cond",envir=.GlobalEnv)
  } else debug.cond<-""
  debug.show<-function(name){
    if(!exists("debug.cond")) return()
    if(debug.cond=="all"|| (name %in% debug.cond) ){
      cat(name,":\n"); obj<-eval(parse(text=name))
      if(is.vector(obj)){ print(obj) }
      return()
    }
  }

  ##################################################################
  #Description:                                                    #
  #   stem.leaf  produces a stem-and-leaf-display of a data set    #
  #                                                                #
  #Usage:                                                          #
  #   stem.leaf(data)                                              #
  #   stem.leaf(data,unit=100,m=5,Min=50,Max=1000,                 #
  #     rule.line=c("Dixon", "Velleman", "Sturges"),               #
  #     style=c("Tukey", "bare"), trim.outliers=TRUE, depths=TRUE, #
  #     reverse.negative.leaves=TRUE,na.rm=FALSE)                  #
  #                                                                #
  #Arguments:                                                      #
  #   data:      vector of input data                              #
  #   unit:      unit of leaves in: { ...,100,10,1,.1,.01,... }    #
  #   m:         1, 2 or 5 -- 10/m=number of possible leaf digits  #
  #   Min:       minimum of stem                                   #
  #   Max:       maximum of stem                                   #
  #   rule.line:   = "Dixon"    => number of lines <- 10*log(n,10) #
  #                = "Velleman" => number of lines <- 2*sqrt(n)    #
  #                = "Sturges"  => number of lines <- 1 + log(n,2) #
  #   style:       = "Tukey"    => Tukey-like stem ( m = 2, 5 )    #
  #   trim.outliers=TRUE        => outliers are printed absent     #
  #   depths       =TRUE        => depths info is printed          #
  #   reverse.negative.leaves=TRUE => neg.leaves are rev. sorted   #
  #Author:                                                         #
  #   Peter Wolf 05/2003 (modified slightly by J. Fox, 20 July 03) #
  #   rounding operation for comparing added 29 March 06           #
  #   07/2008 NA-values are counted if na.rm==FALSE                #
  #   10/2010 rounding error in computing of leaves conremoved     #
  ##################################################################

  n <- length(data <- sort(data))
  row.max <- floor(  c(Dixon   =10*log(n,10),
                       Velleman=2*sqrt(n),
                       Sturges =1+log(n,2)        ))[rule.line]

  stats <- boxplot(data,plot=FALSE)
  if(missing(Min)) Min <- if (trim.outliers) stats$stats[1,1] else min(data, na.rm=TRUE)
  if(missing(Max)) Max <- if (trim.outliers) stats$stats[5,1] else max(data, na.rm=TRUE)
  spannweite.red<-Max - Min

  zeilen.intervall.laenge <- spannweite.red / row.max
  if(missing(unit)){
         factor <- 10^ceiling(log(zeilen.intervall.laenge,10))
  } else factor <- 10^round(log(unit*10,10))
  debug.show("factor")

  z <- zeilen.intervall.laenge/factor  # z in (0.1 ,1]
  delta.tick <- c(.2,.2,.5,1)[sum(z>c(0,.1,.2,.5))]

  if(missing(m)) m <- round(1/delta.tick) else delta.tick <- 1/m
  debug.show("delta.tick"); debug.show("m")

  data.tr <- data/factor
  data.tr <- signif(data.tr, digits = 11) # reduction of significant digits 181128
  Min.tr  <- Min/factor
  Max.tr  <- Max/factor

  spannweite.red <- Max.tr - Min.tr
  sk.min <- floor(Min.tr)
  sk.max <- ceiling(Max.tr)
  skala  <- seq(sk.min,sk.max,by=delta.tick)
  if(sk.min<0) skala <- c(sk.min-delta.tick,skala)
  if(sk.max<0) skala <- skala[-length(skala)]
  debug.show("skala")


  lo.limit <- if (trim.outliers) skala[1] else -Inf
  lo.log   <- if(skala[1   ] <  0) data.tr <= lo.limit else data.tr <  lo.limit
  n.sk <- length(skala)
  hi.limit <- if (trim.outliers) skala[n.sk] + delta.tick else Inf
  hi.log   <- if(skala[n.sk] >= 0) data.tr >= hi.limit else data.tr >  hi.limit

  n.lower.extr.values <- sum(lo.log); n.upper.extr.values <- sum(hi.log)
  if(0<n.lower.extr.values){
    lower.line <- paste("LO:", paste(data[lo.log],collapse=" "))
  }
  if(0<n.upper.extr.values){
    upper.line <- paste("HI:", paste(data[hi.log],collapse=" "))
  }
  data.tr.red <-data.tr[(!lo.log)&(!hi.log)]


  stem.data  <- ifelse(data.tr.red < 0, ceiling(data.tr.red), floor(data.tr.red) )
  # eps <- 1e-12; leaf <- floor(abs(data.tr.red*10-stem.data*10)+eps)
  leaf <- floor(10 * abs(signif(data.tr.red - stem.data, 5))) #181004  , 10
  leaf <- ifelse( leaf == 10, 0, leaf ) # 181004 probably not relevant 
  debug.show("leaf"); debug.show("stem.data")

  class.of.data.tr<-unlist(c(
     sapply(signif(data.tr.red[data.tr.red< 0],10),
       function(x,sk)length(sk)-sum(-sk<=-x),signif(skala,10))
    ,sapply(signif(data.tr.red[data.tr.red>=0],10),
       function(x,sk)sum( sk<= x),signif(skala,10))
  ))
  debug.show("class.of.data.tr")
  class.of.data.tr  <- c(1:length(skala),class.of.data.tr)
  leaf.grouped      <- split(c(rep(-1,length(skala)),leaf),class.of.data.tr)
  leaf.grouped      <- lapply(leaf.grouped, function(x){ sort(x[-1]) })
  # debug.show("leaf.grouped")

  class.negative <- skala < 0
  class.neg.zero <- floor(skala) == -1

  if (reverse.negative.leaves){
          for (i in seq(class.negative))
              if (class.negative[i]) leaf.grouped[[i]] <- rev(leaf.grouped[[i]])
  }

  leaf.grouped.ch <- paste("|",unlist(lapply(leaf.grouped,paste,collapse="")))
  # debug.show("leaf.grouped")

  line.names <- skala
  line.names[class.negative] <- line.names[class.negative]+1
  line.names <- as.character(floor(line.names))
  line.names[class.neg.zero] <- "-0"


  if(style=="Tukey"){
    switch(as.character(m),
    "1"={},
    "2"={
          h<-round(2*(skala%%1)) #; line.names[h!=0] <- ""
          line.names<-paste(line.names,
                  ifelse(skala<0,c(".","*")[1+h],c("*",".")[1+h]),sep="")
        },
    "5"={
          h<-round(5*(skala%%1)); line.names[h>0 & h<4] <- ""
          line.names<-paste(line.names, ifelse(skala<0,
                           c(".","s","f","t","*")[1+h],
                           c("*","t","f","s",".")[1+h]), sep="")
        }
    )
  }
  ragged.left <- function(ch.lines){
    max.n <- max(n.lines<-nchar(ch.lines))
    h     <- paste(rep(" ",max.n),collapse="")
    ch.lines <- paste( substring(h,1,1+max.n-n.lines), ch.lines)
    ch.lines
  }

  line.names <- ragged.left(line.names)


  n.class <- unlist(lapply(leaf.grouped,length))
  debug.show("n.class")
  select <- (cumsum(n.class) > 0) & rev((cumsum(rev(n.class)) > 0))
  depth     <-     cumsum(n.class)          + n.lower.extr.values
  depth.rev <- rev(cumsum(rev(n.class))     + n.upper.extr.values)
  debug.show("depth")

  uplow <- depth>=depth.rev
  # DT-median-error  #150429
  # pos.median <- which(uplow)[1] + (-1:0)
  # h <- abs(depth[pos.median]-depth.rev[pos.median])
  # pos.median <- pos.median[1]+(h[1]>h[2])
  # debug.show("pos.median")

  depth[uplow] <- depth.rev[uplow]
  pos.median <- which(depth == max(depth)) # 150429
  debug.show("pos.median")                 # 150429
  depth <- paste(depth,"")
  depth[pos.median] <- paste("(",n.class[pos.median],")",sep="")
  depth[n.class==0] <- " "
  depth <- if (depths) ragged.left(depth) else ""


  info <- c(  paste("1 | 2: represents",1.2*factor),
           #  paste("    m:",m     ),
              paste(" leaf unit:",factor/10),
              paste("            n:",n     ))


  stem <- paste(depth, line.names, leaf.grouped.ch)
  stem <- if((m!=5)||sum(select)>4) stem[select] else stem
  result <- list(display=stem)
  if(exists("lower.line")) result<-c(lower=lower.line,result)
  if(exists("upper.line")) result<-c(result,upper=upper.line)
  if(0<n.na&&!na.rm) result<-c(result,NAs=paste("NA's:",n.na,collapse=" "))
  result <- c(list( info=info), result)
  if(printresult){ for(i in seq(result)) cat(result[[i]],sep="\n") }
  result <- c(result, list(depths=depth, stem=line.names, leaves=leaf.grouped.ch))
  invisible(result)

}

stem.leaf.backback <- function(x,y, unit, m, Min, Max, rule.line = c("Dixon", "Velleman", 
    "Sturges"), style = c("Tukey", "bare"), trim.outliers = TRUE, 
    depths = TRUE, reverse.negative.leaves = TRUE, na.rm = FALSE,
    printresult=TRUE, show.no.depths = FALSE, add.more.blanks = 0,
    back.to.back = TRUE){
  x.name <- paste(deparse(substitute(x)),collapse="")
  if(missing(y)){ y <- x; y.name <- x.name } 
  else y.name <- paste(deparse(substitute(y)),collapse="")
  n.na.x <- sum(is.na(x)); n.na.y <- sum(is.na(y))

  ## ms <-
  stem.leaf <- function(data, unit, m, Min, Max, 
       rule.line=c("Dixon", "Velleman", "Sturges"),
       style=c("Tukey", "bare"), trim.outliers=TRUE, depths=TRUE,
       reverse.negative.leaves=TRUE,na.rm=FALSE,printresult=TRUE){
    if(missing(data)){cat("Author:  Peter Wolf 05/2003,", 
                          "(modified slightly by J. Fox, 20 July 03)",
                          "03/2006 additional rounding to prevent misclasification",
                          "07/2008 counting of NA's, 04/2009 improvement of rounding",
                          "syntax: stem.leaf(data.set)\n",sep="\n")
                      return("Warning: no data set found by stem.leaf")
    }                  
    rule.line <- match.arg(rule.line)
    style <- match.arg(style)
    n.na  <- sum(is.na(data))
    if(0<n.na){
      data <- data[!is.na(data)]
      if(na.rm){ # data<-data[!is.na(data)]
        print("Warning: NA elements have been removed!!")
      }else{
    #   data[is.na(data)] <- mean(data,na.rm=TRUE)
    #   print("Warning: NA elements have been exchanged by the mean value!!")
      }  
    }


    if(0<length(h<-find("debug.cond")) && ".GlobalEnv" %in% h){
      debug.cond<-get("debug.cond",envir=.GlobalEnv)
    } else debug.cond<-""
    debug.show<-function(name){
      if(!exists("debug.cond")) return()
      if(debug.cond=="all"|| (name %in% debug.cond) ){
        cat(name,":\n"); obj<-eval(parse(text=name))
        if(is.vector(obj)){ print(obj) }
        return()
      }
    }

    ##################################################################
    #Description:                                                    #
    #   stem.leaf  produces a stem-and-leaf-display of a data set    #
    #                                                                #
    #Usage:                                                          #
    #   stem.leaf(data)                                              #
    #   stem.leaf(data,unit=100,m=5,Min=50,Max=1000,                 #
    #     rule.line=c("Dixon", "Velleman", "Sturges"),               #
    #     style=c("Tukey", "bare"), trim.outliers=TRUE, depths=TRUE, #
    #     reverse.negative.leaves=TRUE,na.rm=FALSE)                  #
    #                                                                #
    #Arguments:                                                      #
    #   data:      vector of input data                              #
    #   unit:      unit of leaves in: { ...,100,10,1,.1,.01,... }    #
    #   m:         1, 2 or 5 -- 10/m=number of possible leaf digits  #
    #   Min:       minimum of stem                                   #
    #   Max:       maximum of stem                                   #
    #   rule.line:   = "Dixon"    => number of lines <- 10*log(n,10) #
    #                = "Velleman" => number of lines <- 2*sqrt(n)    #
    #                = "Sturges"  => number of lines <- 1 + log(n,2) #
    #   style:       = "Tukey"    => Tukey-like stem ( m = 2, 5 )    #
    #   trim.outliers=TRUE        => outliers are printed absent     #
    #   depths       =TRUE        => depths info is printed          #
    #   reverse.negative.leaves=TRUE => neg.leaves are rev. sorted   #
    #Author:                                                         #
    #   Peter Wolf 05/2003 (modified slightly by J. Fox, 20 July 03) #
    #   rounding operation for comparing added 29 March 06           #
    #   07/2008 NA-values are counted if na.rm==FALSE                #
    #   10/2010 rounding error in computing of leaves conremoved     #
    ##################################################################

    n <- length(data <- sort(data))
    row.max <- floor(  c(Dixon   =10*log(n,10),
                         Velleman=2*sqrt(n),
                         Sturges =1+log(n,2)        ))[rule.line]

    stats <- boxplot(data,plot=FALSE)
    if(missing(Min)) Min <- if (trim.outliers) stats$stats[1,1] else min(data, na.rm=TRUE)
    if(missing(Max)) Max <- if (trim.outliers) stats$stats[5,1] else max(data, na.rm=TRUE)
    spannweite.red<-Max - Min

    zeilen.intervall.laenge <- spannweite.red / row.max
    if(missing(unit)){
           factor <- 10^ceiling(log(zeilen.intervall.laenge,10))
    } else factor <- 10^round(log(unit*10,10))
    debug.show("factor")

    z <- zeilen.intervall.laenge/factor  # z in (0.1 ,1]
    delta.tick <- c(.2,.2,.5,1)[sum(z>c(0,.1,.2,.5))]

    if(missing(m)) m <- round(1/delta.tick) else delta.tick <- 1/m
    debug.show("delta.tick"); debug.show("m")

    data.tr <- data/factor
    data.tr <- signif(data.tr, digits = 11) # reduction of significant digits 181128
    Min.tr  <- Min/factor
    Max.tr  <- Max/factor

    spannweite.red <- Max.tr - Min.tr
    sk.min <- floor(Min.tr)
    sk.max <- ceiling(Max.tr)
    skala  <- seq(sk.min,sk.max,by=delta.tick)
    if(sk.min<0) skala <- c(sk.min-delta.tick,skala)
    if(sk.max<0) skala <- skala[-length(skala)]
    debug.show("skala")


    lo.limit <- if (trim.outliers) skala[1] else -Inf
    lo.log   <- if(skala[1   ] <  0) data.tr <= lo.limit else data.tr <  lo.limit
    n.sk <- length(skala)
    hi.limit <- if (trim.outliers) skala[n.sk] + delta.tick else Inf
    hi.log   <- if(skala[n.sk] >= 0) data.tr >= hi.limit else data.tr >  hi.limit

    n.lower.extr.values <- sum(lo.log); n.upper.extr.values <- sum(hi.log)
    if(0<n.lower.extr.values){
      lower.line <- paste("LO:", paste(data[lo.log],collapse=" "))
    }
    if(0<n.upper.extr.values){
      upper.line <- paste("HI:", paste(data[hi.log],collapse=" "))
    }
    data.tr.red <-data.tr[(!lo.log)&(!hi.log)]


    stem.data  <- ifelse(data.tr.red < 0, ceiling(data.tr.red), floor(data.tr.red) )
    # eps <- 1e-12; leaf <- floor(abs(data.tr.red*10-stem.data*10)+eps)
    leaf <- floor(10 * abs(signif(data.tr.red - stem.data, 5))) #181004  , 10
    leaf <- ifelse( leaf == 10, 0, leaf ) # 181004 probably not relevant 
    debug.show("leaf"); debug.show("stem.data")

    class.of.data.tr<-unlist(c(
       sapply(signif(data.tr.red[data.tr.red< 0],10),
         function(x,sk)length(sk)-sum(-sk<=-x),signif(skala,10))
      ,sapply(signif(data.tr.red[data.tr.red>=0],10),
         function(x,sk)sum( sk<= x),signif(skala,10))
    ))
    debug.show("class.of.data.tr")
    class.of.data.tr  <- c(1:length(skala),class.of.data.tr)
    leaf.grouped      <- split(c(rep(-1,length(skala)),leaf),class.of.data.tr)
    leaf.grouped      <- lapply(leaf.grouped, function(x){ sort(x[-1]) })
    # debug.show("leaf.grouped")

    class.negative <- skala < 0
    class.neg.zero <- floor(skala) == -1

    if (reverse.negative.leaves){
            for (i in seq(class.negative))
                if (class.negative[i]) leaf.grouped[[i]] <- rev(leaf.grouped[[i]])
    }

    leaf.grouped.ch <- paste("|",unlist(lapply(leaf.grouped,paste,collapse="")))
    # debug.show("leaf.grouped")

    line.names <- skala
    line.names[class.negative] <- line.names[class.negative]+1
    line.names <- as.character(floor(line.names))
    line.names[class.neg.zero] <- "-0"


    if(style=="Tukey"){
      switch(as.character(m),
      "1"={},
      "2"={
            h<-round(2*(skala%%1)) #; line.names[h!=0] <- ""
            line.names<-paste(line.names,
                    ifelse(skala<0,c(".","*")[1+h],c("*",".")[1+h]),sep="")
          },
      "5"={
            h<-round(5*(skala%%1)); line.names[h>0 & h<4] <- ""
            line.names<-paste(line.names, ifelse(skala<0,
                             c(".","s","f","t","*")[1+h],
                             c("*","t","f","s",".")[1+h]), sep="")
          }
      )
    }
    ragged.left <- function(ch.lines){
      max.n <- max(n.lines<-nchar(ch.lines))
      h     <- paste(rep(" ",max.n),collapse="")
      ch.lines <- paste( substring(h,1,1+max.n-n.lines), ch.lines)
      ch.lines
    }

    line.names <- ragged.left(line.names)


    n.class <- unlist(lapply(leaf.grouped,length))
    debug.show("n.class")
    select <- (cumsum(n.class) > 0) & rev((cumsum(rev(n.class)) > 0))
    depth     <-     cumsum(n.class)          + n.lower.extr.values
    depth.rev <- rev(cumsum(rev(n.class))     + n.upper.extr.values)
    debug.show("depth")

    uplow <- depth>=depth.rev
    # DT-median-error  #150429
    # pos.median <- which(uplow)[1] + (-1:0)
    # h <- abs(depth[pos.median]-depth.rev[pos.median])
    # pos.median <- pos.median[1]+(h[1]>h[2])
    # debug.show("pos.median")

    depth[uplow] <- depth.rev[uplow]
    pos.median <- which(depth == max(depth)) # 150429
    debug.show("pos.median")                 # 150429
    depth <- paste(depth,"")
    depth[pos.median] <- paste("(",n.class[pos.median],")",sep="")
    depth[n.class==0] <- " "
    depth <- if (depths) ragged.left(depth) else ""


    info <- c(  paste("1 | 2: represents",1.2*factor),
             #  paste("    m:",m     ),
                paste(" leaf unit:",factor/10),
                paste("            n:",n     ))


    stem <- paste(depth, line.names, leaf.grouped.ch)
    stem <- if((m!=5)||sum(select)>4) stem[select] else stem
    result <- list(display=stem)
    if(exists("lower.line")) result<-c(lower=lower.line,result)
    if(exists("upper.line")) result<-c(result,upper=upper.line)
    if(0<n.na&&!na.rm) result<-c(result,NAs=paste("NA's:",n.na,collapse=" "))
    result <- c(list( info=info), result)
    if(printresult){ for(i in seq(result)) cat(result[[i]],sep="\n") }
    result <- c(result, list(depths=depth, stem=line.names, leaves=leaf.grouped.ch))
    invisible(result)

  }

  data <- c(x,y)
  rule.line <- match.arg(rule.line)
  style <- match.arg(style)
  n.na  <- sum(is.na(data))
  if(0<n.na){
    data <- data[!is.na(data)]
    if(na.rm){ # data<-data[!is.na(data)]
      print("Warning: NA elements have been removed!!")
    }else{
  #   data[is.na(data)] <- mean(data,na.rm=TRUE)
  #   print("Warning: NA elements have been exchanged by the mean value!!")
    }  
  }


  if(0<length(h<-find("debug.cond")) && ".GlobalEnv" %in% h){
    debug.cond<-get("debug.cond",envir=.GlobalEnv)
  } else debug.cond<-""
  debug.show<-function(name){
    if(!exists("debug.cond")) return()
    if(debug.cond=="all"|| (name %in% debug.cond) ){
      cat(name,":\n"); obj<-eval(parse(text=name))
      if(is.vector(obj)){ print(obj) }
      return()
    }
  }

  n <- length(data <- sort(data))
  row.max <- floor(  c(Dixon   =10*log(n,10),
                       Velleman=2*sqrt(n),
                       Sturges =1+log(n,2)        ))[rule.line]

  stats <- boxplot(data,plot=FALSE)
  if(missing(Min)) Min <- if (trim.outliers) stats$stats[1,1] else min(data, na.rm=TRUE)
  if(missing(Max)) Max <- if (trim.outliers) stats$stats[5,1] else max(data, na.rm=TRUE)
  spannweite.red<-Max - Min

  zeilen.intervall.laenge <- spannweite.red / row.max
  if(missing(unit)){
         factor <- 10^ceiling(log(zeilen.intervall.laenge,10))
  } else factor <- 10^round(log(unit*10,10))
  debug.show("factor")

  z <- zeilen.intervall.laenge/factor  # z in (0.1 ,1]
  delta.tick <- c(.2,.2,.5,1)[sum(z>c(0,.1,.2,.5))]

  if(missing(m)) m <- round(1/delta.tick) else delta.tick <- 1/m
  debug.show("delta.tick"); debug.show("m")


  sl.xy <- stem.leaf(c(x,y),unit=unit,m=m,Min=Min, Max=Max, rule.line=rule.line,
                     style=style,trim.outliers=trim.outliers,depths=depths,
                     reverse.negative.leaves = reverse.negative.leaves, 
                     na.rm = na.rm, printresult=FALSE)
  h <- grep(" leaf unit: ",sl.xy$info,value=TRUE)
  unit <- as.numeric(sub(" leaf unit: ","",h))

    sl.x  <- stem.leaf(x,     unit=unit,m=m,Min=Min, Max=Max, rule.line=rule.line,
                       style=style,trim.outliers=trim.outliers,depths=depths,
                       reverse.negative.leaves = reverse.negative.leaves, na.rm = na.rm,
                       printresult=FALSE)
    sl.y  <- stem.leaf(y,     unit=unit,m=m,Min=Min, Max=Max, rule.line=rule.line,
                       style=style,trim.outliers=trim.outliers,depths=depths,
                       reverse.negative.leaves = reverse.negative.leaves, na.rm = na.rm,
                       printresult=FALSE)

  x.stem   <- gsub(" ","",sl.x$stem);          y.stem   <- gsub(" ","",sl.y$stem)
  x.leaves <- substring(sl.x$leaves,3);        y.leaves <- substring(sl.y$leaves,3)
  x.depths <- substring(sl.x$depths,3);        y.depths <- substring(sl.y$depths,3)
  x.digits <- grep("[0-9]",x.stem,value=TRUE); y.digits <- grep("[0-9]",y.stem,value=TRUE)
  h <- match(y.digits, x.digits); h <- h[!is.na(h)][1]
  # take the first ->[1] only otherwise an error occurs, see mail from John Fox 10/2013:
  x.pos <- which(x.stem==x.digits[h])[1]; y.pos <- which(y.stem==x.digits[h])[1]
  LZ <- rep(" ",d <- abs(y.pos - x.pos))
  if(x.pos < y.pos) { # x vorn verlaengern 
    x.stem <- c(y.stem[1:d],x.stem); x.leaves <- c(LZ,x.leaves); x.depths <- c(LZ,x.depths)
  }
  if(y.pos < x.pos) { # y vorn verlaengern 
    y.stem <- c(x.stem[1:d],y.stem); y.leaves <- c(LZ,y.leaves); y.depths <- c(LZ,y.depths)
  }
  x.l <- length(x.stem); y.l <- length(y.stem)
  LZ <- rep(" ",d <- abs(y.l-x.l))
  if(x.l < y.l) { # x hinten verlaengern 
    x.stem <- c(x.stem,y.stem[-(1:x.l)]); x.leaves <- c(x.leaves,LZ)
    x.depths <- c(LZ,x.depths,LZ)
  }
  if(y.l < x.l) { # y hinten verlaengern 
    y.stem <- c(y.stem,x.stem[-(1:y.l)]); y.leaves <- c(y.leaves,LZ)
    y.depths <- c(LZ,y.depths,LZ)
  }

  expand.text <- function(x,N=0,O=0,S=0,W=0,fill.right=TRUE,sep=" "){
    # bringt Elemente auf gleiche Laenge und ergaenzt Leerzeichen in den Himmelsrichtungen
    if(0<O) x <- paste(x,paste(rep(sep,O),collapse=""),sep="")
    if(0<W) x <- paste(  paste(rep(sep,W),collapse=""),x,sep="")
    if(0<S) x <- c(x,rep(sep,S)); if(0<N) x <- c(rep(sep,N),x)
    maxch <- max(nchar(x));  LZ <- paste(rep(sep,maxch),collapse="")
    ch <- substring(LZ,1,maxch-nchar(x))
    x <- if(fill.right) paste(x,ch,sep="") else paste(ch,x,sep="")
    return(x)
  } # test: cbind(expand.text("asdf",3,2,1,4,fill.right=FALSE,sep=" "))

  expand.a.to.b <- function(a,b,fill.right=TRUE,fill.tail=TRUE){
    # expandiert Vektor a auf die Dimensionen von Vektor b
    d <- length(b) - length(a)
    if(0 < d) a <- if(fill.tail) c(a, rep(" ",d)) else c(rep(" ",d), a)
    n.LZ <- max(nchar(b),nchar(a)); d <- n.LZ - nchar(a)
    LZ <- paste(rep(" ",n.LZ),collapse="")
    a <- ifelse( d <= 0, a, if(fill.right) paste(a,substring(LZ,1,d),sep="") 
                            else paste(substring(LZ,1,d),a,sep=""))
    return(a)
  }

  rotate.string <- function(x){
      x <- sapply(x,function(y) { h <- nchar(y); paste(substring(y,h:1,h:1),collapse="") })
  }

  vecpaste <- function(..., sep=" ", widths=NULL, fill.right = TRUE){  ## ???
    # vecpaste pastet Vektoren zusammen
    xyz <- list(...); n <- length(xyz)
    LZ <- paste(rep(" ",200),collapse="")
    if(0 < length(widths)) sep <- "" else widths <- rep(0,n)
    if(is.numeric(sep)) sep <- substring(LZ,1,sep)
    if(length(sep)==1)  sep <- rep(sep,n+1)
    if(length(fill.right)==1)  fill.right <- rep(fill.right,n)
    result <- ""; w <- NULL
    for(i in 1:n){ #print(fill.right[i]); cat("n",n,"i",i)
      h <- as.character(xyz[[i]]); h <- expand.text(h,fill.right=fill.right[i])
      if(nchar(h[1]) < widths[i]) 
        if(fill.right[i]){
          h <- paste(h,substring(LZ,1,widths[i]-nchar(h[1])),sep="")
        }else{
          h <- paste(substring(LZ,1,widths[i]-nchar(h[1])),h,sep="")
        }
      result <- paste(result,h,sep=sep[i])
      w <- c(w, nchar(sep[i]), nchar(h[1]))
    }
    if(0 == length(widths)) widths <- c(w,nchar(sep[n+1])) else widths <- w
    result <- paste(result,"",sep=sep[n+1])
    return(list(result=result,widths=widths))
  }

  line.to.textvec <- function(vec,width,sep=" "){
    # wandelt Textzeile in Textvektor vorgegebener maximaler Zeichenanzahl um
    vec <- paste(vec,collapse=" "); if(width==Inf) return(vec)
    d <- width - nchar(vec); LZ <- paste(rep(" ",width),collapse="")
    if( 0 < d ) return(paste(vec,substring(LZ,1,d),sep=""))
    vec.sep <- unlist(strsplit(vec,sep)); result <- NULL; imax <- 200
    while(0 < length(vec.sep)){        if( (imax<-imax-1) < 0 ) break
      h <- sum( cumsum(nchar(vec.sep)+1) <= width ) # +1 fuer Trennzeichen
      if( h==0 ) { 
        h <- 1; cat("Warning: word '",vec.sep[1],"' too long ...",sep="") 
        vec.sep <- c(substring(vec.sep[1],1,width),substring(vec.sep[1],1+width),vec.sep[-1])
        h <- 1; cat("  and has been split to '",vec.sep[1],"' and '",vec.sep[2],"'",sep="") 
      }
      new.line <- paste(vec.sep[1:h],collapse=sep)
      d <- width - nchar(new.line)
      if( d < 0 ) new.line <- substring(new.line,1,width)
      if( 0 < d ) new.line <- paste(new.line,substring(LZ,1,d),sep="")
      result <- c(result, new.line); vec.sep <- vec.sep[-(1:h)]
    }
    return(result)
  }

  x.leaves <- expand.text(x.leaves,fill.right=TRUE,O=add.more.blanks)
  x.leaves <- rotate.string(x.leaves)
  x.stem   <- expand.text(x.stem,fill.right=FALSE)
  y.leaves <- expand.text(y.leaves,fill.right=TRUE,O=add.more.blanks)
  # Zweige egalisieren
  x.leaves <- expand.a.to.b(x.leaves,y.leaves,fill.right=FALSE)
  y.leaves <- expand.a.to.b(y.leaves,x.leaves)

  if(back.to.back){ 
    if(show.no.depths){
      result <- vecpaste("",x.leaves,x.stem,y.leaves,"",sep=c("  ","","| "," |","","  ")) 
    } else {
      result <- vecpaste(x.depths,x.leaves,x.stem,y.leaves,y.depths,
                         sep=c("  ","  ","| "," |","  ","  "))
    }
    end.of.x.leaves <- sum(result$widths[1:4])
    end.of.x.attributes <- sum(result$widths[1:4])
    start.of.y.attributes <- sum(result$widths[1:7]) # falls x.name sehr lang
    space.x.to.y   <- sum(result$widths[5:7])
    end.of.left.stem <- 0 
    extr.width <- end.of.x.leaves 
  } else { # parallel displays
    if(show.no.depths){
      result <- vecpaste(x.stem,rotate.string(x.leaves),y.leaves,sep=c("  "," |","  |","  "))
      end.of.x.leaves <- sum(result$widths[1:4])
      end.of.x.attributes <- sum(result$widths[1:4])
      start.of.y.attributes <- sum(result$widths[1:4]) # falls x.name sehr lang
      space.x.to.y   <- sum(result$widths[5])
    } else {
      result <- vecpaste(x.stem,rotate.string(x.leaves),x.depths,y.leaves,y.depths,
                         sep=c("  "," |","  "," |","  ","  "))
      end.of.x.leaves <- sum(result$widths[1:6]) 
      end.of.x.attributes <- sum(result$widths[1:6]) 
      start.of.y.attributes <- sum(result$widths[1:7]) # falls x.name sehr lang
      space.x.to.y   <- sum(result$widths[7]) #- 5
    }
    end.of.left.stem <- sum(result$widths[1:3]) 
    extr.width <- end.of.x.leaves-end.of.left.stem
  }
  result <- result$result
  LZ <- paste(rep(" ",max(nchar(result))),collapse="")

  # compose info line
  info.line <- vecpaste(sl.x$info[1],sl.x$info[2],sep=c("  ",","," "))$result
  end.of.attr <- max(end.of.left.stem,4)
  # compose name line
  if( nchar(x.name) < end.of.x.leaves) {
     name.line <- vecpaste("    ",x.name," ",y.name,
          widths=c(end.of.attr, end.of.x.leaves-end.of.attr, space.x.to.y, end.of.x.leaves-4),
          fill.right=c(TRUE,!back.to.back,TRUE,TRUE))$result
  } else {
     name.line <- c(vecpaste(x.name,sep=c(end.of.x.leaves - nchar(x.name),0))$result,
                    vecpaste(y.name,sep=c(start.of.y.attributes,0))$result)
  }
  # compose length line
  n.line <- vecpaste("n:  ",length(x)," ",length(y),
          widths=c(end.of.attr, end.of.x.leaves-end.of.attr, space.x.to.y, end.of.x.leaves-4),
          fill.right=c(TRUE,!back.to.back,TRUE,TRUE))$result
  # compose NA line
  na.line <- vecpaste("NAs:",n.na.x," ",n.na.y,
          widths=c(end.of.attr, end.of.x.leaves-end.of.attr, space.x.to.y, end.of.x.leaves-4),
          fill.right=c(TRUE,!back.to.back,TRUE,TRUE))$result
  if(0==length(grep("[1-9]",na.line))) na.line <- "    "

  # compose info of HI values
  ## split HI info of x in smaller parts
  upper.x.res <- line.to.textvec(sl.x$upper, extr.width)
  ## split HI info of y in smaller parts
  upper.y.res <- line.to.textvec(sl.y$upper, extr.width)
  ## unify x and y HI values
  upper.x.res <- expand.a.to.b(upper.x.res, upper.y.res)
  upper.y.res <- expand.a.to.b(upper.y.res, upper.x.res)
  ## compose HI line
  if(back.to.back){
    upper.line <- vecpaste(upper.x.res,upper.y.res,sep=c(0,space.x.to.y,0))$result
  } else {
    upper.line <- vecpaste(" ",upper.x.res," ",upper.y.res,
       widths=c(end.of.attr,end.of.x.leaves-end.of.attr,space.x.to.y,end.of.x.leaves-4),
       fill.right=c(TRUE,TRUE,TRUE,TRUE))$result
  }    
  # compose info of LO values
  ## width=space by depths, leaves and 2 outer and 2 between
  ## split LO info of x in smaller parts
  lower.x.res <- line.to.textvec(sl.x$lower, extr.width)
  ## split LO info of y in smaller parts
  lower.y.res <- line.to.textvec(sl.y$lower, extr.width)
  ## unify x and y LO values
  lower.x.res <- expand.a.to.b(lower.x.res, lower.y.res)
  lower.y.res <- expand.a.to.b(lower.y.res, lower.x.res)
  ## compose LO line
  if(back.to.back){
    lower.line <- vecpaste(lower.x.res,lower.y.res,sep=c(0,space.x.to.y,0))$result
  } else {
    lower.line <- vecpaste(" ",lower.x.res," ",lower.y.res,
       widths=c(end.of.attr,end.of.x.leaves-end.of.attr,space.x.to.y,end.of.x.leaves-4),
       fill.right=c(TRUE,TRUE,TRUE,TRUE))$result
  }

  # komponiere Ergebnisvektor
  line   <- paste(rep("_",max(nchar(result))),collapse="")
  result <- c(line,info.line,name.line,lower.line,line,result,line,upper.line,n.line,
              if(substring(na.line,1,1)=="N") na.line,line)
  result <- result[grep("[^ ]",result)]
  # zeige Output
  if(printresult){ cat(result,sep="\n") }
  invisible(list(info=sl.x$info, display=result,lower.x=sl.x$lower,upper.x=sl.x$upper,
                 lower.y=sl.y$lower,upper.y=sl.y$upper,
                 x.depths=x.depths,y.depths=y.depths,stem=x.stem,x.leaves,y.leaves))

}

spin3R <- function(x, alpha=1, delay=.015, na.rm=FALSE){
 #################################################################
 # spin3R: simple spin function to rotate a 3-dim cloud of points#
 # pwolf 070831 / 080520                                             #
 #                                                               #
 # arguments:                                                    #
 #                                                               #
 #  x             (nx3)-matrix of points                         #
 #  alpha         arc of rotation                                #
 #  delay         sleeping time between rotations                #
 #                                                               #
 #################################################################
if(ncol(x)!=3) { print("Error: data matrix must have 3 columns"); return() }
 if (!requireNamespace("tcltk", quietly = TRUE)) stop("package 'tcltk' is needed") #190715
 bw <- 4
 topl<-tktoplevel();   tkwm.geometry(topl,"+0+500")
 f1 <- tkframe(topl);f2 <- tkframe(topl);f3 <- tkframe(topl)
 f4 <- tkframe(topl);f5 <- tkframe(topl);tkpack(f1,f2,f3,f4,f5)
 f6 <- tkframe(topl); tkpack(f6)
 b12 <- tkbutton(f1, relief="ridge",  width=bw, text="up")
 b21 <- tkbutton(f2, relief="ridge",  width=bw, text="left")
 b22 <- tklabel(f2,  relief="flat",   width=bw)
 b23 <- tkbutton(f2, relief="ridge",  width=bw, text="right")
 b32 <- tkbutton(f3, relief="ridge",  width=bw, text="down")
 b41 <- tkbutton(f4, relief="ridge",  width=bw, text="clock")
 b42 <- tklabel(f4,  relief="flat",   width=bw)
 b43 <- tkbutton(f4, relief="ridge",  width=bw, text="cclock")
 b51 <- tkbutton(f5, relief="flat", width=bw, text="------")
 b52 <- tklabel(f5,  relief="flat",   width=bw, height=bw)
 b53 <- tkbutton(f5, relief="flat", width=bw, text="------")
 b61 <- tkbutton(f6, relief="raised", width=3*bw, text="EXIT")
 tkpack(b12,b32)
 tkpack(b21,b22,b41,b42,b51,b52,side="left")
 tkpack(b23,b43,b53,side="right")
 tkpack(b61)

 alpha<-alpha/360*2*pi; ca<-cos(alpha); sa<-sin(alpha)
 rot<-matrix(c(ca,-sa,sa,ca),2,2)

 n <- nrow(x)
 if(any(is.na(x))){
   if(na.rm){ x<-x[!apply(is.na(x),1,any),,drop=FALSE]
     print("Warning: NA elements have been removed!!")
   }else{
     xy.means<-colMeans(x,na.rm=TRUE)
     for(j in 1:ncol(x)) x[is.na(x[,j]),j]<-xy.means[j]
     print("Warning: NA elements have been exchanged by mean values!!")
   }  
 }
 x  <- x - matrix(apply(x,2,min),n,3,TRUE)
 x.o<-x<-x / matrix(apply(x,2,max),n,3,TRUE) - 0.5;                
 xa <- x[,2:3]
 A.o<-A<-0.5*matrix(c(1,0,0, 0,0,0, 0,1,0, 0,0,0, 0,0,1),5,3,TRUE)
 Aa <- A[,2:3]
 plot(xa, xlim=.7*c(-1,1), ylim=.7*c(-1,1),bty="n",
           pch=20, xlab="",ylab="",xaxt="n",yaxt="n",type="n")
 lines(Aa)

 i <- 0               ; i.max<-60
 cat("exit by button Exit\n")
 delay<-.01
 if(delay < 0.015) delay <- 0.005 
 colors<-rev(rainbow(ncolors<-30))

 # first view
 ind<-c(1,3); x0 <- x; x0[,ind] <- x[,ind]%*%rot; xb <- x0[,2:3]
 xcol<-colors[ceiling((x0[,1]+1)*0.5*ncolors)]
 points(xb, pch=20, col=xcol,cex=2*(1.5+x0[,1]))
 cex <- .3*2*(1.5+x0[,1])
 points(xb + 0.005 * cex, pch=20, col="white",cex=cex^2);
 xa<-x0[,2:3]
 # info box
 tkmessageBox(title="ready for spinning?", # icon="yesno",
              message=paste("move cursor to with the desired rotation",
                            "move cursor on 'EXIT' to exit",sep="\n"))   
 # loop
 repeat{
   Sys.sleep(delay) ##; if(  ((i<-i+1)>i.max) ){ break }
   cx<-tclvalue(tkwinfo("pointerx",topl))
   cy<-tclvalue(tkwinfo("pointery",topl))
   widget.id<-tclvalue(tkwinfo("containing",cx,cy))
   choice<-sub(paste(sep="",topl$ID,".*([1-6].[1-6]$)"),"\\1",widget.id)
   if(choice=="6.1") break
   switch(choice,
    "1.1" = ind<-c(1,3), "2.1" = ind<-c(2,1), "2.3" = ind<-c(1,2),
    "3.1" = ind<-c(3,1), "4.1" = ind<-c(3,2), "4.3" = ind<-c(2,3), next
   )
   x[,ind] <- x[,ind]%*%rot; A[,ind] <- A[,ind]%*%rot
   xb<-x[,2:3]; Ab<-A[,2:3] #; dcol<-c(rep("black",n),rep("white",n))
   xcol<-colors[ceiling((x[,1]+1)*0.5*ncolors)]
   dcol<-c(xcol,rep("white",n))
   points(rbind(xb,xa), pch=20, col=dcol,cex=2*c(1.5+x[,1],rep(3,n))) # 1*
 #  points(xb, pch=20, col="black",cex=1.5+x[,1]); points(xa, pch=20, cex=3, col="white")
   lines(Aa, col="white",lwd=3)
   points(xb, pch=20, col=xcol,cex=2*(1.5+x[,1])) # 1*
   cex <- .3*2*(1.5+x[,1])
   points(xb + 0.005 * cex, pch=20, col="white",cex=cex^2);
   lines(Ab, col="black")
   xa<-x[,2:3]; Aa<-A[,2:3]
 }
 print(cex)
 tkdestroy(topl)
 "control widget closed"

} # end of spin3R

faces<-function(xy,which.row,fill=FALSE,face.type=1,
                nrow.plot,ncol.plot,scale=TRUE,byrow=FALSE,main,
                labels,print.info = TRUE,na.rm = FALSE,
                ncolors=20,
                col.nose=rainbow(ncolors),                   # nose
                col.eyes=rainbow(ncolors,start=0.6,end=0.85),# eyes
                col.hair=terrain.colors(ncolors),            # hair
                col.face=heat.colors(ncolors),               # face
                col.lips=rainbow(ncolors,start=0.0,end=0.2), # lips
                col.ears=rainbow(ncolors,start=0.0,end=0.2), # ears

                plot.faces=TRUE, cex = 2){  # 180308 pwolf
  if((demo<-missing(xy))){
    xy<-rbind(
              c(1,3,5),c(3,5,7),
              c(1,5,3),c(3,7,5),
              c(3,1,5),c(5,3,7),
              c(3,5,1),c(5,7,3),
              c(5,1,3),c(7,3,5),
              c(5,3,1),c(7,5,3),
              c(1,1,1),c(4,4,4),c(7,7,7)
    )
    labels<-apply(xy,1,function(x) paste(x,collapse="-"))
  }  
  spline<-function(a,y,m=200,plot=FALSE){
      n<-length(a)
    h<-diff(a)
    dy<-diff(y)
    sigma<-dy/h
    lambda<-h[-1]/(hh<-h[-1]+h[-length(h)])
    mu<-1-lambda
    d<-6*diff(sigma)/hh
    tri.mat<-2*diag(n-2)
    tri.mat[2+  (0:(n-4))*(n-1)] <-mu[-1]
    tri.mat[    (1:(n-3))*(n-1)] <-lambda[-(n-2)]
    M<-c(0,solve(tri.mat)%*%d,0)
    x<-seq(from=a[1],to=a[n],length=m)
    anz.kl <- hist(x,breaks=a,plot=FALSE)$counts
    adj<-function(i) i-1
    i<-rep(1:(n-1),anz.kl)+1
    S.x<-  M[i-1]*(a[i]-x          )^3 / (6*h[adj(i)])  +
           M[i]  *(x        -a[i-1])^3 / (6*h[adj(i)])  +
           (y[i-1] - M[i-1]*h[adj(i)]^2 /6) * (a[i]-x)/ h[adj(i)] +
          (y[i]   - M[i]  *h[adj(i)]^2 /6) * (x-a[i-1]) / h[adj(i)]
    if(plot){ plot(x,S.x,type="l"); points(a,y)    }
    return(cbind(x,S.x))
  }

  n.char<-15
  xy<-rbind(xy)
  if(byrow) xy<-t(xy)
  if(any(is.na(xy))){
    if(na.rm){ 
      xy<-xy[!apply(is.na(xy),1,any),,drop=FALSE]
      if(nrow(xy)<3) {print("not enough data points"); return()}
      print("Warning: NA elements have been removed!!")
     }else{
      xy.means<-colMeans(xy,na.rm=TRUE)
      for(j in 1:length(xy[1,])) xy[is.na(xy[,j]),j]<-xy.means[j]
      print("Warning: NA elements have been exchanged by mean values!!")
    }  
  }
  if(!missing(which.row)&& all(  !is.na(match(which.row,1:dim(xy)[2]))  ))
         xy<-xy[,which.row,drop=FALSE]
  mm<-dim(xy)[2];  n<-dim(xy)[1]
  xnames<-dimnames(xy)[[1]]
  if(is.null(xnames)) xnames<-as.character(1:n)
  if(!missing(labels)) xnames<-labels
  if(scale){
     xy<-apply(xy,2,function(x){
             x<-x-min(x); x<-if(max(x)>0) 2*x/max(x)-1 else x })
  } else xy[]<-pmin(pmax(-1,xy),1)
  xy<-rbind(xy);n.c<-dim(xy)[2]
  # expand input matrix xy by replication of cols
  xy<-xy[,(rows.orig<-h<-rep(1:mm,ceiling(n.char/mm))),drop=FALSE]
  if(fill) xy[,-(1:n.c)]<-0

  face.orig<-list(
        eye  =rbind(c(12,0),c(19,8),c(30,8),c(37,0),c(30,-8),c(19,-8),c(12,0))
       ,iris =rbind(c(20,0),c(24,4),c(29,0),c(24,-5),c(20,0))
       ,lipso=rbind(c(0,-47),c( 7,-49),lipsiend=c( 16,-53),c( 7,-60),c(0,-62))
       ,lipsi=rbind(c(7,-54),c(0,-54))                  # add lipsiend
       ,nose =rbind(c(0,-6),c(3,-16),c(6,-30),c(0,-31))
       ,shape =rbind(c(0,44),c(29,40),c(51,22),hairend=c(54,11),earsta=c(52,-4),
                    earend=c(46,-36),c(38,-61),c(25,-83),c(0,-89))
       ,ear  =rbind(c(60,-11),c(57,-30))                # add earsta,earend
       ,hair =rbind(hair1=c(72,12),hair2=c(64,50),c(36,74),c(0,79)) # add hairend
  )
  lipso.refl.ind<-4:1
  lipsi.refl.ind<-1
  nose.refl.ind<-3:1
  hair.refl.ind<-3:1
  shape.refl.ind<-8:1
  shape.xnotnull<-2:8
  nose.xnotnull<-2:3

  nr<-n^0.5; nc<-n^0.5
  if(!missing(nrow.plot)) nr<-nrow.plot
  if(!missing(ncol.plot)) nc<-ncol.plot
  if(plot.faces){
    opar<-par(mfrow=c(ceiling(c(nr,nc))),oma=rep(6,4), mar=rep(.7,4))
    on.exit(par(opar))
  }

  face.list<-list()
  for(ind in 1:n){
    factors<-xy[ind,]
    face<-face.orig

    m<-mean(face$lipso[,2])
    face$lipso[,2]<-m+(face$lipso[,2]-m)*(1+0.7*factors[4])
    face$lipsi[,2]<-m+(face$lipsi[,2]-m)*(1+0.7*factors[4])
    face$lipso[,1]<-face$lipso[,1]*(1+0.7*factors[5])
    face$lipsi[,1]<-face$lipsi[,1]*(1+0.7*factors[5])
    face$lipso["lipsiend",2]<-face$lipso["lipsiend",2]+20*factors[6]

    m<-mean(face$eye[,2])
    face$eye[,2] <-m+(face$eye[,2] -m)*(1+0.7*factors[7])
    face$iris[,2]<-m+(face$iris[,2]-m)*(1+0.7*factors[7])
    m<-mean(face$eye[,1])
    face$eye[,1] <-m+(face$eye[,1] -m)*(1+0.7*factors[8])
    face$iris[,1]<-m+(face$iris[,1]-m)*(1+0.7*factors[8])


    m<-min(face$hair[,2])
    face$hair[,2]<-m+(face$hair[,2]-m)*(1+0.2*factors[9])
    m<-0
    face$hair[,1]<-m+(face$hair[,1]-m)*(1+0.2*factors[10])
    m<-0
    face$hair[c("hair1","hair2"),2]<-face$hair[c("hair1","hair2"),2]+50*factors[11]

    m<-mean(face$nose[,2])
    face$nose[,2]<-m+(face$nose[,2]-m)*(1+0.7*factors[12])
    face$nose[nose.xnotnull,1]<-face$nose[nose.xnotnull,1]*(1+factors[13])

    m<-mean(face$shape[c("earsta","earend"),1])
    face$ear[,1]<-m+(face$ear[,1]-m)* (1+0.7*factors[14])
    m<-min(face$ear[,2])
    face$ear[,2]<-m+(face$ear[,2]-m)* (1+0.7*factors[15])

    face<-lapply(face,function(x){ x[,2]<-x[,2]*(1+0.2*factors[1]);x})
    face<-lapply(face,function(x){ x[,1]<-x[,1]*(1+0.2*factors[2]);x})
    face<-lapply(face,function(x){ x[,1]<-ifelse(x[,1]>0,
                                            ifelse(x[,2] > -30, x[,1],
                      pmax(0,x[,1]+(x[,2]+50)*0.2*sin(1.5*(-factors[3])))),0);x})
    #face$shape[,2]<-face$shape[,2]*(1+0.2*factors[1])
    #face$shape[,1]<-face$shape[,1]*(1+0.2*factors[2])
    #face$shape[,1]<-face$shape[,1]<-ifelse(face$shape[,1]>0,
    #   ifelse(face$shape[,2] > -30, face$shape[,1],
    #      pmax(0,face$shape[,1]+(face$shape[,2]+50)*0.2*sin(1.5*(-factors[3])))),0)

    invert<-function(x) cbind(-x[,1],x[,2])
    face.obj<-list(
         eyer=face$eye
        ,eyel=invert(face$eye)
        ,irisr=face$iris
        ,irisl=invert(face$iris)
        ,lipso=rbind(face$lipso,invert(face$lipso[lipso.refl.ind,]))
        ,lipsi=rbind(face$lipso["lipsiend",],face$lipsi,
                     invert(face$lipsi[lipsi.refl.ind,,drop=FALSE]),
                     invert(face$lipso["lipsiend",,drop=FALSE]))
        ,earr=rbind(face$shape["earsta",],face$ear,face$shape["earend",])
        ,earl=invert(rbind(face$shape["earsta",],face$ear,face$shape["earend",]))
        ,nose=rbind(face$nose,invert(face$nose[nose.refl.ind,]))
        ,hair=rbind(face$shape["hairend",],face$hair,invert(face$hair[hair.refl.ind,]),
                    invert(face$shape["hairend",,drop=FALSE]))
        ,shape=rbind(face$shape,invert(face$shape[shape.refl.ind,]))
    )
    face.list<-c(face.list,list(face.obj))

    if(plot.faces){
      plot(1,type="n",xlim=c(-105,105)*1.1, axes=FALSE,
           ylab="",ylim=c(-105,105)*1.3)
      title(xnames[ind], cex.main = cex, xpd = NA) #180308
      f<-1+(ncolors-1)*(factors+1)/2 # translate factors into color numbers
      xtrans<-function(x){x};  ytrans<-function(y){y}
      for(obj.ind in seq(face.obj)[c(10:11,1:9)]) {
        x <-face.obj[[obj.ind]][,1]; y<-face.obj[[obj.ind]][,2]
        xx<-spline(1:length(x),x,40,FALSE)[,2]
        yy<-spline(1:length(y),y,40,FALSE)[,2]
        if(plot.faces){ 
          lines(xx,yy)
          if(face.type>0){
            if(obj.ind==10) 
              polygon(xtrans(xx),ytrans(yy),col=col.hair[ceiling(mean(f[9:11]))],xpd=NA) # hair
            if(obj.ind==11){ 
              polygon(xtrans(xx),ytrans(yy),col=col.face[ceiling(mean(f[1:2 ]))],xpd=NA) # face
              if(face.type==2){
                  # beard
                  for(zzz in seq(hhh<-max(face.obj[[8]][,1]),-hhh,length=30)){
                    hrx<-rnorm(8,zzz,2); hry<-0:7*-3*rnorm(1,3)+abs(hrx)^2/150
                    hry<-min(face.obj[[9]][,2])+hry
                    lines(xtrans(hrx),ytrans(hry),lwd=5,col="#eeeeee",xpd=NA)
                  }
                  ind<-which.max(xx); wx<-xx[ind]; ind<-which.max(yy); wy<-yy[ind]
                  # edge of hat
                  wxh<-wx<-seq(-wx,wx,length=20); wyh<-wy<-wy-(wx-mean(wx))^2/250+runif(20)*3
                  lines(xtrans(wxh),ytrans(wyh)); wx<-c(wx,rev(wx)); wy<-c(wy-10,rev(wy)+20)
                  wmxy1<-wmxy0<-c(min(wx),min(wy)+20)
                  wmxy2<-wmxy3<-c(runif(1,wmxy0[1],-wmxy0[1]), wy[1]+100)
                  wmxy1[2]<-0.5*(wmxy0[2]+wmxy3[2]); wmxy2[1]<-0.5*(wmxy2[1]+wmxy0[1])
                  npxy<-20; pxy<-seq(0,1,length=npxy)
                  gew<-outer(pxy,0:3,"^")*outer(1-pxy,3:0,"^")*
                       matrix(c(1,3,3,1),npxy,4,byrow=TRUE)
                  wxl<-wmxy0[1]*gew[,1]+wmxy1[1]*gew[,2]+wmxy2[1]*gew[,3]+wmxy3[1]*gew[,4]
                  wyl<-wmxy0[2]*gew[,1]+wmxy1[2]*gew[,2]+wmxy2[2]*gew[,3]+wmxy3[2]*gew[,4]
                  lines(xtrans(wxl),ytrans(wyl),col="green")
                  wmxy1[1]<- wmxy0[1]<- -wmxy0[1]
                  wmxy1[2]<-0.5*(wmxy0[2]+wmxy3[2]); wmxy2[1]<-0.5*(wmxy2[1]+wmxy0[1])
                  wxr<-wmxy0[1]*gew[,1]+wmxy1[1]*gew[,2]+wmxy2[1]*gew[,3]+wmxy3[1]*gew[,4]
                  wyr<-wmxy0[2]*gew[,1]+wmxy1[2]*gew[,2]+wmxy2[2]*gew[,3]+wmxy3[2]*gew[,4]
                  points(xtrans(wmxy3[1]),ytrans(wmxy3[2]),pch=19,cex=2,col="#ffffff",xpd=NA)
                  points(xtrans(wmxy3[1]),ytrans(wmxy3[2]),pch=11,cex=2.53,col="red",xpd=NA)
                  polygon(xtrans(c(wxl,rev(wxr))),ytrans(c(wyl,rev(wyr))),col="red",xpd=NA) # hat
                  polygon(xtrans(wx),ytrans(wy),col="#ffffff",xpd=NA) # edge of hat
              }

            }
            xx<-xtrans(xx); yy<-ytrans(yy)
            if(obj.ind %in% 1:2) polygon(xx,yy,col="#eeeeee") # eyes without iris
            if(obj.ind %in% 3:4) polygon(xx,yy,col=col.eyes[ceiling(mean(f[7:8 ]))],xpd=NA) # eyes:iris
            if(obj.ind %in% 9)   polygon(xx,yy,col=col.nose[ceiling(mean(f[12:13]))],xpd=NA)# nose
            if(obj.ind %in% 5:6) polygon(xx,yy,col=col.lips[ceiling(mean(f[1:3]))],xpd=NA)  # lips
            if(obj.ind %in% 7:8) polygon(xx,yy,col=col.ears[ceiling(mean(f[14:15]))],xpd=NA)# ears

          }
        }
      }
    }

  }

  if(plot.faces&&!missing(main)){
    par(opar);par(mfrow=c(1,1))
    mtext(main, 3, 3, TRUE, 0.5)
    title(main)
  }

  info<-c(
    "var1"="height of face   ",
    "var2"="width of face    ",
    "var3"="structure of face",
    "var4"="height of mouth  ",
    "var5"="width of mouth   ",
    "var6"="smiling          ",
    "var7"="height of eyes   ",
    "var8"="width of eyes    ",
    "var9"="height of hair   ",
    "var10"="width of hair   ",
    "var11"="style of hair   ",
    "var12"="height of nose  ",
    "var13"="width of nose   ",
    "var14"="width of ear    ",
    "var15"="height of ear   ")
  var.names<-dimnames(xy)[[2]]
  if(0==length(var.names)) var.names<-paste("Var",rows.orig,sep="")
  info<-cbind("modified item"=info,"Var"=var.names[1:length(info)])
  rownames(info)<-rep("",15)
  if(print.info){
    cat("effect of variables:\n")
    print(info)
  }
  if(demo&&plot.faces) {
    plot(1:15,1:15,type="n",axes=FALSE,bty="n")
    text(rep(1,15),15:1,adj=0,apply(info,1,function(x) 
        paste(x,collapse="   -   ")),cex=0.7)
  }

  names(face.list)<-xnames
  out<-list(faces=face.list,info=info,xy=t(xy))
  class(out)<-"faces"
  invisible(out)

}

slider<-
function (sl.functions, sl.names, sl.mins, sl.maxs, sl.deltas, 
    sl.defaults, but.functions, but.names, no, set.no.value, 
    obj.name, obj.value, reset.function, title, prompt=FALSE,
    sliders.frame.vertical=TRUE) 
{ # pwolf 080310 080603 100917
  slider.env<-"1"; rm("slider.env")
  if (!exists("slider.env")) slider<-slider.env<<-new.env(parent=.GlobalEnv)
  if (!missing(no)) 
          return(as.numeric(tclvalue(get(paste("slider", no, sep = ""), 
              envir = slider.env))))
  if (!missing(set.no.value)) {
          try(eval(parse(text = paste("tclvalue(slider", set.no.value[1], 
              ")<-", set.no.value[2], sep = "")), envir = slider.env))
          return(set.no.value[2])
  }
  if (!missing(obj.name)) {
          if (!missing(obj.value)) 
              assign(obj.name, obj.value, envir = slider.env)
          else obj.value <- get(obj.name, envir = slider.env)
          return(obj.value)
  }
  if (missing(title))        title<-"slider control widget"
  if (missing(sl.names))     {sl.defaults <- sl.names <- NULL}
  if (missing(sl.functions)) sl.functions <- function(...) {  }
   

  if (!requireNamespace("tcltk", quietly = TRUE)) stop("package 'tcltk' is needed") #190715
  nt.top <-tktoplevel()                              # 160115
  tkwm.title(nt.top, title)                          # 160115
  tkwm.geometry(nt.top, "+0+15")                     # 160115
  assign("tktop.slider", nt.top, envir = slider.env) # 160115
  nt <- tkframe(nt.top)                              # 160115
  "relax"  
  tkpack(f.slider<-tkframe(nt)) ##vertical
  for (i in seq(sl.names)) {
     "relax"
     eval(parse(text=paste("assign('slider", i, 
                           "',tclVar(sl.defaults[i]),envir=slider.env)",sep="")
     ))
  }
  for (i in seq(along=sl.names)) {
     tkpack(fr <- tkframe(f.slider), 
            side = if (sliders.frame.vertical) "top" else "right") ##vertical
     lab <- tklabel(fr, text = sl.names[i], width = "25")
     sc <- tkscale(fr, from = sl.mins[i], to = sl.maxs[i], 
     showvalue = TRUE, resolution = sl.deltas[i], orient = "horiz")
     tkpack(lab, sc, side=if(sliders.frame.vertical) "right" else "top") ##vertical
     assign("sc", sc, envir = slider.env)
     eval(parse(text=paste("tkconfigure(sc,variable=slider", 
                           i, ")", sep = "")), envir = slider.env)
     sl.fun<-if(length(sl.functions)>1)sl.functions[[i]] else sl.functions
     if(!is.function(sl.fun)) 
       sl.fun <- eval(parse(text = paste("function(...){", sl.fun, "}")))
     if(prompt) tkconfigure(sc,command=sl.fun) else tkbind(sc,"<ButtonRelease>",sl.fun)
  }

  assign("slider.values.old", sl.defaults, envir = slider.env)
  tkpack(f.but <- tkframe(nt), fill = "x")
  tkpack(tkbutton(f.but, text = "Exit", 
         command = function() tkdestroy(nt.top)), side = "right") # 160115
  if(!missing(reset.function)){
    # reset.function <- function(...) print("relax")
    if(!is.function(reset.function)) 
      reset.function <- eval(parse(text = 
          paste("function(...){",reset.function, "}")))
    tkpack(tkbutton(f.but,text="Reset", command = function(){
         for (i in seq(sl.names)) 
           eval(parse(text = 
             paste("tclvalue(slider", 
                   i, ")<-", sl.defaults[i], 
                   sep = "")), envir = slider.env)
         reset.function()
    }), side = "right")
  }

  if (missing(but.names)) but.names <- NULL
  for(i in seq(but.names)) {
    but.fun<-if(length(but.functions)>1)but.functions[[i]] else but.functions
    if(!is.function(but.fun)) 
      but.fun<-eval(parse(text = c("function(...){",but.fun,"}")))
    tkpack(tkbutton(f.but, text = but.names[i], command = but.fun), 
                    side = "left")
  }

  Sys.sleep(.2)
  tkpack(nt)

  invisible(nt)
}

gslider<-
function (sl.functions, sl.names, sl.mins, sl.maxs, sl.deltas, 
    sl.defaults, but.functions, but.names, no, set.no.value, 
    obj.name, obj.value, reset.function, title, prompt=FALSE,
    sliders.frame.vertical=TRUE, hscale=1, vscale=1,
    pos.of.panel = c("bottom","top","left","right")[1]) 
{ # pwolf 100915 / 121206
  if (!requireNamespace("tkrplot", quietly = TRUE)) stop("package 'tkrplot' is needed") #190715
  slider.env<-"1"; rm("slider.env")
  if (!exists("slider.env")) slider<-slider.env<<-new.env(parent=.GlobalEnv)
  if (!missing(no)) 
          return(as.numeric(tclvalue(get(paste("slider", no, sep = ""), 
              envir = slider.env))))
  if (!missing(set.no.value)) {
          try(eval(parse(text = paste("tclvalue(slider", set.no.value[1], 
              ")<-", set.no.value[2], sep = "")), envir = slider.env))
          return(set.no.value[2])
  }
  if (!missing(obj.name)) {
          if (!missing(obj.value)) 
              assign(obj.name, obj.value, envir = slider.env)
          else obj.value <- get(obj.name, envir = slider.env)
          return(obj.value)
  }
  if (missing(title))        title<-"slider control widget"
  if (missing(sl.names))     {sl.defaults <- sl.names <- NULL}
  if (missing(sl.functions)) sl.functions <- function(...) {  }
   

  if (!requireNamespace("tcltk", quietly = TRUE)) stop("package 'tcltk' is needed") #190715
  nt.top <-tktoplevel()                              # 160115
  tkwm.title(nt.top, title)                          # 160115
  tkwm.geometry(nt.top, "+0+15")                     # 160115
  assign("tktop.slider", nt.top, envir = slider.env) # 160115
  nt <- tkframe(nt.top)                              # 160115
  "relax"  
  nt.bak <- nt
  sl.frame <- tkframe(nt); gr.frame <- tkframe(nt)
  if( !any(pos.of.panel == c("bottom","top","left","right"))) pos.of.panel <- "bottom"
  tkpack(sl.frame,gr.frame,side=pos.of.panel)
  # gslider start:  
  newpl<-function(...){ graphics::plot(0:2,0:2,type="n",xlab="",ylab=""); graphics::text(1,1,"dummy plot") }
  img <- tkrplot::tkrplot(gr.frame, newpl, vscale=vscale, hscale=hscale ); tkpack(img,side="top") 
  assign("img",img,envir=slider.env)



  # :gslider end
  ## sliders.frame.vertical ##vertical
  tkpack(f.slider<-tkframe(sl.frame)) ##vertical
  for (i in seq(along=sl.names)) {
     "relax"
     eval(parse(text=paste("assign('slider", i, 
                           "',tclVar(sl.defaults[i]),envir=slider.env)",sep="")
     ))
  }
  # gslider start:
  parent.env<-sys.frame(sys.nframe()-1)
  # :gslider end
  for (i in seq(along=sl.names)) {
     tkpack(fr <- tkframe(f.slider), # 
            side = if( pos.of.panel %in% c("left","right")) "top" else {
                     if (sliders.frame.vertical) "top" else "right" ##vertical
                   })
     lab <- tklabel(fr, text = sl.names[i], width = "25")
     sc <- tkscale(fr, from = sl.mins[i], to = sl.maxs[i], 
                   showvalue = TRUE, resolution = sl.deltas[i], orient = "horiz")
     tkpack(lab, sc, 
            side=  if( pos.of.panel %in% c("left","right")) "top" else {
                     if(sliders.frame.vertical) "right" else "top" ##vertical
                   })
     assign("sc", sc, envir = slider.env)
     eval(parse(text=paste("tkconfigure(sc,variable=slider", 
                           i, ")", sep = "")), envir = slider.env)
     sl.fun<-if(is.list(sl.functions))sl.functions[[min(i,length(sl.functions))]]
             else                     sl.functions
     if(!is.function(sl.fun)) 
       sl.fun <- eval(parse(text = paste("function(...){", sl.fun, "}")))
    # gslider start:
      fname<-paste("tkrrsl.fun",i,sep="")
      eval(parse(text=c(paste(fname, " <-")," function(...){", 
                  "tkrreplot(get('img',envir=slider.env),fun=function()",
                  deparse(sl.fun)[-1],")", "}" )))       
      eval(parse(text=paste("environment(",fname,")<-parent.env")))     
      if (prompt) tkconfigure(sc, command = get(fname))
          else tkbind(sc, "<ButtonRelease>", get(fname))
  }
  if(exists("tkrrsl.fun1")) get("tkrrsl.fun1")() ## gslider only
  # :gslider end




  assign("slider.values.old", sl.defaults, envir = slider.env)
  tkpack(f.but <- tkframe(sl.frame), fill = "x")
  tkpack(tkbutton(f.but, text = "Exit", 
         command = function() tkdestroy(nt.top)), side = "right")
  if(!missing(reset.function)){
    # reset.function <- function(...) print("relax")
    if(!is.function(reset.function)) 
      reset.function <- eval(parse(text = 
          paste("function(...){",reset.function, "}")))
    fname<-"reset.function"
    idx<-seq(along=sl.names)
    hhh <- paste(sep = "","sl",idx,"<-get('slider",idx,"',envir=slider.env);",
                          "tclvalue(sl",idx,")<-",sl.defaults[idx],"\n")
    eval(parse(text = c(paste(fname, " <-"), " function(...){", hhh,
              "tkrreplot(get('img',envir=slider.env),fun=function()", 
              deparse(reset.function)[-1], ")", "}")))
    eval(parse(text = paste("environment(", fname, ")<-parent.env")))
    tkpack(tkbutton(f.but, text = "Reset", command = get(fname)), side = "right")
  }

  if (missing(but.names)) but.names <- NULL
  for(i in seq(along=but.names)) {
    but.fun<-if(is.list(but.functions)) but.functions[[min(i,length(but.functions))]]
             else                       but.functions

    if(!is.function(but.fun)) but.fun<-eval(parse(text = c("function(...){",but.fun,"}")))
    # gslider start:
    fname<-paste("tkrr.fun",i,sep="")
    eval(parse(text=c(paste(fname, " <-")," function(...){", 
                  "tkrreplot(get('img',envir=slider.env),fun=function()",
                  deparse(but.fun)[-1],")", "}" )))       
    eval(parse(text=paste("environment(",fname,")<-parent.env")))     
    
    tkpack(tkbutton(f.but, text = but.names[i], command = get(fname)), side = "left")
  }
  if(exists("tkrr.fun1")) get("tkrr.fun1")() ## gslider only
  # :gslider end


  Sys.sleep(.2)
  tkpack(nt)

  invisible(img)
}

slider.split.plot.ts<-function(x,type="l",...)
{  
 x.name<-deparse(substitute(x))
 if(missing(x)||length(x)<2) return("Error: x must be a vector")
 y<-x; if(is.ts(x)) { x<-time(x) } else { x<-seq(x) }

 args<-list(...)
 n<-length(x); xmin<-min(x); xmax<-max(x)
 xdelta<-xmax-xmin
 slider(obj.name="summary.type",obj.value="linear")
 refresh<-function(...){
 # initialization
   summary.type<-slider(obj.name="summary.type")
   width<-slider(no=1)
   limit<-slider(no=2)
   n.sec<-1 
   limit<-limit-width*ceiling((limit-xmin)/width)
 # plot: # plot(x,y,type=type,bty="n",xlab="",ylab="")
   do.call("plot",c(alist(x,y,type=type),args))
   limit<-limit-width-width/n.sec; j<-0
 #   abline(v=limits,lwd=0.5,lty=3)    
   while(limit<xmax){ j<-j+1
     limit<-limit+width/n.sec; limit2<-limit+width
     ind<-limit<=x & x<=limit2
     xx<-x[ind]; yy<-y[ind]; if(length(xx)<2) next
     abline(v=limit,lwd=0.5,lty=3,col=1)    
     if(summary.type=="linear"){
       coef<-lm(yy~xx)$coef
       segments(limit, coef[1]+coef[2]*limit,
                limit2,coef[1]+coef[2]*limit2,col=j) 
     }
     if(summary.type=="five.number"){
       five<-fivenum(yy)
       xx<-0.5*(limit+limit2)
       points(xx,five[3],pch=19,cex=1,col="red")
       segments(xx,five[1],xx,five[2],lwd=3,col="red")
       segments(xx,five[4],xx,five[5],lwd=3,col="red")
     }
   }
   abline(v=slider(no=2),lwd=0.5,lty=1,col=1)    
 }    
 f1<-function(...){
   slider(obj.name="summary.type",obj.value="linear")
   refresh()
 }
 f2<-function(...){
   slider(obj.name="summary.type",obj.value="five.number")
   refresh()
 }
 slider(refresh,c("width of window","limit"),
      c(xdelta/length(x)*3,xmin),c(xdelta,xmax),
      c(xdelta/1000,xdelta/1000),c(xdelta/4,xmin),
      but.functions=c(f1,f2),
      but.names=c("linear model","fivenum summary")
 )
 refresh() 
 cat("select window and summary type and look at time series!\n")
}

slider.density<-function(x,panel=rug,...)
{
  x.name<-deparse(substitute(x))
  if(missing(x)||length(x)<2) return("Error: x must be a vector")

  args<-list(...)
  if(!any("main"==names(args))) args<-c(args,list(main=x.name))
  kernel<-c("gaussian",  "epanechnikov","rectangular",
            "triangular","biweight",    "cosine",     "optcosine")
  slider(obj.name="kno",obj.value=1)
  refresh<-function(...){
    width<-slider(no=1)*diff(range(x))/100
    kno<-slider(obj.name="kno"); kernel<-kernel[kno]
    xy<-density(x,width=width,kernel=kernel)
    do.call("plot",c(alist(x=xy),args))
    title(paste("\n\nwidth =",signif(width,4),", kernel =",kernel))
    panel(x)
  }
  set.kernel<-function(...){  
    kernel<-slider(no=2)
    slider(obj.name="kno",obj.value=kernel)
    refresh()
  }
  bw.default<-diff(range(x))/density(x)$bw
  nt <- slider(c(refresh,set.kernel),
         c("width (% of range)","kernel"),
         c(.1,1),c(100,7),c(.1,1),c(bw.default,1)
  )
  # tkwm.minsize(nt, "300", "110") # set width, height to prevent to small sizes
  refresh()
  cat("use slider to select width of window and to select kernel:\n")
  print(cbind("no"=1:7,"kernel"=kernel))
}

slider.hist<-function(x,panel=rug,...)
{
  x.name<-deparse(substitute(x))
  if(missing(x)||length(x)<2) return("Error: x must be a vector")

  args<-list(...)
  args<-args[names(args)!="breaks"]
  ClassNumber<-length(hist(x,plot=FALSE)$breaks)
  if(!any("main"==names(args)))args<-c(args,list(main=x.name))
  refresh<-function(...){
    xrange<-range(x); num<-slider(no=1)
    breaks<-seq(xrange[1],xrange[2],length=num+1)
    do.call("hist",c(alist(x=x,breaks=breaks),args))
    panel(x)
  }
  slider(refresh,"ClassNumber",1,100,1,ClassNumber);  refresh()
  "use slider to select number of classes"
}

slider.brush.plot.xy<-function(x,y=NULL,z=NULL,...)
{
  x.name<-deparse(substitute(x))
  y.name<-deparse(substitute(y))
  z.name<-deparse(substitute(z))
  if(length(x)<2) return("Error: x is of length 0 or 1")
  if(!is.null(y)){ 
    if(length(y)<2) return("Error: y must be a vector")
    if(length(x)!=length(y)) 
      return("Error: x and y must have the same length")
    x<-cbind(x,y) 
  }
  if(!is.null(z)){ 
    if(length(z)<2) return("Error: z must be a vector")
    if(length(x)!=length(z)) 
      return("Error: x and z must have the same length")
    x<-cbind(x,z) 
  }
  if(!is.matrix(x)&& !is.data.frame(x) && ncol(x)<3)
    return("Error: not enough variables")
  if("NULL"==y.name){x.name<-colnames(x)[1]; y.name<-colnames(x)[2]}
  if("NULL"==z.name){x.name<-colnames(x)[1]; z.name<-colnames(x)[3]}
  z<-x[,3]; y<-x[,2]; x<-x[,1]

  args<-list(...)
  if(!any("main"==names(args))) 
    args<-c(args,list(main=paste(x.name,"<-->",y.name)))
  if(!any("xlab"==names(args)))args<-c(args,list(xlab=x.name))
  if(!any("ylab"==names(args)))args<-c(args,list(ylab=y.name))
  do.call("plot.default",c(alist(x=x,y=y,pch=19),args))
  refresh<-function(...){
    zrange<-range(z); z1<-slider(no=1); z2<-slider(no=2)
    zmin<-z1; zmax<-z1+z2; ind<-zmin<=z&z<=zmax; pos<-par()$usr
    rect(pos[2],pos[4],pos[1]*.5+pos[2]*.5,pos[3]*.1+pos[4]*.9,
         col="white",border=NA)
    txt<-paste(z.name,"(red) in [",format(zmin,digits=4),",",
               format(zmax,digits=4),"]",sep="")
    text(pos[2],pos[4],txt,adj=c(1,1),col="red",cex=0.7)
    col<-c("black","red")[1+ind]
    points(x,y,col=col,pch=19,
           cex=if("cex" %in% names(args)) args$cex else 1)
  }
  z.min<-min(z); z.max<-max(z); delta<-(z.max-z.min)/100
  reset<-function(...){
    do.call("plot",c(alist(x=x,y=y,col="red",pch=19),args)); pos<-par()$usr #090216
    rect(pos[2],pos[4],pos[1]*.4+pos[2]*.6,pos[3]*.1+pos[4]*.9,
         col="white",border=NA)
  }
  slider(refresh,
         c("minimum of z","interval width of z"),
         c(z.min,0),c(z.max+delta,(z.max-z.min)+delta),
         c(delta,delta),c(z.min-delta,(z.max-z.min)/2),
         reset.function=reset
  )
  refresh()
  cat("use sliders to select interval for inking points\n")
}

plot.faces<-function(x,x.pos,y.pos,face.type = 1, 
                     width=1,height=1,labels,
                     ncolors=20,
                     col.nose=rainbow(ncolors),                   # nose
                     col.eyes=rainbow(ncolors,start=0.6,end=0.85),# eyes
                     col.hair=terrain.colors(ncolors),            # hair
                     col.face=heat.colors(ncolors),               # face
                     col.lips=rainbow(ncolors,start=0.0,end=0.2), # lips
                     col.ears=rainbow(ncolors,start=0.0,end=0.2), # ears

                     cex = 2, ...){ #180308
  if(missing(x)) return("no face.list object in call")
  face.list<-x$faces; face.data<-x$xy
  if(class(face.list)!="faces") {
      if(!is.list(face.list) || !any(names(face.list[[1]])=="lipso") )
        return("input not of class faces")
  }
  spline<-function(a,y,m=200,plot=FALSE){
      n<-length(a)
    h<-diff(a)
    dy<-diff(y)
    sigma<-dy/h
    lambda<-h[-1]/(hh<-h[-1]+h[-length(h)])
    mu<-1-lambda
    d<-6*diff(sigma)/hh
    tri.mat<-2*diag(n-2)
    tri.mat[2+  (0:(n-4))*(n-1)] <-mu[-1]
    tri.mat[    (1:(n-3))*(n-1)] <-lambda[-(n-2)]
    M<-c(0,solve(tri.mat)%*%d,0)
    x<-seq(from=a[1],to=a[n],length=m)
    anz.kl <- hist(x,breaks=a,plot=FALSE)$counts
    adj<-function(i) i-1
    i<-rep(1:(n-1),anz.kl)+1
    S.x<-  M[i-1]*(a[i]-x          )^3 / (6*h[adj(i)])  +
           M[i]  *(x        -a[i-1])^3 / (6*h[adj(i)])  +
           (y[i-1] - M[i-1]*h[adj(i)]^2 /6) * (a[i]-x)/ h[adj(i)] +
          (y[i]   - M[i]  *h[adj(i)]^2 /6) * (x-a[i-1]) / h[adj(i)]
    if(plot){ plot(x,S.x,type="l"); points(a,y)    }
    return(cbind(x,S.x))
  }

  n<-length(face.list)
  if(missing(x.pos)){
     co<-ro<-ceiling(n^0.5)
     plot((0:ro)+.5,(0:co)+.5,type="n",xlab="",ylab="",axes=FALSE)
     m<-matrix(1,ro,co); x.pos<-col(m); y.pos<-(1+ro)-row(m)
  } 
  if(!missing(labels)) names(face.list)<-labels 
  fac.x<-width/1.1/210; fac.y<-height/1.3/210
  xtrans<-function(x){x.pos[j]+fac.x*x};  ytrans<-function(y){y.pos[j]+fac.y*y}
  for(j in seq(face.list)){
    face.obj<-face.list[[j]]; factors<-face.data[,j]
    f<-1+(ncolors-1)*(factors+1)/2 # translate factors into color numbers
    for(obj.ind in seq(face.obj)[c(10:11,1:9)]) {
       x <-face.obj[[obj.ind]][,1]; y<-face.obj[[obj.ind]][,2]
       xx<-spline(1:length(x),x,40,FALSE)[,2]
       yy<-spline(1:length(y),y,40,FALSE)[,2]
       lines(xtrans(xx),ytrans(yy),...)
       if(face.type>0){ if(obj.ind==10) 
                          polygon(xtrans(xx),ytrans(yy),col=col.hair[ceiling(mean(f[9:11]))],xpd=NA) # hair
                        if(obj.ind==11){ 
                          polygon(xtrans(xx),ytrans(yy),col=col.face[ceiling(mean(f[1:2 ]))],xpd=NA) # face
                          if(face.type==2){
                              # beard
                              for(zzz in seq(hhh<-max(face.obj[[8]][,1]),-hhh,length=30)){
                                hrx<-rnorm(8,zzz,2); hry<-0:7*-3*rnorm(1,3)+abs(hrx)^2/150
                                hry<-min(face.obj[[9]][,2])+hry
                                lines(xtrans(hrx),ytrans(hry),lwd=5,col="#eeeeee",xpd=NA)
                              }
                              ind<-which.max(xx); wx<-xx[ind]; ind<-which.max(yy); wy<-yy[ind]
                              # edge of hat
                              wxh<-wx<-seq(-wx,wx,length=20); wyh<-wy<-wy-(wx-mean(wx))^2/250+runif(20)*3
                              lines(xtrans(wxh),ytrans(wyh)); wx<-c(wx,rev(wx)); wy<-c(wy-10,rev(wy)+20)
                              wmxy1<-wmxy0<-c(min(wx),min(wy)+20)
                              wmxy2<-wmxy3<-c(runif(1,wmxy0[1],-wmxy0[1]), wy[1]+100)
                              wmxy1[2]<-0.5*(wmxy0[2]+wmxy3[2]); wmxy2[1]<-0.5*(wmxy2[1]+wmxy0[1])
                              npxy<-20; pxy<-seq(0,1,length=npxy)
                              gew<-outer(pxy,0:3,"^")*outer(1-pxy,3:0,"^")*
                                   matrix(c(1,3,3,1),npxy,4,byrow=TRUE)
                              wxl<-wmxy0[1]*gew[,1]+wmxy1[1]*gew[,2]+wmxy2[1]*gew[,3]+wmxy3[1]*gew[,4]
                              wyl<-wmxy0[2]*gew[,1]+wmxy1[2]*gew[,2]+wmxy2[2]*gew[,3]+wmxy3[2]*gew[,4]
                              lines(xtrans(wxl),ytrans(wyl),col="green")
                              wmxy1[1]<- wmxy0[1]<- -wmxy0[1]
                              wmxy1[2]<-0.5*(wmxy0[2]+wmxy3[2]); wmxy2[1]<-0.5*(wmxy2[1]+wmxy0[1])
                              wxr<-wmxy0[1]*gew[,1]+wmxy1[1]*gew[,2]+wmxy2[1]*gew[,3]+wmxy3[1]*gew[,4]
                              wyr<-wmxy0[2]*gew[,1]+wmxy1[2]*gew[,2]+wmxy2[2]*gew[,3]+wmxy3[2]*gew[,4]
                              points(xtrans(wmxy3[1]),ytrans(wmxy3[2]),pch=19,cex=2,col="#ffffff",xpd=NA)
                              points(xtrans(wmxy3[1]),ytrans(wmxy3[2]),pch=11,cex=2.53,col="red",xpd=NA)
                              polygon(xtrans(c(wxl,rev(wxr))),ytrans(c(wyl,rev(wyr))),col="red",xpd=NA) # hat
                              polygon(xtrans(wx),ytrans(wy),col="#ffffff",xpd=NA) # edge of hat
                          }

                        }
                        xx<-xtrans(xx); yy<-ytrans(yy)
                        if(obj.ind %in% 1:2) polygon(xx,yy,col="#eeeeee") # eyes without iris
                        if(obj.ind %in% 3:4) polygon(xx,yy,col=col.eyes[ceiling(mean(f[7:8 ]))],xpd=NA) # eyes:iris
                        if(obj.ind %in% 9)   polygon(xx,yy,col=col.nose[ceiling(mean(f[12:13]))],xpd=NA)# nose
                        if(obj.ind %in% 5:6) polygon(xx,yy,col=col.lips[ceiling(mean(f[1:3]))],xpd=NA)  # lips
                        if(obj.ind %in% 7:8) polygon(xx,yy,col=col.ears[ceiling(mean(f[14:15]))],xpd=NA)# ears
 }
    }
    lab<-names(face.list)[j]
    text(x.pos[j],y.pos[j]-0.5*height,lab,xpd=NA, cex = cex)
  }
}

#0:
##start:##
compute.bagplot<-function(x,y,
   factor=3, # expanding factor for bag to get the loop
   na.rm=FALSE, # should NAs removed or exchanged
   approx.limit=300, # limit 
   dkmethod=2, # in 1:2; method 2 is recommended
   precision=1, # controls precision of computation
   verbose=FALSE,debug.plots="no" # tools for debugging
){
  
"bagplot, version 2012/12/05, peter wolf"
  
  
# define some functions
win<-function(dx,dy){  atan2(y=dy,x=dx) }
out.of.polygon<-function(xy,pg){  # 121026
  xy<-matrix(xy,ncol=2)
  # check trivial case
  if(nrow(pg)==1)  return(xy[,1]==pg[1] & xy[,2]==pg[2])
  # store number of points of xy and polygon
  m<-nrow(xy); n<-nrow(pg)
  # find small value relative to polygon
  limit <- -abs(1E-10*diff(range(pg)))
  # find vectors that are orthogonal to segments of polygon
  pgn<-cbind(diff(c(pg[,2],pg[1,2])),-diff(c(pg[,1],pg[1,1])))
  # find center of gravity of xy
  S<-colMeans(xy)
  # compute negative distances of polygon to center of gravity of xy
  dxy<-cbind(S[1]-pg[,1],S[2]-pg[,2])
  # unused: S.in.pg<-all(limit<apply(dxy*pgn,1,sum))
  if( !all( limit < apply(dxy*pgn,1,sum) ) ){
    pg<-pg[n:1,]; pgn<--pgn[n:1,]
  }
  # initialize result
  in.pg<-rep(TRUE,m)
  for(j in 1:n){
    dxy<-xy-matrix(pg[j,],m,2,byrow=TRUE)
    in.pg<-in.pg & limit<(dxy%*%pgn[j,])
  }
  return(!in.pg)
}
cut.z.pg<-function(zx,zy,p1x,p1y,p2x,p2y){
  a2<-(p2y-p1y)/(p2x-p1x); a1<-zy/zx
  sx<-(p1y-a2*p1x)/(a1-a2); sy<-a1*sx
  sxy<-cbind(sx,sy)
  h<-any(is.nan(sxy))||any(is.na(sxy))||any(Inf==abs(sxy))
  if(h){ # print("NAN found"); print(cbind(a1,a2,zx,zy,sxy,p2x-p1x))
  if(!exists("verbose")) verbose<-FALSE
    if(verbose) cat("special")
    # zx is zero # 121030
    h<-0==zx 
       sx<-ifelse(h,zx,sx); sy<-ifelse(h,p1y-a2*p1x,sy)
    # points on line defined by line segment
    a1 <- ifelse( abs(a1) == Inf, sign(a1)*123456789*1E10, a1) # 121030
    a2 <- ifelse( abs(a2) == Inf, sign(a2)*123456789*1E10, a2)
    # points on line defined by line segment
    h<-0==(a1-a2) & sign(zx)==sign(p1x)
       sx<-ifelse(h,p1x,sx); sy<-ifelse(h,p1y,sy)
    h<-0==(a1-a2) & sign(zx)!=sign(p1x)
       sx<-ifelse(h,p2x,sx); sy<-ifelse(h,p2y,sy)
    # line segment vertical 
    #   & center NOT ON line segment
    h<-p1x==p2x & zx!=p1x & p1x!=0 
       sx<-ifelse(h,p1x,sx); sy<-ifelse(h,zy*p1x/zx,sy)
    #   & center ON line segment
    h<-p1x==p2x & zx!=p1x & p1x==0 
       sx<-ifelse(h,p1x,sx); sy<-ifelse(h,0,sy)
    #   & center NOT ON line segment & point on line     # 121126
    h<-p1x==p2x & zx==p1x & p1x!=0 # & sign(zy)==sign(p1y)
         sx<-ifelse(h,zx,sx); sy<-ifelse(h,zy,sy)
    #   & center ON line segment & point on line
    h<-p1x==p2x & zx==p1x & p1x==0 & sign(zy)==sign(p1y)
       sx<-ifelse(h,p1x,sx); sy<-ifelse(h,p1y,sy)
    h<-p1x==p2x & zx==p1x & p1x==0 & sign(zy)!=sign(p1y)
       sx<-ifelse(h,p1x,sx); sy<-ifelse(h,p2y,sy)
    #  points identical to end points of line segment
    h<-zx==p1x & zy==p1y; sx<-ifelse(h,p1x,sx); sy<-ifelse(h,p1y,sy)
    h<-zx==p2x & zy==p2y; sx<-ifelse(h,p2x,sx); sy<-ifelse(h,p2y,sy)
    # point of z is center
    h<-zx==0 & zy==0; sx<-ifelse(h,0,sx); sy<-ifelse(h,0,sy)
    sxy<-cbind(sx,sy)
  } # end of special cases
  #if(verbose){ print(rbind(a1,a2));print(cbind(zx,zy,p1x,p1y,p2x,p2y,sxy))}
  if(!exists("debug.plots")) debug.plots<-"no"
  if(debug.plots=="all"){
    segments(sxy[,1],sxy[,2],zx,zy,col="red") 
    segments(0,0,sxy[,1],sxy[,2],col="green",lty=2) ##!!
    points(sxy,col="red")
  }
  return(sxy)
} 
find.cut.z.pg<-function(z,pg,center=c(0,0),debug.plots="no"){
  if(!is.matrix(z)) z<-rbind(z)
  if(1==nrow(pg)) return(matrix(center,nrow(z),2,TRUE))
  n.pg<-nrow(pg); n.z<-nrow(z)
  z<-cbind(z[,1]-center[1],z[,2]-center[2])
  pgo<-pg; pg<-cbind(pg[,1]-center[1],pg[,2]-center[2])
  if(!exists("debug.plots")) debug.plots<-"no"
  if(debug.plots=="all"){
           plot(rbind(z,pg,0),bty="n"); points(z,pch="p")
           lines(c(pg[,1],pg[1,1]),c(pg[,2],pg[1,2]))}
  # find angles of pg und z
  apg<-win(pg[,1],pg[,2])
  apg[is.nan(apg)]<-0; a<-order(apg); apg<-apg[a]; pg<-pg[a,]
  az<-win(z[,1],z[,2])
  # find line segments
  segm.no<-apply((outer(apg,az,"<")),2,sum)
  segm.no<-ifelse(segm.no==0,n.pg,segm.no)
  next.no<-1+(segm.no %% length(apg))
  # compute cut points
  cuts<-cut.z.pg(z[,1],z[,2],pg[segm.no,1],pg[segm.no,2],
                             pg[next.no,1],pg[next.no,2])
  # rescale 
  cuts<-cbind(cuts[,1]+center[1],cuts[,2]+center[2])
  return(cuts)
}
## find.cut.z.pg(EX,  EX1,center=CE)
hdepth.of.points<-function(tp){ 
  # 121030 second parameter n has been removed
  # if(!exists("precision")) precision <- 1 # 121203
  # return(find.hdepths.tp(tp, xy, 181*precision)) # 121202
  n.tp<-nrow(tp)
  tphdepth<-rep(0,n.tp); dpi<-2*pi-0.000001
  for(j in 1:n.tp) {
    dx<-tp[j,1]-xy[,1]; dy<-tp[j,2]-xy[,2] 
    a<-win(dx,dy)+pi; h<-a<10; a<-a[h]; ident<-sum(!h)
    init<-sum(a < pi); a.shift<-(a+pi) %% dpi
    minusplus<-c(rep(-1,length(a)),rep(1,length(a))) ## 070824 
    h<-cumsum(minusplus[order(c(a,a.shift))])
    tphdepth[j]<-init+min(h)+1 # +1 because of the point itself!!
    # tphdepth[j]<-init+min(h)+ident; cat("SUMME",ident)
  }
  tphdepth
}
expand.hull<-function(pg,k){
  if( 1 >= nrow(pg) ) return(pg) ## 121026 ## 121123 <= statt ==
  
resolution<-floor(20*precision)
pg0<-xy[hdepth==1,]
pg0<-pg0[chull(pg0[,1],pg0[,2]),]
end.points<-find.cut.z.pg(pg,pg0,center=center,debug.plots=debug.plots)
lam<-((0:resolution)^1)/resolution^1
  
pg.new<-pg
for(i in 1:nrow(pg)){
  tp<-cbind(pg[i,1]+lam*(end.points[i,1]-pg[i,1]),
            pg[i,2]+lam*(end.points[i,2]-pg[i,2]))
  # hd.tp<-hdepth.of.points(tp)
  hd.tp<-find.hdepths.tp(tp,xy)
  ind<-max(sum(hd.tp>=k),1) 
  if(ind<length(hd.tp)){  # hd.tp[ind]>k && 
    tp<-cbind(tp[ind,1]+lam*(tp[ind+1,1]-tp[ind,1]),
              tp[ind,2]+lam*(tp[ind+1,2]-tp[ind,2]))
    # hd.tp<-hdepth.of.points(tp)
    hp.tp<-find.hdepths.tp(tp,xy)
    ind<-max(sum(hd.tp>=k),1) 
  } 
  pg.new[i,]<-tp[ind,]
}
pg.new<-pg.new[chull(pg.new[,1],pg.new[,2]),]
# cat("depth pg.new", hdepth.of.points(pg.new))
# cat("depth pg.new", find.hdepths.tp(pg.new,xy))
  
pg.add<-0.5*(pg.new+rbind(pg.new[-1,],pg.new[1,]))
# end.points<-find.cut.z.pg(pg,pg0,center=center)
end.points<-find.cut.z.pg(pg.add,pg0,center=center) ## 070824
for(i in 1:nrow(pg.add)){
  tp<-cbind(pg.add[i,1]+lam*(end.points[i,1]-pg.add[i,1]),
            pg.add[i,2]+lam*(end.points[i,2]-pg.add[i,2]))
  # hd.tp<-hdepth.of.points(tp)
  hd.tp<-find.hdepths.tp(tp,xy)
  ind<-max(sum(hd.tp>=k),1) 
  if(ind<length(hd.tp)){ # hd.tp[ind]>k && 
    tp<-cbind(tp[ind,1]+lam*(tp[ind+1,1]-tp[ind,1]),
              tp[ind,2]+lam*(tp[ind+1,2]-tp[ind,2]))
    # hd.tp<-hdepth.of.points(tp)
    hd.tp<-find.hdepths.tp(tp,xy)
    ind<-max(sum(hd.tp>=k),1) 
  } 
  pg.add[i,]<-tp[ind,]
}
# cat("depth pg.add", hdepth.of.points(pg.add))
  
pg.new<-rbind(pg.new,pg.add)
pg.new<-pg.new[chull(pg.new[,1],pg.new[,2]),]
}
cut.p.sl.p.sl<-function(xy1,m1,xy2,m2){
  sx<-(xy2[2]-m2*xy2[1]-xy1[2]+m1*xy1[1])/(m1-m2)
  sy<-xy1[2]-m1*xy1[1]+m1*sx
  if(!is.nan(sy)) return( c(sx,sy) )
  if(abs(m1)==Inf) return( c(xy1[1],xy2[2]+m2*(xy1[1]-xy2[1])) )
  if(abs(m2)==Inf) return( c(xy2[1],xy1[2]+m1*(xy2[1]-xy1[1])) )
}
pos.to.pg<-function(z,pg,reverse=FALSE){
  if(reverse){
    int.no<-apply(outer(pg[,1],z[,1],">="),2,sum)
    zy.on.pg<-pg[int.no,2]+pg[int.no,3]*(z[,1]-pg[int.no,1])
  }else{
    int.no<-apply(outer(pg[,1],z[,1],"<="),2,sum)
    zy.on.pg<-pg[int.no,2]+pg[int.no,3]*(z[,1]-pg[int.no,1])
  }
  ### ifelse(z[,2]<zy.on.pg, "lower","higher") ### 121004
  result <- ifelse(z[,2]<zy.on.pg, "lower","higher") ###
  return(result)
  if( all(result=="lower") ){
    result <- ifelse(((z[,2] - zy.on.pg)/max(z[,2] - zy.on.pg)+1e-10) < 0, 
                     "lower","higher")
  }
  if( all(result=="higher") ){
    result <- ifelse(((z[,2] - zy.on.pg)/max(z[,2] - zy.on.pg)-1e-10) < 0, 
                     "lower","higher")
  }
  print(result)
  return(result)
}
find.polygon.center<-function(xy){
  ## if(missing(xy)){n<-50;x<-rnorm(n);y<-rnorm(n); xy<-cbind(x,y)}
  ## xy<-xy[chull(xy),]
  if(length(xy)==2) return(xy[1:2])
  if(nrow(xy)==2) return(colMeans(xy)) ## 121009
  ## partition polygon into triangles
  n<-length(xy[,1]); mxy<-colMeans(xy)
  xy2<-rbind(xy[-1,],xy[1,]); xy3<-cbind(rep(mxy[1],n),mxy[2])
  ## determine areas and centers of gravity of triangles
  S<-(xy+xy2+xy3)/3
  F2<-abs((xy[,1]-xy3[,1])*(xy2[,2]-xy3[,2])-
          (xy[,2]-xy3[,2])*(xy2[,1]-xy3[,1]))
  ## compute center of gravity of polygon 
  lambda<-F2/sum(F2)
  SP<-colSums(cbind(S[,1]*lambda,S[,2]*lambda))
  return(SP)
}
# check input
xydata<-if(missing(y)) x else cbind(x,y)
if(is.data.frame(xydata)) xydata<-as.matrix(xydata)
if(any(is.na(xydata))){
  if(na.rm){ xydata<-xydata[!apply(is.na(xydata),1,any),,drop=FALSE]
    print("Warning: NA elements have been removed!!")
  }else{ #121129
    xy.medians<-apply(xydata,2,function(x) median(x, na.rm=TRUE)) 
              # colMeans(xydata,na.rm=TRUE)
    for(j in 1:ncol(xydata)) xydata[is.na(xydata[,j]),j]<-xy.medians[j]
    print("Warning: NA elements have been exchanged by median values!!")
  }  
}
# if(nrow(xydata)<3) {print("not enough data points"); return()} ## 121008
if(length(xydata)<4) {print("not enough data points"); return()}
if((length(xydata)%%2)==1) {print("number of values isn't even"); return()}
if(!is.matrix(xydata)) xydata<-matrix(xydata,ncol=2,byrow=TRUE)
# select sample in case of a very large data set
very.large.data.set<-nrow(xydata) > approx.limit
# use of random number generator may disturb simulation 
# therefore we now use a systematical part of the data 20120930
### OLD: set.seed(random.seed<-13)  ### SEED 
if(very.large.data.set){
  ## OLD: ind<-sample(seq(nrow(xydata)),size=approx.limit)
  step<-(n<-nrow(xydata))/approx.limit; ind <- round(seq(1,n,by=step))
  xy<-xydata[ind,]
} else xy<-xydata
n<-nrow(xy)
points.in.bag<-floor(n/2)
# if jittering is needed 
# the following two lines can be activated
#xy<-xy+cbind(rnorm(n,0,.0001*sd(xy[,1])),
#             rnorm(n,0,.0001*sd(xy[,2])))
if(verbose) cat("end of initialization")
  
prdata<-prcomp(xydata)
is.one.dim<-(0 == max(prdata[[1]])) || (min(prdata[[1]])/max(prdata[[1]]))<0.00001 # 121129
if(is.one.dim){
  if(verbose) cat("data set one dimensional")
  center<-colMeans(xydata)
  res<-list(xy=xy,xydata=xydata,prdata=prdata,
            is.one.dim=is.one.dim,center=center)
  class(res)<-"bagplot"
  return(res)
} 
if(verbose) cat("data not linear")
  
if(nrow(xydata)<=4) {
  if(verbose) cat("only three or four data points")
  center<-colMeans(xydata)
  res<-list(xy=xy,xydata=xydata,prdata=prdata,hdepths=rep(1,n),hdepth=rep(1,n),
            is.one.dim=is.one.dim,center=center,hull.center=NULL,
            hull.bag=NULL,hull.loop=NULL,pxy.bag=NULL,pxy.outer=xydata,
            pxy.outlier=NULL,exp.dk=xydata)
  class(res)<-"bagplot"
  return(res)
}
  
xym<-apply(xy,2,mean); xysd<-apply(xy,2,sd)
xyxy<-cbind((xy[,1]-xym[1])/xysd[1],(xy[,2]-xym[2])/xysd[2])
  
dx<-(outer(xy[,1],xy[,1],"-"))
dy<-(outer(xy[,2],xy[,2],"-"))
alpha<-atan2(y=dy,x=dx); diag(alpha)<-1000 
for(j in 1:n) alpha[,j]<-sort(alpha[,j])
alpha<-alpha[-n,] ; m<-n-1
## quick look inside, just for check
if(debug.plots=="all"){
  plot(xy,bty="n"); xdelta<-abs(diff(range(xy[,1]))); dx<-xdelta*.3
  for(j in 1:n) {
    p<-xy[j,]; dy<-dx*tan(alpha[,j])
    segments(p[1]-dx,p[2]-dy,p[1]+dx,p[2]+dy,col=j)
    text(p[1]-xdelta*.02,p[2],j,col=j)
  }
}
if(verbose) print("end of computation of angles")
  
  hdepth<-rep(0,n); dpi<-2*pi-0.000001; mypi<-pi-0.000001
  minusplus<-c(rep(-1,m),rep(1,m))
if(FALSE){
  for(j in 1:n) {
    a<-alpha[,j]+pi; h<-a<10; a<-a[h]; init<-sum(a < mypi) # hallo
    a.shift<-(a+pi) %% dpi
    minusplus<-c(rep(-1,length(a)),rep(1,length(a))) ## 070824 
    h<-cumsum(minusplus[order(c(a,a.shift))])
    hdepth[j]<-init+min(h)+1 # or do we have to count identical points?
  # hdepth[j]<-init+min(h)+sum(xy[j,1]==xy[,1] & xy[j,2]==xy[,2])
  }
}
find.hdepths <- function(xy, number.of.directions=181){ # 121126
  
xy <- as.matrix(xy)
for( j in 1:2) {
  xy[,j] <- xy[,j] - min(xy[,j])
  if( 0 < (h <- max(xy[,j]))) xy[,j] <- xy[,j] / max(xy[,j])
}
  
phi    <- c(seq(0,180,length=number.of.directions)[-1]*(2*pi/360))
sinphi <- c(sin(phi),1); cosphi <- c(cos(phi),0)
RM1 <- round(digits=6,rbind(cosphi,sinphi))
hd <- rep(h<-length(xy[,1]),h)
for( j in seq(along=sinphi)){
   xyt <- xy %*% RM1[,j]
   hd <- pmin(hd,rank(xyt,ties.method="min"), rank(-xyt,ties.method="min"))
}
#  xyt <- xy %*% RM1
#  hd2 <- cbind(apply(xyt, 2, rank, ties.method="min"), 
#               apply(-xyt,2, rank, ties.method="min"))
#  hd2 <- apply(hd2, 1, min)
  hd
}
hdepth <- find.hdepths(xy,181*precision)
if(verbose){print("end of computation of hdepth:"); print(hdepth)}
## quick look inside, just for a check
if(debug.plots=="all"){
  plot(xy,bty="n")
  xdelta<-abs(diff(range(xy[,1]))); dx<-xdelta*.1
  for(j in 1:n) {
    a<-alpha[,j]+pi; a<-a[a<10]; init<-sum(a < pi)
    a.shift<-(a+pi) %% dpi
    minusplus<-c(rep(-1,length(a)),rep(1,length(a))) ## 070824 
    h<-cumsum(minusplus[ao<-(order(c(a,a.shift)))])
    no<-which((init+min(h)) == (init+h))[1]
    p<-xy[j,]; dy<-dx*tan(alpha[,j])
    segments(p[1]-dx,p[2]-dy,p[1]+dx,p[2]+dy,col=j,lty=3)
    dy<-dx*tan(c(sort(a),sort(a))[no])
    segments(p[1]-5*dx,p[2]-5*dy,p[1]+5*dx,p[2]+5*dy,col="black")
    text(p[1]-xdelta*.02,p[2],hdepth[j],col=1) # cex=2.5 assumes suitable fonts
  }
}
  
hd.table<-table(sort(hdepth))
d.k<-cbind(dk=rev(cumsum(rev(hd.table))),
           k =as.numeric(names(hd.table)))
k.1<-sum( points.in.bag < d.k[,1] )
# if(nrow(d.k)>1){ # version 09/2005, error in data set 1 of Meuleman
# instead of >2 now >k.1 # 070827
# if(nrow(d.k)>k.1){ k<-d.k[k.1+1,2] } else { k<-d.k[k.1,2] } 
# this statement will not have an effect because of the next one:
k<-d.k[k.1,2]+1 # 121004 increment depth by one not by looking for next depth
if(verbose){cat("numbers of members of dk:"); print(hd.table); print(d.k)}
if(verbose){cat("end of computation of k, k=",k,"k.1:",k.1)}
# D.K<<-d.k; K.1<<-k.1; EX<<-exp.dk; EX.1<<-exp.dk.1; PDK<<-pdk; HDEPTH<<-hdepth
  
center<-apply(xy[which(hdepth==max(hdepth)),,drop=FALSE],2,mean)
hull.center<-NULL
if(3<nrow(xy)&&length(hd.table)>0){
  n.p<-floor(1.5*c(32,16,8)[1+(n>50)+(n>200)]*precision)
  # limit.hdepth.to.check <- sort(hdepth, decreasing = TRUE)[min(nrow(xy),6)] 
  # 121126
  h <- unique(sort(hdepth, decreasing = TRUE))
  limit.hdepth.to.check <- sort(h)[min(length(h),3)]
  h<-cands<-xy[limit.hdepth.to.check <= hdepth,,drop=FALSE]
  # h<-cands<-xy[rev(order(hdepth))[1:(min(nrow(xy),6))],]
  cands<-cands[chull(cands[,1],cands[,2]),]; n.c<-nrow(cands)
  if(is.null(n.c))cands<-h
  
xyextr<-rbind(apply(cands,2,min),apply(cands,2,max))
## xydel<-2*(xyextr[2,]-xyextr[1,])/n.p # unused
if( (xyextr[2,1]-xyextr[1,1]) < 0.2*(h <- diff(range(xy[,1])))){ 
   xyextr[1:2,1] <- mean(xyextr[,1]) + c(-.1,.1) * h }            ## 121203
if( (xyextr[2,2]-xyextr[1,2]) < 0.2*(h <- diff(range(xy[,2])))){ 
   xyextr[1:2,2] <- mean(xyextr[,2]) + c(-.1,.1) * h }            ## 121203
if(verbose){cat("xyextr: looking for maximal depth"); print(xyextr) }
h1<-seq(xyextr[1,1],xyextr[2,1],length=n.p)
h2<-seq(xyextr[1,2],xyextr[2,2],length=n.p)
tp<-cbind(as.vector(matrix(h1,n.p,n.p)), #      [1:n.p^2],
          as.vector(matrix(h2,n.p,n.p,TRUE))) # [1:n.p^2])
# tphdepth<-max(hdepth.of.points(tp))-1
tphdepth<-max(find.hdepths.tp(tp,xy))
# if(verbose) { TP<<-tp; TPD<<-find.hdepths.tp(tp,xy) }
if(verbose) cat("points(TP,pch=c(letters,LETTERS)[TPD+1])")
  # if max of testpoint is smaller than max depth of points take that max!
  if(verbose){ cat("depth of testpoints"); print(summary(tphdepth)) } # 121126
  tphdepth<-max(tphdepth,d.k[,2]) # 121004
  
# define direction for hdepth search
num<-floor(2*c(417,351,171,85,67,43)[sum(n>c(1,50,100,150,200,250))]*precision)
num.h<-floor(num/2); angles<-seq(0,pi,length=num.h) 
ang<-tan(pi/2-angles)
kkk<-tphdepth
if(verbose){cat("max-hdepth found:"); print(kkk)}
if(verbose) cat("find polygon with max depth")
ia<-1; a<-angles[ia]; xyt<-xyxy%*%c(cos(a),-sin(a)); xyto<-order(xyt)
# initial for upper part
ind.k<-xyto[kkk]; cutp<-c(xyxy[ind.k,1],-10)
dxy<-diff(range(xyxy))
pg<-rbind(c(cutp[1],-dxy,Inf),c(cutp[1],dxy,NA))
# initial for lower part
ind.kk<-xyto[n+1-kkk]; cutpl<-c(xyxy[ind.kk,1],10)
# pgl<-rbind(c(cutpl[1],dxy,Inf),c(cutpl[1],-dxy,NA))
pgl<-rbind(c(cutpl[1],dxy,-Inf),c(cutpl[1],-dxy,NA)) 
# the sign of inf doesn't matter
if(debug.plots=="all"){ plot(xyxy,type="p",bty="n") 
 text(xy,,1:n,col="blue")
 hx<-xy[ind.k,c(1,1)]; hy<-xy[ind.k,c(2,2)]
 segments(hx,hy,c(10,-10),hy+ang[ia]*(c(10,-10)-hx),lty=2)
 text(hx+rnorm(1,,.1),hy+rnorm(1,,.1),ia)
}  
if(verbose) cat("start of computation of the directions: ","kkk=",kkk) # 121030
for(ia in seq(angles)[-1]){ 
  
# determine critical points pnew and pnewl of direction a
# if(verbose) cat("ia",ia,angles[ia])
# 121030
a<-angles[ia]; angtan<-ang[ia]; xyt<-xyxy%*%c(cos(a),-sin(a)); xyto<-order(xyt)
ind.k <-xyto[kkk]; ind.kk<-xyto[n+1-kkk]; pnew<-xyxy[ind.k,]; pnewl<-xyxy[ind.kk,] 
# if(verbose) if( 1 < sum(xyt == xyt[ind.k]) )print("WARNING: some points identical")
if(debug.plots=="all") points(pnew[1],pnew[2],col="red")
# new limiting lines are defined by pnew / pnewl and slope a
# find segment of polygon that is cut by new limiting line and cut
# if(ia>200) { #<show pg pgl>#; points(pnew[1],pnew[2],col="magenta",cex=6) }
if( abs(angtan)>1e10){ if(verbose) cat("kkk",kkk,"x=c case")  
    # case of vertical slope #print(pg);print(pnew);print(xyt);lines(pg,col="red",lwd=3)
    # number of points left of point pnew that limit the polygon
    pg.no<-sum(pg[,1]<pnew[1]) 
    if( 0 < pg.no ){
      # the polygon (segment pg.no) has to be cut at x==pnew[1] 
      cutp <- c(pnew[1], pg [pg.no, 2]+pg [pg.no, 3]*(pnew [1]-pg [pg.no ,1]))
      pg<- rbind(pg[1:pg.no,],  c(cutp,angtan), c(cutp[1]+dxy,  cutp[2] +angtan*dxy,NA))
    } else {
      if(verbose) cat("!!! case degenerated UPPER polygon: pg.no==0")
      # the limiting point pnew is above the beginning of the polygon
      # therefore, the polygon reduces to line
      pg <- rbind(pg[1,], c(pg[2,1:2],NA))
    }
    pg.nol<-sum(pgl[,1]>=pnewl[1])
    if( 0 < pg.nol ){ ##??2 # 121204
      cutpl<-c(pnewl[1],pgl[pg.nol,2]+pgl[pg.nol,3]*(pnewl[1]-pgl[pg.nol,1]))
      pgl<-rbind(pgl[1:pg.nol,],c(cutpl,angtan),c(cutpl[1]-dxy, cutpl[2]-angtan*dxy,NA))
    } else {
      if(verbose) cat("!!! case degenerated LOWER polygon: pgl.no==0")
      pgl <- rbind(pgl[1,], c(pgl[2,1:2],NA))
    }
}else{ # if(verbose) cat("kkk",kkk,"normal case")
    # normal case upper polygon
    pg.inter<-pg[,2]-angtan*pg[,1]; pnew.inter<-pnew[2]-angtan*pnew[1]
    pg.no<-sum(pg.inter<pnew.inter)
    if(is.na(pg[pg.no,3])) pg[pg.no,3] <- -Inf # 121129 NaN/Na error
    cutp<-cut.p.sl.p.sl(pnew,ang[ia],pg[pg.no,1:2],pg[pg.no,3])
    pg<- rbind(pg[1:pg.no,],  c(cutp,angtan), c(cutp[1]+dxy,  cutp[2] +angtan*dxy,NA))
    # normal case lower polygon
    pg.interl<-pgl[,2]-angtan*pgl[,1]; pnew.interl<-pnewl[2]-angtan*pnewl[1]
    pg.nol<-sum(pg.interl>pnew.interl)
    if(is.na(pgl[pg.nol,3])) pgl[pg.nol,3] <- Inf # 121129 NaN/Na error
    cutpl<-cut.p.sl.p.sl(pnewl,angtan,pgl[pg.nol,1:2],pgl[pg.nol,3]) 
    pgl<-rbind(pgl[1:pg.nol,],c(cutpl,angtan),c(cutpl[1]-dxy, cutpl[2]-angtan*dxy,NA))
}
## if(kkk==KKK && ia == 51) { cat("ENDE: pgl"); print(pgl) }
# update pg, pgl completed
# PG<<-pg;PG.NO<<-pg.no;CUTP<<-cutp;DXY<<-dxy;PNEW<<-pnew;PGL<<-pgl;PG.NOL<<-pg.nol
#########################################
#### cat("angtan",angtan,"pg.no",pg.no,"pkt:",pnew)
# if(ia==stopp) lines(pg,type="b",col="green") 
if(debug.plots=="all"){ 
  points(pnew[1],pnew[2],col="red") 
  hx<-xyxy[ind.k,c(1,1)]; hy<-xyxy[ind.k,c(2,2)]
  segments(hx,hy,c(10,-10),hy+ang[ia]*(c(10,-10)-hx),lty=2)
# text(hx+rnorm(1,,.1),hy+rnorm(1,,.1),ia)
# print(pg) 
# if(ia==stopp) lines(pgl,type="b",col="green") 
  points(cutpl[1],cutpl[2],col="red") 
  hx<-xyxy[ind.kk,c(1,1)]; hy<-xyxy[ind.kk,c(2,2)]
  segments(hx,hy,c(10,-10),hy+ang[ia]*(c(10,-10)-hx),lty=2)
#  text(hx+rnorm(1,,.1),hy+rnorm(1,,.1),ia)
# print(pgl)
}
##show pg pgl##
}
# if(verbose) PG <<- pg; PGL <<- pgl
if(2<nrow(pg) && 2<nrow(pgl)){
  
## plot(xyxy[,1:2],xlim=c(-.5,+.5),ylim=c(-.5,.50))
## lines(pg,type="b",col="red"); lines(pgl,type="b",col="blue")
## remove first and last points and multiple points #<show pg pgl>#
limit<-1e-10
## pg <-pg [c(TRUE,(abs(diff(pg [,1]))>limit)|(abs(diff(pg [,2]))>limit)),] old#
idx <- c(TRUE,(abs(diff(pg [,1]))>limit)|(abs(diff(pg [,2]))>limit)) # 121008
if(any(idx==FALSE)){
  pg <-pg[idx,]; pg[,3] <- c(diff(pg[,2])/diff(pg[,1]), NA)
}
# old reduction which caused some errors:
## pgl<-pgl[c(TRUE,(abs(diff(pgl[,1]))>limit)|(abs(diff(pgl[,2]))>limit)),] error##
## pgl<-pgl[c(     (abs(diff(pgl[,1]))>limit)|(abs(diff(pgl[,2]))>limit),TRUE),] old#
idx <-      c(     (abs(diff(pgl[,1]))>limit)|(abs(diff(pgl[,2]))>limit),TRUE)#121008
if(any(idx==FALSE)){
  pgl<-pgl[idx,]; pgl[,3] <- c(diff(pgl[,2])/diff(pgl[,1]), NA)
}
## add some tolerance in course of numerical problems
pgl[,2]<-pgl[,2] - .00001  ## 121004  
## show pg pgl>>
pg<- pg [-nrow(pg ),][-1,,drop=FALSE]
pgl<-pgl[-nrow(pgl),][-1,,drop=FALSE]
# determine position according to the other polygon
#   cat("relative position: lower polygon")
indl<-pos.to.pg(round(pgl,digits=10),round(pg,digits=10))  # 121126
#   cat("relative position: upper polygon")
indu<-pos.to.pg(round(pg,digits=10),round(pgl,digits=10),TRUE)
sr<-sl<-NULL # ; ##show pg pgl>>
# right region
if(indu[(npg<-nrow(pg))]=="lower" & indl[1]=="higher"){ 
  # cat("in if of right region: the upper polynom is somewhere lower")
  #  checking from the right: last point of lower polygon that is NOT ok
  rnuml<-which(indl=="lower")[1]-1
  #  checking from the left: last point of upper polygon that is ok
  rnumu<-npg+1-which(rev(indu=="higher"))[1]
  #  special case all points of lower polygon are upper
  if(is.na(rnuml)) rnuml<-sum(pg[rnumu,1]<pgl[,1])
  #  special case all points of upper polygon are lower
  if(is.na(rnumu)) rnumu<-sum(pg[,1]<pgl[rnuml,1])
  xyl<-pgl[rnuml,]; xyu<-pg[rnumu,]
  # cat("right"); print(rnuml); print(xyl)
  # cat("right"); print(rnumu); print(xyu)
  sr<-cut.p.sl.p.sl(xyl[1:2],xyl[3],xyu[1:2],xyu[3])
}
# left region
if(indl[(npgl<-nrow(pgl))]=="higher"&indu[1]=="lower"){ 
  # cat("in if of left region: the upper polynom is somewhere lower")
  #  checking from the right: last point of lower polygon that is ok
  lnuml<-npgl+1-which(rev(indl=="lower"))[1]
  #  checking from the left: last point of upper polygon that is NOT ok
  lnumu<-which(indu=="higher")[1]-1
  #  special case all points of lower polygon are upper
  if(is.na(lnuml)) lnuml<-sum(pg[lnumu,1]<pgl[,1])
  #  special case all points of upper polygon are lower
  if(is.na(lnumu)) lnumu<-sum(pg[,1]<pgl[lnuml,1])
  xyl<-pgl[lnuml,]; xyu<-pg[lnumu,] 
  # cat("left"); print(lnuml); print(xyl)
  # cat("left"); print(lnumu); print(xyu)
  sl<-cut.p.sl.p.sl(xyl[1:2],xyl[3],xyu[1:2],xyu[3])
}
# if(kkk==2){ ##show pg pgl##; INDU<<-indu; INDL<<-indl; PGL<<-pgl; PGU<<-pg}
pg<-rbind(pg [indu=="higher",1:2,drop=FALSE],sr,
          pgl[indl=="lower", 1:2,drop=FALSE],sl)
if(debug.plots=="all") lines(rbind(pg,pg[1,]),col="red")
if(!any(is.na(pg)))  pg<-pg[chull(pg[,1],pg[,2]),]
# if(kkk==7){ PG <<- pg }
} else {
  if(2<nrow(pgl)){ #121204
    pg <- rbind(pg[2,1:2],pgl[-c(1,length(pgl[,1])),1:2])
  } else {
    pg <- rbind(pg [-c(1,length(pg [,1])),1:2],pgl[2,1:2])
          # rbind(pgl[2,1:2],pg[2,1:2])
  }
}
if(verbose) cat("END of computation of the directions")
hull.center<-cbind(pg[,1]*xysd[1]+xym[1],pg[,2]*xysd[2]+xym[2])
if(!any(is.na(hull.center))) center<-find.polygon.center(hull.center) else 
              hull.center <- rbind(center)       # 121126
if(verbose){ cat("CENTER"); print(center) }
  if(verbose){cat("hull.center",hull.center); print(table(tphdepth)) }
}
# if(verbose) cat("center depth:",hdepth.of.points(rbind(center))-1)
if(verbose) cat("center depth:",find.hdepths.tp(rbind(center),xy)-1)
if(verbose){print("end of computation of center"); print(center)}
  if(dkmethod==1){
    
# inner hull of bag
xyi<-xy[hdepth>=k,,drop=FALSE] # cat("dim XYI", dim(xyi))
# 121028 some corrections for strange k situations
if(0 < length(xyi)) pdk<-xyi[chull(xyi[,1],xyi[,2]),,drop=FALSE]
# outer hull of bag
if( k > 1 ){ 
  xyo<-xy[hdepth>=(k-1),,drop=FALSE] 
  pdk.1<-xyo[chull(xyo[,1],xyo[,2]),,drop=FALSE]
} else pdk.1 <- pdk 
if(0 == length(xyi)) pdk <- pdk.1
if(verbose)cat("hull computed: pdk, pdk.1:") 
if(verbose){print(pdk); print(pdk.1) }
if(debug.plots=="all"){
  plot(xy,bty="n")
  h<-rbind(pdk,pdk[1,]); lines(h,col="red",lty=2)
  h<-rbind(pdk.1,pdk.1[1,]);lines(h,col="blue",lty=3)
  points(center[1],center[2],pch=8,col="red")
}
exp.dk<-expand.hull(pdk,k)
exp.dk.1<-expand.hull(exp.dk,k-1) # pdk.1,k-1,20)
  }else{
    
# define direction for hdepth search
num<-floor(2*c(417,351,171,85,67,43)[sum(n>c(1,50,100,150,200,250))]*precision)
num.h<-floor(num/2); angles<-seq(0,pi,length=num.h) 
ang<-tan(pi/2-angles)
# standardization of data set xyxy is used
kkk<-k          
if(verbose) print("find polygon with depth something higher than that of the bag") 
if( kkk <= max(d.k[,2]) ){ # inner one # 121030
  
ia<-1; a<-angles[ia]; xyt<-xyxy%*%c(cos(a),-sin(a)); xyto<-order(xyt)
# initial for upper part
ind.k<-xyto[kkk]; cutp<-c(xyxy[ind.k,1],-10)
dxy<-diff(range(xyxy))
pg<-rbind(c(cutp[1],-dxy,Inf),c(cutp[1],dxy,NA))
# initial for lower part
ind.kk<-xyto[n+1-kkk]; cutpl<-c(xyxy[ind.kk,1],10)
# pgl<-rbind(c(cutpl[1],dxy,Inf),c(cutpl[1],-dxy,NA))
pgl<-rbind(c(cutpl[1],dxy,-Inf),c(cutpl[1],-dxy,NA)) 
# the sign of inf doesn't matter
if(debug.plots=="all"){ plot(xyxy,type="p",bty="n") 
 text(xy,,1:n,col="blue")
 hx<-xy[ind.k,c(1,1)]; hy<-xy[ind.k,c(2,2)]
 segments(hx,hy,c(10,-10),hy+ang[ia]*(c(10,-10)-hx),lty=2)
 text(hx+rnorm(1,,.1),hy+rnorm(1,,.1),ia)
}  
if(verbose) cat("start of computation of the directions: ","kkk=",kkk) # 121030
for(ia in seq(angles)[-1]){ 
  
# determine critical points pnew and pnewl of direction a
# if(verbose) cat("ia",ia,angles[ia])
# 121030
a<-angles[ia]; angtan<-ang[ia]; xyt<-xyxy%*%c(cos(a),-sin(a)); xyto<-order(xyt)
ind.k <-xyto[kkk]; ind.kk<-xyto[n+1-kkk]; pnew<-xyxy[ind.k,]; pnewl<-xyxy[ind.kk,] 
# if(verbose) if( 1 < sum(xyt == xyt[ind.k]) )print("WARNING: some points identical")
if(debug.plots=="all") points(pnew[1],pnew[2],col="red")
# new limiting lines are defined by pnew / pnewl and slope a
# find segment of polygon that is cut by new limiting line and cut
# if(ia>200) { #<show pg pgl>#; points(pnew[1],pnew[2],col="magenta",cex=6) }
if( abs(angtan)>1e10){ if(verbose) cat("kkk",kkk,"x=c case")  
    # case of vertical slope #print(pg);print(pnew);print(xyt);lines(pg,col="red",lwd=3)
    # number of points left of point pnew that limit the polygon
    pg.no<-sum(pg[,1]<pnew[1]) 
    if( 0 < pg.no ){
      # the polygon (segment pg.no) has to be cut at x==pnew[1] 
      cutp <- c(pnew[1], pg [pg.no, 2]+pg [pg.no, 3]*(pnew [1]-pg [pg.no ,1]))
      pg<- rbind(pg[1:pg.no,],  c(cutp,angtan), c(cutp[1]+dxy,  cutp[2] +angtan*dxy,NA))
    } else {
      if(verbose) cat("!!! case degenerated UPPER polygon: pg.no==0")
      # the limiting point pnew is above the beginning of the polygon
      # therefore, the polygon reduces to line
      pg <- rbind(pg[1,], c(pg[2,1:2],NA))
    }
    pg.nol<-sum(pgl[,1]>=pnewl[1])
    if( 0 < pg.nol ){ ##??2 # 121204
      cutpl<-c(pnewl[1],pgl[pg.nol,2]+pgl[pg.nol,3]*(pnewl[1]-pgl[pg.nol,1]))
      pgl<-rbind(pgl[1:pg.nol,],c(cutpl,angtan),c(cutpl[1]-dxy, cutpl[2]-angtan*dxy,NA))
    } else {
      if(verbose) cat("!!! case degenerated LOWER polygon: pgl.no==0")
      pgl <- rbind(pgl[1,], c(pgl[2,1:2],NA))
    }
}else{ # if(verbose) cat("kkk",kkk,"normal case")
    # normal case upper polygon
    pg.inter<-pg[,2]-angtan*pg[,1]; pnew.inter<-pnew[2]-angtan*pnew[1]
    pg.no<-sum(pg.inter<pnew.inter)
    if(is.na(pg[pg.no,3])) pg[pg.no,3] <- -Inf # 121129 NaN/Na error
    cutp<-cut.p.sl.p.sl(pnew,ang[ia],pg[pg.no,1:2],pg[pg.no,3])
    pg<- rbind(pg[1:pg.no,],  c(cutp,angtan), c(cutp[1]+dxy,  cutp[2] +angtan*dxy,NA))
    # normal case lower polygon
    pg.interl<-pgl[,2]-angtan*pgl[,1]; pnew.interl<-pnewl[2]-angtan*pnewl[1]
    pg.nol<-sum(pg.interl>pnew.interl)
    if(is.na(pgl[pg.nol,3])) pgl[pg.nol,3] <- Inf # 121129 NaN/Na error
    cutpl<-cut.p.sl.p.sl(pnewl,angtan,pgl[pg.nol,1:2],pgl[pg.nol,3]) 
    pgl<-rbind(pgl[1:pg.nol,],c(cutpl,angtan),c(cutpl[1]-dxy, cutpl[2]-angtan*dxy,NA))
}
## if(kkk==KKK && ia == 51) { cat("ENDE: pgl"); print(pgl) }
# update pg, pgl completed
# PG<<-pg;PG.NO<<-pg.no;CUTP<<-cutp;DXY<<-dxy;PNEW<<-pnew;PGL<<-pgl;PG.NOL<<-pg.nol
#########################################
#### cat("angtan",angtan,"pg.no",pg.no,"pkt:",pnew)
# if(ia==stopp) lines(pg,type="b",col="green") 
if(debug.plots=="all"){ 
  points(pnew[1],pnew[2],col="red") 
  hx<-xyxy[ind.k,c(1,1)]; hy<-xyxy[ind.k,c(2,2)]
  segments(hx,hy,c(10,-10),hy+ang[ia]*(c(10,-10)-hx),lty=2)
# text(hx+rnorm(1,,.1),hy+rnorm(1,,.1),ia)
# print(pg) 
# if(ia==stopp) lines(pgl,type="b",col="green") 
  points(cutpl[1],cutpl[2],col="red") 
  hx<-xyxy[ind.kk,c(1,1)]; hy<-xyxy[ind.kk,c(2,2)]
  segments(hx,hy,c(10,-10),hy+ang[ia]*(c(10,-10)-hx),lty=2)
#  text(hx+rnorm(1,,.1),hy+rnorm(1,,.1),ia)
# print(pgl)
}
##show pg pgl##
}
# if(verbose) PG <<- pg; PGL <<- pgl
if(2<nrow(pg) && 2<nrow(pgl)){
  
## plot(xyxy[,1:2],xlim=c(-.5,+.5),ylim=c(-.5,.50))
## lines(pg,type="b",col="red"); lines(pgl,type="b",col="blue")
## remove first and last points and multiple points #<show pg pgl>#
limit<-1e-10
## pg <-pg [c(TRUE,(abs(diff(pg [,1]))>limit)|(abs(diff(pg [,2]))>limit)),] old#
idx <- c(TRUE,(abs(diff(pg [,1]))>limit)|(abs(diff(pg [,2]))>limit)) # 121008
if(any(idx==FALSE)){
  pg <-pg[idx,]; pg[,3] <- c(diff(pg[,2])/diff(pg[,1]), NA)
}
# old reduction which caused some errors:
## pgl<-pgl[c(TRUE,(abs(diff(pgl[,1]))>limit)|(abs(diff(pgl[,2]))>limit)),] error##
## pgl<-pgl[c(     (abs(diff(pgl[,1]))>limit)|(abs(diff(pgl[,2]))>limit),TRUE),] old#
idx <-      c(     (abs(diff(pgl[,1]))>limit)|(abs(diff(pgl[,2]))>limit),TRUE)#121008
if(any(idx==FALSE)){
  pgl<-pgl[idx,]; pgl[,3] <- c(diff(pgl[,2])/diff(pgl[,1]), NA)
}
## add some tolerance in course of numerical problems
pgl[,2]<-pgl[,2] - .00001  ## 121004  
## show pg pgl>>
pg<- pg [-nrow(pg ),][-1,,drop=FALSE]
pgl<-pgl[-nrow(pgl),][-1,,drop=FALSE]
# determine position according to the other polygon
#   cat("relative position: lower polygon")
indl<-pos.to.pg(round(pgl,digits=10),round(pg,digits=10))  # 121126
#   cat("relative position: upper polygon")
indu<-pos.to.pg(round(pg,digits=10),round(pgl,digits=10),TRUE)
sr<-sl<-NULL # ; ##show pg pgl>>
# right region
if(indu[(npg<-nrow(pg))]=="lower" & indl[1]=="higher"){ 
  # cat("in if of right region: the upper polynom is somewhere lower")
  #  checking from the right: last point of lower polygon that is NOT ok
  rnuml<-which(indl=="lower")[1]-1
  #  checking from the left: last point of upper polygon that is ok
  rnumu<-npg+1-which(rev(indu=="higher"))[1]
  #  special case all points of lower polygon are upper
  if(is.na(rnuml)) rnuml<-sum(pg[rnumu,1]<pgl[,1])
  #  special case all points of upper polygon are lower
  if(is.na(rnumu)) rnumu<-sum(pg[,1]<pgl[rnuml,1])
  xyl<-pgl[rnuml,]; xyu<-pg[rnumu,]
  # cat("right"); print(rnuml); print(xyl)
  # cat("right"); print(rnumu); print(xyu)
  sr<-cut.p.sl.p.sl(xyl[1:2],xyl[3],xyu[1:2],xyu[3])
}
# left region
if(indl[(npgl<-nrow(pgl))]=="higher"&indu[1]=="lower"){ 
  # cat("in if of left region: the upper polynom is somewhere lower")
  #  checking from the right: last point of lower polygon that is ok
  lnuml<-npgl+1-which(rev(indl=="lower"))[1]
  #  checking from the left: last point of upper polygon that is NOT ok
  lnumu<-which(indu=="higher")[1]-1
  #  special case all points of lower polygon are upper
  if(is.na(lnuml)) lnuml<-sum(pg[lnumu,1]<pgl[,1])
  #  special case all points of upper polygon are lower
  if(is.na(lnumu)) lnumu<-sum(pg[,1]<pgl[lnuml,1])
  xyl<-pgl[lnuml,]; xyu<-pg[lnumu,] 
  # cat("left"); print(lnuml); print(xyl)
  # cat("left"); print(lnumu); print(xyu)
  sl<-cut.p.sl.p.sl(xyl[1:2],xyl[3],xyu[1:2],xyu[3])
}
# if(kkk==2){ ##show pg pgl##; INDU<<-indu; INDL<<-indl; PGL<<-pgl; PGU<<-pg}
pg<-rbind(pg [indu=="higher",1:2,drop=FALSE],sr,
          pgl[indl=="lower", 1:2,drop=FALSE],sl)
if(debug.plots=="all") lines(rbind(pg,pg[1,]),col="red")
if(!any(is.na(pg)))  pg<-pg[chull(pg[,1],pg[,2]),]
# if(kkk==7){ PG <<- pg }
} else {
  if(2<nrow(pgl)){ #121204
    pg <- rbind(pg[2,1:2],pgl[-c(1,length(pgl[,1])),1:2])
  } else {
    pg <- rbind(pg [-c(1,length(pg [,1])),1:2],pgl[2,1:2])
          # rbind(pgl[2,1:2],pg[2,1:2])
  }
}
if(verbose) cat("END of computation of the directions")
  exp.dk<-cbind(pg[,1]*xysd[1]+xym[1],pg[,2]*xysd[2]+xym[2])
} else {
  exp.dk <- NULL
}
if( 1 < kkk ) kkk<-kkk-1 # outer one
if(verbose) print("find polygon with depth a little bit lower than that of the bag") 
ia<-1; a<-angles[ia]; xyt<-xyxy%*%c(cos(a),-sin(a)); xyto<-order(xyt)
# initial for upper part
ind.k<-xyto[kkk]; cutp<-c(xyxy[ind.k,1],-10)
dxy<-diff(range(xyxy))
pg<-rbind(c(cutp[1],-dxy,Inf),c(cutp[1],dxy,NA))
# initial for lower part
ind.kk<-xyto[n+1-kkk]; cutpl<-c(xyxy[ind.kk,1],10)
# pgl<-rbind(c(cutpl[1],dxy,Inf),c(cutpl[1],-dxy,NA))
pgl<-rbind(c(cutpl[1],dxy,-Inf),c(cutpl[1],-dxy,NA)) 
# the sign of inf doesn't matter
if(debug.plots=="all"){ plot(xyxy,type="p",bty="n") 
 text(xy,,1:n,col="blue")
 hx<-xy[ind.k,c(1,1)]; hy<-xy[ind.k,c(2,2)]
 segments(hx,hy,c(10,-10),hy+ang[ia]*(c(10,-10)-hx),lty=2)
 text(hx+rnorm(1,,.1),hy+rnorm(1,,.1),ia)
}  
if(verbose) cat("start of computation of the directions: ","kkk=",kkk) # 121030
for(ia in seq(angles)[-1]){ 
  
# determine critical points pnew and pnewl of direction a
# if(verbose) cat("ia",ia,angles[ia])
# 121030
a<-angles[ia]; angtan<-ang[ia]; xyt<-xyxy%*%c(cos(a),-sin(a)); xyto<-order(xyt)
ind.k <-xyto[kkk]; ind.kk<-xyto[n+1-kkk]; pnew<-xyxy[ind.k,]; pnewl<-xyxy[ind.kk,] 
# if(verbose) if( 1 < sum(xyt == xyt[ind.k]) )print("WARNING: some points identical")
if(debug.plots=="all") points(pnew[1],pnew[2],col="red")
# new limiting lines are defined by pnew / pnewl and slope a
# find segment of polygon that is cut by new limiting line and cut
# if(ia>200) { #<show pg pgl>#; points(pnew[1],pnew[2],col="magenta",cex=6) }
if( abs(angtan)>1e10){ if(verbose) cat("kkk",kkk,"x=c case")  
    # case of vertical slope #print(pg);print(pnew);print(xyt);lines(pg,col="red",lwd=3)
    # number of points left of point pnew that limit the polygon
    pg.no<-sum(pg[,1]<pnew[1]) 
    if( 0 < pg.no ){
      # the polygon (segment pg.no) has to be cut at x==pnew[1] 
      cutp <- c(pnew[1], pg [pg.no, 2]+pg [pg.no, 3]*(pnew [1]-pg [pg.no ,1]))
      pg<- rbind(pg[1:pg.no,],  c(cutp,angtan), c(cutp[1]+dxy,  cutp[2] +angtan*dxy,NA))
    } else {
      if(verbose) cat("!!! case degenerated UPPER polygon: pg.no==0")
      # the limiting point pnew is above the beginning of the polygon
      # therefore, the polygon reduces to line
      pg <- rbind(pg[1,], c(pg[2,1:2],NA))
    }
    pg.nol<-sum(pgl[,1]>=pnewl[1])
    if( 0 < pg.nol ){ ##??2 # 121204
      cutpl<-c(pnewl[1],pgl[pg.nol,2]+pgl[pg.nol,3]*(pnewl[1]-pgl[pg.nol,1]))
      pgl<-rbind(pgl[1:pg.nol,],c(cutpl,angtan),c(cutpl[1]-dxy, cutpl[2]-angtan*dxy,NA))
    } else {
      if(verbose) cat("!!! case degenerated LOWER polygon: pgl.no==0")
      pgl <- rbind(pgl[1,], c(pgl[2,1:2],NA))
    }
}else{ # if(verbose) cat("kkk",kkk,"normal case")
    # normal case upper polygon
    pg.inter<-pg[,2]-angtan*pg[,1]; pnew.inter<-pnew[2]-angtan*pnew[1]
    pg.no<-sum(pg.inter<pnew.inter)
    if(is.na(pg[pg.no,3])) pg[pg.no,3] <- -Inf # 121129 NaN/Na error
    cutp<-cut.p.sl.p.sl(pnew,ang[ia],pg[pg.no,1:2],pg[pg.no,3])
    pg<- rbind(pg[1:pg.no,],  c(cutp,angtan), c(cutp[1]+dxy,  cutp[2] +angtan*dxy,NA))
    # normal case lower polygon
    pg.interl<-pgl[,2]-angtan*pgl[,1]; pnew.interl<-pnewl[2]-angtan*pnewl[1]
    pg.nol<-sum(pg.interl>pnew.interl)
    if(is.na(pgl[pg.nol,3])) pgl[pg.nol,3] <- Inf # 121129 NaN/Na error
    cutpl<-cut.p.sl.p.sl(pnewl,angtan,pgl[pg.nol,1:2],pgl[pg.nol,3]) 
    pgl<-rbind(pgl[1:pg.nol,],c(cutpl,angtan),c(cutpl[1]-dxy, cutpl[2]-angtan*dxy,NA))
}
## if(kkk==KKK && ia == 51) { cat("ENDE: pgl"); print(pgl) }
# update pg, pgl completed
# PG<<-pg;PG.NO<<-pg.no;CUTP<<-cutp;DXY<<-dxy;PNEW<<-pnew;PGL<<-pgl;PG.NOL<<-pg.nol
#########################################
#### cat("angtan",angtan,"pg.no",pg.no,"pkt:",pnew)
# if(ia==stopp) lines(pg,type="b",col="green") 
if(debug.plots=="all"){ 
  points(pnew[1],pnew[2],col="red") 
  hx<-xyxy[ind.k,c(1,1)]; hy<-xyxy[ind.k,c(2,2)]
  segments(hx,hy,c(10,-10),hy+ang[ia]*(c(10,-10)-hx),lty=2)
# text(hx+rnorm(1,,.1),hy+rnorm(1,,.1),ia)
# print(pg) 
# if(ia==stopp) lines(pgl,type="b",col="green") 
  points(cutpl[1],cutpl[2],col="red") 
  hx<-xyxy[ind.kk,c(1,1)]; hy<-xyxy[ind.kk,c(2,2)]
  segments(hx,hy,c(10,-10),hy+ang[ia]*(c(10,-10)-hx),lty=2)
#  text(hx+rnorm(1,,.1),hy+rnorm(1,,.1),ia)
# print(pgl)
}
##show pg pgl##
}
# if(verbose) PG <<- pg; PGL <<- pgl
if(2<nrow(pg) && 2<nrow(pgl)){
  
## plot(xyxy[,1:2],xlim=c(-.5,+.5),ylim=c(-.5,.50))
## lines(pg,type="b",col="red"); lines(pgl,type="b",col="blue")
## remove first and last points and multiple points #<show pg pgl>#
limit<-1e-10
## pg <-pg [c(TRUE,(abs(diff(pg [,1]))>limit)|(abs(diff(pg [,2]))>limit)),] old#
idx <- c(TRUE,(abs(diff(pg [,1]))>limit)|(abs(diff(pg [,2]))>limit)) # 121008
if(any(idx==FALSE)){
  pg <-pg[idx,]; pg[,3] <- c(diff(pg[,2])/diff(pg[,1]), NA)
}
# old reduction which caused some errors:
## pgl<-pgl[c(TRUE,(abs(diff(pgl[,1]))>limit)|(abs(diff(pgl[,2]))>limit)),] error##
## pgl<-pgl[c(     (abs(diff(pgl[,1]))>limit)|(abs(diff(pgl[,2]))>limit),TRUE),] old#
idx <-      c(     (abs(diff(pgl[,1]))>limit)|(abs(diff(pgl[,2]))>limit),TRUE)#121008
if(any(idx==FALSE)){
  pgl<-pgl[idx,]; pgl[,3] <- c(diff(pgl[,2])/diff(pgl[,1]), NA)
}
## add some tolerance in course of numerical problems
pgl[,2]<-pgl[,2] - .00001  ## 121004  
## show pg pgl>>
pg<- pg [-nrow(pg ),][-1,,drop=FALSE]
pgl<-pgl[-nrow(pgl),][-1,,drop=FALSE]
# determine position according to the other polygon
#   cat("relative position: lower polygon")
indl<-pos.to.pg(round(pgl,digits=10),round(pg,digits=10))  # 121126
#   cat("relative position: upper polygon")
indu<-pos.to.pg(round(pg,digits=10),round(pgl,digits=10),TRUE)
sr<-sl<-NULL # ; ##show pg pgl>>
# right region
if(indu[(npg<-nrow(pg))]=="lower" & indl[1]=="higher"){ 
  # cat("in if of right region: the upper polynom is somewhere lower")
  #  checking from the right: last point of lower polygon that is NOT ok
  rnuml<-which(indl=="lower")[1]-1
  #  checking from the left: last point of upper polygon that is ok
  rnumu<-npg+1-which(rev(indu=="higher"))[1]
  #  special case all points of lower polygon are upper
  if(is.na(rnuml)) rnuml<-sum(pg[rnumu,1]<pgl[,1])
  #  special case all points of upper polygon are lower
  if(is.na(rnumu)) rnumu<-sum(pg[,1]<pgl[rnuml,1])
  xyl<-pgl[rnuml,]; xyu<-pg[rnumu,]
  # cat("right"); print(rnuml); print(xyl)
  # cat("right"); print(rnumu); print(xyu)
  sr<-cut.p.sl.p.sl(xyl[1:2],xyl[3],xyu[1:2],xyu[3])
}
# left region
if(indl[(npgl<-nrow(pgl))]=="higher"&indu[1]=="lower"){ 
  # cat("in if of left region: the upper polynom is somewhere lower")
  #  checking from the right: last point of lower polygon that is ok
  lnuml<-npgl+1-which(rev(indl=="lower"))[1]
  #  checking from the left: last point of upper polygon that is NOT ok
  lnumu<-which(indu=="higher")[1]-1
  #  special case all points of lower polygon are upper
  if(is.na(lnuml)) lnuml<-sum(pg[lnumu,1]<pgl[,1])
  #  special case all points of upper polygon are lower
  if(is.na(lnumu)) lnumu<-sum(pg[,1]<pgl[lnuml,1])
  xyl<-pgl[lnuml,]; xyu<-pg[lnumu,] 
  # cat("left"); print(lnuml); print(xyl)
  # cat("left"); print(lnumu); print(xyu)
  sl<-cut.p.sl.p.sl(xyl[1:2],xyl[3],xyu[1:2],xyu[3])
}
# if(kkk==2){ ##show pg pgl##; INDU<<-indu; INDL<<-indl; PGL<<-pgl; PGU<<-pg}
pg<-rbind(pg [indu=="higher",1:2,drop=FALSE],sr,
          pgl[indl=="lower", 1:2,drop=FALSE],sl)
if(debug.plots=="all") lines(rbind(pg,pg[1,]),col="red")
if(!any(is.na(pg)))  pg<-pg[chull(pg[,1],pg[,2]),]
# if(kkk==7){ PG <<- pg }
} else {
  if(2<nrow(pgl)){ #121204
    pg <- rbind(pg[2,1:2],pgl[-c(1,length(pgl[,1])),1:2])
  } else {
    pg <- rbind(pg [-c(1,length(pg [,1])),1:2],pgl[2,1:2])
          # rbind(pgl[2,1:2],pg[2,1:2])
  }
}
if(verbose) cat("END of computation of the directions")
exp.dk.1<-cbind(pg[,1]*xysd[1]+xym[1],pg[,2]*xysd[2]+xym[2])
if(is.null(exp.dk)) exp.dk <- exp.dk.1
# EX.1 <<- exp.dk.1; EX   <<- exp.dk
if(verbose) print("End of find hulls, method two")
  }
  
# if(max(d.k[,2])==k.1||nrow(d.k)==1) lambda<-0 else {  # 121027
if(nrow(d.k)==k.1 || nrow(d.k)==1) lambda<-0 else {  # 121126
  ind <- sum(d.k[,2] <= k.1) # complicated, may be wrong in case of missing depths
  ind <- k.1 # 121123 
  ndk.1 <- d.k[ ind, 1]
  ndk   <- d.k[ ind+1, 1] # number inner
  #         (halve - number inner)/(number outer - number inner)
  lambda  <-(n/2-ndk)             /(ndk.1   - ndk)
  # lambda<-(n/2-d.k[k.1+1,1])    /(d.k[k.1,1]-d.k[k.1+1,1]) # old
  # cat(n/2, ndk,ndk.1, "k.1",k.1,"ind",ind)
}
if(verbose) cat("lambda",lambda)
  
cut.on.pdk.1<-find.cut.z.pg(exp.dk,  exp.dk.1,center=center) 
# print("HALLO"); print(cut.on.pdk.1)
cut.on.pdk  <-find.cut.z.pg(exp.dk.1,exp.dk,  center=center)
# expand inner polgon exp.dk
h1<-(1-lambda)*exp.dk+lambda*cut.on.pdk.1
# shrink outer polygon exp.dk.1
h2<-(1-lambda)*cut.on.pdk+lambda*exp.dk.1
h<-rbind(h1,h2); 
h<-h[!is.nan(h[,1])&!is.nan(h[,2]),] 
hull.bag<-h[chull(h[,1],h[,2]),]
# if(verbose){
#   plot(xy); lines(exp.dk,col="red"); lines(exp.dk.1,col="blue"); 
#   segments(cut.on.pdk[,1],cut.on.pdk[,2],exp.dk.1[,1],exp.dk.1[,2],col="red")
#   segments(cut.on.pdk.1[,1],cut.on.pdk.1[,2],exp.dk[,1],exp.dk[,2],col="blue",lwd=3)
#   points(cut.on.pdk.1,col="blue"); cat("cut.on.pdk.1"); print(cut.on.pdk.1)
#   points(cut.on.pdk,col="red"); cat("cut.on.pdk"); print(cut.on.pdk)
#   lines(hull.bag,col="green")
# }
if(verbose)cat("bag completed:") 
#if(verbose) print(hull.bag) 
if(debug.plots=="all"){   lines(hull.bag,col="red") }
  
hull.loop<-cbind(hull.bag[,1]-center[1],hull.bag[,2]-center[2])
hull.loop<-factor*hull.loop
hull.loop<-cbind(hull.loop[,1]+center[1],hull.loop[,2]+center[2])
if(verbose) cat("loop computed")
  
if(!very.large.data.set){
  pxy.bag    <-xydata[hdepth>= k   ,,drop=FALSE]
  pkt.cand   <-xydata[hdepth==(k-1),,drop=FALSE]    
  pkt.not.bag<-xydata[hdepth< (k-1),,drop=FALSE]
  if( 0 < length(pkt.cand) && 0 < length(hull.bag) ){
    outside<-out.of.polygon(pkt.cand,hull.bag)
    if(sum(!outside)>0) 
      pxy.bag    <-rbind(pxy.bag,     pkt.cand[!outside,])
    if(sum( outside)>0) 
      pkt.not.bag<-rbind(pkt.not.bag, pkt.cand[ outside,])
  }
}else {
  extr<-out.of.polygon(xydata,hull.bag)
  pxy.bag    <-xydata[!extr,] 
  pkt.not.bag<-xydata[extr,,drop=FALSE]  
}
if(length(pkt.not.bag)>0){ 
  extr<-out.of.polygon(pkt.not.bag,hull.loop)
  pxy.outlier<-pkt.not.bag[extr,,drop=FALSE]
  if(0==length(pxy.outlier)) pxy.outlier<-NULL
  pxy.outer<-pkt.not.bag[!extr,,drop=FALSE]
}else{
  pxy.outer<-pxy.outlier<-NULL
}  
if(verbose) cat("points of bag, outer points and outlier identified")
  
hull.loop<-rbind(pxy.outer,hull.bag)
hull.loop<-hull.loop[chull(hull.loop[,1],hull.loop[,2]),]
if(verbose) cat("end of computation of loop")
  
res<-list(
 center=center,
 hull.center=hull.center,
 hull.bag=hull.bag,
 hull.loop=hull.loop,
 pxy.bag=pxy.bag,
 pxy.outer=if(length(pxy.outer)>0) pxy.outer else NULL,
 pxy.outlier=if(length(pxy.outlier)>0) pxy.outlier else NULL,
 hdepths=hdepth,
 is.one.dim=is.one.dim,
 prdata=prdata,
 ## random.seed=random.seed,  #SEED 
 xy=xy,xydata=xydata
)
if(verbose) res<-c(res,list(exp.dk=exp.dk,exp.dk.1=exp.dk.1,hdepth=hdepth))
class(res)<-"bagplot"
return(res)
}
plot.bagplot<-function(x,
   show.outlier=TRUE,# if TRUE outlier are shown
   show.whiskers=TRUE, # if TRUE whiskers are shown
   show.looppoints=TRUE, # if TRUE points in loop are shown
   show.bagpoints=TRUE, # if TRUE points in bag are shown
   show.loophull=TRUE, # if TRUE loop is shown
   show.baghull=TRUE, # if TRUE bag is shown
   add=FALSE, # if TRUE graphical elements are added to actual plot
   pch=16,cex=.4, # to define further parameters of plot
   verbose=FALSE, # tools for debugging
   col.loophull="#aaccff", # Alternatives: #ccffaa, #ffaacc
   col.looppoints="#3355ff", # Alternatives: #55ff33, #ff3355
   col.baghull="#7799ff", # Alternatives: #99ff77, #ff7799
   col.bagpoints="#000088", # Alternatives: #008800, #880000
   transparency=FALSE,
   show.center = TRUE,
   ...
){
 if(missing(x)) return(
"bagplot, version 2012/12/05, peter wolf"
)
 # transparency flag and color flags have been proposed by wouter 
    if (transparency==TRUE) {
      col.loophull = paste(col.loophull, "99", sep="")
      col.baghull = paste(col.baghull, "99", sep="")
    }    
 
win<-function(dx,dy){  atan2(y=dy,x=dx) }
 
cut.z.pg<-function(zx,zy,p1x,p1y,p2x,p2y){
  a2<-(p2y-p1y)/(p2x-p1x); a1<-zy/zx
  sx<-(p1y-a2*p1x)/(a1-a2); sy<-a1*sx
  sxy<-cbind(sx,sy)
  h<-any(is.nan(sxy))||any(is.na(sxy))||any(Inf==abs(sxy))
  if(h){ # print("NAN found"); print(cbind(a1,a2,zx,zy,sxy,p2x-p1x))
  if(!exists("verbose")) verbose<-FALSE
    if(verbose) cat("special")
    # zx is zero # 121030
    h<-0==zx 
       sx<-ifelse(h,zx,sx); sy<-ifelse(h,p1y-a2*p1x,sy)
    # points on line defined by line segment
    a1 <- ifelse( abs(a1) == Inf, sign(a1)*123456789*1E10, a1) # 121030
    a2 <- ifelse( abs(a2) == Inf, sign(a2)*123456789*1E10, a2)
    # points on line defined by line segment
    h<-0==(a1-a2) & sign(zx)==sign(p1x)
       sx<-ifelse(h,p1x,sx); sy<-ifelse(h,p1y,sy)
    h<-0==(a1-a2) & sign(zx)!=sign(p1x)
       sx<-ifelse(h,p2x,sx); sy<-ifelse(h,p2y,sy)
    # line segment vertical 
    #   & center NOT ON line segment
    h<-p1x==p2x & zx!=p1x & p1x!=0 
       sx<-ifelse(h,p1x,sx); sy<-ifelse(h,zy*p1x/zx,sy)
    #   & center ON line segment
    h<-p1x==p2x & zx!=p1x & p1x==0 
       sx<-ifelse(h,p1x,sx); sy<-ifelse(h,0,sy)
    #   & center NOT ON line segment & point on line     # 121126
    h<-p1x==p2x & zx==p1x & p1x!=0 # & sign(zy)==sign(p1y)
         sx<-ifelse(h,zx,sx); sy<-ifelse(h,zy,sy)
    #   & center ON line segment & point on line
    h<-p1x==p2x & zx==p1x & p1x==0 & sign(zy)==sign(p1y)
       sx<-ifelse(h,p1x,sx); sy<-ifelse(h,p1y,sy)
    h<-p1x==p2x & zx==p1x & p1x==0 & sign(zy)!=sign(p1y)
       sx<-ifelse(h,p1x,sx); sy<-ifelse(h,p2y,sy)
    #  points identical to end points of line segment
    h<-zx==p1x & zy==p1y; sx<-ifelse(h,p1x,sx); sy<-ifelse(h,p1y,sy)
    h<-zx==p2x & zy==p2y; sx<-ifelse(h,p2x,sx); sy<-ifelse(h,p2y,sy)
    # point of z is center
    h<-zx==0 & zy==0; sx<-ifelse(h,0,sx); sy<-ifelse(h,0,sy)
    sxy<-cbind(sx,sy)
  } # end of special cases
  #if(verbose){ print(rbind(a1,a2));print(cbind(zx,zy,p1x,p1y,p2x,p2y,sxy))}
  if(!exists("debug.plots")) debug.plots<-"no"
  if(debug.plots=="all"){
    segments(sxy[,1],sxy[,2],zx,zy,col="red") 
    segments(0,0,sxy[,1],sxy[,2],col="green",lty=2) ##!!
    points(sxy,col="red")
  }
  return(sxy)
} 
 
find.cut.z.pg<-function(z,pg,center=c(0,0),debug.plots="no"){
  if(!is.matrix(z)) z<-rbind(z)
  if(1==nrow(pg)) return(matrix(center,nrow(z),2,TRUE))
  n.pg<-nrow(pg); n.z<-nrow(z)
  z<-cbind(z[,1]-center[1],z[,2]-center[2])
  pgo<-pg; pg<-cbind(pg[,1]-center[1],pg[,2]-center[2])
  if(!exists("debug.plots")) debug.plots<-"no"
  if(debug.plots=="all"){
           plot(rbind(z,pg,0),bty="n"); points(z,pch="p")
           lines(c(pg[,1],pg[1,1]),c(pg[,2],pg[1,2]))}
  # find angles of pg und z
  apg<-win(pg[,1],pg[,2])
  apg[is.nan(apg)]<-0; a<-order(apg); apg<-apg[a]; pg<-pg[a,]
  az<-win(z[,1],z[,2])
  # find line segments
  segm.no<-apply((outer(apg,az,"<")),2,sum)
  segm.no<-ifelse(segm.no==0,n.pg,segm.no)
  next.no<-1+(segm.no %% length(apg))
  # compute cut points
  cuts<-cut.z.pg(z[,1],z[,2],pg[segm.no,1],pg[segm.no,2],
                             pg[next.no,1],pg[next.no,2])
  # rescale 
  cuts<-cbind(cuts[,1]+center[1],cuts[,2]+center[2])
  return(cuts)
}
## find.cut.z.pg(EX,  EX1,center=CE)
 
center<-hull.center<-hull.bag<-hull.loop<-pxy.bag<-pxy.outer<-pxy.outlier<-NULL
# random.seed <-
hdepths<-is.one.dim<-prdata<-xy<-xydata<-exp.dk<-exp.dk.1<-hdepth<-NULL
tphdepth<-tp<-NULL
 #090216
 bagplotobj<-x
 for(i in seq(along=bagplotobj)) 
    eval(parse(text=paste(names(bagplotobj)[i],"<-bagplotobj[[",i,"]]")))
 if(is.one.dim){
    
  if(!verbose) cat("data set one dimensional") # 121202
  ROT<-round(prdata[[2]],digits=5); IROT<-round(solve(ROT),digits=5)
  if(!add){ ## 121008 ## 121130
      plot(xydata,type="n",bty="n",pch=16,cex=1, ...) # xlim=xlim, ylim=ylim, ...) 
  } 
  # find five points for box and whiskers
  usr <- par()$usr; xlim <- usr[1:2]; ylim <- usr[3:4]
  mins <- usr[c(1,3)]; ranges <- usr[c(2,4)] - mins
  if(ROT[1,1]==0){ #  cat("FALL senkrecht") 
    xydata <- cbind( mean(usr[1:2])  ,xydata[,2])
    boxplotres<-boxplot(xydata[,2],plot=FALSE)
    five<-cbind(mean(usr[1:2]),boxplotres$stat)
    dx <- 0.1*(xlim[2]-xlim[1]); dy <- 0
    idx.out <- if(0<length(boxplotres$out)) match(boxplotres$out, xydata[,2] ) else NULL
  }
  if(ROT[1,2]==0){ #  cat("FALL waagerecht") 
    xydata <- cbind( xydata[,1], mean(usr[3:4]))
    boxplotres<-boxplot(xydata[,1],plot=FALSE)
    five<-cbind(boxplotres$stat,mean(usr[3:4]))
    dx <- 0; dy <- 0.1*(ylim[2]-ylim[1]) # 1/5 of del.y
    idx.out <- if(0<length(boxplotres$out)) match(boxplotres$out, xydata[,1] ) else NULL
  }
  if(ROT[1,2]!=0 && ROT[1,1]!=0){
    xytr<-xydata%*%ROT
    boxplotres<-boxplot(xytr[,1],plot=FALSE)
    five<-cbind(boxplotres$stat,xytr[1,2])%*%IROT
    # find small vector for box height
    vec <- five[5,] - five[1,]
    vec.ortho <- c(vec[2],-vec[1]) * ranges / par()$pin 
    xy.delta <- vec.ortho * par()$pin[2:1] * ranges # plot region inches
    xy.delta <- xy.delta / sqrt( sum(xy.delta * xy.delta) ) 
    xy.delta <- xy.delta * .15 / ( sqrt(sum(abs(par()$pin*xy.delta/ranges)^2) ))
    dx <- xy.delta[1]; dy <- xy.delta[2]
    idx.out <- if(0<length(boxplotres$out)) match(boxplotres$out, xytr ) else NULL
  }
  # construct segments
  # whiskers
  segments(five[h<-c(1,5),1],five[h,2],five[h<-c(2,4),1],five[h,2], # col=col.looppoints,
           lwd=2)
  points(five[c(1,5),], cex=1, col=col.looppoints,pch=16)
  # box
  #segments(five[h<-2:4,1] + dx, five[h,2] + dy, five[h,1] - dx, five[h,2] - dy,
  #         col=col.bagpoints,lwd=2)
  #segments(five[2,1] + (h<-c(-1,1))*dx, five[2,2] + h*dy, 
  #         five[4,1] + h*dx, five[4,2] + h*dy,
  #         col=col.bagpoints,lwd=2)
  polygon(five[c(2,4,4,2,2),1] + c(dx,dx,-dx,-dx,dx), 
          five[c(2,4,4,2,2),2] + c(dy,dy,-dy,-dy,dy),
          col=col.baghull,lwd=1)  
  # median
  segments(five[h<-3  ,1] + dx, five[h,2] + dy,
           five[h,1] - dx, five[h,2] - dy,col="red",lwd=3)
  # Outlier
  if(0 < length(idx.out) && !is.na(idx.out[1])){ 
    points(xydata[idx.out,,drop=FALSE], cex=1, pch=16,col="red")
  }
  #  segments(five[3,1],five[3,2],five[3,1]+1*vec.ortho[1],
  #           five[3,2]+100*vec.ortho[2],col="green",lwd=5)
  #  segments(five[3,1],five[3,2],five[3,1]+1*vec1[1],
  #           five[3,2]+1*vec1[2],col="red",lwd=5)
  #  points(five,cex=2,col="green")
  return("one dimensional boxplot plottet")
 } else {
    
if(!add) plot(xydata,type="n",pch=pch,cex=cex,bty="n",...)
if(verbose) text(xy[,1],xy[,2],paste(as.character(hdepth))) # cex=2 needs fonts
# loop: ------------------------------------------------------
if(show.loophull){ # fill loop
    h<-rbind(hull.loop,hull.loop[1,]); lines(h[,1],h[,2],lty=1)
    polygon(hull.loop[,1],hull.loop[,2],col=col.loophull)
}
if(show.looppoints && 0 < length(pxy.outer)){ # points in loop
    points(pxy.outer[,1],pxy.outer[,2],col=col.looppoints,pch=pch,cex=cex)
}
# bag: -------------------------------------------------------
if(show.baghull && 0 < length(hull.bag)){ # fill bag
    h<-rbind(hull.bag,hull.bag[1,]); lines(h[,1],h[,2],lty=1)
    polygon(hull.bag[,1],hull.bag[,2],col=col.baghull)
}
if(show.bagpoints && 0 < length(pxy.bag)){ # points in bag 
    points(pxy.bag[,1],pxy.bag[,2],col=col.bagpoints,pch=pch,cex=cex)
}
# whiskers
if(show.whiskers && 0 < length(pxy.outer)){
    debug.plots<-"not"
    if((n<-length(xy[,1]))<15){
      segments(xy[,1],xy[,2],rep(center[1],n),rep(center[2],n),
               col="red")
    }else{
      pkt.cut<-find.cut.z.pg(pxy.outer,hull.bag,center=center)
      segments(pxy.outer[,1],pxy.outer[,2],pkt.cut[,1],pkt.cut[,2],
               col="red")
    }
}
# outlier: --------------------------------------------------
if(show.outlier && 0 < length(pxy.outlier)){ # points in loop 
      points(pxy.outlier[,1],pxy.outlier[,2],col="red",pch=pch,cex=cex)
}
# center:
if(exists("hull.center") && 2 < length(hull.center) && show.center){ #190715
    h<-rbind(hull.center,hull.center[1,]); lines(h[,1],h[,2],lty=1)
    polygon(hull.center[,1],hull.center[,2],col="orange")
}
if(!is.one.dim && show.center) points(center[1],center[2],pch=8,col="red") #190715
if(verbose && 0 < length(exp.dk.1) ){
   h<-rbind(exp.dk,exp.dk[1,]); lines(h,col="blue",lty=2)
   h<-rbind(exp.dk.1,exp.dk.1[1,]); lines(h,col="black",lty=2, lwd=3)
   if(exists("tphdepth") && 0<length(tphdepth))
      text(tp[,1],tp[,2],as.character(tphdepth),col="green")
   text(xy[,1],xy[,2],paste(as.character(hdepth)))  # cex=2 needs special fonts
   points(center[1],center[2],pch=8,col="red")
}
"bagplot plottet"
 }
}
find.hdepths <- function(xy, number.of.directions=181){ # 121126
  
xy <- as.matrix(xy)
for( j in 1:2) {
  xy[,j] <- xy[,j] - min(xy[,j])
  if( 0 < (h <- max(xy[,j]))) xy[,j] <- xy[,j] / max(xy[,j])
}
  
phi    <- c(seq(0,180,length=number.of.directions)[-1]*(2*pi/360))
sinphi <- c(sin(phi),1); cosphi <- c(cos(phi),0)
RM1 <- round(digits=6,rbind(cosphi,sinphi))
hd <- rep(h<-length(xy[,1]),h)
for( j in seq(along=sinphi)){
   xyt <- xy %*% RM1[,j]
   hd <- pmin(hd,rank(xyt,ties.method="min"), rank(-xyt,ties.method="min"))
}
#  xyt <- xy %*% RM1
#  hd2 <- cbind(apply(xyt, 2, rank, ties.method="min"), 
#               apply(-xyt,2, rank, ties.method="min"))
#  hd2 <- apply(hd2, 1, min)
  hd
}
find.hdepths.tp <- function(tp, data, number.of.directions=181){ # 121130
  ## standardize dimensions ##
  xy <- as.matrix(data); tp <- as.matrix(rbind(tp)); n.tp <- dim(tp)[1]
  for( j in 1:2) {
    xy[,j] <- xy[,j] - (h <- min(xy[,j], na.rm=TRUE))
    tp[,j] <- tp[,j] -  h
    if( 0 < (h <- max(xy[,j], na.rm=TRUE))){
      xy[,j] <- xy[,j]/h; tp[,j] <- tp[,j]/h
    }
  }
  ##loop over directions##
  phi    <- c(seq(0,180,length=number.of.directions)[-1]*(2*pi/360))
  sinphi <- c(sin(phi),1); cosphi <- c(cos(phi),0)
  RM1 <- round(digits=6,rbind(cosphi,sinphi))
  hdtp <- rep(length(xy[,1]),length(tp[,1]))
  for( j in seq(along=sinphi)){ #print(j)  
    xyt <- xy %*% RM1[,j]; tpt <- (tp %*% RM1[,j])[]
    xyt <- xyt[!is.na(xyt)] #; tpt <- sort(tpt)
    hdtp <- pmin(hdtp,(rank( c(tpt,xyt), ties.method="min"))[1:n.tp]
                      -rank( tpt,ties.method="min")
                      ,rank(-c(tpt,xyt), ties.method="min")[1:n.tp]
                      -rank(-tpt,ties.method="min")                
            )
  }
  hdtp
}
hdepth<-function(xy,data){
  # function to compute the h-depths of points
  
win<-function(dx,dy){  atan2(y=dy,x=dx) }
  if(missing(data)) data <- xy
  tp <- xy; xy <- data
  n.tp<-nrow(tp); n <- length(xy[,1])
  tphdepth<-rep(0,n.tp); dpi<-2*pi-0.000001
  for(j in 1:n.tp) {
    # compute difference of coordinates of tp j and data
    dx<-tp[j,1]-xy[,1]; dy<-tp[j,2]-xy[,2] 
    # remove data points that are identical to tp j
    h <- tp[j,1] != xy[,1] & tp[j,2] != xy[,2]
    dx <- dx[h]; dy <- dy[h]; n <- length(dx)
    minusplus<-c(rep(-1,n),rep(1,n)) ## 070824 
    # compute angles of slopes of lines through tp j and data
    a<-win(dx,dy)+pi; h<-a<10; a<-a[h]; ident<-sum(!h)
    # count number of angles that are lower than pi == points above tp j
    init<-sum(a < pi); a.shift<-(a+pi) %% dpi
    # count points relative to the tp j in halve planes
    h<-cumsum(minusplus[order(c(a,a.shift))])
    # find minimum number of points in a halve plane 
    tphdepth[j]<-init+min(h)+1 # +1 because of the point itself!!
    # tphdepth[j]<-init+min(h)+ident; cat("SUMME",ident)
  }
  tphdepth
}
hdepth<-find.hdepths.tp #121202
bagplot<-function(x,y,
   factor=3, # expanding factor for bag to get the loop
   na.rm=FALSE, # should 'NAs' values be removed or exchanged
   approx.limit=300, # limit 
   show.outlier=TRUE,# if TRUE outlier are shown
   show.whiskers=TRUE, # if TRUE whiskers are shown
   show.looppoints=TRUE, # if TRUE points in loop are shown
   show.bagpoints=TRUE, # if TRUE points in bag are shown
   show.loophull=TRUE, # if TRUE loop is shown
   show.baghull=TRUE, # if TRUE bag is shown
   create.plot=TRUE, # if TRUE a plot is created 
   add=FALSE, # if TRUE graphical elements are added to actual plot
   pch=16,cex=.4, # some graphical parameters
   dkmethod=2, # in 1:2; there are two methods for approximating the bag
   precision=1, # controls precision of computation
   verbose=FALSE,debug.plots="no", # tools for debugging
   col.loophull="#aaccff", # Alternatives: #ccffaa, #ffaacc
   col.looppoints="#3355ff", # Alternatives: #55ff33, #ff3355
   col.baghull="#7799ff", # Alternatives: #99ff77, #ff7799
   col.bagpoints="#000088", # Alternatives: #008800, #880000
   transparency=FALSE, 
   show.center = TRUE, # if TRUE center is shown
   ... # to define further parameters of plot
){
  if(missing(x)) return(
"bagplot, version 2012/12/05, peter wolf"
)
  if((is.data.frame(x) || is.matrix(x)) && ncol(x) == 2){ y <- x[,2]; x <- x[,1] } #180308
  if(missing(y)){ y <- x; x <- seq(along = y) }   #180308
  bo<-compute.bagplot(x=x,y=y,factor=factor,na.rm=na.rm,
        approx.limit=approx.limit,dkmethod=dkmethod,
        precision=precision,verbose=verbose,debug.plots=debug.plots)
  if(create.plot){ 
    plot(bo,
     show.outlier=show.outlier,
     show.whiskers=show.whiskers,
     show.looppoints=show.looppoints,
     show.bagpoints=show.bagpoints,
     show.loophull=show.loophull,
     show.baghull=show.baghull,
     add=add,pch=pch,cex=cex,
     verbose=verbose,
     col.loophull=col.loophull,
     col.looppoints=col.looppoints,
     col.baghull=col.baghull,
     col.bagpoints=col.bagpoints,
     transparency=transparency, 
     show.center = show.center, ...
    )
  }
  invisible(bo)
}
bagplot.pairs<- function(dm, trim = 0.0, main, numeric.only = TRUE, 
                          factor = 3, approx.limit = 300, pch = 16, 
                          cex = 0.8, precision = 1, col.loophull = "#aaccff",
                          col.looppoints = "#3355ff", col.baghull = "#7799ff",
                          col.bagpoints = "#000088", ...){
  if(missing(main)) main <- paste(deparse(substitute(dm)),"/ trim =",round(trim,3))
  if(length(trim) == 1) trim <- rep(trim, ncol(dm))
  if(numeric.only){
    dm <- dm[, idx <- sapply(1:ncol(dm), function(x) is.numeric(dm[,x]))]
    trim <- trim[idx]
  }
  for(j in 1:ncol(dm)){
    x <- dm[,j]
    if(!is.numeric(x)) x <- as.numeric(x)
    if( trim[j] > 0) {
      na.idx <- is.na(x)      
      xlim <- quantile(x[!na.idx], c(trim[j] , 1-trim[j])) 
      x[ na.idx |  x < xlim[1] | xlim[2] < x ] <- NA
    }
    dm[,j] <- x
  }
  # DM0 <<- dm
  h.fn <- function(x,y){
    idx <- !is.na(x) & !is.na(y)
    x <- x[ idx ]; y <- y[ idx ]
    BP <- bagplot(x,y,add=TRUE,factor = factor, approx.limit = approx.limit, pch = pch, 
                  cex = cex, precision = precision, col.loophull = col.loophull,
                  col.looppoints = col.looppoints, col.baghull = col.baghull,
                  col.bagpoints = col.bagpoints, verbose=FALSE)
    # BP <<- BP # for debugging
  }
  par(mfrow=c(1,1))
  pairs(dm, panel = h.fn, ...) 
  mtext(main, line=2.5)
  dm
}
plotsummary <- 
  function(data, trim = 0.0, types=c("stripes","ecdf","density","boxplot"), y.sizes = 4:1, 
           design = "chessboard", main, mycols="RB"){
  
plot_single_summary <- 
  function(x, trim = 0.0, types=c("stripes","ecdf","density","boxplot"), y.sizes = 1, 
           main="", mycols = c("#bbff77","#ffffbb","#bbffff","#77ffbb"), set.par=TRUE){
  
if("#" != substring(mycols[1],1,1)){
    mycols <- if(is.numeric(mycols)) c("RG","RB","GB","GR","BR","BG")[mycols] else 
                                     substring(mycols[1],1,2)
#    h <- cbind("ff",c("77","bb","ff","bb"), c("bb","ff","bb","77"))
    h <- cbind("ff",c("77","cc","bb","77"), c("77","cc","dd","99"))
    switch( mycols,
           "RG" = mycols <- h[,c(1,2,3)], "RB" = mycols <- h[,c(1,3,2)],
           "GB" = mycols <- h[,c(3,1,2)], "GR" = mycols <- h[,c(2,1,3)],
           "BR" = mycols <- h[,c(2,3,1)], "BG" = mycols <- h[,c(3,2,1)]
    )
    mycols <- paste("#",mycols[,1],mycols[,2],mycols[,3],sep="")
}
  
if("" == main) main <- deparse(substitute(x))
  
if(is.ts(x)) x <- as.vector(x)
if(is.character(x)) x <- as.factor(x); if(is.factor(x)) x <- as.numeric(x)
  
idx.na <- is.na(x)
if(0 < trim) xlim <- quantile(x[!idx.na],c(trim,1-trim)) else xlim <- range(x[!idx.na])
if(xlim[1] < xlim[2]) x <- (x - xlim[1])/(xlim[2] - xlim[1]) else x <- x*0 +.5
xlim <- 0:1
idx.visible <- (!idx.na) & (0 <= x) & (x <= 1) # index of visible data points
  
if(set.par) oldpar <- par(mfrow=c(1,1),omi=c(0,0,0,0),mar=c(2,2,1,1))
plot(1,xlim=xlim,bty="n",type="n",main="",axes=FALSE,ylim=c(0,1)) 
par(usr=c(-0.01,1.01,-0.01,1.01))  # ; axis(1)
title(main,cex.main=0.75)
rug(x[idx.visible])
fn <- fivenum(x[idx.visible])
rect(fn[1:4], 0, fn[2:5], 1, col=mycols[1:4],border=mycols[1:4],xpd=NA) # color
grid() # ; axis(1)
n.types <- length(types); if(length(y.sizes) == 1) y.sizes <- rep(y.sizes, n.types)
y.mins <- 1 - cumsum(y.sizes <- y.sizes/sum(y.sizes))
  for(i in seq(along=types)){
    type <- types[i]
    
if(type == "stripes" || "s" == substring(type,1,1) ){
  n <- length(x)
  y0 <- 0.95*seq(x)/n; y0 <- y0*y.sizes[i] + y.mins[i]  # print(x); print(xlim)
  segments(rep(xlim[1],n),y0,pmin(xlim[2],pmax(xlim[1],x)),y0,col=i)         # stripes
  x [idx.na] <- 0.5
  if(any( ind <- x<xlim[1] )){ points( cbind(-0.01, y0[ ind ]), pch=18, xpd=NA ) }
  if(any( ind <- xlim[2]<x )){ points( cbind( 1.01, y0[ ind ]), pch=18, xpd=NA ) }
  if( 0 < sum(idx.na)){
    segments(rep(xlim[1]-.02,length(idx.na)),y0[idx.na],
             rep(xlim[2]+.02,length(idx.na)),y0[idx.na],col="red")    # red NA-stripes
  }
}
    
if(type == "density" || "d" == substring(type,1,1) ){
 if( 10 < length( tb <- table(x[idx.visible])) ){
    dx <- density(x[!idx.na]); y0 <- dx$y; x0 <- dx$x
    y0 <- 0.9*y0 / max(y0);  y0 <- y0*y.sizes[i] + y.mins[i]
    lines(x0, y0, lwd=2)                                                    # density
  } else {
    y0 <- tb; x0 <- as.numeric(names(tb))
    y0 <- 0.9*y0 / max(y0);  y0 <- y0*y.sizes[i] + y.mins[i]
    segments( x0, y.mins[i], x0, y0, lwd=3)
  }
}
 
    
if(type == "boxplot" || "b" == substring(type,1,1) ){
  result <- boxplot(x[idx.visible],plot=FALSE); fn <- result$stats; out <- result$out
  y0 <- y.mins[i] + c(0.3,0.7)*y.sizes[i]
  rect(fn[2:3],y0[1],fn[3:4],y0[2],lwd=2)                                   # box
  y0 <- y.mins[i] + 0.5*y.sizes[i]
  segments(fn[c(1,5)],y0,fn[c(2,4)],y0,lwd=2)  #,col=mycols[c(1,4)]         # whisker
  points(cbind(out,y0))
  if(any( ind <- x < xlim[1] )){ points( -0.01, y0, pch=18, xpd=NA, cex=2 ) }
  if(any( ind <- xlim[2] < x )){ points(  1.01, y0, pch=18, xpd=NA, cex=2 ) }
}
    
if(type == "ecdf" || "e" == substring(type,1,1) ){
  xx <- sort(x[idx.visible])
  yy <- 0.9*seq(along=xx)/length(xx)
  y0 <- yy*y.sizes[i] + y.mins[i]
  points(xx, y0, pch=16); points(xx, y0, type="s"); n.xx <- length(xx)
  segments(-0.02,y.mins[i],xx[1],y.mins[i]);  segments(1.02,y0[n.xx],xx[n.xx],y0[n.xx])
  if(any( ind <- x < xlim[1] )){points(-0.01, y.mins[i], pch=18, xpd=NA ) }
  if(any( ind <- xlim[2] < x )){points( 1.01, y.mins[i] + .9*y.sizes[i], pch=18, xpd=NA)}
}
  }
  return()
}
  data.name <- deparse(substitute(data)); if(missing(main)) main <- data.name 
  if(is.list(data)){       cols <- length(data);     Names <- names(data)}    else 
    if(is.matrix(data)){   cols <- ncol(data);       Names <- colnames(data)}   else {
      data <-  cbind(as.vector(unlist(data))); cols <- Names <- 1 }
      # if(is.vector(data)||is.ts(data)){
      #   cols <- 1; data <- cbind(data); Names <- " " 
      # } else return("Warning: data set not compatible")
  if(0 == length(Names)) Names <- as.character(1:cols) 
  plot(1,type="n",xlab="",ylab="",axes=FALSE); oldpar <- par(no.readonly = TRUE)
  if( design != "chessboard" ) mfrow <- c(1,cols) else{
    mfrow <- ceiling(rep(sqrt(cols),2)); mfrow[1] <- ceiling(cols/mfrow[2])
  }
  par(mfrow=mfrow, omi=c(0.1,0.1,.5,0.1), mai=c(.1,.1,.15,0))
  for(j in seq(cols)){
    dat <- if( is.matrix(data) ) dat <- data[,j] else dat <- unlist(data[[j]])
    try(plot_single_summary(dat, trim = trim, types=types, y.sizes=y.sizes, 
                            main=Names[j], mycols=mycols, set.par=FALSE))
  }
  mtext(main,line=1,adj=0,outer=TRUE)
  par(oldpar) 
  NULL
}
skyline.hist <- function(
                x, n.class, n.hist = 1, main, ylab="density", 
                night = FALSE, col.bars = NA, col.border = 4, lwd.border = 2.5,
                n.shading = 6, lwd.shading = 2, col.shading = NA, lty.shading = 3,
                pcol.data = "green", cex.data = 0.3, pch.data = 16, col.data = 1,
                lwd.data = .2, permutation = FALSE, 
                xlab, xlim, ylim, new.plot=TRUE, bty="n", ...){
  # initialization of variables
  if(missing(main)) main <- paste("skyline plot")
  if(missing(xlab)) xlab <- deparse(substitute(x))
  # find the width of a cell
  hist.res <- hist(x, plot=FALSE)
  if(!missing(n.class)) width.bars <- diff(range(x))/n.class else {
    width.bars <- diff(hist.res$breaks[1:2])
    n.class <- ceiling(diff(rank(x))/width.bars)
  }
  # find range for x-axis
  x.lim <- (x.range<-range(x)) + c(-1,1) * width.bars
  # find size of the bars
  starts.bars <- x.range[1] - width.bars*(n.hist-1)/n.hist # start of bar one
  starts.bars <- starts.bars + width.bars*(0:(n.hist-1))/n.hist # all starts
  starts.bars <- sapply(starts.bars, function(x) x + width.bars*(0:(n.class+1)))
  starts.bars <- starts.bars[starts.bars <= max(x)]
  idx <- x==x.range[1]; if(any(idx)) x[idx] <- x[idx]+0.001*diff(x.range)
  n.bars <- length(starts.bars)
  counts.bars <- rep(0,n.bars)
  for(i in 1:n.bars){
    counts.bars[i]<-sum( starts.bars[i] < x & x <= (starts.bars[i] + width.bars))
  }
  n <- length(x)
  heights.bars <- counts.bars/n/width.bars
  if( 0 < permutation ){
    if(!is.numeric(permutation)) permuation <- 1
    idx <- rep((permutation + 13*7654321)%%9573, n)
    for(i in 2:n) idx[i] <- (idx[i-1] * 1234567 + 87654321) %% 9573
    idx <- order(idx); x <- x[idx]
  }
  # prepare plot
  if(missing(xlim)) xlim <- x.lim
  if(missing(ylim)) ylim <- c(0, max(heights.bars))
  if(new.plot) 
    plot(0, xlim=xlim, ylim=ylim, type="n", bty=bty, xlab=xlab, ylab=ylab, ...)
  title(main)
  # background
  if( night != FALSE ){
     col.night  <- if(is.logical(night)) "blue" else night
     usr <- par()$usr; rect(usr[1], usr[3], usr[2], usr[4], col = col.night)
     night <- TRUE
  }
  # add histogram like borders  # if(broder) hist(x,add=TRUE,prob=TRUE) 
  if(missing(col.bars)) col.bars <- if(night) "#555555" else "white"
  rect(starts.bars, heights.bars * 0, starts.bars + width.bars,
       heights.bars, lwd = lwd.border, border = col.border, 
       col = col.bars)
  # add pattern for filling the bars small windows
  if(0 < n.shading){
    dx <- width.bars * ((1:n.shading) - 0.5)/n.shading
    if(is.na(col.shading)) col.shading <- rainbow(n.bars) 
    if(length(col.shading) < n.bars) col.shading <- rep(col.shading,n.bars)
    for(i in 1:n.bars){
      segments(starts.bars[i] + dx, rep(0,n.shading),
               starts.bars[i] + dx, rep(heights.bars[i],n.shading),
               lty=lty.shading, lwd=lwd.shading, col=col.shading[i])  
    }
  }
  # representation of the data
  for(i in 1:n.bars){
    idx <- starts.bars[i] < x & x <= (starts.bars[i] + width.bars)
    if((count <- sum(idx)) == 0) next
    x.i <- c(starts.bars[i] + 0.5 * width.bars, x[idx])
    n.i <- count + 1
    max.h <- count/n/width.bars
    if(missing(col.data)) col.data <- rainbow(count,start=.0,end=.15)
    y.i <- (0:count)/count * max.h 
    segments( x.i[-n.i], y.i[-n.i], x.i[-1], y.i[-1], col = col.data, lwd = lwd.data)
    points(col = pcol.data, pch = pch.data, cex=cex.data, x.i[-1], y.i[-1])
  } 
  # return info of hist
  invisible(hist.res)
}
plothulls <- function(x, y, fraction, n.hull = 1, main, add=FALSE,
                      col.hull, lty.hull, lwd.hull, density=0, ...){
  # function for data peeling:
  # x,y : data
  # fraction.in.inner.hull : max percentage of points within the hull to be drawn
  # n.hull : number of hulls to be plotted (if there is no fractiion argument)
  # col.hull, lty.hull, lwd.hull : style of hull line
  # add : if TRUE old plot is used
  # pw 130524 180308
  if((is.data.frame(x) || is.matrix(x)) && ncol(x) == 2){ y <- x[,2]; x <- x[,1] } #180308
  if(missing(y)){ y <- x; x <- seq(along = y) }   #180308
  if(add) points(x,y,...) else plot(x,y,...)
  n <- length(x)
  if(!missing(fraction)) { # find special hull
     n.hull <- 1
     if(missing(col.hull)) col.hull <- 1
     if(missing(lty.hull)) lty.hull <- 1
     if(missing(lwd.hull)) lwd.hull <- 1
     x.old <- x; y.old <- y
     idx <- chull(x,y); x.hull <- x[idx]; y.hull <- y[idx]
     for( i in 1:(length(x)/3)){
       x <- x[-idx]; y <- y[-idx]
       if( (length(x)/n) < fraction ){
         if(missing(main))
           title(paste("fraction in polygon:\n",
                       round((length(x)+length(x.hull))/n,4)))
         polygon(x.hull, y.hull, col=col.hull,
                 lty=lty.hull, lwd=lwd.hull, density=density) 
         return(cbind(x.hull,y.hull))
       }
       idx <- chull(x,y); x.hull <- x[idx]; y.hull <- y[idx];
     }
  }
  if(missing(col.hull)) col.hull <- 1:n.hull
  if(length(col.hull)) col.hull <- rep(col.hull,n.hull)
  if(missing(lty.hull)) lty.hull <- 1:n.hull
  if(length(lty.hull)) lty.hull <- rep(lty.hull,n.hull)
  if(missing(lwd.hull)) lwd.hull <- 1
  if(length(lwd.hull)) lwd.hull <- rep(lwd.hull,n.hull)
  result <- NULL
  for( i in 1:n.hull){
    idx <- chull(x,y); x.hull <- x[idx]; y.hull <- y[idx]
    result <- c(result, list( cbind(x.hull,y.hull) ))
    polygon(x[idx], y[idx], col=col.hull[i],
            lty=lty.hull[i], lwd=lwd.hull[i], density=density) 
    x <- x[-idx]; y <- y[-idx]
    if(0 == length(x)) return(result)
  }
  if(missing(main))
    title(paste("fraction of points within the smallest polygon:\n",
                round((length(x)+length(x.hull))/n,4)))
  result
} # end of definition of plothulls
 
##:start##
#:0

slider.lowess.plot<-function(x,y=NULL,...)
{
  # slider function to draw lowess smoother, pwolf 080525
  x.name<-deparse(substitute(x))
  y.name<-deparse(substitute(y))
  if(length(x)<2) return("Error: x is of length 0 or 1")
  if(!is.null(y)){ 
    if(length(y)<2) return("Error: y must be a vector")
    if(length(x)!=length(y)) 
      return("Error: x and y must have the same length")
    x<-cbind(x,y) 
  }
  if(!is.matrix(x) && !is.data.frame(x)){ 
    x<-cbind(seq(x),x) 
    y.name<-x.name; x.name<-"index"
  }
  if(is.null(y.name)){x.name<-colnames(x)[1]; y.name<-colnames(x)[2]}
  y<-x[,2]; x<-x[,1]

  args<-list(...)
  refresh<-function(...){
    f<-slider(no=1)
    iter<-slider(no=2)
    xy<-lowess(x,y,f=f,iter=iter)
    # plot(x,y,bty="n")
    do.call("plot",c(alist(x,y,bty="n"),args))
    lines(xy)
    title(paste("\n\nlowess: f =",signif(f,4),", iterations =",iter))
    lines(xy)
  }
  slider(refresh,
         c("smoother span","iterations"),
         c(.01,1),c(1,7),c(.01,1),c(2/3,3)
  )
  refresh()
  cat("use slider to select smoother span!\n")
}

slider.bootstrap.lm.plot<-function(x,y=NULL,...)
{ 
 x.name<-deparse(substitute(x))
 y.name<-deparse(substitute(y))
 if(length(x)<2) return("Error: x is of length 0 or 1")
 if(!is.null(y)){ 
   if(length(y)<2) return("Error: y must be a vector")
   if(length(x)!=length(y)) 
     return("Error: x and y must have the same length")
   x<-cbind(x,y) 
 }
 if(!is.matrix(x) && !is.data.frame(x)){ 
   x<-cbind(seq(x),x) 
   y.name<-x.name; x.name<-"index"
 }
 if(is.null(y.name)){x.name<-colnames(x)[1]; y.name<-colnames(x)[2]}
 y<-x[,2]; x<-x[,1]

 args<-list(...)
 n<-length(x)
 ind<-order(x); x.orig<-x<-x[ind]; y.orig<-y<-y[ind]
 xx<-seq(min(x),max(x),length=100)         
 # plot(x,y,...)       
 do.call("plot",c(alist(x,y,bty="n"),args))
 abline(lm(y~x),lwd=5)
 refresh<-function(...){
   # plot(x,y,...); 
   do.call("plot",c(alist(x,y,bty="n"),args))
   abline(coefyx<-lm(y~x)$coef, lwd=3)
   polytype<-slider(no=1)
   form<-paste(paste(sep="","I(x^",1:polytype,")"),collapse="+")
   form<-as.formula(paste("y ~",form)); coef<-lm(form)$coef
   yy<-outer(xx,0:polytype,"^")%*%coef; lines(xx,yy,lwd=2)
   B<-slider(no=2); zz<-slider(no=3); set.seed(zz)
   result<-matrix(0,1+polytype,B)
   for(i in 1:B){
     index<-sample(1:n,n,replace=TRUE)
     x<-x.orig[index]; y<-y.orig[index]
     coef<-lm(form)$coef
     yy<-outer(xx,0:polytype,"^")%*%coef
     lines(xx,yy,lwd=2,col=i,lty=2)
     result[,i]<-coef
   }
   abline(coefyx, lwd=5)
   result<-t(result); 
   colnames(result)<-c("intercept",paste(sep="","beta: x^",1:polytype))
   print(summary(result))
 }
 slider(refresh,c("polynomial degree","number repetitions","random seed"),
        c(1,1,1),c(5,50,100),c(1,1,1),c(1,10,1))
 refresh()
 "ok"
}

##define [[puticon()]]:##
#275:
puticon <- function(x = 0, y = 0, icon = "", grey.levels = .5,
    icon.cex = 10, color = "red", ..., adj = c(0.5,0.5), xpd = NA){
  
#276:
##check inputs and manage case of showing design in [[puticon()]]:##
pch <- file <- ""
if( is.numeric(icon) && length(icon) == 1 ) pch <- icon
if( is.character(icon) && !is.raster(icon)){
  icon <- icon [1]; h <- nchar(icon) 
  if( substring( icon, h - 3, h ) %in% 
        c(".jpg", ".JPG", "jpeg", "JPEG", ".pnm", ".PNM", ".png", ".PNG") 
  ){ 
    if( substring( icon, 1, 4 ) == "http" ){
      fname <- sub(".*[.]", ".", icon)
      fname <- tempfile("icon-pic", fileext = fname)
      h <- try( utils::download.file(url = icon, destfile = fname) )
      if( "error" %in% class(h) ){ 
        cat("Error in puticon: Download of file", icon, "failed.\n")
        return()
      } 
      on.exit(file.remove(fname))
      icon <- fname
    }
    if( file.exists(icon) ) file <- icon else {
      cat("Error in puticon: reading of file", icon, "failed.\n")
    }
  } 
}
if(missing(x)){
  
#277:
##show design layout of special icon in [[puticon()]]:##
   
#314:
##define [[show.icon.design()]]:##
show.icon.design <- function(icon, reset = TRUE, color = NA, ...){
  old <- par(pin = c(100, 100) / 25.4)
  plot(1:100, xlim = c(0,100), ylim = c(0,100), type = "n", 
       axes = FALSE, xlab = "", ylab = "")
  par(usr = c(0,100,0,100)); axis(1); axis(2)
  color <- ifelse(is.na(color), sample(rainbow(15)), color)
  abline(h = c(0,100), v = c(0,100), lwd = 2, col = "blue", xpd = NA)
  puticon(50, 50, icon, icon.cex = 100, color = color, ...)
  if(reset) par(pin = old)
}
##:define [[show.icon.design()]]##
#:314
 
   if(identical(icon, "")){  # no specific input
     # show internal icon generators:  # find headers of generator
     h <- deparse(puticon); h <- h[grep(paste("\"internal generator", "function"), h) + 1]
     h <- sub("[<][-].*", "", h); h <- gsub(" ", "", h) # remove assignment
     h <- unique(h)
     cat("list of internal generator functions :\n"); cat(h, "\n")
     return(invisible(h))
   }
   if(is.function(icon)){    # icon is a generator function
     show.icon.design(icon, color = "lightblue") 
     cat("arguments of", substitute(icon),":\n")
     print(noquote(h <- args(icon)))
     return()
   }
   if(is.raster(icon)){      # icon is a raster graphics
     show.icon.design("car", color = "green") 
     # icon[] <- (icon - (h <- min(icon))) / (max(icon) - h) # standardization
     rasterImage(icon, 0, 0, 100, 100 * ((h <- dim(icon))[1] / h[2]), 
                 interpolate = FALSE, xpd = xpd)
     return()
   }
   if( is.numeric(icon) ){   # central symbol
     show.icon.design("circle", color = "white") 
     cex <- 25.4 * par()$pin[1] * 0.21 
     points(50, 50, pch = pch, cex = cex, lwd = cex )
     cat("central symbol", icon[1], "will be used as icon; see points()\n")
     return()
   } # now icon is the name of an internal generator or a file name
   if( is.character(icon) ){ # but no raster object 
     if( "" != file ){       # variable file is assigned yet
       show.icon.design("circle", color = "white") 
       
#287:
##read jpeg, png or pnm file in [[puticon()]]:##
  icon <- 0; class(icon) <- "error"
  # JPEG
  if( 0 < length(grep("jp[e]{0,1}g$", file))  || 
      0 < length(grep("JP[E]{0,1}G$", file))){
    if(!"package:jpeg" %in% search()){
      print("puticon() requires package jpeg")
      # library(jpeg, lib.loc = .libPaths()) 
    }
    icon <- try(jpeg::readJPEG(file, native = !TRUE)) #############
  }
  # PNG
  if( 0 < length(grep("png$", file))  || 0 < length(grep("PNG$", file))){
    if(!"package:png" %in% search()){
      print("puticon() requires package png")
      # library(png, lib.loc = .libPaths()) 
    }
    icon <- png::readPNG(file, native = !TRUE)  ##################
  }
  # PNM
  if( 0 < length(grep("pnm$", file))  || 0 < length(grep("PNM$", file))){
    if(!"package:tcltk" %in% search()){
      print("puticon() requires package tcltk")
      # library(tcltk, lib.loc = .libPaths()) 
    }
    
#221:
##define [[get.pnm()]]:##
get.pnm <- function(filename, verbose = FALSE){
  
#222:
##find P* type of pnm file:##
nextline <- scan(filename, what="", n=1)
if( substring(nextline, 1, 1) != "P" || 
    ! ( PType <- substring(nextline, 2, 2) ) %in% as.character(1:6)) 
  return("ERROR: reading pnm file failed: no pnm file")
PType <- as.numeric(PType); if(verbose) cat("PType:", PType); skip <- 0
nextline <- scan(filename, what="", sep="\n", n=1, skip = skip, 
                 blank.lines.skip = FALSE)
nextline <- unlist( strsplit( nextline, "[ \t]"))[-1]
##:find P* type of pnm file##
#:222
  
#223:
##get width of pnm picture:##
#226:
##get next line that is not empty:##
idx <- 20
while(idx > 0 & 0 == length(nextline)){
  idx <- idx - 1; skip <- skip + 1
  nextline <- scan(filename, what="", sep="\n", n=1, skip = skip,
                   blank.lines.skip = FALSE)
  nextline <- sub("[#].*", "", nextline)
  nextline <- unlist( strsplit( nextline, "[ \t]"))
}
if( idx == 0 ) return("ERROR: reading pnm file failed: too many #-lines")
nextline <- as.numeric(nextline)
##:get next line that is not empty##
#:226
width <- nextline[1]; if(verbose) cat("width:",width)
nextline <- nextline[-1]
##:get width of pnm picture##
#:223
  
#224:
##get height of pnm picture:##
if( length(nextline) == 0 ){
  
#226:
##get next line that is not empty:##
idx <- 20
while(idx > 0 & 0 == length(nextline)){
  idx <- idx - 1; skip <- skip + 1
  nextline <- scan(filename, what="", sep="\n", n=1, skip = skip,
                   blank.lines.skip = FALSE)
  nextline <- sub("[#].*", "", nextline)
  nextline <- unlist( strsplit( nextline, "[ \t]"))
}
if( idx == 0 ) return("ERROR: reading pnm file failed: too many #-lines")
nextline <- as.numeric(nextline)
##:get next line that is not empty##
#:226
}
height <- nextline[1]; if(verbose) cat("height:", height)
nextline <- nextline[-1]
##:get height of pnm picture##
#:224
  
#225:
##get colors of pnm picture:##
if(PType == 1 || PType == 4) colors <- 1 else {
  if( length(nextline) == 0 ){
    
#226:
##get next line that is not empty:##
idx <- 20
while(idx > 0 & 0 == length(nextline)){
  idx <- idx - 1; skip <- skip + 1
  nextline <- scan(filename, what="", sep="\n", n=1, skip = skip,
                   blank.lines.skip = FALSE)
  nextline <- sub("[#].*", "", nextline)
  nextline <- unlist( strsplit( nextline, "[ \t]"))
}
if( idx == 0 ) return("ERROR: reading pnm file failed: too many #-lines")
nextline <- as.numeric(nextline)
##:get next line that is not empty##
#:226
  }
  colors <- nextline[1]
}; if(verbose){ cat("colors:", colors); cat("head processed") }
##:get colors of pnm picture##
#:225
  
#228:
##get decpixel of pnm picture:##
if(PType < 4){
  decpixel <- scan(filename, what="", sep="\n", skip = skip+1)
  decpixel <- paste(collapse=" ", decpixel)
  decpixel <- unlist( strsplit( decpixel, " +"))
  decpixel <- as.numeric(decpixel)
  decpixel <- matrix( decpixel, ncol = width, byrow = TRUE)
} else { # P4, P5, P6
  
#227:
##read picture data of P4, P5 or P6 pictures:##
tclcmds <- c('
  # https://de.wikipedia.org/wiki/Portable_Pixmap
  # set fname mm.pnm
  set fname FILENAME       
  set size [ file size $fname ]  
  # puts $size
  set fp [open $fname]
  # http://www.tek-tips.com/viewthread.cfm?qid=1477934  
  fconfigure $fp -translation binary 
  # scan [string range $contents i i] %c strA  
  set binpixel [read $fp $size]
  close $fp
  binary scan $binpixel cu* decpixel
')
tclcmds <- sub("FILENAME", filename, tclcmds)
#require(tcltk)
if( requireNamespace("tcltk") ){ 
  tcltk::.Tcl(tclcmds)
} else { 
  print("Error from get.pnm: tcltk not found!!"); return() 
}
decpixel <- as.character(tclvalue("decpixel"))
##:read picture data of P4, P5 or P6 pictures##
#:227
  decpixel <- unlist( strsplit( decpixel, " "))
  if( PType == 4){
    n.infos <- ceiling(width/8) * height 
    # if(verbose) cat("length(decpixel)", length(decpixel), "n.infos", n.infos)
    decpixel <- decpixel[ -(1 : ( length(decpixel) - n.infos )) ]
    encode <- function(number, base) {
      # simple version of APL-encode / APL-representation "T", pw 10/02
      # "encode" converts the numbers "number" using the radix vector "base"
      n.base <- length(base); result <- matrix(0, length(base), length(number))
      for(i in n.base:1){
        result[i,] <- if(base[i]>0) number %% base[i] else number
        number     <- ifelse(rep(base[i]>0,length(number)),
                             floor(number/base[i]), 0)
      }
      return( if(length(number)==1) result[,1] else result )
    }
    decpixel <- encode(as.numeric(decpixel), rep(2,8))
    decpixel <- matrix(decpixel, nrow = height, byrow = TRUE)[, 1:width]
    # decpixel <- matrix(decpixel, ncol = height, byrow = !TRUE)
    # decpixel <- t(decpixel[(1:width),])
  } else { # P5 or P6
    BigEndian <- colors > 255
    n.infos <- width * height * c(1,3)[1+(PType == 6)] * c(1,2)[1+BigEndian]   
    decpixel <- decpixel[ -(1 : ( length(decpixel) - n.infos )) ]
    if( BigEndian ){ # use the first byte of a pixel only
      decpixel <- matrix(decpixel, ncol = 2, byrow = TRUE)[,1] ### 1 or 2?
    }
    decpixel <- as.numeric(decpixel)
    decpixel <- matrix( decpixel, ncol = width * (1 + 2*(PType == 6)), byrow = TRUE)
  }
  PType <- PType - 3
}
##:get decpixel of pnm picture##
#:228
  
#229:
##define [[decpixel.to.raster()]]:##
decpixel.to.raster <- function(decpixel, PType, width, height, colors){
  HEX <- unlist(strsplit("0123456789ABCDEF",""))
  if(PType < 3){ # black and white or grey -- P1 or P2
    if(PType==1) decpixel <- colors - decpixel
    pixel <- decpixel / colors * 255
    first <- floor( pixel / 16 ); second <- pixel %% 16
    hexpixel <- paste(sep="", HEX[1 + first], HEX[1 + second])
    hexpixel <- paste(sep="", "#", hexpixel, hexpixel, hexpixel)
    hexpixel <- matrix(hexpixel, ncol = width)
  } else {       # colors -- P3
    decpixel <- array(t(decpixel), c(3, width, height))
    if( 255 < colors ) colors <- 255                                 # 160928
    pixel <- decpixel / colors * 255
    first <- floor(pixel / 16); second <- pixel %% 16
    hexpixel <- paste(sep="", HEX[1 + first], HEX[1 + second])
    hexpixel <- array(hexpixel, c(3, width, height))
    hexpixel <- paste(sep="", "#", hexpixel[1,,], hexpixel[2,,], hexpixel[3,,])
    hexpixel <- matrix(hexpixel, ncol = width, byrow = TRUE)
  }
  raster <- hexpixel
}
#table(decpixel.to.raster(a, 6, 724, 561, 65535))
#table(a)
##:define [[decpixel.to.raster()]]##
#:229
  as.raster(decpixel.to.raster(decpixel, PType, width, height, colors))
} #; dump("get.pnm", file = "get.pnm.R")
##:define [[get.pnm()]]##
#:221
    icon <- get.pnm(file)
  }
  if( "try-error" %in% class(icon) ){
    cat("Error in puticon(): file", file, "not readable by puticon()")
    return()
  }
##:read jpeg, png or pnm file in [[puticon()]]##
#:287
       rasterImage(icon, 0, 0, 100, 100 * ((h <- dim(icon))[1] / h[2]), 
                   interpolate = FALSE, xpd = xpd)
       return()
     } else {                # internal generator
       icon <- icon [1]
       h <- deparse(puticon); hh <- grep(paste(icon, sep = "", " [<][-]"), h)
       if( 0 < length(hh) ){
         h <- h[hh + (0:5)]; h <- paste(h, collapse = "")
         h <- sub("^[^(]*[(]", "", h); h <- sub("[{].*", "", h) # )))(
         h <- gsub(" +", " ", h); h <- sub("[)] *$", "", h)     #
         if(nchar(h) > 0){ 
           
#351:
##define generator functions:##
h <- "internal generator function"
  
#315:
##define [[BI()]]:##
BI <- function(){
  result <- list()
  res <- cbind( x = c(0, 25, 25, 0), y = c(0, 0, 61, 61), color = NA)
  class(res) <- "polygon"
  result <- c(result, list(res))
  res <- cbind( x = c(72, 57, 57, 72), y = c(0, 0, 61, 61), color = NA)
  class(res) <- "polygon"
  result <- c(result, list(res))
  res <- cbind( x = c( 0, 72,  72,  56, 56, 44,  44,  29, 29, 16,  16,   0), 
                y = c(72, 72, 100, 100, 87, 87, 100, 100, 87, 87, 100, 100), color = NA)
  class(res) <- "polygon"
  result <- c(result, list(res))
  res <- rbind( c(19.0, 43, 24,   43, lwd.mm = 36, color = NA),
                c(19.0, 18, 30.5, 18, lwd.mm = 36, color = NA),
                c(12, 43, 21, 43, lwd.mm = 11, 0),
                c(12, 18, 27, 18, lwd.mm = 11, 0) )
  colnames(res) <- c("x0", "y0", "x1", "y1", "lwd.mm", "color")
  class(res) <- "segments"
  result <- c(result, list(res))
  res <- cbind( x = c(0, 15, 15, 0), y = c(0, 0, 61, 61), color = NA)
  class(res) <- "polygon"
  result <- c(result, list(res))
  result
}
##:define [[BI()]]##
#:315
h <- "internal generator function"
  
#318:
##define [[TL()]]:##
TL <- function(L = c("AB", "DT", "PW", "NV", "Hello")[1], t.cex.mm = 10, 
               startx, starty, delx, dely, Lcolors,
               pointx = 90, pointy = 90, pointsize = 8, pointcolor = "red" ){
  # L               letters to be used
  # t.cex.mm        letter size: a 'W' will have a width of 'text.cex.mm' mm 
  # startx, starty  x coordinate of first letter in mm
  # delx, dely      shift in x and in y between letters in mm
  # Lcolors         colors of the letters to be used
  # pointx, pointy  x and y coordinate of point
  # pointsize       size of the point
  # pointcolor      color of the point
  if(is.factor(L) || is.numeric(L) ) L <- as.character(L)
  L <- unlist(strsplit(L,""))
  n <- length(L)
  check.num <- function(x, n = 2){
    if(is.factor(x)) x <- as.character(x); x <- as.numeric(x); x <- rep(x, n)[1:n] 
  }
  if(missing(startx)) startx <- 50 / n; if(missing(delx)) delx <- 100 / n  
  if(missing(starty)) starty <- 50 / n; if(missing(dely)) dely <- 100 / n 
  if(missing(t.cex.mm))  t.cex.mm  <- 100 / n 
  if(missing(pointx))   pointx <- 100 - min(60, 5 + n * 2.5)
  if(missing(pointy)){  pointy <-       min(40, 5 + n * 2.5)
                        if(starty[1] > 50) pointy <- 100 - pointy }
  if(missing(pointsize)) pointsize <- min(40, 10 + n * 2.5)
  if(missing(Lcolors)) Lcolors <- 1; Lcolors <- rep(Lcolors, n)[1:n]
  startx <- check.num(startx, n); starty <- check.num(starty, n) 
  delx <- cumsum(c(0, check.num(delx, n - 1))); dely <- cumsum(c(0, check.num(dely, n - 1)))
  startx <- (startx + delx) %% 100; starty <- (starty + dely) %% 100
  result <- list()
  res <- data.frame( x = c(0, 0, 100, 100), y = c(0, 100, 100, 0), color = NA) 
  class(res) <- c( class(res), "polygon"); result <- c(result, list(res))  # box of the icon
  res <- data.frame(x0 = pointx, y0 = pointy, x1 = pointx, y1 = pointy, 
                    lwd.mm = pointsize, color = pointcolor)
  class(res) <- c( class(res), "segments"); result <- c(result, list(res)) # special point
  res <- data.frame(x = startx, y = starty, L = L, text.cex.mm = t.cex.mm, color = Lcolors)
  class(res) <- c( class(res), "text"); result <- c(result, list(res))     # letters
  result
} # ; show.icon.design(TL) #; TL()
##:define [[TL()]]##
#:318
h <- "internal generator function"
  
#325:
##define [[cross.simple()]]:##
cross.simple <- function(){  # print("in cross")
  res <- rbind( c( 05, 05, 95, 95, lwd.mm = 10, NA), 
                c( 05, 95, 95, 05, lwd.mm = 10, NA),
                c( 50, 50, 50, 50, lwd.mm = 30, 2) ) 
  colnames(res) <- c("x0", "y0", "x1", "y1", "lwd.mm", "color")
  class(res) <- "segments"; res
}
##:define [[cross.simple()]]##
#:325
h <- "internal generator function"
  
#326:
##define [[cross()]]:##
cross <- function(z = 0.30){ # print("in cross")
  if(is.factor(z)){ z <- as.numeric(z); z <- 0.5 * z / length(levels(z)) } 
  z <- z * 100; eps <- 1 # *0.7
  z <- min(100, max(0, z))
  result <- list()
  res <- cbind( x = c(z, 100 - z, 100 - z, z), 
                y = c(0, 0, 100 - z, 100 - z), 
                color = 5) 
  class(res) <- "polygon"
  result <- c(result, list(res))
  res <- rbind( c(eps*c( 5,   5, 95, 95, lwd.mm = 10), NA), 
                c(eps*c( 5,  95, 95,  5, lwd.mm = 10), NA),
                c(eps*c( 50, 50, 50, 50, lwd.mm = 30), 3) ) 
  colnames(res) <- c("x0", "y0", "x1", "y1", "lwd.mm", "color")
  class(res) <- "segments"
  result <- c(result, list(res))
  result
}
##:define [[cross()]]##
#:326
h <- "internal generator function"
  
#327:
##define [[circle.simple()]]:##
circle.simple <- function(){ # print("in circle.simple")
  res <- rbind( c( 50, 50, 50, 50, lwd.mm = 100, NA)) 
  colnames(res) <- c("x0", "y0", "x1", "y1", "lwd.mm", "color")
  class(res) <- "segments"; res
}
##:define [[circle.simple()]]##
#:327
h <- "internal generator function"
  
#328:
##define [[circle()]]:##
circle <- function(whole = 0.50){     # print("in circle")
  if(is.factor(whole)){ 
    whole <- as.numeric(whole); whole <- 0.50 * whole / length(levels(whole))
  }
  whole <- min(1, whole)
  res <- rbind( c( 50, 50, 50, 50, lwd.mm = 100,          NA), 
                c( 50, 50, 50, 50, lwd.mm = whole * 100,  0)) 
  colnames(res) <- c("x0", "y0", "x1", "y1", "lwd.mm", "color")
  class(res) <- "segments"; res
}
##:define [[circle()]]##
#:328
h <- "internal generator function"
  
#331:
##define [[car.simple()]]:##
car.simple <- function(){ # print("in cross")
  res0 <- cbind(t(cbind( 0.6* c( 05, 05, 95, 95), 0.6* c( 05, 95, 95, 05),
                         0.6* c( 50, 50, 50, 50)) + c(2.7,2.2)) ,
                lwd.mm = c(10,10,30), color =  c(2,5,7) ) 
  colnames(res0) <- c("x0", "y0", "x1", "y1", "lwd.mm", "color")
  class(res0) <- "segments"
  res1 <- cbind( x = c(10, 90, 85, 75, 70, 45, 40, 20, 10), # car polygon
                 y = c(10, 10, 30, 30, 45, 45, 30, 30, 10))
  class(res1) <- "polygon"
  res2 <- cbind(t(cbind( 0.3* c( 05, 05, 95, 95), 0.3* c( 05, 95, 95, 05),
                         0.3* c( 50, 50, 50, 50)) + c(43, 10)) ,
                lwd.mm = 0.3 * c(10,10,30), # cross on door
                color =  c(4,6,2) ) 
  colnames(res2) <- c("x0", "y0", "x1", "y1", "lwd.mm", "color")
  class(res2) <- "segments"
  res3 <- rbind( c(25, 10, 25, 10, 15, 1), c(75, 10, 75, 10, 15, 1)) # wheel
  colnames(res3) <- c("x0", "y0", "x1", "y1", "lwd.mm", "color")
  class(res3) <- "segments"
  list(res1, res1, res2, res3)
} # ; car.simple()
##:define [[car.simple()]]##
#:331
h <- "internal generator function"
  
#332:
##define [[car()]]:##
car <- function(width = .5, height = .0){ # print("in cross")
  width  <- (width  * 2   + 2) / 3.2; height <- (height * 5.0 + 1) / 3.2
  x <- c(-40,  40, 35, 25, 20,-05,-10,-30, -40) * width  + 50
  y <- c(-20, -20,  0,  5, 20, 20,  5,  0, -20) * height + 50
  wheel.size <- height * 10 + 5
  ymin <- min(y); xmin <- min(x); xmax <- max(x)
  res1 <- cbind( x, y) # car polygon
  class(res1) <- "polygon"
  res2 <- rbind( c(h <- 0.75*xmin + 0.25*xmax, ymin, h, ymin, wheel.size, 1), 
                 c(100 - h, ymin, 100 - h, ymin, wheel.size, 1)) # wheel
  colnames(res2) <- c("x0", "y0", "x1", "y1", "lwd.mm", "color")
  class(res2) <- "segments"; list(res1, res2)
} # ; car()
##:define [[car()]]##
#:332
h <- "internal generator function"
  
#334:
##define [[nabla()]]:##
nabla <- function(){ 
  res <- rbind( c( 05, 95, 50, 05, 10), c( 50, 05, 95, 95, 10),
                c( 95, 95, 05, 95, 10) );  class(res) <- "segments"
  colnames(res) <- c("x0", "y0", "x1", "y1", "lwd.mm"); res
} # ; nabla()
##:define [[nabla()]]##
#:334
h <- "internal generator function"
  
#363:
##define [[walkman()]]:##
walkman <- function( balpha = 70, col = NA, 
           ll1alpha =  -80, ll2alpha = -120, lr1alpha = -45, lr2alpha = -100,
           al1alpha = -170, al2alpha = -100, ar1alpha = -60, ar2alpha =  +20 ){
  # generates a walking man in a device of pin-sizes: 10cm x 10 cm and lwd = 10 mm
  # col <- sample(1:10, size = 1)
  xy <- c(0,0); dxq <- 10; dyq <- 10; size <- 10; lwd <- 10.5; lw.unit <- 1
  segs.set <- NULL; col.set <- NULL
  scale.xy <- 2.54 
  balpha   <- balpha   / 180 * pi
  ll1alpha <- ll1alpha / 180 * pi;  ll2alpha <- ll2alpha / 180 * pi
  lr1alpha <- lr1alpha / 180 * pi;  lr2alpha <- lr2alpha / 180 * pi
  al1alpha <- al1alpha / 180 * pi;  al2alpha <- al2alpha / 180 * pi
  ar1alpha <- ar1alpha / 180 * pi;  ar2alpha <- ar2alpha / 180 * pi
  
#364:
##define body of [[walkman]]:##
  x <- c(cos(balpha), sin(balpha)) * scale.xy
  ba <- c(0,0); be <- ba + x
  bal <- lwd * lw.unit * 1.7; bac <- col 
  seg.mat <- cbind(a=ba[1], b=ba[2], c=be[1], d=be[2], e=bal)
  segs.set <- rbind(segs.set, seg.mat); col.set <- c(col.set, bac)
##:define body of [[walkman]]##
#:364
  
#366:
##define head of [[walkman]]:##
  h <- be + ( be - ba) * .75; hl <- lwd * lw.unit * 1.6; hc <- col
  seg.mat <- cbind(a=h[1], b=h[2], c=h[1], d=h[2], e=hl)
  segs.set <- rbind(segs.set, seg.mat); col.set <- c(col.set, hc)
##:define head of [[walkman]]##
#:366
  
#365:
##define legs of [[walkman]]:##
  lbecken <- 0.19; llength <- 1; ll <- lwd * lw.unit * 0.85
  ll1a <- ba +   c(cos(balpha+pi/2), sin(balpha+pi/2)) * scale.xy * lbecken
  ll1e <- ll1a + c(cos(ll1alpha),    sin(ll1alpha))    * scale.xy * llength
  lr1a <- ba +   c(cos(balpha-pi/2), sin(balpha-pi/2)) * scale.xy * lbecken
  lr1e <- lr1a + c(cos(lr1alpha), sin(lr1alpha))  * scale.xy * llength
  ll2a <- ll1e 
  ll2e <- ll2a + c(cos(ll2alpha), sin(ll2alpha)) * scale.xy * llength
  lr2a <- lr1e 
  lr2e <- lr2a + c(cos(lr2alpha), sin(lr2alpha)) * scale.xy * llength
  l <- rbind(cbind(ll1a[1], ll1a[2], ll1e[1], ll1e[2])
            ,cbind(lr1a[1], lr1a[2], lr1e[1], lr1e[2])
            ,cbind(ll2a[1], ll2a[2], ll2e[1], ll2e[2])
            ,cbind(lr2a[1], lr2a[2], lr2e[1], lr2e[2]) )
  seg.mat <- cbind(l, e=ll)
  segs.set <- rbind(segs.set, seg.mat); col.set <- c(col.set, hc)
##:define legs of [[walkman]]##
#:365
  
#367:
##define arms of [[walkman]]:##
  aschulter <- 0.19; alength <- 0.7; al <- lwd * lw.unit * 0.85
  al1a <- be +   c(cos(balpha+pi/2), sin(balpha+pi/2)) * scale.xy * aschulter
  al1e <- al1a + c(cos(al1alpha), sin(al1alpha))       * scale.xy * alength
  ar1a <- be +   c(cos(balpha-pi/2), sin(balpha-pi/2)) * scale.xy * aschulter
  ar1e <- ar1a + c(cos(ar1alpha), sin(ar1alpha))       * scale.xy * alength
  al2a <- al1e 
  al2e <- al2a + c(cos(al2alpha), sin(al2alpha)) * scale.xy * alength
  ar2a <- ar1e 
  ar2e <- ar2a + c(cos(ar2alpha), sin(ar2alpha)) * scale.xy * alength
  a <- rbind( cbind(al1a[1], al1a[2], al1e[1], al1e[2]), 
              cbind(ar1a[1], ar1a[2], ar1e[1], ar1e[2]),
              cbind(al2a[1], al2a[2], al2e[1], al2e[2]),
              cbind(ar2a[1], ar2a[2], ar2e[1], ar2e[2]) )
  seg.mat <- cbind(a, e=al)
  segs.set <- rbind(segs.set, seg.mat); col.set <- c(col.set, hc)
##:define arms of [[walkman]]##
#:367
  segs.set[, 1:4] <- segs.set[, 1:4] + 5 # shift to the center
  segs.set <- cbind(as.data.frame(segs.set), f = col) # set color
  class(segs.set) <- c(class(segs.set), "segments")
  segs.set[, 1:4] <- segs.set[, 1:4] * 10
  colnames(segs.set) <- c("x0", "y0", "x1", "y1", "lwd.mm", "color")
  return(segs.set)
} #; show.icon.design(walkman, balpha = 90) # ; 
# plot(1:10, type = "n", axes = FALSE, xlab = "", ylab = "")
# puticon(5, 5.5, icon = walkman, icon.cex = 160, balpha = 80)
# walkman()
##:define [[walkman()]]##
#:363
h <- "internal generator function"
  
#371:
##define [[smiley.blueeye()]]:##
smiley.blueeye <- function(){
  # output: x0, y0, x1, y1, lwd, col 
  circle <- function(x0 = 1, y0 = 1, a = 3, lwd.mm = 5, # a == radius
                     time.0 = 0, time.1 = 12, n = 30){
    # function to draw a part of a circle line
    alpha <- seq(time.0, time.1, length = n); alpha <- alpha * (2*pi/12)
    x <- a * sin(alpha) + x0; y <- a * cos(alpha) + y0
    cbind(x[-n],y[-n], x[-1],y[-1], lwd.mm)
  }
  res <- NULL
  #                               x0   y0   radius lwd.mm
  res <- rbind( res, cbind(circle(50, 49.5, 23,    50), col.code = NA) ) # face
  res <- rbind( res, cbind(       50, 45,   50,    50,  15,         1) ) # nose
  res <- rbind( res, cbind(circle(50, 49.5, 47.5,   5), 1) ) # margin
  res <- rbind( res, cbind(circle(35, 65,  2.5,    10), 4) ) # eye left
  res <- rbind( res, cbind(circle(65, 65,  2.5,    10), 1) ) # eye right
  res <- rbind( res, cbind(circle(50, 50,   27,     8,  7.50, 4.50), 3) ) # mouth
  colnames(res) <- c("x0", "y0", "x1", "y1", "lwd.mm", "color")
  class(res) <- "segments"; res
} # ; show.icon.design(smiley.blueeye) # ; smiley.blueeye()
##:define [[smiley.blueeye()]]##
#:371
h <- "internal generator function"
  
#372:
##define [[smiley.normal()]]:##
smiley.normal <- function(){
  # output: x0, y0, x1, y1, lwd, col 
  circle <- function(x0 = 1, y0 = 1, a = 3, lwd.mm = 5, # a = radius
                     time.0 = 0, time.1 = 12, n = 30){
    # function to draw a part of a circle line
    alpha <- seq(time.0, time.1, length = n); alpha <- alpha * (2*pi/12)
    x <- a * sin(alpha) + x0; y <- a * cos(alpha) + y0
    cbind(x[-n],y[-n], x[-1],y[-1], lwd.mm)
  }
  res <- NULL # res <- rbind( res, cbind( 50, 45, 50, 50, 15,      1) ) # nose
  res <- rbind( res, cbind(circle(50, 49.5, 23,   50), col.code = NA) ) # face
  res <- rbind( res, cbind(circle(50, 49.5, 47.5,  5), 1) ) # rand
  res <- rbind( res, cbind(circle(35, 60.5,  3.0, 10), 1) ) # eye
  res <- rbind( res, cbind(circle(65, 60.5,  3.0, 10), 1) ) # eye 
  res <- rbind( res, cbind(circle(50, 50,   27,    8, 7.50, 4.50),1) ) # mouth
  colnames(res) <- c("x0", "y0", "x1", "y1", "lwd.mm", "color")
  class(res) <- "segments"; res
} #; show.icon.design(smiley.normal)
##:define [[smiley.normal()]]##
#:372
h <- "internal generator function"
  
#377:
##define [[smiley()]]:##
smiley <- function(smile = 0.8){
  if(is.factor(smile)) smile <- as.numeric(smile) / length(levels(smile))
  circle <- function(x0 = 1, y0 = 1, a = 3, lwd = 5, 
                     time.0 = 0, time.1 = 12, n = 60){
    alpha <- seq(time.0, time.1, length = n); alpha <- alpha * (2*pi/12)
    x <- a * sin(alpha) + x0;               y <- a * cos(alpha) + y0
    cbind(x[-n],y[-n], x[-1],y[-1], lwd)
  }
  res <- NULL
  # res <- rbind( res, cbind(circle(50, 49.5,23,   50), col.code = NA) ) # face
  # res <- rbind( res, cbind(circle(50, 49.5,47,   60),  1) )            # rand
  res <- rbind( res, cbind(         50, 50,  50,   50, 100, 1 ))         # face+rand
  res <- rbind( res, cbind         (50, 50,  50,   50,  88, NA))         # face 
  res <- rbind( res, cbind(circle(  35, 60.5, 3.0, 10),  1) )            # eye
  res <- rbind( res, cbind(circle(  65, 60.5, 3.0, 10),  1) )            # eye 
  if(is.na(smile)){
    res <- rbind( res, cbind(circle(50, 50, 27,  7.5, 7.50, 4.50),1) ) # mouth
  } else {
    #             x0  y0            a lwd time.0  time.1
    # hs <- circle(50,50,         27,  10,   7.5,    4.5) # mouth laughing
    # hn <- circle(50,10,         27,  10,  10.5,   13.5) # mouth not laughing    
    hs <- circle( 50, 40,         17,  10,   8.5,    3.5) # mouth laughing
    hn <- circle( 50, 20,         17,  10,   9.5,   14.5) # mouth not laughing    
    s <- smile; n <- 1 - s
    h <- cbind( hs[,1], s*hs[,2]+n*hn[,2], hs[,3], s*hs[,4]+n*hn[,4], hs[,5])
    res <- rbind( res, cbind(h, 1) )                      # mouth
  }
  class(res) <- "segments"; res
  return(res)
}
##:define [[smiley()]]##
#:377
h <- "internal generator function"
  
#373:
##define [[smiley.sad()]]:##
smiley.sad <- function(){
  # output: x0, y0, x1, y1, lwd, col 
  circle <- function(x0 = 1, y0 = 1, a = 3, lwd.mm = 5, 
                     time.0 = 0, time.1 = 12, n = 30){
    # function to draw a part of a circle line
    alpha <- seq(time.0, time.1, length = n); alpha <- alpha * (2*pi/12)
    x <- a * sin(alpha) + x0; y <- a * cos(alpha) + y0
    cbind(x[-n],y[-n], x[-1],y[-1], lwd.mm)
  }
  res <- NULL #; res <- rbind( res, cbind(50, 45, 50, 50, 15,      1) ) # nose
  res <- rbind( res, cbind(circle(50, 49.5, 23,   50), col.code = NA) ) # face
  res <- rbind( res, cbind(circle(50, 49.5, 47.5,  5), 1) ) # rand
  res <- rbind( res, cbind(circle(35, 60.5,  3.0, 10), 1) ) # eye
  res <- rbind( res, cbind(circle(65, 60.5,  3.0, 10), 1) ) # eye 
  res <- rbind( res, cbind(circle(50, 10,   27,    8, 10.50, 13.50),1) ) # mouth
  colnames(res) <- c("x0", "y0", "x1", "y1", "lwd.mm", "color")
  class(res) <- "segments"; res
} # ; show.icon.design(smiley.sad)
##:define [[smiley.sad()]]##
#:373
h <- "internal generator function"
  
#381:
##define [[mazz.man()]]:##
mazz.man <- function(Mean = 100, Penalty = 1, Region = "region:", 
                     expo = 1/(1:3)[3], Mean.max = 107, Mean.half = 90, 
                     Penalty.max = 5, Penalty.min = 0, 
                     x.text = 70, y.text = 10, text.cex.mm = 10){ 
  # bag.size %in% [0,1] # idea of the icon: Adriano Pareto, Matteo Mazziotta
  Mean.min <- Mean.half - (Mean.max - Mean.half) / ((h <- 2^(1/expo)) - 1)
  Mean.min <- min(Mean.min, Mean)
  fac      <- 0.95 * ((h * (Mean - Mean.min)) / Mean.max) ^ expo
  bag.size <- 0.80 * ((Penalty - Penalty.min) / Penalty.max )^expo /2
  res <- rbind(
    c(50,            77.5*fac + 5, 50,          77.5 *fac + 5), #head
    c(50,            35  *fac + 5, 50,          60   *fac + 5), #body
    c(50,            32  *fac + 5, 50,           0   *fac + 5), #leg in white
    c(50,            32  *fac + 5, 50,           0   *fac + 5), #leg
    c(50 + 30*fac,   55  *fac + 5, 50 + 25*fac, 75   *fac + 5), #tape2
    c(50 - 20*fac,   65  *fac + 5, 50 + 30*fac, 70   *fac + 5), #stick
    c(50,            64  *fac + 5, 50 - 15*fac, 45   *fac + 5), #arm one
    c(50 - 20*fac,   65  *fac + 5, 50 - 15*fac, 45   *fac + 5), #arm
    c(50 + 27.5*fac, 50  *fac + 5 - 20*bag.size ,
      50 + 27.5*fac, 50  *fac + 5 - 20*bag.size),               #bag
    c(50 + 25*fac,   55  *fac + 5, 50 + 30*fac, 75   *fac + 5)) #tape1
  colnames(res) <- c("x0", "y0", "x1", "y1")
  lwd.mm <-  c( c(17, 14, 12, 10, 2.5, 2, 6, 6) * fac / 0.927042
                ,   31 * bag.size / 0.2924, 2.5 * fac / 0.927042 ) 
  colors <- c("#3377BB", "white", "brown", "orange")[c(1,1,2,1,4,3,1,1,4,4)]
  res <- data.frame(res, lwd.mm = lwd.mm, color = colors)
  class(res) <- c(class(res), "segments"); result <- list(res)
  res <- data.frame(x = x.text, y = y.text, L = Region, text.cex.mm = text.cex.mm, color = 1) 
  class(res) <- c(class(res), "text"); res <- list(res) 
  result <- c(result, res)                   
  return(result)
} # ; show.icon.design(mazz.man) # Mazzi.Pareto
  # res1 <- rbind(c(0,0,100,100)); class(res1)<-c("segments"); res1 <- list(res1) 
  # res2 <- rbind(c(100,0,0,100)); class(res2)<-c("segments"); res2 <- list(res2) 
##:define [[mazz.man()]]##
#:381
h <- "internal generator function"
  
#389:
##define [[bike()]]:##
bike <- function(){
   res.liste <- NULL; a <- 1.5
   res <- rbind( c(20, 20, 20,    20, 40, 1),  # wheel front
                 c(20, 20, 20,    20, 30, NA), # wheel front
                 c(80, 20, 80,    20, 40, 1),  # wheel back
                 c(80, 20, 80,    20, 30, NA), # wheel back
                 c(50, 20, 80,    20,  3*a, 1),  # ---
                 c(50, 20, 65,    50,  3*a, 1),  # /
                 c(80, 20, 32.5,  45,  3*a, 1),    # \
                 c(50, 20, 32.5,  45,  3*a, 1),    # \
                 c(60, 50, 70,    50,  5*a, 1),  # seat
                 c(20, 20, 40,    60,  3*a, 1),  # /
                 c(40, 60, 45,    60,  5*a, 1) # control
   )
   res[, c(2,4)] <- res[, c(2,4)] + 20; class(res) <- "segments"
   colnames(res) <- c("x0", "y0", "x1", "y1", "lwd.mm", "color")
   res.liste <- c(res.liste, list(res))
}
##:define [[bike()]]##
#:389
h <- "internal generator function"
  
#390:
##define [[bike2()]]:##
bike2 <- function() {
   res.liste <- NULL; a <- 1.5
   res <- rbind( c(20, 20, 20,    20, 40, 1),  # wheel front
                 c(20, 20, 20,    20, 30, NA), # wheel front
                 c(80, 20, 80,    20, 40, 1),  # wheel back
                 c(80, 20, 80,    20, 30, NA), # wheel back
                 c(50, 20, 80,    20,3*a, 1),  # ---
                 c(50, 20, 65,    50,3*a, 1),  # /
                 c(80, 20, 32.5,  45,3*a, 1),  # \
                 c(50, 20, 32.5,  45,3*a, 1),  # \
                 c(60, 50, 70,    50,5*a, 1),  # seat
                 c(20, 20, 40,    60,3*a, 1),  # /
                 c(40, 60, 45,    60,5*a, 1))  # control  
   res[, c(2,4)] <- (res[, c(2,4)] - 9.3) * 10/5.3; class(res) <- "segments"
   colnames(res) <- c("x0", "y0", "x1", "y1", "lwd.mm", "color")
   res.liste <- c(res.liste, list(res))
}
##:define [[bike2()]]##
#:390
h <- "internal generator function"
  
#391:
##define [[heart()]]:##
heart <- function(txt = "xy"){
   txt <- substring(paste(txt, " "), 1:2, 1:2)
   res1 <- cbind( x = c(50, 80, 90, 70, 50, 50, 30, 10, 20, 50),
                  y = c(05, 30, 60, 85, 50, 50, 85, 60, 30, 05) + 05, color = NA)
   class(res1) <- c(class(res1), "polygon"); res1 <- list(res1)
   res2 <- cbind( x = c(50, 90, 70, 50, 50, 30, 10, 50),
                  y = c(05, 60, 85, 50, 50, 85, 60, 05) + 05)
   res2 <- data.frame( res2, lwd.mm = 19.5, color = NA)
   class(res2) <- c(class(res2), "spline"); res2 <- list(res2)
   res3 <- data.frame( x = c(27, 73), y = c(65, 65), txt = txt, 40, 1)
   class(res3) <- c(class(res3), "text");   res3 <- list(res3)
   result <- c(res1, res2, res3) 
} # ; show.icon.design(heart)()
##:define [[heart()]]##
#:391
h <- "internal generator function"
  
#392:
##define [[bend.sign()]]:##
bend.sign <- function(txt = "xy"){
   txt <- substring(paste(txt, " "), 1:2, 1:2)
   ground <- 6; top <- 90; center <- 55.5; size <- 25
   res0o <- c(50, top, 50, ground + 3, 7, 1) # Pfahl outer
   res0i <- c(50, top, 50, ground + 2, 3, 3) # Pfahl inner
   res1  <- c(30, ground, 70, ground, 2, 1)  # Fundament
   res2  <- rbind( c(50, center+size, 50-size, center), c(50-size, center, 50, center-size),
                   c(50, center-size, 50+size, center), c(50+size, center, 50, center+size))
   res2 <- cbind(res2, lwd.mm = 15, color = 1)    # Schildrand
   size <- size - 0                               # Innenrand:
   res3 <- rbind( c(50, center+size, 50-size, center), c(50-size, center, 50, center-size),
                  c(50, center-size, 50+size, center), c(50+size, center, 50, center+size))
   res3 <- cbind(res3, lwd.mm = 10, color = 2)
   res <- rbind(res0o, res0i, res1, res2, res3); rownames(res) <- NULL
   res <- as.data.frame(res)
   colnames(res) <- c("x0", "y0", "x1", "y1", "lwd.mm", "color")
   res$color <- c("black", NA, "gray")[res$color]
   class(res) <- c(class(res), "segments"); res <- list(res)
   size <- size - 2
   res1b <- rbind( c(50, center+size), c(50-size, center),
                   c(50, center-size), c(50+size, center))
   res1b <- cbind(res1b, color = NA)
   class(res1b) <- c(class(res1b), "polygon"); res1b <- list(res1b) # Innenflaeche
   f <- size / 25
   res2b <- cbind( x = 50     + f*c( h <- c(- 9,  5, 12), rev(-h)),
                   y = center + f*c( h <- c( 16, 13,  6), rev(-h)), 
                   lwd.mm = f^0.6*6.5, color = 1)
   class(res2b) <- c(class(res2b), "spline"); res2b <- list(res2b)
   #res3 <- data.frame( x = c(27, 73), y = c(65, 65), txt = txt, 40, 1)
   #class(res3) <- c(class(res3), "text");   res3 <- list(res3)
   result <- c(res, res1b, res2b) #, res1) 
}  # ; show.icon.design(bike2)# bend.sign) #; bend.sign()
##:define [[bend.sign()]]##
#:392
h <- "internal generator function"
  
#398:
##define [[fir.tree()]]:##
fir.tree <- function(height = 1, width = 1, txt = ".....", t.cex.mm = 10){ 
  fac.x <- width * 100/60; fac.y <- height * 100/70
  # build standardized elements of pictogram
  res <- data.frame( 
    x = c(20, 40, 25, 45, 35, 50, 65, 55, 75, 60, 80),
    y = c(20, 40, 40, 60, 60, 80, 60, 60, 40, 40, 20) + 5,
    color = NA)
  class(res) <- c(class(res), "polygon")
  res.liste <- c(list(res))
  res <- data.frame( 
    x = c(55, 55, 45, 45),
    y = c(20, 10, 10, 20) + 5 ,
    color = "brown")
  class(res) <- c(class(res), "polygon")
  res.liste <- c(res.liste, list(res))
  # integrate effects of arg1 and arg2
  res.liste <- lapply( res.liste, function(xyc){
                         xyc$x <- fac.x * (xyc$x - 50) + 50; xyc} )
  res.liste <- lapply( res.liste, function(xyc){
                         xyc$y <- fac.y * (xyc$y - 50) + 50; xyc} )
  # append text element # res <- data.frame( x = 20, y = 2, txt = txt, t.cex.mm, color = "1") 
  res <- data.frame( x =  fac.x * (30 - 50) + 50, y = fac.y * (10 - 50) + 50, 
                     txt = txt, t.cex.mm, color = "1") #180327
   class(res) <- c(class(res), "text")
  res.liste <- c(res.liste, list(res))
  res.liste
}  # ; show.icon.design(fir.tree)
##:define [[fir.tree()]]##
#:398
#343:
##define [[find.smooth.curve()]] and [[find.brush.polygon()]]:##
#342:
##define [[bs.approx()]] and [[loess.approx()]]:##
bs.approx <- function(x, y, x.new, degree = 3, knots = 10, df = NULL){
  # library(splines)                                          # check package splines
  if(is.matrix(x) || is.data.frame(x)){y <- x[,2];x <- x[,1]} # check x,y input
  n <- length(x); idx <- order(x); x <- x[idx]; y <- y[idx]   # order by x
  y.new <- rep(NA, length(x.new))                             # init y result
  x.all <- c(x, x.new);   y.all <- c(y, y.new)                # combine old and new points
  basis <- splines::bs(x.all, degree = degree, df = df, knots = knots) # find design matrix 
  res <- lm(y.all ~ basis); coef.ok <- !is.na(res$coeff)      # estimate spline coefficients
  X     <- cbind(1, basis[  1:n ,])[,coef.ok]                 # extract design matrix for old 
  X.new <- cbind(1, basis[-(1:n),])[,coef.ok]                 # extract design matrix for new
  y.dach     <- X     %*% res$coefficients[coef.ok]           # compute spline of old points 
  y.new.dach <- X.new %*% res$coefficients[coef.ok]           # compute spline of new points
  list(cbind(x, y.dach), cbind(x.new, y.new.dach))            # compose result
}
loess.approx <- function(x, y, x.new, span = 0.6, degree = 2){
  smooth.curve <- loess(y ~ x, span = span, degree = degree)
  res.new <- predict(smooth.curve, x.new)
  res.old <- predict(smooth.curve, x)
  return(list(cbind(x, res.old), cbind(x.new, res.new)))
}
##:define [[bs.approx()]] and [[loess.approx()]]##
#:342
find.smooth.curve <- function(x.in, y.in, n.new = 100, method = c("bs", "loess")[1],
                              degree = 3, knots = 50, span = 0.75){
  if(is.matrix(x.in) || is.data.frame(x.in)){y.in <- x.in[,2]; x.in <- x.in[,1]} # check input
  n <- length(x.in)
  dx.min <- 0.1 * diff(range(x.in)) / length(x.in)            # set minimal dx of spline
  x.h <- cumsum(c(1, pmax(dx.min, (diff(x.in)^2 + diff(y.in)^2)^0.5))) # find x of spline
  x.new <- seq(x.h[1], x.h[n], length = n.new)                # find new x for spline eval 
  if( method == "bs" ){
    res.x <- bs.approx(x = x.h, y = x.in, x.new = x.new, degree = degree, knots = knots)
    res.y <- bs.approx(x = x.h, y = y.in, x.new = x.new, degree = degree, knots = knots)
  } else {
    res.x <- loess.approx(x = x.h, y = x.in, x.new = x.new, span = span, degree = min(2, degree))
    res.y <- loess.approx(x = x.h, y = y.in, x.new = x.new, span = span, degree = min(2, degree))
  }
  return(cbind(x = res.x[[2]][,2], y = res.y[[2]][,2]))       # compose result
}
find.brush.polygon <- function(x, y, hwd = 10){
  # find area along the polygon of points (x, y) with width 2*hwd 
  if(is.matrix(x) || is.data.frame(x)){ y <- x[,2]; x <- x[,1] } # check input
  dy <- diff(x); dx <- -diff(y); h <- length(dx)            # find orthogonal vectors to segments
  dx <- c(dx[1], 0.5 * (dx[-1] + dx[-h]), dx[h])            # find means of neighbours 
  dy <- c(dy[1], 0.5 * (dy[-1] + dy[-h]), dy[h])            #    of orthogonal vectors
  d <- hwd / sqrt(dx^2 + dy^2); dy <- d * dy; dx <- d * dx  # scale orthognal vectors
  xy <- rbind(cbind(x = x + dx, y = y + dy), cbind(x = rev(x - dx), y = rev(y - dy))) 
  rbind(xy, xy[1,])                                         # copy first point to the end
}
##:define [[find.smooth.curve()]] and [[find.brush.polygon()]]##
#:343
h <- "internal generator function"
  
#406:
##define [[comet()]]:##
comet <- function(comet.color = NA){ 
  t2xy <- function(t,radius,init.angle=0) {
        t <- t / 360
        t2p <- 2*pi * t + init.angle * pi/180
        list(x = radius * cos(t2p), y = radius * sin(t2p))
  }
  center <- c(17, 30); fac <- 1.2 #; fac <- .2
  # c.color <- 4; s.color <- 3; comet.bg.color <- 7;  bg.color <- 0; t.color <- 5
  # c.color <- "gold"; s.color <- "red"; comet.bg.color <- "green"; 
  # t.color <- "gold";  bg.color <- "lightgrey"
  comet.bg.color <- "white"; t.color <- NA;  bg.color <- "white"; s.color <- "white"
  c.color <- comet.color
  res.liste <- NULL
  # aera of icon -----------------------------------------------------------------------------
  res <- data.frame(c(1, 99, 99, 1, 1), c(1, 1, 99, 99, 1), color = bg.color)
  class(res) <- c(class(res), "polygon"); res.liste <- c(res.liste, list(res)) 
  # aera of comet ----------------------------------------------------------------------------
  width <- 20 * fac
  res <- data.frame(center[1], center[2], center[1], center[2], width, color = comet.bg.color)
  class(res) <- c(class(res), "segments"); res.liste <- c(res.liste, list(res)) # comet gb
  # letter C of Comet -----------------------------------------------------------------------
  width <- 3 * fac; radius <- 10 * fac
  P <- t2xy( 90:-45 , radius, 0)
  res <- data.frame(P$x + center[1], P$y + center[2]); res <- cbind(res, res, 
                    width, color = bg.color)
  class(res) <- c(class(res), "segments"); res.liste <- c(res.liste, list(res)) # C missing part
  P <- t2xy( 67.5:180 , radius, 0)
  res <- data.frame(P$x + center[1], P$y + center[2]); res <- cbind(res, res, 
                    width, color = c.color)
  class(res) <- c(class(res), "segments"); res.liste <- c(res.liste, list(res)) # C
  P <- t2xy( -180:-22.5 , radius, 0)
  res <- data.frame(P$x + center[1], P$y + center[2]); res <- cbind(res, res, 
                    width, color = c.color)
  class(res) <- c(class(res), "segments"); res.liste <- c(res.liste, list(res)) # C
  # letter M of coMet ----------------------------------------------------------------------
  if( TRUE){
    width <- 2.5 * fac; shift <- c(1, 0.5) * 2 * fac; h <- 22.5 / 360 * 2 * pi
    xy <- cbind(c(-1, -1, 0, 1, 1), c(-1, 1, -1, 1, -1))
    xy <- xy %*% matrix( c( cos( h ), -sin(h), sin(h), cos(h)), 2, 2)
    x <- shift[1] + xy[,1] * 4 * fac; y <- shift[2] + xy[,2] * 4 * fac
    res <- data.frame(x[-5] + center[1], y[-5] + center[2], x[-1] + center[1], y[-1] + center[2],  
                      width, color = c.color)
    class(res) <- c(class(res), "segments"); res.liste <- c(res.liste, list(res)) # M
  }
  # tail of comet with letter T of comeT --------------------------------------------------
  radius <- c(1, 5) * fac; width <- 3 * fac
  for(i in 1:6){
    radius <- radius + 10 * fac
    P1 <- t2xy(c(0, 22.5, 45), radius[1], 0)
    P2 <- t2xy(c(0, 22.5, 45), radius[2], 0)
    res <- data.frame( P1$x + center[1], P1$y + center[2], P2$x + center[1], P2$y + center[2], 
                       width, color = t.color)
    class(res) <- c(class(res), "segments"); res.liste <- c(res.liste, list(res)) # comet gb
    if(i == 1){
      res <- data.frame(P1$x[1] + center[1], P1$y[1] + center[2], 
                        P1$x[3] + center[1], P1$y[3] + center[2], 
                        width, color = c.color)
      class(res) <- c(class(res), "segments"); res.liste <- c(res.liste, list(res)) # comet gb
      res <- data.frame( P1$x + center[1], P1$y + center[2], P2$x + center[1], P2$y + center[2], 
                        width, color = c.color)
      class(res) <- c(class(res), "segments"); res.liste <- c(res.liste, list(res)) # comet gb
    } else {
      res <- data.frame( P1$x + center[1], P1$y + center[2], P2$x + center[1], P2$y + center[2], 
                        width, color = t.color)
      class(res) <- c(class(res), "segments"); res.liste <- c(res.liste, list(res)) # comet gb
    }
    # T of comeT
    if(i == 5){
      h <- c(P2$x[2] - P1$x[2], P2$y[2] - P1$y[2]) * 2.5
      res <- data.frame( P1$x[2] + center[1], P1$y[2] + center[2], 
                         P2$x[2] + h[1] + center[1], P2$y[2] + h[2] +  center[2], 
                         width, color = c.color)
      class(res) <- c(class(res), "segments"); res.liste <- c(res.liste, list(res)) # comet gb
      h <- h * 0.6
      res <- data.frame( P1$x[2] + center[1], P1$y[2] + center[2], 
                         P1$x[2] - h[2] + center[1], P1$y[2] + h[1] +  center[2], 
                         width, color = c.color)
      class(res) <- c(class(res), "segments"); res.liste <- c(res.liste, list(res)) # comet gb
      res <- data.frame( P1$x[2] + center[1], P1$y[2] + center[2], 
                         P1$x[2] + h[2] + center[1], P1$y[2] - h[1] +  center[2], 
                         width, color = c.color)
      class(res) <- c(class(res), "segments"); res.liste <- c(res.liste, list(res)) # comet gb     
    }
  }
  # letter O of cOmet
  width <- 2.5 * fac; radius <- 7.5 * fac; shift <- c(1, 0.5) * 1.2 * fac
  P <- t2xy( 0:359 , radius, 0)
  res <- data.frame(P$x + shift[1] + center[1], P$y + shift[2] + center[2])
  res <- cbind(res, res, width, color = "white")
  class(res) <- c(class(res), "segments"); res.liste <- c(res.liste, list(res)) # O by white
  res.liste
} # ; print(comet());  show.icon.design(comet)
##:define [[comet()]]##
#:406
h <- "internal generator function"
  
#337:
##define [[coor.system()]]:##
coor.system <- function(xxx, yyy, pcex = 5, xrange, yrange, axes = FALSE){ 
  shift <- 0.5; lwd <- .25
  x <- c(.1, 3, 6, 9.9); y <- c(0, 0.1, -0.1, 0) + shift
  xy <- spline(x,y); x <- xy$x; y <- xy$y; n.1 <- length(x) - 1
  res <-            cbind(x[1:n.1], y[1:n.1], x[-1], y[-1], lwd)  # x line
  res <- rbind(res, cbind(y[1:n.1], x[1:n.1], y[-1], x[-1], lwd)) # y line
  res <- rbind(res, c(9.5, shift - 0.4, 9.9, shift, lwd),         # x arrow
                    c(9.4, shift + 0.3, 9.9, shift, lwd),         # x arrow
                    c(shift - 0.4, 9.5, shift, 9.9, lwd),         # y arrow
                    c(shift + 0.3, 9.4, shift, 9.9, lwd)) * 10    # y arrow
  res <- cbind(res, 1)
  class(res) <- "segments";   res.list <- list(res)
  if( !missing(xxx) ){
    if(missing(xrange)){ xrange <- range(xxx); xrange <- xrange + c(-0.1,0.1)*diff(xrange) }
    if(missing(yrange)){ yrange <- range(yyy); yrange <- yrange + c(-0.1,0.1)*diff(yrange) }
    xticks <- pretty(xrange); xticks <- xticks[ xrange[1] < xticks & xticks < xrange[2]]
    yticks <- pretty(yrange); yticks <- yticks[ yrange[1] < yticks & yticks < yrange[2]]
    xtickspos <- (xticks - xrange[1]) / (xrange[2] - xrange[1]) * 95 + 5
    ytickspos <- (yticks - yrange[1]) / (yrange[2] - yrange[1]) * 95 + 5
    res <- rbind(
             cbind(xtickspos, 5, xtickspos, 2, 2, 1)   # x ticks
            ,cbind(2, ytickspos, 5, ytickspos, 2, 1)   # y ticks
           )
    class(res) <- "segments"; res.list <- c(res.list, list(res))
    x <- c(-3, -1.5, 0, 1.5, 3); y <- c(-2.5, -0.5, 0.4, 1.5, 2.5) 
    xy <- spline(x,y); x <- xy$x; y <- xy$y
    xxx <- (xxx - xrange[1]) / (xrange[2] - xrange[1]) * 95 + 5
    yyy <- (yyy - yrange[1]) / (yrange[2] - yrange[1]) * 95 + 5
    res <- NULL; h <- length(x)
    for( i in seq(along = xxx) ){
      res <- rbind(res, 
             cbind(xxx[i] + x[-1], yyy[i] + y[-1], 
                   xxx[i] + x[-h], yyy[i] + y[-h], pcex * 0.2, NA), # points xxx, yyy
             cbind(xxx[i] + x[-1], yyy[i] + rev(y)[-1], 
                   xxx[i] + x[-h], yyy[i] + rev(y)[-h], pcex * 0.2, NA) # points xxx, yyy
      )
    }
    class(res) <- "segments"; res.list <- c(res.list, list(res))
    h <- length(xticks)  # x axis
    res <- data.frame( xtickspos, rep(-4, h), paste(xticks), rep(6, h),rep(1, h))
    class(res) <- c(class(res), "text"); if(axes) res.list <- c(res.list, list(res))
    h <- length(yticks); hh <- max(nchar(yticks)) # y axis
    res <- data.frame( rep(-2*hh, h), ytickspos, paste(yticks), rep(6, h),rep(1, h))
    class(res) <- c(class(res), "text"); if(axes) res.list <- c(res.list, list(res))
  } 
  res.list
}  ; coor.system()
##:define [[coor.system()]]##
#:337
##:define generator functions##
#:351
           show.icon.design(icon, color = "lightblue") 
           cat("arguments of", icon,":\n"); print(noquote(h))
           return(get(icon))
         }
       } else {
         cat("Error in puticon(): something wrong with input icon =", 
             paste('"',icon,'"',sep = ""), "\n")
         return()
       }
     } 
   } 
##:show design layout of special icon in [[puticon()]]##
#:277
}
if(identical(icon, "")) icon <- "circle" ## default setting of icon !!!!
if( is.matrix(x) && ncol(x) == 2){ 
  xy <- x 
} else {
  if(missing(y)){ 
    cat("Error in puticon: no x or no y coordinates are given!\n"); return()
  }
  xy <- cbind(x, y)
}
n.items <- dim(xy)[1]
##:check inputs and manage case of showing design in [[puticon()]]##
#:276
  
#282:
##get device infos and compute aspect ratios in [[puticon()]]:##
  h <- par(); usr <- h$usr; pin <- h$pin; cin <- h$cin 
  xwcoor.pmm <- diff(usr[1:2]) / pin[1] / 25.4 # xrange per mm of plot-region
  ywcoor.pmm <- diff(usr[3:4]) / pin[2] / 25.4 # yrange per mm of plot-region
  # correction because of uncorrect display sizes may by processed by:
  # dev.fac.vp <- c(1, 1, 1.1)[ c(dev.cur() == c("postscript", "pdf"), TRUE) ][1]
  # xwcoor.pmm <- xwcoor.pmm * dev.fac.vp; ywcoor.pmm <- ywcoor.pmm * dev.fac.vp
  aspect     <- xwcoor.pmm / ywcoor.pmm  # width / height concerning plot-region
  # if icon.cex < 1: size of icon is defined relative to width of plot #180411
  icon.cex <- ifelse( icon.cex < 1, icon.cex * pin[1] * 25.4, icon.cex)
  if(length(icon.cex) < n.items) icon.cex <- rep(icon.cex, n.items)[1:n.items]
  xsize <- icon.cex * xwcoor.pmm         # width(s)  of icon in user coordinates
  ysize <- icon.cex * ywcoor.pmm         # height(s) of icon in user coordinates
  if(length(xsize) < n.items) xsize <- rep(xsize, n.items)[1:n.items]
  if(length(ysize) < n.items) ysize <- rep(ysize, n.items)[1:n.items]
##:get device infos and compute aspect ratios in [[puticon()]]##
#:282
  
#283:
##define [[mm.to.lwd()]] and [[mm.to.cex]] in [[puticon()]]:##
  dev.fac <- c(0.8, 1, 1)[ c(dev.cur() == c("postscript", "pdf"), TRUE) ][1]
  mm.to.lwd <- function(lwd.mm) lwd.mm * 3.787878 * dev.fac 
  ## mm.to.lwd <- function(lwd.mm) lwd.mm * 100 / 30 * dev.fac 
  mm.to.cex <- function(text.cex.mm) text.cex.mm / (cin[1] * 25.4)
##:define [[mm.to.lwd()]] and [[mm.to.cex]] in [[puticon()]]##
#:283
  
#280:
##define [[transform.color.to.rgb.integer()]]:##
transform.color.to.rgb.integer <- function(x, to = c("#rrggbb", "rgb"), 
                                           debug = FALSE){
  dim.x <- n <- length(x)
  # if(is.matrix(x)) rasterImage(t(x), 5, 5, 15, 15)
  if( 0 < length( h <- dim(x) ) ) dim.x <- h
  if( is.numeric(x[1]) ){
    if( all( x %in% 0:8 ) ){
          from <- "color.code"      # col = 3
          xx <- t(col2rgb(palette("default")[x]))
    } else {
      if( all(x <= 1) ){            # 
          from <- "rgb.decimal"     # col = c(0.3, 0.5, 0.6 )
          xx <- floor( x * 255 ) 
      } else { 
        if( any( 1 < x ) & all(x == floor(x)) ){
          from <- "rgb.integer"     # col = c( 13, 25, 254 )
          xx <- x
        }
      }
    }
  } else {
    if( is.character(x[1]) ){
      from <- "color.name.or.char"  # col = "red" or col = "#1304FF"
      xx <- t(col2rgb(x))           # t?
    } 
  }
  if( (3 * n) == length(xx) ){ 
    xx <- array( xx, c(rev(dim.x), 3)) 
    if( length(dim(xx)) == 3 ) xx <- aperm(xx, c(2,1,3))
  }
  if(debug) cat("dim.x", dim.x, "from = ", from, "::", x, "->", (xx))
  xx
}
##:define [[transform.color.to.rgb.integer()]]##
#:280
  
#291:
##define [[greys.to.colors.puticon()]]:##
greys.to.colors.puticon <- function(grey.idx, color,      # invert = FALSE, 
                         set.black.and.white = FALSE, simple = FALSE){
  # cat("greys.to.colors.puticon")
  # if(invert) grey.idx[] <- max(grey.idx) + 1 - grey.idx # inversion of levels
  if(simple){ # simple case of recoloring
    # set of colors based on color
    color <- c("#000000", color, "#FFFFFF") # ;print(color)
    grey.idx[] <- color[grey.idx]; icon <- grey.idx; return(icon)
  } 
  n <- max(grey.idx)                        # find colors based on color:
  rgb.col1 <- col2rgb(color[1]) / 255; rgb.col2 <- 1 - rgb.col1
  n1 <- round(n / 2) ; n2 <- n - n1 
  f1 <- ((1:n1) - 1/2) / n1; f2 <- ((n2:1) - 1/2) / n2
  rgb.col1 <-     cbind(f1 * rgb.col1[1], f1 * rgb.col1[2], f1 * rgb.col1[3])
  rgb.col2 <- 1 - cbind(f2 * rgb.col2[1], f2 * rgb.col2[2], f2 * rgb.col2[3])
  rgb.col <- rbind(rgb.col1, rgb.col2); colors <- rgb(rgb.col)
  if(0 < set.black.and.white){
    if(set.black.and.white <= 1) colors[1]              <- "#000000"
    if(1 <= set.black.and.white) colors[length(colors)] <- "#FFFFFF"
  }  
  grey.idx[] <- colors[grey.idx]; icon <- grey.idx; return(icon)
} 
##:define [[greys.to.colors.puticon()]]##
#:291
     #
  
#233:
##define [[raster.to.greys()]]:##
raster.to.greys <- function(pic, grey.levels = c(0.05, 0.95),  # 2 :: black + white  
                            reduce = TRUE, n.icons = 1){
  
#234:
##prepare [[mat]] for coloring:##
d.mat <- dim(pic)
if( 3 == length(d.mat) ){ 
  mat <- apply(pic, 1:2, sum)  ; dim(mat) <- d.mat <- d.mat[1:2] 
} else {
  mat <- as.matrix(pic); d.mat <- dim(mat)
  mat <- col2rgb(mat, 7 < nchar(mat[1]))
  mat <- colMeans(mat)
}
mat   <- mat/max(1,mat) # /255 # shifted from else statements #180417 
mat <- matrix(mat, ncol = d.mat[2])
##:prepare [[mat]] for coloring##
#:234
  if( 2 == length(grey.levels) ){
    limits <- grey.levels
    
#241:
##find levels if the two [[limits]] are in (0,1):##
#235:
##reduce size of [[mat]]:##
if(reduce > 0 ){
  if(is.logical(reduce)) {
    # pixel.per.pic.plan <- width.of.picture * pixel.per.mm / n.icons^0.5
    pixel.per.pic <- 120 * 5 / n.icons^0.5 
    # reduction.factor <- pixel.per.pic.real / pixel.per.pic.plan
    reduce <- ceiling( max(d.mat) / pixel.per.pic )
  }
  if(reduce > 1){
    dim.mat.new <- reduce * (floor(d.mat/reduce))
    mat.new <- mat[1:dim.mat.new[1], 1:dim.mat.new[2]]
    mat.new <- array(mat.new, rbind(reduce, dim.mat.new/reduce))
    mat.new <- apply(mat.new, c(2,4), mean)
    d.mat <- dim(mat.new); mat <- pmin(1,mat.new); dim(mat) <- d.mat 
  }
}
##:reduce size of [[mat]]##
#:235
# generate matrix of levels
levs <- 1 + (limits[1] < mat) + (limits[2] < mat)   
dim(levs) <- d.mat  
##:find levels if the two [[limits]] are in (0,1)##
#:241
    return(levs)
  }
  
#235:
##reduce size of [[mat]]:##
if(reduce > 0 ){
  if(is.logical(reduce)) {
    # pixel.per.pic.plan <- width.of.picture * pixel.per.mm / n.icons^0.5
    pixel.per.pic <- 120 * 5 / n.icons^0.5 
    # reduction.factor <- pixel.per.pic.real / pixel.per.pic.plan
    reduce <- ceiling( max(d.mat) / pixel.per.pic )
  }
  if(reduce > 1){
    dim.mat.new <- reduce * (floor(d.mat/reduce))
    mat.new <- mat[1:dim.mat.new[1], 1:dim.mat.new[2]]
    mat.new <- array(mat.new, rbind(reduce, dim.mat.new/reduce))
    mat.new <- apply(mat.new, c(2,4), mean)
    d.mat <- dim(mat.new); mat <- pmin(1,mat.new); dim(mat) <- d.mat 
  }
}
##:reduce size of [[mat]]##
#:235
  if( 1 == length(grey.levels) && 0 == (grey.levels %% 1) ){ # number of levels given
    # find greys by number of greys
    n.greys <- max(round(grey.levels), 2)
    mat <- unclass(mat); min.mat <- min(mat); max.mat <- max(mat)
    grey.levels <- seq(min.mat, max.mat, length = n.greys + 1)[-(n.greys+1)][-1]
    p <- c(min.mat, mat[ min.mat < mat & mat < max.mat], max.mat )
    greys <- c(min.mat, quantile(p, grey.levels))
    greys <- unique(greys[ !is.na(greys) ])
  } else {                   # find greys by quantiles of grey rates
    grey.levels <- unique( pmin(1, pmax(0, sort(c(0, grey.levels, 1)))) )
    greys       <- unique( quantile(mat, grey.levels) )
    if( (h <- length(greys)) > 2 ) greys <- greys[ -h ]
  }  # generate matrix of levels:
  levs <- sapply( mat, function(x) sum( x >= greys ) ) 
  if(max(levs) == 2) levs <- levs + 1 # if 2 cols only use one color and white
  if( 2 == length(h <- unique(levs)) ) levs <- 2 + ( levs == max(h) ) 
  dim(levs) <- d.mat; return(levs)
} 
##:define [[raster.to.greys()]]##
#:233
  
#279:
##prepare color vector in [[puticon()]]:##
# adjust representation of color rgb in decimal form
if( ! is.na(color[1]) ){
  color <- transform.color.to.rgb.integer(color) 
  color <- rbind(color)
  color <- sapply(split(color, row(color)), 
    function(x) paste(sep="", "#", paste(collapse = "", 
              as.character(as.hexmode(c(x,255)))[-4])))
  # generate vectors of colors and icon.cex if 1 < length(x)
  if( 1 < n.items ){ 
    color    <- rep(color, n.items)[1:n.items]
    icon.cex <- rep(icon.cex, n.items)[1:n.items]
  }
}
##:prepare color vector in [[puticon()]]##
#:279
  
#286:
##plot jpg-, png- or pnm-file-icons and [[return()]] in [[puticon()]]:##
if( "" != file ){  # case: icon saved in a file # cat("dim icon", dim(icon))
  
#287:
##read jpeg, png or pnm file in [[puticon()]]:##
  icon <- 0; class(icon) <- "error"
  # JPEG
  if( 0 < length(grep("jp[e]{0,1}g$", file))  || 
      0 < length(grep("JP[E]{0,1}G$", file))){
    if(!"package:jpeg" %in% search()){
      print("puticon() requires package jpeg")
      # library(jpeg, lib.loc = .libPaths()) 
    }
    icon <- try(jpeg::readJPEG(file, native = !TRUE)) #############
  }
  # PNG
  if( 0 < length(grep("png$", file))  || 0 < length(grep("PNG$", file))){
    if(!"package:png" %in% search()){
      print("puticon() requires package png")
      # library(png, lib.loc = .libPaths()) 
    }
    icon <- png::readPNG(file, native = !TRUE)  ##################
  }
  # PNM
  if( 0 < length(grep("pnm$", file))  || 0 < length(grep("PNM$", file))){
    if(!"package:tcltk" %in% search()){
      print("puticon() requires package tcltk")
      # library(tcltk, lib.loc = .libPaths()) 
    }
    
#221:
##define [[get.pnm()]]:##
get.pnm <- function(filename, verbose = FALSE){
  
#222:
##find P* type of pnm file:##
nextline <- scan(filename, what="", n=1)
if( substring(nextline, 1, 1) != "P" || 
    ! ( PType <- substring(nextline, 2, 2) ) %in% as.character(1:6)) 
  return("ERROR: reading pnm file failed: no pnm file")
PType <- as.numeric(PType); if(verbose) cat("PType:", PType); skip <- 0
nextline <- scan(filename, what="", sep="\n", n=1, skip = skip, 
                 blank.lines.skip = FALSE)
nextline <- unlist( strsplit( nextline, "[ \t]"))[-1]
##:find P* type of pnm file##
#:222
  
#223:
##get width of pnm picture:##
#226:
##get next line that is not empty:##
idx <- 20
while(idx > 0 & 0 == length(nextline)){
  idx <- idx - 1; skip <- skip + 1
  nextline <- scan(filename, what="", sep="\n", n=1, skip = skip,
                   blank.lines.skip = FALSE)
  nextline <- sub("[#].*", "", nextline)
  nextline <- unlist( strsplit( nextline, "[ \t]"))
}
if( idx == 0 ) return("ERROR: reading pnm file failed: too many #-lines")
nextline <- as.numeric(nextline)
##:get next line that is not empty##
#:226
width <- nextline[1]; if(verbose) cat("width:",width)
nextline <- nextline[-1]
##:get width of pnm picture##
#:223
  
#224:
##get height of pnm picture:##
if( length(nextline) == 0 ){
  
#226:
##get next line that is not empty:##
idx <- 20
while(idx > 0 & 0 == length(nextline)){
  idx <- idx - 1; skip <- skip + 1
  nextline <- scan(filename, what="", sep="\n", n=1, skip = skip,
                   blank.lines.skip = FALSE)
  nextline <- sub("[#].*", "", nextline)
  nextline <- unlist( strsplit( nextline, "[ \t]"))
}
if( idx == 0 ) return("ERROR: reading pnm file failed: too many #-lines")
nextline <- as.numeric(nextline)
##:get next line that is not empty##
#:226
}
height <- nextline[1]; if(verbose) cat("height:", height)
nextline <- nextline[-1]
##:get height of pnm picture##
#:224
  
#225:
##get colors of pnm picture:##
if(PType == 1 || PType == 4) colors <- 1 else {
  if( length(nextline) == 0 ){
    
#226:
##get next line that is not empty:##
idx <- 20
while(idx > 0 & 0 == length(nextline)){
  idx <- idx - 1; skip <- skip + 1
  nextline <- scan(filename, what="", sep="\n", n=1, skip = skip,
                   blank.lines.skip = FALSE)
  nextline <- sub("[#].*", "", nextline)
  nextline <- unlist( strsplit( nextline, "[ \t]"))
}
if( idx == 0 ) return("ERROR: reading pnm file failed: too many #-lines")
nextline <- as.numeric(nextline)
##:get next line that is not empty##
#:226
  }
  colors <- nextline[1]
}; if(verbose){ cat("colors:", colors); cat("head processed") }
##:get colors of pnm picture##
#:225
  
#228:
##get decpixel of pnm picture:##
if(PType < 4){
  decpixel <- scan(filename, what="", sep="\n", skip = skip+1)
  decpixel <- paste(collapse=" ", decpixel)
  decpixel <- unlist( strsplit( decpixel, " +"))
  decpixel <- as.numeric(decpixel)
  decpixel <- matrix( decpixel, ncol = width, byrow = TRUE)
} else { # P4, P5, P6
  
#227:
##read picture data of P4, P5 or P6 pictures:##
tclcmds <- c('
  # https://de.wikipedia.org/wiki/Portable_Pixmap
  # set fname mm.pnm
  set fname FILENAME       
  set size [ file size $fname ]  
  # puts $size
  set fp [open $fname]
  # http://www.tek-tips.com/viewthread.cfm?qid=1477934  
  fconfigure $fp -translation binary 
  # scan [string range $contents i i] %c strA  
  set binpixel [read $fp $size]
  close $fp
  binary scan $binpixel cu* decpixel
')
tclcmds <- sub("FILENAME", filename, tclcmds)
#require(tcltk)
if( requireNamespace("tcltk") ){ 
  tcltk::.Tcl(tclcmds)
} else { 
  print("Error from get.pnm: tcltk not found!!"); return() 
}
decpixel <- as.character(tclvalue("decpixel"))
##:read picture data of P4, P5 or P6 pictures##
#:227
  decpixel <- unlist( strsplit( decpixel, " "))
  if( PType == 4){
    n.infos <- ceiling(width/8) * height 
    # if(verbose) cat("length(decpixel)", length(decpixel), "n.infos", n.infos)
    decpixel <- decpixel[ -(1 : ( length(decpixel) - n.infos )) ]
    encode <- function(number, base) {
      # simple version of APL-encode / APL-representation "T", pw 10/02
      # "encode" converts the numbers "number" using the radix vector "base"
      n.base <- length(base); result <- matrix(0, length(base), length(number))
      for(i in n.base:1){
        result[i,] <- if(base[i]>0) number %% base[i] else number
        number     <- ifelse(rep(base[i]>0,length(number)),
                             floor(number/base[i]), 0)
      }
      return( if(length(number)==1) result[,1] else result )
    }
    decpixel <- encode(as.numeric(decpixel), rep(2,8))
    decpixel <- matrix(decpixel, nrow = height, byrow = TRUE)[, 1:width]
    # decpixel <- matrix(decpixel, ncol = height, byrow = !TRUE)
    # decpixel <- t(decpixel[(1:width),])
  } else { # P5 or P6
    BigEndian <- colors > 255
    n.infos <- width * height * c(1,3)[1+(PType == 6)] * c(1,2)[1+BigEndian]   
    decpixel <- decpixel[ -(1 : ( length(decpixel) - n.infos )) ]
    if( BigEndian ){ # use the first byte of a pixel only
      decpixel <- matrix(decpixel, ncol = 2, byrow = TRUE)[,1] ### 1 or 2?
    }
    decpixel <- as.numeric(decpixel)
    decpixel <- matrix( decpixel, ncol = width * (1 + 2*(PType == 6)), byrow = TRUE)
  }
  PType <- PType - 3
}
##:get decpixel of pnm picture##
#:228
  
#229:
##define [[decpixel.to.raster()]]:##
decpixel.to.raster <- function(decpixel, PType, width, height, colors){
  HEX <- unlist(strsplit("0123456789ABCDEF",""))
  if(PType < 3){ # black and white or grey -- P1 or P2
    if(PType==1) decpixel <- colors - decpixel
    pixel <- decpixel / colors * 255
    first <- floor( pixel / 16 ); second <- pixel %% 16
    hexpixel <- paste(sep="", HEX[1 + first], HEX[1 + second])
    hexpixel <- paste(sep="", "#", hexpixel, hexpixel, hexpixel)
    hexpixel <- matrix(hexpixel, ncol = width)
  } else {       # colors -- P3
    decpixel <- array(t(decpixel), c(3, width, height))
    if( 255 < colors ) colors <- 255                                 # 160928
    pixel <- decpixel / colors * 255
    first <- floor(pixel / 16); second <- pixel %% 16
    hexpixel <- paste(sep="", HEX[1 + first], HEX[1 + second])
    hexpixel <- array(hexpixel, c(3, width, height))
    hexpixel <- paste(sep="", "#", hexpixel[1,,], hexpixel[2,,], hexpixel[3,,])
    hexpixel <- matrix(hexpixel, ncol = width, byrow = TRUE)
  }
  raster <- hexpixel
}
#table(decpixel.to.raster(a, 6, 724, 561, 65535))
#table(a)
##:define [[decpixel.to.raster()]]##
#:229
  as.raster(decpixel.to.raster(decpixel, PType, width, height, colors))
} #; dump("get.pnm", file = "get.pnm.R")
##:define [[get.pnm()]]##
#:221
    icon <- get.pnm(file)
  }
  if( "try-error" %in% class(icon) ){
    cat("Error in puticon(): file", file, "not readable by puticon()")
    return()
  }
##:read jpeg, png or pnm file in [[puticon()]]##
#:287
  
#289:
##transform colors of [[icon]] to grey levels in [[puticon()]]:##
# transform different representations of colors 
icon <- transform.color.to.rgb.integer(icon.orig <- icon)
# expand a single grey.levels value lower 1
if( length(grey.levels) == 1 && grey.levels < 1 ) 
  grey.levels <- c( grey.levels, 1)
# find the grey levels of the picture
icon <- raster.to.greys(icon, grey.levels = grey.levels, reduce = TRUE, 
              n.icons = max(1, ceiling(pin[1]*25.4 / max(icon.cex))^2))
# Now we have a matrix consisting of the grey levels of the pixels.
# A subset of the grey levels will be changed by the replacement color.
##:transform colors of [[icon]] to grey levels in [[puticon()]]##
#:289
  
#290:
##recolor [[icon]] for position [[i.x]] and plot it in [[puticon()]]:##
# precondition: icon must be a matrix describing 
#               the levels of greys of a raster graphics
simple <- all(grey.levels <= 1) &&  length(grey.levels) == 2 
# cat("simple", simple, "levels", grey.levels)
# recolor icons dependent on color # cat("else", simple, color)
if( is.na(color[1]) ){ # no recoloring
  idx.color.of.icon <- rep(1, length(x))
  pic <- list(as.raster(icon.orig))
} else {  
  pic <- NULL
  color.used <- unique(color)
  idx.color.of.icon <- match(color, color.used)
  for(i.color in color.used){      # cat("i.color", i.color)
    p <- greys.to.colors.puticon(icon, i.color,
                          set.black.and.white = 1.5, simple = simple)
    pic <- c( pic, list( p ))
  }
}
# find size(s) and position(s) of icon(s)
delx <- xwcoor.pmm * icon.cex / 2;  dely <- ywcoor.pmm * icon.cex / 2
dely <- dely * (h <- dim(icon))[1] / h[2] # proportional scaling
xmin <- x - delx; xmax <- x + delx; ymin <- y - dely; ymax <- y + dely
for(i.x in seq(along = x)){        # cat("i.x", i.x, "--------------")
  # get icon and plot
  icon.i.x <- pic[[ idx.color.of.icon[i.x] ]]
  rasterImage(icon.i.x, xmin[i.x], ymin[i.x], xmax[i.x], ymax[i.x], 
              interpolate = FALSE, xpd = xpd)
}
##:recolor [[icon]] for position [[i.x]] and plot it in [[puticon()]]##
#:290
  return()
}
##:plot jpg-, png- or pnm-file-icons and [[return()]] in [[puticon()]]##
#:286
  
#296:
##plot icons from a raster image object and [[return()]] in [[puticon()]]:##
if( is.raster(icon) ){
  
#289:
##transform colors of [[icon]] to grey levels in [[puticon()]]:##
# transform different representations of colors 
icon <- transform.color.to.rgb.integer(icon.orig <- icon)
# expand a single grey.levels value lower 1
if( length(grey.levels) == 1 && grey.levels < 1 ) 
  grey.levels <- c( grey.levels, 1)
# find the grey levels of the picture
icon <- raster.to.greys(icon, grey.levels = grey.levels, reduce = TRUE, 
              n.icons = max(1, ceiling(pin[1]*25.4 / max(icon.cex))^2))
# Now we have a matrix consisting of the grey levels of the pixels.
# A subset of the grey levels will be changed by the replacement color.
##:transform colors of [[icon]] to grey levels in [[puticon()]]##
#:289
  
#291:
##define [[greys.to.colors.puticon()]]:##
greys.to.colors.puticon <- function(grey.idx, color,      # invert = FALSE, 
                         set.black.and.white = FALSE, simple = FALSE){
  # cat("greys.to.colors.puticon")
  # if(invert) grey.idx[] <- max(grey.idx) + 1 - grey.idx # inversion of levels
  if(simple){ # simple case of recoloring
    # set of colors based on color
    color <- c("#000000", color, "#FFFFFF") # ;print(color)
    grey.idx[] <- color[grey.idx]; icon <- grey.idx; return(icon)
  } 
  n <- max(grey.idx)                        # find colors based on color:
  rgb.col1 <- col2rgb(color[1]) / 255; rgb.col2 <- 1 - rgb.col1
  n1 <- round(n / 2) ; n2 <- n - n1 
  f1 <- ((1:n1) - 1/2) / n1; f2 <- ((n2:1) - 1/2) / n2
  rgb.col1 <-     cbind(f1 * rgb.col1[1], f1 * rgb.col1[2], f1 * rgb.col1[3])
  rgb.col2 <- 1 - cbind(f2 * rgb.col2[1], f2 * rgb.col2[2], f2 * rgb.col2[3])
  rgb.col <- rbind(rgb.col1, rgb.col2); colors <- rgb(rgb.col)
  if(0 < set.black.and.white){
    if(set.black.and.white <= 1) colors[1]              <- "#000000"
    if(1 <= set.black.and.white) colors[length(colors)] <- "#FFFFFF"
  }  
  grey.idx[] <- colors[grey.idx]; icon <- grey.idx; return(icon)
} 
##:define [[greys.to.colors.puticon()]]##
#:291
     
  
#290:
##recolor [[icon]] for position [[i.x]] and plot it in [[puticon()]]:##
# precondition: icon must be a matrix describing 
#               the levels of greys of a raster graphics
simple <- all(grey.levels <= 1) &&  length(grey.levels) == 2 
# cat("simple", simple, "levels", grey.levels)
# recolor icons dependent on color # cat("else", simple, color)
if( is.na(color[1]) ){ # no recoloring
  idx.color.of.icon <- rep(1, length(x))
  pic <- list(as.raster(icon.orig))
} else {  
  pic <- NULL
  color.used <- unique(color)
  idx.color.of.icon <- match(color, color.used)
  for(i.color in color.used){      # cat("i.color", i.color)
    p <- greys.to.colors.puticon(icon, i.color,
                          set.black.and.white = 1.5, simple = simple)
    pic <- c( pic, list( p ))
  }
}
# find size(s) and position(s) of icon(s)
delx <- xwcoor.pmm * icon.cex / 2;  dely <- ywcoor.pmm * icon.cex / 2
dely <- dely * (h <- dim(icon))[1] / h[2] # proportional scaling
xmin <- x - delx; xmax <- x + delx; ymin <- y - dely; ymax <- y + dely
for(i.x in seq(along = x)){        # cat("i.x", i.x, "--------------")
  # get icon and plot
  icon.i.x <- pic[[ idx.color.of.icon[i.x] ]]
  rasterImage(icon.i.x, xmin[i.x], ymin[i.x], xmax[i.x], ymax[i.x], 
              interpolate = FALSE, xpd = xpd)
}
##:recolor [[icon]] for position [[i.x]] and plot it in [[puticon()]]##
#:290
  return()
}
##:plot icons from a raster image object and [[return()]] in [[puticon()]]##
#:296
  
#284:
##plot central symbols in [[pch]]-case and [[return()]] in [[puticon()]]:##
if( "" != pch ){
  if( is.numeric(pch) && pch %in% (1:128)){
    cex <- mm.to.cex(icon.cex) 
    cex <- cex / 0.75       # factor proposed by help of points, item 'pch'
    lwd <- list(...)$lwd; if( 0 == length(lwd)) lwd <- cex # lwd set by user 
    points(x, y, pch = pch, cex = cex, col = color, xpd = xpd, lwd = lwd) 
  } else { print("Error in puticon(): plotting symbol must be in 1..127") }
  return()
}
##:plot central symbols in [[pch]]-case and [[return()]] in [[puticon()]]##
#:284
  
#301:
##check pictogram generating function in [[puticon()]]:##
  
#311:
##if [[is.character(icon)]] look for internal generator in [[puticon()]]:##
if(is.character(icon)){ 
  
#351:
##define generator functions:##
h <- "internal generator function"
  
#315:
##define [[BI()]]:##
BI <- function(){
  result <- list()
  res <- cbind( x = c(0, 25, 25, 0), y = c(0, 0, 61, 61), color = NA)
  class(res) <- "polygon"
  result <- c(result, list(res))
  res <- cbind( x = c(72, 57, 57, 72), y = c(0, 0, 61, 61), color = NA)
  class(res) <- "polygon"
  result <- c(result, list(res))
  res <- cbind( x = c( 0, 72,  72,  56, 56, 44,  44,  29, 29, 16,  16,   0), 
                y = c(72, 72, 100, 100, 87, 87, 100, 100, 87, 87, 100, 100), color = NA)
  class(res) <- "polygon"
  result <- c(result, list(res))
  res <- rbind( c(19.0, 43, 24,   43, lwd.mm = 36, color = NA),
                c(19.0, 18, 30.5, 18, lwd.mm = 36, color = NA),
                c(12, 43, 21, 43, lwd.mm = 11, 0),
                c(12, 18, 27, 18, lwd.mm = 11, 0) )
  colnames(res) <- c("x0", "y0", "x1", "y1", "lwd.mm", "color")
  class(res) <- "segments"
  result <- c(result, list(res))
  res <- cbind( x = c(0, 15, 15, 0), y = c(0, 0, 61, 61), color = NA)
  class(res) <- "polygon"
  result <- c(result, list(res))
  result
}
##:define [[BI()]]##
#:315
h <- "internal generator function"
  
#318:
##define [[TL()]]:##
TL <- function(L = c("AB", "DT", "PW", "NV", "Hello")[1], t.cex.mm = 10, 
               startx, starty, delx, dely, Lcolors,
               pointx = 90, pointy = 90, pointsize = 8, pointcolor = "red" ){
  # L               letters to be used
  # t.cex.mm        letter size: a 'W' will have a width of 'text.cex.mm' mm 
  # startx, starty  x coordinate of first letter in mm
  # delx, dely      shift in x and in y between letters in mm
  # Lcolors         colors of the letters to be used
  # pointx, pointy  x and y coordinate of point
  # pointsize       size of the point
  # pointcolor      color of the point
  if(is.factor(L) || is.numeric(L) ) L <- as.character(L)
  L <- unlist(strsplit(L,""))
  n <- length(L)
  check.num <- function(x, n = 2){
    if(is.factor(x)) x <- as.character(x); x <- as.numeric(x); x <- rep(x, n)[1:n] 
  }
  if(missing(startx)) startx <- 50 / n; if(missing(delx)) delx <- 100 / n  
  if(missing(starty)) starty <- 50 / n; if(missing(dely)) dely <- 100 / n 
  if(missing(t.cex.mm))  t.cex.mm  <- 100 / n 
  if(missing(pointx))   pointx <- 100 - min(60, 5 + n * 2.5)
  if(missing(pointy)){  pointy <-       min(40, 5 + n * 2.5)
                        if(starty[1] > 50) pointy <- 100 - pointy }
  if(missing(pointsize)) pointsize <- min(40, 10 + n * 2.5)
  if(missing(Lcolors)) Lcolors <- 1; Lcolors <- rep(Lcolors, n)[1:n]
  startx <- check.num(startx, n); starty <- check.num(starty, n) 
  delx <- cumsum(c(0, check.num(delx, n - 1))); dely <- cumsum(c(0, check.num(dely, n - 1)))
  startx <- (startx + delx) %% 100; starty <- (starty + dely) %% 100
  result <- list()
  res <- data.frame( x = c(0, 0, 100, 100), y = c(0, 100, 100, 0), color = NA) 
  class(res) <- c( class(res), "polygon"); result <- c(result, list(res))  # box of the icon
  res <- data.frame(x0 = pointx, y0 = pointy, x1 = pointx, y1 = pointy, 
                    lwd.mm = pointsize, color = pointcolor)
  class(res) <- c( class(res), "segments"); result <- c(result, list(res)) # special point
  res <- data.frame(x = startx, y = starty, L = L, text.cex.mm = t.cex.mm, color = Lcolors)
  class(res) <- c( class(res), "text"); result <- c(result, list(res))     # letters
  result
} # ; show.icon.design(TL) #; TL()
##:define [[TL()]]##
#:318
h <- "internal generator function"
  
#325:
##define [[cross.simple()]]:##
cross.simple <- function(){  # print("in cross")
  res <- rbind( c( 05, 05, 95, 95, lwd.mm = 10, NA), 
                c( 05, 95, 95, 05, lwd.mm = 10, NA),
                c( 50, 50, 50, 50, lwd.mm = 30, 2) ) 
  colnames(res) <- c("x0", "y0", "x1", "y1", "lwd.mm", "color")
  class(res) <- "segments"; res
}
##:define [[cross.simple()]]##
#:325
h <- "internal generator function"
  
#326:
##define [[cross()]]:##
cross <- function(z = 0.30){ # print("in cross")
  if(is.factor(z)){ z <- as.numeric(z); z <- 0.5 * z / length(levels(z)) } 
  z <- z * 100; eps <- 1 # *0.7
  z <- min(100, max(0, z))
  result <- list()
  res <- cbind( x = c(z, 100 - z, 100 - z, z), 
                y = c(0, 0, 100 - z, 100 - z), 
                color = 5) 
  class(res) <- "polygon"
  result <- c(result, list(res))
  res <- rbind( c(eps*c( 5,   5, 95, 95, lwd.mm = 10), NA), 
                c(eps*c( 5,  95, 95,  5, lwd.mm = 10), NA),
                c(eps*c( 50, 50, 50, 50, lwd.mm = 30), 3) ) 
  colnames(res) <- c("x0", "y0", "x1", "y1", "lwd.mm", "color")
  class(res) <- "segments"
  result <- c(result, list(res))
  result
}
##:define [[cross()]]##
#:326
h <- "internal generator function"
  
#327:
##define [[circle.simple()]]:##
circle.simple <- function(){ # print("in circle.simple")
  res <- rbind( c( 50, 50, 50, 50, lwd.mm = 100, NA)) 
  colnames(res) <- c("x0", "y0", "x1", "y1", "lwd.mm", "color")
  class(res) <- "segments"; res
}
##:define [[circle.simple()]]##
#:327
h <- "internal generator function"
  
#328:
##define [[circle()]]:##
circle <- function(whole = 0.50){     # print("in circle")
  if(is.factor(whole)){ 
    whole <- as.numeric(whole); whole <- 0.50 * whole / length(levels(whole))
  }
  whole <- min(1, whole)
  res <- rbind( c( 50, 50, 50, 50, lwd.mm = 100,          NA), 
                c( 50, 50, 50, 50, lwd.mm = whole * 100,  0)) 
  colnames(res) <- c("x0", "y0", "x1", "y1", "lwd.mm", "color")
  class(res) <- "segments"; res
}
##:define [[circle()]]##
#:328
h <- "internal generator function"
  
#331:
##define [[car.simple()]]:##
car.simple <- function(){ # print("in cross")
  res0 <- cbind(t(cbind( 0.6* c( 05, 05, 95, 95), 0.6* c( 05, 95, 95, 05),
                         0.6* c( 50, 50, 50, 50)) + c(2.7,2.2)) ,
                lwd.mm = c(10,10,30), color =  c(2,5,7) ) 
  colnames(res0) <- c("x0", "y0", "x1", "y1", "lwd.mm", "color")
  class(res0) <- "segments"
  res1 <- cbind( x = c(10, 90, 85, 75, 70, 45, 40, 20, 10), # car polygon
                 y = c(10, 10, 30, 30, 45, 45, 30, 30, 10))
  class(res1) <- "polygon"
  res2 <- cbind(t(cbind( 0.3* c( 05, 05, 95, 95), 0.3* c( 05, 95, 95, 05),
                         0.3* c( 50, 50, 50, 50)) + c(43, 10)) ,
                lwd.mm = 0.3 * c(10,10,30), # cross on door
                color =  c(4,6,2) ) 
  colnames(res2) <- c("x0", "y0", "x1", "y1", "lwd.mm", "color")
  class(res2) <- "segments"
  res3 <- rbind( c(25, 10, 25, 10, 15, 1), c(75, 10, 75, 10, 15, 1)) # wheel
  colnames(res3) <- c("x0", "y0", "x1", "y1", "lwd.mm", "color")
  class(res3) <- "segments"
  list(res1, res1, res2, res3)
} # ; car.simple()
##:define [[car.simple()]]##
#:331
h <- "internal generator function"
  
#332:
##define [[car()]]:##
car <- function(width = .5, height = .0){ # print("in cross")
  width  <- (width  * 2   + 2) / 3.2; height <- (height * 5.0 + 1) / 3.2
  x <- c(-40,  40, 35, 25, 20,-05,-10,-30, -40) * width  + 50
  y <- c(-20, -20,  0,  5, 20, 20,  5,  0, -20) * height + 50
  wheel.size <- height * 10 + 5
  ymin <- min(y); xmin <- min(x); xmax <- max(x)
  res1 <- cbind( x, y) # car polygon
  class(res1) <- "polygon"
  res2 <- rbind( c(h <- 0.75*xmin + 0.25*xmax, ymin, h, ymin, wheel.size, 1), 
                 c(100 - h, ymin, 100 - h, ymin, wheel.size, 1)) # wheel
  colnames(res2) <- c("x0", "y0", "x1", "y1", "lwd.mm", "color")
  class(res2) <- "segments"; list(res1, res2)
} # ; car()
##:define [[car()]]##
#:332
h <- "internal generator function"
  
#334:
##define [[nabla()]]:##
nabla <- function(){ 
  res <- rbind( c( 05, 95, 50, 05, 10), c( 50, 05, 95, 95, 10),
                c( 95, 95, 05, 95, 10) );  class(res) <- "segments"
  colnames(res) <- c("x0", "y0", "x1", "y1", "lwd.mm"); res
} # ; nabla()
##:define [[nabla()]]##
#:334
h <- "internal generator function"
  
#363:
##define [[walkman()]]:##
walkman <- function( balpha = 70, col = NA, 
           ll1alpha =  -80, ll2alpha = -120, lr1alpha = -45, lr2alpha = -100,
           al1alpha = -170, al2alpha = -100, ar1alpha = -60, ar2alpha =  +20 ){
  # generates a walking man in a device of pin-sizes: 10cm x 10 cm and lwd = 10 mm
  # col <- sample(1:10, size = 1)
  xy <- c(0,0); dxq <- 10; dyq <- 10; size <- 10; lwd <- 10.5; lw.unit <- 1
  segs.set <- NULL; col.set <- NULL
  scale.xy <- 2.54 
  balpha   <- balpha   / 180 * pi
  ll1alpha <- ll1alpha / 180 * pi;  ll2alpha <- ll2alpha / 180 * pi
  lr1alpha <- lr1alpha / 180 * pi;  lr2alpha <- lr2alpha / 180 * pi
  al1alpha <- al1alpha / 180 * pi;  al2alpha <- al2alpha / 180 * pi
  ar1alpha <- ar1alpha / 180 * pi;  ar2alpha <- ar2alpha / 180 * pi
  
#364:
##define body of [[walkman]]:##
  x <- c(cos(balpha), sin(balpha)) * scale.xy
  ba <- c(0,0); be <- ba + x
  bal <- lwd * lw.unit * 1.7; bac <- col 
  seg.mat <- cbind(a=ba[1], b=ba[2], c=be[1], d=be[2], e=bal)
  segs.set <- rbind(segs.set, seg.mat); col.set <- c(col.set, bac)
##:define body of [[walkman]]##
#:364
  
#366:
##define head of [[walkman]]:##
  h <- be + ( be - ba) * .75; hl <- lwd * lw.unit * 1.6; hc <- col
  seg.mat <- cbind(a=h[1], b=h[2], c=h[1], d=h[2], e=hl)
  segs.set <- rbind(segs.set, seg.mat); col.set <- c(col.set, hc)
##:define head of [[walkman]]##
#:366
  
#365:
##define legs of [[walkman]]:##
  lbecken <- 0.19; llength <- 1; ll <- lwd * lw.unit * 0.85
  ll1a <- ba +   c(cos(balpha+pi/2), sin(balpha+pi/2)) * scale.xy * lbecken
  ll1e <- ll1a + c(cos(ll1alpha),    sin(ll1alpha))    * scale.xy * llength
  lr1a <- ba +   c(cos(balpha-pi/2), sin(balpha-pi/2)) * scale.xy * lbecken
  lr1e <- lr1a + c(cos(lr1alpha), sin(lr1alpha))  * scale.xy * llength
  ll2a <- ll1e 
  ll2e <- ll2a + c(cos(ll2alpha), sin(ll2alpha)) * scale.xy * llength
  lr2a <- lr1e 
  lr2e <- lr2a + c(cos(lr2alpha), sin(lr2alpha)) * scale.xy * llength
  l <- rbind(cbind(ll1a[1], ll1a[2], ll1e[1], ll1e[2])
            ,cbind(lr1a[1], lr1a[2], lr1e[1], lr1e[2])
            ,cbind(ll2a[1], ll2a[2], ll2e[1], ll2e[2])
            ,cbind(lr2a[1], lr2a[2], lr2e[1], lr2e[2]) )
  seg.mat <- cbind(l, e=ll)
  segs.set <- rbind(segs.set, seg.mat); col.set <- c(col.set, hc)
##:define legs of [[walkman]]##
#:365
  
#367:
##define arms of [[walkman]]:##
  aschulter <- 0.19; alength <- 0.7; al <- lwd * lw.unit * 0.85
  al1a <- be +   c(cos(balpha+pi/2), sin(balpha+pi/2)) * scale.xy * aschulter
  al1e <- al1a + c(cos(al1alpha), sin(al1alpha))       * scale.xy * alength
  ar1a <- be +   c(cos(balpha-pi/2), sin(balpha-pi/2)) * scale.xy * aschulter
  ar1e <- ar1a + c(cos(ar1alpha), sin(ar1alpha))       * scale.xy * alength
  al2a <- al1e 
  al2e <- al2a + c(cos(al2alpha), sin(al2alpha)) * scale.xy * alength
  ar2a <- ar1e 
  ar2e <- ar2a + c(cos(ar2alpha), sin(ar2alpha)) * scale.xy * alength
  a <- rbind( cbind(al1a[1], al1a[2], al1e[1], al1e[2]), 
              cbind(ar1a[1], ar1a[2], ar1e[1], ar1e[2]),
              cbind(al2a[1], al2a[2], al2e[1], al2e[2]),
              cbind(ar2a[1], ar2a[2], ar2e[1], ar2e[2]) )
  seg.mat <- cbind(a, e=al)
  segs.set <- rbind(segs.set, seg.mat); col.set <- c(col.set, hc)
##:define arms of [[walkman]]##
#:367
  segs.set[, 1:4] <- segs.set[, 1:4] + 5 # shift to the center
  segs.set <- cbind(as.data.frame(segs.set), f = col) # set color
  class(segs.set) <- c(class(segs.set), "segments")
  segs.set[, 1:4] <- segs.set[, 1:4] * 10
  colnames(segs.set) <- c("x0", "y0", "x1", "y1", "lwd.mm", "color")
  return(segs.set)
} #; show.icon.design(walkman, balpha = 90) # ; 
# plot(1:10, type = "n", axes = FALSE, xlab = "", ylab = "")
# puticon(5, 5.5, icon = walkman, icon.cex = 160, balpha = 80)
# walkman()
##:define [[walkman()]]##
#:363
h <- "internal generator function"
  
#371:
##define [[smiley.blueeye()]]:##
smiley.blueeye <- function(){
  # output: x0, y0, x1, y1, lwd, col 
  circle <- function(x0 = 1, y0 = 1, a = 3, lwd.mm = 5, # a == radius
                     time.0 = 0, time.1 = 12, n = 30){
    # function to draw a part of a circle line
    alpha <- seq(time.0, time.1, length = n); alpha <- alpha * (2*pi/12)
    x <- a * sin(alpha) + x0; y <- a * cos(alpha) + y0
    cbind(x[-n],y[-n], x[-1],y[-1], lwd.mm)
  }
  res <- NULL
  #                               x0   y0   radius lwd.mm
  res <- rbind( res, cbind(circle(50, 49.5, 23,    50), col.code = NA) ) # face
  res <- rbind( res, cbind(       50, 45,   50,    50,  15,         1) ) # nose
  res <- rbind( res, cbind(circle(50, 49.5, 47.5,   5), 1) ) # margin
  res <- rbind( res, cbind(circle(35, 65,  2.5,    10), 4) ) # eye left
  res <- rbind( res, cbind(circle(65, 65,  2.5,    10), 1) ) # eye right
  res <- rbind( res, cbind(circle(50, 50,   27,     8,  7.50, 4.50), 3) ) # mouth
  colnames(res) <- c("x0", "y0", "x1", "y1", "lwd.mm", "color")
  class(res) <- "segments"; res
} # ; show.icon.design(smiley.blueeye) # ; smiley.blueeye()
##:define [[smiley.blueeye()]]##
#:371
h <- "internal generator function"
  
#372:
##define [[smiley.normal()]]:##
smiley.normal <- function(){
  # output: x0, y0, x1, y1, lwd, col 
  circle <- function(x0 = 1, y0 = 1, a = 3, lwd.mm = 5, # a = radius
                     time.0 = 0, time.1 = 12, n = 30){
    # function to draw a part of a circle line
    alpha <- seq(time.0, time.1, length = n); alpha <- alpha * (2*pi/12)
    x <- a * sin(alpha) + x0; y <- a * cos(alpha) + y0
    cbind(x[-n],y[-n], x[-1],y[-1], lwd.mm)
  }
  res <- NULL # res <- rbind( res, cbind( 50, 45, 50, 50, 15,      1) ) # nose
  res <- rbind( res, cbind(circle(50, 49.5, 23,   50), col.code = NA) ) # face
  res <- rbind( res, cbind(circle(50, 49.5, 47.5,  5), 1) ) # rand
  res <- rbind( res, cbind(circle(35, 60.5,  3.0, 10), 1) ) # eye
  res <- rbind( res, cbind(circle(65, 60.5,  3.0, 10), 1) ) # eye 
  res <- rbind( res, cbind(circle(50, 50,   27,    8, 7.50, 4.50),1) ) # mouth
  colnames(res) <- c("x0", "y0", "x1", "y1", "lwd.mm", "color")
  class(res) <- "segments"; res
} #; show.icon.design(smiley.normal)
##:define [[smiley.normal()]]##
#:372
h <- "internal generator function"
  
#377:
##define [[smiley()]]:##
smiley <- function(smile = 0.8){
  if(is.factor(smile)) smile <- as.numeric(smile) / length(levels(smile))
  circle <- function(x0 = 1, y0 = 1, a = 3, lwd = 5, 
                     time.0 = 0, time.1 = 12, n = 60){
    alpha <- seq(time.0, time.1, length = n); alpha <- alpha * (2*pi/12)
    x <- a * sin(alpha) + x0;               y <- a * cos(alpha) + y0
    cbind(x[-n],y[-n], x[-1],y[-1], lwd)
  }
  res <- NULL
  # res <- rbind( res, cbind(circle(50, 49.5,23,   50), col.code = NA) ) # face
  # res <- rbind( res, cbind(circle(50, 49.5,47,   60),  1) )            # rand
  res <- rbind( res, cbind(         50, 50,  50,   50, 100, 1 ))         # face+rand
  res <- rbind( res, cbind         (50, 50,  50,   50,  88, NA))         # face 
  res <- rbind( res, cbind(circle(  35, 60.5, 3.0, 10),  1) )            # eye
  res <- rbind( res, cbind(circle(  65, 60.5, 3.0, 10),  1) )            # eye 
  if(is.na(smile)){
    res <- rbind( res, cbind(circle(50, 50, 27,  7.5, 7.50, 4.50),1) ) # mouth
  } else {
    #             x0  y0            a lwd time.0  time.1
    # hs <- circle(50,50,         27,  10,   7.5,    4.5) # mouth laughing
    # hn <- circle(50,10,         27,  10,  10.5,   13.5) # mouth not laughing    
    hs <- circle( 50, 40,         17,  10,   8.5,    3.5) # mouth laughing
    hn <- circle( 50, 20,         17,  10,   9.5,   14.5) # mouth not laughing    
    s <- smile; n <- 1 - s
    h <- cbind( hs[,1], s*hs[,2]+n*hn[,2], hs[,3], s*hs[,4]+n*hn[,4], hs[,5])
    res <- rbind( res, cbind(h, 1) )                      # mouth
  }
  class(res) <- "segments"; res
  return(res)
}
##:define [[smiley()]]##
#:377
h <- "internal generator function"
  
#373:
##define [[smiley.sad()]]:##
smiley.sad <- function(){
  # output: x0, y0, x1, y1, lwd, col 
  circle <- function(x0 = 1, y0 = 1, a = 3, lwd.mm = 5, 
                     time.0 = 0, time.1 = 12, n = 30){
    # function to draw a part of a circle line
    alpha <- seq(time.0, time.1, length = n); alpha <- alpha * (2*pi/12)
    x <- a * sin(alpha) + x0; y <- a * cos(alpha) + y0
    cbind(x[-n],y[-n], x[-1],y[-1], lwd.mm)
  }
  res <- NULL #; res <- rbind( res, cbind(50, 45, 50, 50, 15,      1) ) # nose
  res <- rbind( res, cbind(circle(50, 49.5, 23,   50), col.code = NA) ) # face
  res <- rbind( res, cbind(circle(50, 49.5, 47.5,  5), 1) ) # rand
  res <- rbind( res, cbind(circle(35, 60.5,  3.0, 10), 1) ) # eye
  res <- rbind( res, cbind(circle(65, 60.5,  3.0, 10), 1) ) # eye 
  res <- rbind( res, cbind(circle(50, 10,   27,    8, 10.50, 13.50),1) ) # mouth
  colnames(res) <- c("x0", "y0", "x1", "y1", "lwd.mm", "color")
  class(res) <- "segments"; res
} # ; show.icon.design(smiley.sad)
##:define [[smiley.sad()]]##
#:373
h <- "internal generator function"
  
#381:
##define [[mazz.man()]]:##
mazz.man <- function(Mean = 100, Penalty = 1, Region = "region:", 
                     expo = 1/(1:3)[3], Mean.max = 107, Mean.half = 90, 
                     Penalty.max = 5, Penalty.min = 0, 
                     x.text = 70, y.text = 10, text.cex.mm = 10){ 
  # bag.size %in% [0,1] # idea of the icon: Adriano Pareto, Matteo Mazziotta
  Mean.min <- Mean.half - (Mean.max - Mean.half) / ((h <- 2^(1/expo)) - 1)
  Mean.min <- min(Mean.min, Mean)
  fac      <- 0.95 * ((h * (Mean - Mean.min)) / Mean.max) ^ expo
  bag.size <- 0.80 * ((Penalty - Penalty.min) / Penalty.max )^expo /2
  res <- rbind(
    c(50,            77.5*fac + 5, 50,          77.5 *fac + 5), #head
    c(50,            35  *fac + 5, 50,          60   *fac + 5), #body
    c(50,            32  *fac + 5, 50,           0   *fac + 5), #leg in white
    c(50,            32  *fac + 5, 50,           0   *fac + 5), #leg
    c(50 + 30*fac,   55  *fac + 5, 50 + 25*fac, 75   *fac + 5), #tape2
    c(50 - 20*fac,   65  *fac + 5, 50 + 30*fac, 70   *fac + 5), #stick
    c(50,            64  *fac + 5, 50 - 15*fac, 45   *fac + 5), #arm one
    c(50 - 20*fac,   65  *fac + 5, 50 - 15*fac, 45   *fac + 5), #arm
    c(50 + 27.5*fac, 50  *fac + 5 - 20*bag.size ,
      50 + 27.5*fac, 50  *fac + 5 - 20*bag.size),               #bag
    c(50 + 25*fac,   55  *fac + 5, 50 + 30*fac, 75   *fac + 5)) #tape1
  colnames(res) <- c("x0", "y0", "x1", "y1")
  lwd.mm <-  c( c(17, 14, 12, 10, 2.5, 2, 6, 6) * fac / 0.927042
                ,   31 * bag.size / 0.2924, 2.5 * fac / 0.927042 ) 
  colors <- c("#3377BB", "white", "brown", "orange")[c(1,1,2,1,4,3,1,1,4,4)]
  res <- data.frame(res, lwd.mm = lwd.mm, color = colors)
  class(res) <- c(class(res), "segments"); result <- list(res)
  res <- data.frame(x = x.text, y = y.text, L = Region, text.cex.mm = text.cex.mm, color = 1) 
  class(res) <- c(class(res), "text"); res <- list(res) 
  result <- c(result, res)                   
  return(result)
} # ; show.icon.design(mazz.man) # Mazzi.Pareto
  # res1 <- rbind(c(0,0,100,100)); class(res1)<-c("segments"); res1 <- list(res1) 
  # res2 <- rbind(c(100,0,0,100)); class(res2)<-c("segments"); res2 <- list(res2) 
##:define [[mazz.man()]]##
#:381
h <- "internal generator function"
  
#389:
##define [[bike()]]:##
bike <- function(){
   res.liste <- NULL; a <- 1.5
   res <- rbind( c(20, 20, 20,    20, 40, 1),  # wheel front
                 c(20, 20, 20,    20, 30, NA), # wheel front
                 c(80, 20, 80,    20, 40, 1),  # wheel back
                 c(80, 20, 80,    20, 30, NA), # wheel back
                 c(50, 20, 80,    20,  3*a, 1),  # ---
                 c(50, 20, 65,    50,  3*a, 1),  # /
                 c(80, 20, 32.5,  45,  3*a, 1),    # \
                 c(50, 20, 32.5,  45,  3*a, 1),    # \
                 c(60, 50, 70,    50,  5*a, 1),  # seat
                 c(20, 20, 40,    60,  3*a, 1),  # /
                 c(40, 60, 45,    60,  5*a, 1) # control
   )
   res[, c(2,4)] <- res[, c(2,4)] + 20; class(res) <- "segments"
   colnames(res) <- c("x0", "y0", "x1", "y1", "lwd.mm", "color")
   res.liste <- c(res.liste, list(res))
}
##:define [[bike()]]##
#:389
h <- "internal generator function"
  
#390:
##define [[bike2()]]:##
bike2 <- function() {
   res.liste <- NULL; a <- 1.5
   res <- rbind( c(20, 20, 20,    20, 40, 1),  # wheel front
                 c(20, 20, 20,    20, 30, NA), # wheel front
                 c(80, 20, 80,    20, 40, 1),  # wheel back
                 c(80, 20, 80,    20, 30, NA), # wheel back
                 c(50, 20, 80,    20,3*a, 1),  # ---
                 c(50, 20, 65,    50,3*a, 1),  # /
                 c(80, 20, 32.5,  45,3*a, 1),  # \
                 c(50, 20, 32.5,  45,3*a, 1),  # \
                 c(60, 50, 70,    50,5*a, 1),  # seat
                 c(20, 20, 40,    60,3*a, 1),  # /
                 c(40, 60, 45,    60,5*a, 1))  # control  
   res[, c(2,4)] <- (res[, c(2,4)] - 9.3) * 10/5.3; class(res) <- "segments"
   colnames(res) <- c("x0", "y0", "x1", "y1", "lwd.mm", "color")
   res.liste <- c(res.liste, list(res))
}
##:define [[bike2()]]##
#:390
h <- "internal generator function"
  
#391:
##define [[heart()]]:##
heart <- function(txt = "xy"){
   txt <- substring(paste(txt, " "), 1:2, 1:2)
   res1 <- cbind( x = c(50, 80, 90, 70, 50, 50, 30, 10, 20, 50),
                  y = c(05, 30, 60, 85, 50, 50, 85, 60, 30, 05) + 05, color = NA)
   class(res1) <- c(class(res1), "polygon"); res1 <- list(res1)
   res2 <- cbind( x = c(50, 90, 70, 50, 50, 30, 10, 50),
                  y = c(05, 60, 85, 50, 50, 85, 60, 05) + 05)
   res2 <- data.frame( res2, lwd.mm = 19.5, color = NA)
   class(res2) <- c(class(res2), "spline"); res2 <- list(res2)
   res3 <- data.frame( x = c(27, 73), y = c(65, 65), txt = txt, 40, 1)
   class(res3) <- c(class(res3), "text");   res3 <- list(res3)
   result <- c(res1, res2, res3) 
} # ; show.icon.design(heart)()
##:define [[heart()]]##
#:391
h <- "internal generator function"
  
#392:
##define [[bend.sign()]]:##
bend.sign <- function(txt = "xy"){
   txt <- substring(paste(txt, " "), 1:2, 1:2)
   ground <- 6; top <- 90; center <- 55.5; size <- 25
   res0o <- c(50, top, 50, ground + 3, 7, 1) # Pfahl outer
   res0i <- c(50, top, 50, ground + 2, 3, 3) # Pfahl inner
   res1  <- c(30, ground, 70, ground, 2, 1)  # Fundament
   res2  <- rbind( c(50, center+size, 50-size, center), c(50-size, center, 50, center-size),
                   c(50, center-size, 50+size, center), c(50+size, center, 50, center+size))
   res2 <- cbind(res2, lwd.mm = 15, color = 1)    # Schildrand
   size <- size - 0                               # Innenrand:
   res3 <- rbind( c(50, center+size, 50-size, center), c(50-size, center, 50, center-size),
                  c(50, center-size, 50+size, center), c(50+size, center, 50, center+size))
   res3 <- cbind(res3, lwd.mm = 10, color = 2)
   res <- rbind(res0o, res0i, res1, res2, res3); rownames(res) <- NULL
   res <- as.data.frame(res)
   colnames(res) <- c("x0", "y0", "x1", "y1", "lwd.mm", "color")
   res$color <- c("black", NA, "gray")[res$color]
   class(res) <- c(class(res), "segments"); res <- list(res)
   size <- size - 2
   res1b <- rbind( c(50, center+size), c(50-size, center),
                   c(50, center-size), c(50+size, center))
   res1b <- cbind(res1b, color = NA)
   class(res1b) <- c(class(res1b), "polygon"); res1b <- list(res1b) # Innenflaeche
   f <- size / 25
   res2b <- cbind( x = 50     + f*c( h <- c(- 9,  5, 12), rev(-h)),
                   y = center + f*c( h <- c( 16, 13,  6), rev(-h)), 
                   lwd.mm = f^0.6*6.5, color = 1)
   class(res2b) <- c(class(res2b), "spline"); res2b <- list(res2b)
   #res3 <- data.frame( x = c(27, 73), y = c(65, 65), txt = txt, 40, 1)
   #class(res3) <- c(class(res3), "text");   res3 <- list(res3)
   result <- c(res, res1b, res2b) #, res1) 
}  # ; show.icon.design(bike2)# bend.sign) #; bend.sign()
##:define [[bend.sign()]]##
#:392
h <- "internal generator function"
  
#398:
##define [[fir.tree()]]:##
fir.tree <- function(height = 1, width = 1, txt = ".....", t.cex.mm = 10){ 
  fac.x <- width * 100/60; fac.y <- height * 100/70
  # build standardized elements of pictogram
  res <- data.frame( 
    x = c(20, 40, 25, 45, 35, 50, 65, 55, 75, 60, 80),
    y = c(20, 40, 40, 60, 60, 80, 60, 60, 40, 40, 20) + 5,
    color = NA)
  class(res) <- c(class(res), "polygon")
  res.liste <- c(list(res))
  res <- data.frame( 
    x = c(55, 55, 45, 45),
    y = c(20, 10, 10, 20) + 5 ,
    color = "brown")
  class(res) <- c(class(res), "polygon")
  res.liste <- c(res.liste, list(res))
  # integrate effects of arg1 and arg2
  res.liste <- lapply( res.liste, function(xyc){
                         xyc$x <- fac.x * (xyc$x - 50) + 50; xyc} )
  res.liste <- lapply( res.liste, function(xyc){
                         xyc$y <- fac.y * (xyc$y - 50) + 50; xyc} )
  # append text element # res <- data.frame( x = 20, y = 2, txt = txt, t.cex.mm, color = "1") 
  res <- data.frame( x =  fac.x * (30 - 50) + 50, y = fac.y * (10 - 50) + 50, 
                     txt = txt, t.cex.mm, color = "1") #180327
   class(res) <- c(class(res), "text")
  res.liste <- c(res.liste, list(res))
  res.liste
}  # ; show.icon.design(fir.tree)
##:define [[fir.tree()]]##
#:398
#343:
##define [[find.smooth.curve()]] and [[find.brush.polygon()]]:##
#342:
##define [[bs.approx()]] and [[loess.approx()]]:##
bs.approx <- function(x, y, x.new, degree = 3, knots = 10, df = NULL){
  # library(splines)                                          # check package splines
  if(is.matrix(x) || is.data.frame(x)){y <- x[,2];x <- x[,1]} # check x,y input
  n <- length(x); idx <- order(x); x <- x[idx]; y <- y[idx]   # order by x
  y.new <- rep(NA, length(x.new))                             # init y result
  x.all <- c(x, x.new);   y.all <- c(y, y.new)                # combine old and new points
  basis <- splines::bs(x.all, degree = degree, df = df, knots = knots) # find design matrix 
  res <- lm(y.all ~ basis); coef.ok <- !is.na(res$coeff)      # estimate spline coefficients
  X     <- cbind(1, basis[  1:n ,])[,coef.ok]                 # extract design matrix for old 
  X.new <- cbind(1, basis[-(1:n),])[,coef.ok]                 # extract design matrix for new
  y.dach     <- X     %*% res$coefficients[coef.ok]           # compute spline of old points 
  y.new.dach <- X.new %*% res$coefficients[coef.ok]           # compute spline of new points
  list(cbind(x, y.dach), cbind(x.new, y.new.dach))            # compose result
}
loess.approx <- function(x, y, x.new, span = 0.6, degree = 2){
  smooth.curve <- loess(y ~ x, span = span, degree = degree)
  res.new <- predict(smooth.curve, x.new)
  res.old <- predict(smooth.curve, x)
  return(list(cbind(x, res.old), cbind(x.new, res.new)))
}
##:define [[bs.approx()]] and [[loess.approx()]]##
#:342
find.smooth.curve <- function(x.in, y.in, n.new = 100, method = c("bs", "loess")[1],
                              degree = 3, knots = 50, span = 0.75){
  if(is.matrix(x.in) || is.data.frame(x.in)){y.in <- x.in[,2]; x.in <- x.in[,1]} # check input
  n <- length(x.in)
  dx.min <- 0.1 * diff(range(x.in)) / length(x.in)            # set minimal dx of spline
  x.h <- cumsum(c(1, pmax(dx.min, (diff(x.in)^2 + diff(y.in)^2)^0.5))) # find x of spline
  x.new <- seq(x.h[1], x.h[n], length = n.new)                # find new x for spline eval 
  if( method == "bs" ){
    res.x <- bs.approx(x = x.h, y = x.in, x.new = x.new, degree = degree, knots = knots)
    res.y <- bs.approx(x = x.h, y = y.in, x.new = x.new, degree = degree, knots = knots)
  } else {
    res.x <- loess.approx(x = x.h, y = x.in, x.new = x.new, span = span, degree = min(2, degree))
    res.y <- loess.approx(x = x.h, y = y.in, x.new = x.new, span = span, degree = min(2, degree))
  }
  return(cbind(x = res.x[[2]][,2], y = res.y[[2]][,2]))       # compose result
}
find.brush.polygon <- function(x, y, hwd = 10){
  # find area along the polygon of points (x, y) with width 2*hwd 
  if(is.matrix(x) || is.data.frame(x)){ y <- x[,2]; x <- x[,1] } # check input
  dy <- diff(x); dx <- -diff(y); h <- length(dx)            # find orthogonal vectors to segments
  dx <- c(dx[1], 0.5 * (dx[-1] + dx[-h]), dx[h])            # find means of neighbours 
  dy <- c(dy[1], 0.5 * (dy[-1] + dy[-h]), dy[h])            #    of orthogonal vectors
  d <- hwd / sqrt(dx^2 + dy^2); dy <- d * dy; dx <- d * dx  # scale orthognal vectors
  xy <- rbind(cbind(x = x + dx, y = y + dy), cbind(x = rev(x - dx), y = rev(y - dy))) 
  rbind(xy, xy[1,])                                         # copy first point to the end
}
##:define [[find.smooth.curve()]] and [[find.brush.polygon()]]##
#:343
h <- "internal generator function"
  
#406:
##define [[comet()]]:##
comet <- function(comet.color = NA){ 
  t2xy <- function(t,radius,init.angle=0) {
        t <- t / 360
        t2p <- 2*pi * t + init.angle * pi/180
        list(x = radius * cos(t2p), y = radius * sin(t2p))
  }
  center <- c(17, 30); fac <- 1.2 #; fac <- .2
  # c.color <- 4; s.color <- 3; comet.bg.color <- 7;  bg.color <- 0; t.color <- 5
  # c.color <- "gold"; s.color <- "red"; comet.bg.color <- "green"; 
  # t.color <- "gold";  bg.color <- "lightgrey"
  comet.bg.color <- "white"; t.color <- NA;  bg.color <- "white"; s.color <- "white"
  c.color <- comet.color
  res.liste <- NULL
  # aera of icon -----------------------------------------------------------------------------
  res <- data.frame(c(1, 99, 99, 1, 1), c(1, 1, 99, 99, 1), color = bg.color)
  class(res) <- c(class(res), "polygon"); res.liste <- c(res.liste, list(res)) 
  # aera of comet ----------------------------------------------------------------------------
  width <- 20 * fac
  res <- data.frame(center[1], center[2], center[1], center[2], width, color = comet.bg.color)
  class(res) <- c(class(res), "segments"); res.liste <- c(res.liste, list(res)) # comet gb
  # letter C of Comet -----------------------------------------------------------------------
  width <- 3 * fac; radius <- 10 * fac
  P <- t2xy( 90:-45 , radius, 0)
  res <- data.frame(P$x + center[1], P$y + center[2]); res <- cbind(res, res, 
                    width, color = bg.color)
  class(res) <- c(class(res), "segments"); res.liste <- c(res.liste, list(res)) # C missing part
  P <- t2xy( 67.5:180 , radius, 0)
  res <- data.frame(P$x + center[1], P$y + center[2]); res <- cbind(res, res, 
                    width, color = c.color)
  class(res) <- c(class(res), "segments"); res.liste <- c(res.liste, list(res)) # C
  P <- t2xy( -180:-22.5 , radius, 0)
  res <- data.frame(P$x + center[1], P$y + center[2]); res <- cbind(res, res, 
                    width, color = c.color)
  class(res) <- c(class(res), "segments"); res.liste <- c(res.liste, list(res)) # C
  # letter M of coMet ----------------------------------------------------------------------
  if( TRUE){
    width <- 2.5 * fac; shift <- c(1, 0.5) * 2 * fac; h <- 22.5 / 360 * 2 * pi
    xy <- cbind(c(-1, -1, 0, 1, 1), c(-1, 1, -1, 1, -1))
    xy <- xy %*% matrix( c( cos( h ), -sin(h), sin(h), cos(h)), 2, 2)
    x <- shift[1] + xy[,1] * 4 * fac; y <- shift[2] + xy[,2] * 4 * fac
    res <- data.frame(x[-5] + center[1], y[-5] + center[2], x[-1] + center[1], y[-1] + center[2],  
                      width, color = c.color)
    class(res) <- c(class(res), "segments"); res.liste <- c(res.liste, list(res)) # M
  }
  # tail of comet with letter T of comeT --------------------------------------------------
  radius <- c(1, 5) * fac; width <- 3 * fac
  for(i in 1:6){
    radius <- radius + 10 * fac
    P1 <- t2xy(c(0, 22.5, 45), radius[1], 0)
    P2 <- t2xy(c(0, 22.5, 45), radius[2], 0)
    res <- data.frame( P1$x + center[1], P1$y + center[2], P2$x + center[1], P2$y + center[2], 
                       width, color = t.color)
    class(res) <- c(class(res), "segments"); res.liste <- c(res.liste, list(res)) # comet gb
    if(i == 1){
      res <- data.frame(P1$x[1] + center[1], P1$y[1] + center[2], 
                        P1$x[3] + center[1], P1$y[3] + center[2], 
                        width, color = c.color)
      class(res) <- c(class(res), "segments"); res.liste <- c(res.liste, list(res)) # comet gb
      res <- data.frame( P1$x + center[1], P1$y + center[2], P2$x + center[1], P2$y + center[2], 
                        width, color = c.color)
      class(res) <- c(class(res), "segments"); res.liste <- c(res.liste, list(res)) # comet gb
    } else {
      res <- data.frame( P1$x + center[1], P1$y + center[2], P2$x + center[1], P2$y + center[2], 
                        width, color = t.color)
      class(res) <- c(class(res), "segments"); res.liste <- c(res.liste, list(res)) # comet gb
    }
    # T of comeT
    if(i == 5){
      h <- c(P2$x[2] - P1$x[2], P2$y[2] - P1$y[2]) * 2.5
      res <- data.frame( P1$x[2] + center[1], P1$y[2] + center[2], 
                         P2$x[2] + h[1] + center[1], P2$y[2] + h[2] +  center[2], 
                         width, color = c.color)
      class(res) <- c(class(res), "segments"); res.liste <- c(res.liste, list(res)) # comet gb
      h <- h * 0.6
      res <- data.frame( P1$x[2] + center[1], P1$y[2] + center[2], 
                         P1$x[2] - h[2] + center[1], P1$y[2] + h[1] +  center[2], 
                         width, color = c.color)
      class(res) <- c(class(res), "segments"); res.liste <- c(res.liste, list(res)) # comet gb
      res <- data.frame( P1$x[2] + center[1], P1$y[2] + center[2], 
                         P1$x[2] + h[2] + center[1], P1$y[2] - h[1] +  center[2], 
                         width, color = c.color)
      class(res) <- c(class(res), "segments"); res.liste <- c(res.liste, list(res)) # comet gb     
    }
  }
  # letter O of cOmet
  width <- 2.5 * fac; radius <- 7.5 * fac; shift <- c(1, 0.5) * 1.2 * fac
  P <- t2xy( 0:359 , radius, 0)
  res <- data.frame(P$x + shift[1] + center[1], P$y + shift[2] + center[2])
  res <- cbind(res, res, width, color = "white")
  class(res) <- c(class(res), "segments"); res.liste <- c(res.liste, list(res)) # O by white
  res.liste
} # ; print(comet());  show.icon.design(comet)
##:define [[comet()]]##
#:406
h <- "internal generator function"
  
#337:
##define [[coor.system()]]:##
coor.system <- function(xxx, yyy, pcex = 5, xrange, yrange, axes = FALSE){ 
  shift <- 0.5; lwd <- .25
  x <- c(.1, 3, 6, 9.9); y <- c(0, 0.1, -0.1, 0) + shift
  xy <- spline(x,y); x <- xy$x; y <- xy$y; n.1 <- length(x) - 1
  res <-            cbind(x[1:n.1], y[1:n.1], x[-1], y[-1], lwd)  # x line
  res <- rbind(res, cbind(y[1:n.1], x[1:n.1], y[-1], x[-1], lwd)) # y line
  res <- rbind(res, c(9.5, shift - 0.4, 9.9, shift, lwd),         # x arrow
                    c(9.4, shift + 0.3, 9.9, shift, lwd),         # x arrow
                    c(shift - 0.4, 9.5, shift, 9.9, lwd),         # y arrow
                    c(shift + 0.3, 9.4, shift, 9.9, lwd)) * 10    # y arrow
  res <- cbind(res, 1)
  class(res) <- "segments";   res.list <- list(res)
  if( !missing(xxx) ){
    if(missing(xrange)){ xrange <- range(xxx); xrange <- xrange + c(-0.1,0.1)*diff(xrange) }
    if(missing(yrange)){ yrange <- range(yyy); yrange <- yrange + c(-0.1,0.1)*diff(yrange) }
    xticks <- pretty(xrange); xticks <- xticks[ xrange[1] < xticks & xticks < xrange[2]]
    yticks <- pretty(yrange); yticks <- yticks[ yrange[1] < yticks & yticks < yrange[2]]
    xtickspos <- (xticks - xrange[1]) / (xrange[2] - xrange[1]) * 95 + 5
    ytickspos <- (yticks - yrange[1]) / (yrange[2] - yrange[1]) * 95 + 5
    res <- rbind(
             cbind(xtickspos, 5, xtickspos, 2, 2, 1)   # x ticks
            ,cbind(2, ytickspos, 5, ytickspos, 2, 1)   # y ticks
           )
    class(res) <- "segments"; res.list <- c(res.list, list(res))
    x <- c(-3, -1.5, 0, 1.5, 3); y <- c(-2.5, -0.5, 0.4, 1.5, 2.5) 
    xy <- spline(x,y); x <- xy$x; y <- xy$y
    xxx <- (xxx - xrange[1]) / (xrange[2] - xrange[1]) * 95 + 5
    yyy <- (yyy - yrange[1]) / (yrange[2] - yrange[1]) * 95 + 5
    res <- NULL; h <- length(x)
    for( i in seq(along = xxx) ){
      res <- rbind(res, 
             cbind(xxx[i] + x[-1], yyy[i] + y[-1], 
                   xxx[i] + x[-h], yyy[i] + y[-h], pcex * 0.2, NA), # points xxx, yyy
             cbind(xxx[i] + x[-1], yyy[i] + rev(y)[-1], 
                   xxx[i] + x[-h], yyy[i] + rev(y)[-h], pcex * 0.2, NA) # points xxx, yyy
      )
    }
    class(res) <- "segments"; res.list <- c(res.list, list(res))
    h <- length(xticks)  # x axis
    res <- data.frame( xtickspos, rep(-4, h), paste(xticks), rep(6, h),rep(1, h))
    class(res) <- c(class(res), "text"); if(axes) res.list <- c(res.list, list(res))
    h <- length(yticks); hh <- max(nchar(yticks)) # y axis
    res <- data.frame( rep(-2*hh, h), ytickspos, paste(yticks), rep(6, h),rep(1, h))
    class(res) <- c(class(res), "text"); if(axes) res.list <- c(res.list, list(res))
  } 
  res.list
}  ; coor.system()
##:define [[coor.system()]]##
#:337
##:define generator functions##
#:351
  if( icon %in% ls() ) icon <- get(icon)
  if( !is.function(icon) ) {
    cat("Error in puticon():", icon,"not implemented yet!")
    return()
  }
}
##:if [[is.character(icon)]] look for internal generator in [[puticon()]]##
#:311
  if( !is.function(icon) ){ # then: icon is not a generator function
    if( is.list(icon) ){
      txt <- c("icon <- function(){", deparse(icon), "}")
      h <- try(eval(parse(text = txt)))
      if("try-error" %in% class(h)){
        cat("Error in puticon(): definition of icon generating function failed\n")
        return( cat("Error in puticon(): argument icon must be a function or a list\n", 
                    "or an integer to specify a plotting character\n") )
      }
    } 
  } 
  icon.gen.args  <- formals(icon)
  n.icon.gen.args <- length(icon.gen.args)
##:check pictogram generating function in [[puticon()]]##
#:301
  
#302:
##extract additional args in [[puticon()]]:##
  args <- list(); n.args <- 0 # no additional args to concern
  if( n.icon.gen.args > 0 ){ 
    # extract relevant args of argument "..." 
    args <- list(...); n.args <- length(args)
    if( 0 < n.args ){ # match names of "..."-args and icons args   
      idx <- match(names(icon.gen.args), names(args))
      idx <- idx[!is.na(idx)]
      args <- args[idx]
      n.args <- length(args)
    }
    if( 0 == n.args ){ # explizit assignment of args if empty
      args <- list()
    } else { # expand args[[i]] cyclically to get n.items elements
      for( i in seq(n.args) ){ # for each position xy[i, ] ...
        if( length(args[[i]]) < n.items )
          args[[i]] <- rep(args[[i]], n.items)[1:n.items]
      }
    }
  } # relevant args found and expanded
##:extract additional args in [[puticon()]]##
#:302
  
#303:
##call icon without arguments in case of no args in [[puticon()]]:##
  if( 0 == n.args ){ 
    pic.sets <- try(do.call(icon, args)) 
    if("try-error" %in% class(pic.sets) ){ 
      cat("ERROR in call.icon.generator: generator function failed!\n"); return()
    }
    if( !is.list(pic.sets) || is.data.frame(pic.sets) ) pic.sets <- list(pic.sets)
  }
##:call icon without arguments in case of no args in [[puticon()]]##
#:303
  
#304:
##loop along the positions in [[puticon()]]:##
  type.set <- c("polygon", "segments", "text", "spline") # constant vector
  for(i in 1:n.items){        # loop along each of the positions: xy[i, ]   
    
#305:
##compute [[pic.sets]] in case of arguments in [[puticon()]]:##
    if( 0 < n.args ){
      # call pictogram generating function with element i of each of the args-vectors
      a <- lapply(args, function(x) x[[i]]) # remark: a is a list 
                                  # x[[i]] not x[i] #180514
      pic.sets <- try(do.call(icon, a))  # pic.sets is a list of descriptions
      if("try-error" %in% class(pic.sets) ){ 
        cat("!ERROR in call.icon.generator: generator function failed!\n"); return()
      }
      if( !is.list(pic.sets) || is.data.frame(pic.sets) ) pic.sets <- list(pic.sets)
    }
##:compute [[pic.sets]] in case of arguments in [[puticon()]]##
#:305
    
    for( pic.i in pic.sets ){ # loop along the elements of pic.sets
      # find type (last element of class vector) and dimensions of pic.i
      type <- rev(class(pic.i))[1]; type <- type[ type %in% type.set ]
      h <- dim(pic.i); rows.pic.i <- h[1]; cols.pic.i <- h[2] # s
      
#306:
##add missing colums in [[puticon()]]:##
if( type == "polygon" ){
  if( cols.pic.i < 3 ) pic.i <- cbind( pic.i, color.vec = NA )
}
if( type == "segments" ){
  if( cols.pic.i < 5 ) pic.i <- cbind( pic.i, lwd.mm = 10 )
  if( cols.pic.i < 6 ) pic.i <- cbind( pic.i, color.vec = NA )
}
if( type == "text" ){
  if( cols.pic.i < 4 ) pic.i <- cbind( pic.i, text.cex.mm = 10 )
  if( cols.pic.i < 5 ) pic.i <- cbind( pic.i, color.vec = NA )
}
if( type == "spline" ){
  if( cols.pic.i < 3 ) pic.i <- cbind( pic.i, lwd.mm = 10 )
  if( cols.pic.i < 4 ) pic.i <- cbind( pic.i, color.vec = NA )
}
##:add missing colums in [[puticon()]]##
#:306
      
#307:
##prepare colors in [[puticon()]]:##
# cat("--- prepare colors -------------")
# print(type); print(type.set); print(pic.i); print(cols.pic.i)
# extract color column: color.vec of group of descriptions
col.no <- c(3, 6, 5, 4)[ match( type, type.set ) ]
color.vec <- pic.i[, col.no]
# standardize format of color.vec
if(is.factor (color.vec)) color.vec <- as.character(color.vec)
if(is.numeric(color.vec)) color.vec <- c("white", palette("default"))[1+color.vec]
# <=> if(is.numeric(color.vec)) color.vec <- colornames[1 + color.vec]
# replace NA entries by argument color[i] of puticon call
res.color <- ifelse( is.na(color.vec), color[i], color.vec ) 
##:prepare colors in [[puticon()]]##
#:307
      
#308:
##transform coordinates in [[puticon()]]:##
      n.cols <- c(2, 4, 2, 2)[ match(type, type.set) ]
      adj.h <- matrix( adj, nrow(pic.i), n.cols, byrow = TRUE ) #180327
      res <- # shift because of design size
             # (pic.i[, 1:n.cols] - 100 * adj) *
             (pic.i[, 1:n.cols] + 100 * (adj.h - 1)) *  #180327
             # scaling: rescaling design size 0..100 -> 0..1: factor = 0.01
             0.01 * matrix(c(xsize[i], ysize[i]), rows.pic.i, n.cols, byrow = TRUE) + 
             # shift because of desired position
             matrix(xy[i,],                       rows.pic.i, n.cols, byrow = TRUE)
 
##:transform coordinates in [[puticon()]]##
#:308
      
#310:
##activate plotting commands in [[puticon()]]:##
      switch(type, 
        "polygon"  = polygon (res[,1], res[,2], col = res.color, xpd = NA, border = NA),
        "segments" = segments(res[,1], res[,2], res[,3], res[,4], col = res.color, 
                            # lwd = mm.to.lwd(pic.i[, 5]  * xsize[i] / xwcoor.pmm),
                              lwd = mm.to.lwd(pic.i[, 5]) * icon.cex[i] / 100,
                              xpd = NA),
        "text"     = text(res[,1], res[,2], as.character(pic.i[,3]),
                       col = res.color, cex = mm.to.cex(pic.i[,4]) * icon.cex[i] / 100, 
                       # adj = c(0,0), # adjust for text implemented by coordinates
                       xpd = NA),
        "spline"   = {
                       n.h <- length(res[,1]); z <- seq(n.h); n <- 10
                       xy.h <- cbind(spline( z, res[,1], n = n * n.h)$y, 
                                     spline( z, res[,2], n = n * n.h)$y)
                       lines(xy.h, col=res.color, 
                             lwd=mm.to.lwd(pic.i[,3]) * icon.cex[i] / 100, 
                             xpd = NA)
        }
      )
##:activate plotting commands in [[puticon()]]##
#:310
    }
  } # end of loop along the positions
##:loop along the positions in [[puticon()]]##
#:304
  return(NULL) 
}
#:275
##:define [[puticon()]]##

\name{slider.lowess.plot}
\title{interactive lowess smoothing}
\alias{slider.lowess.plot}
\description{
  \code{slider.lowess.plot} computes an xy-plot of the data and 
  adds LOWESS lines. The smoother
  span and the number of iterations are selected by sliders.
}
\usage{
  slider.lowess.plot(x, y, ...)
}
\arguments{
  \item{x}{ data set to be used for plotting or vector of x values }
  \item{y}{ vector of y values in case \code{x} is not a matrix }
  \item{\dots}{ additional (graphics) parameter settings }
}
\details{
  \code{slider.lowess.plot} computes a scatterplot of the data.
  Then a LOWESS smoother line is added to the plot.   
  For more details about the lowess parameters \code{f} and \code{iter}
  take a look at the help page of \code{lowess}.
  The parameters are set by moving sliders of the 
  control widget. The first slider defines the smoother span \code{f}
  and the second one the number of iterations.
}
\value{
  a message about the usage
}
\references{ for references see help file of \code{lowess} }
\author{ Hans Peter Wolf }
 \seealso{ \code{\link{lowess}}, \code{slider} }
\examples{
\dontrun{
## This example cannot be run by examples() but should be work in an interactive R session
  slider.lowess.plot(cars)
}
}
\keyword{ iplot }

\name{hdepth}
\alias{hdepth}
\title{ hdepth of points }
\description{
  \code{hdepth()} computes the h-depths of points.
}
\usage{
hdepth(tp, data, number.of.directions=181)
}
\arguments{
  \item{tp}{ two column matrix of the coordinates of points which h-depths are needed } 
  \item{data}{ two column matrix of the coordinates of the points of a data set} 
  \item{number.of.directions}{ number of directions to be checked }
}
\details{
The function \code{hdepth} computes the h-depths of the points
\code{tp} relative to data set \code{data}. If \code{data} is 
missing \code{tp} will also be taken as data set.
}
\value{
the h-depths of the test points
}
\author{ Peter Wolf }
\note{
  Version of bagplot: 12/2012 }
 \seealso{ \code{\link[aplpack]{bagplot}} }
\examples{
  # computation of h-depths
  data <- cbind(rnorm(40), rnorm(40)) 
  xy <- cbind(runif(50,-2,2),runif(50,-2,2))
  bagplot(data); text(xy, as.character(hdepth(xy,data)))
}

\name{slider.smooth.plot.ts}
\title{interactive Tukey smoothing}
\alias{slider.smooth.plot.ts}

\description{
  \code{slider.smooth.plot.ts} computes smooth curves
  of a time series plot by Tukey's smoothers.
  The kind of smoothing is controlled by a Tcl/Tk widget. 
}
\usage{
  slider.smooth.plot.ts(x, ...)
}
\arguments{
  \item{x}{ time series }
  \item{\dots}{ additional graphical parameters }
}
\details{
  \code{slider.smooth.plot.ts} draws the time series \code{x}.
  The user selects a filter of the set 
  \code{c("3RS3R", "3RSS", "3RSR", "3R", "3", "S")}
  step by step and the resulting curve is added to the plot.
  The selection is performed by pressing a button of the control
  widget of \code{slider.smooth.plot.ts}. 
  The button \code{reset} restarts the smoothing process.
}
\value{
  a message about the usage
}
\references{  Tukey, J. W. (1977). Exploratory Data Analysis, Reading
     Massachusetts: Addison-Wesley.
}
\author{ Hans Peter Wolf }
 \seealso{ \code{\link{plot}}, \code{\link{smooth}} }
\examples{
\dontrun{
## This example cannot be run by examples() but should be work in an interactive R session
  slider.smooth.plot.ts(rnorm(100))
}
}
\keyword{ iplot }

\name{plothulls}
\alias{plothulls}
\title{plothulls for data peeling }
\description{
  \code{plothulls plots convex hulls of a bivariate data set.}
}
\usage{
plothulls(x, y, fraction, n.hull = 1, main, add = FALSE, col.hull, 
    lty.hull, lwd.hull, density = 0, ...) 
}
\arguments{
  \item{x}{ two column matrix of the coordinates of points of x-values of a data set} 
  \item{y}{ if x is one dimensional then y contains the y-values of the data set} 
  \item{fraction}{ ... of points that lies inside the hull to be plotted} 
  \item{n.hull}{ number of directions sequential hulls to be plotted}
  \item{main}{ title for the graphics}
  \item{add}{ if TRUE no new plot is initialized}
  \item{col.hull}{ color(s) of the hull(s)}
  \item{lty.hull}{ line type(s) of the hull(s)}
  \item{lwd.hull}{ line width(s) of the hull(s)}
  \item{density}{ density argument of polygon() that draws the hulls}
  \item{...}{ further arguments used in the call of plot() or points()}
}
\details{
The function \code{plothulls} computes hulls of a bivariate data set using the 
function \code{chull}. After finding a hull the hull maybe plotted. 
Then the data points of the hull will be removed and 
the hull of the remaining points is computed. 
The style of plotting a hull depends on the setting of 
\code{col.hull}, \code{lty.hull}, \code{lwd.hull} and \code{density}.
\code{density=NA} has the effect that the regions of the hulls are filled by a color.
Using \code{fraction} you can plot a single hull. 
\code{n.hull} defines the number of hull that should be drawn one after the other.
}
\value{
The  hull(s) are stored as a list of matrices with two columns, 
the innermost first and so on. 
}
\references{ 
  Green, P.J. (1981): Peeling bivariate data. 
  In: Interpreting Multivariate Data, V. Barnett (ed.), pp 3-19, Wiley.
  Porzio, Giovanni C., Ragozini, Giancarlo (2000): 
  Peeling multvariate data sets: a new approach. Quanderni di Statistica, Vol. 2.
}
\author{ Peter Wolf }
\note{
  Version of plothulls: 10/2013 }
 \seealso{ \code{\link[aplpack]{bagplot}} }
\examples{
  # 10 hulls computed from the faithful data and plotted
  plothulls(faithful, n.hull=10, lty.hull=1)
  # plotting additionally a hull with 90 percent of points within the hull
  plot(faithful)
  plothulls(faithful, fraction=.90, add=TRUE, col.hull="red", lwd.hull=3)
  # hull with 10 percent of points within the hull 
  plothulls(faithful, fraction=.10, col.hull="red", lwd.hull=3)
  # first 3 hulls of the cars data set
  n <- 3
  plothulls(cars, n.hull=n, col.hull=1:n, lty.hull=1:n)
  # 5 hulls represented by colored regions
  n <- 5
  cols <- heat.colors(9)[3:(3+n-1)]
  plothulls(cars, n.hull=n, col.hull=cols, lty.hull=1:n, density=NA, col=0)
  points(cars, pch=17, cex=1)
  # 6 hulls: regions colored and boundaries shown
  n <- 6
  cols <- rainbow(n)
  plothulls(cars, n.hull=n, col.hull=cols, lty.hull=1:n, density=NA, col=0)
  plothulls(cars, n.hull=n, add=TRUE, col.hull=1, lwd.hull=2, lty=1, col=0)
}

\name{slider.hist}
\title{interactive histogram and density traces}
\alias{slider.hist}
\alias{slider.density}

\description{
  The functions \code{slider.hist} and \code{slider.density}
  compute histograms and density traces 
  whereas some parameter are controlled by sliders. 

  \code{slider.hist} computes a histogram; the number of classes is
  defined by a slider.

  \code{slider.density} computes a density trace; width and 
  type of the kernel are defined by sliders.
}
\usage{
  slider.hist(x, panel, ...)
  slider.density(x, panel, ...)
}
\arguments{
  \item{x}{ data set to be used for plotting }
  \item{panel}{ function constructing additional graphical elements to the plot}
  \item{\dots}{ additional (graphics) parameters which are passed to 
                the invoked high level plotting function }
}
\details{
  \code{slider.hist} draws a histogram of the data set \code{x} by
  calling \code{hist} and opens a Tcl/Tk widget with one slider. 
  The slider defines the number of classes of the histogram. Changing the
  slider results in redrawing of the plot. For further
  details see the help page of \code{hist}. \code{rug} is used as the
  default panel function.

  \code{slider.density} draws a density trace of the data set \code{x}
  by \code{plot(density(...))} and opens a Tcl/Tk-widget with two 
  sliders. The first slider defines the width of the density trace 
  and the second one the kernel function: 
   \code{"1-gaussian",  "2-epanechnikov", "3-rectangular", 
         "4-triangular","5-biweight",     "6-cosine",     "7-optcosine"}
  Changing one of the sliders results in a redrawing of the plot. 
  For further details see the help page of \code{density}. 
  \code{rug} is used as the default panel function.
}
\value{
  a message about the usage
}
\references{ ~~ }
\author{ Hans Peter Wolf }
  \seealso{ \code{\link{hist}}, \code{slider}} 
\examples{
\dontrun{
## This example cannot be run by examples() but should be work in an interactive R session
  slider.hist(log(islands))
}
\dontrun{
## This example cannot be run by examples() but should be work in an interactive R session
slider.density(rivers,xlab="rivers",col="red")
}
\dontrun{
## This example cannot be run by examples() but should be work in an interactive R session
slider.density(log(rivers),xlab="rivers",col="red",
  panel=function(x){
    xx<-seq(min(x),max(x),length=100)
    yy<-dnorm(xx,mean(x),sd(x))
    lines(xx,yy)
    rug(x)
    print(summary(yy))
  }
)
}
}
\keyword{ univar }
\keyword{ iplot }

\name{boxplot2D}
\alias{boxplot2D}
\title{ Boxplot of projection of two dimensional data }
\description{
  boxplot2D computes summary statistics of a one dimensional 
  projection of a two dimensional data set and plots a sloped
  boxplot of the statistics into the scatterplot of the two 
  dimensional data set.
}
\usage{
    boxplot2D(xy, add.to.plot = TRUE, box.size = 10, box.shift = 0, 
    angle = 0, angle.type = "0", tukey.style = TRUE, coef.out = 1.5, 
    coef.h.out = 3, design = "sl", na.rm=FALSE, ...)
}
\arguments{
  \item{xy}{ \code{(nx2)}-matrix, two dimensional data set  }
  \item{add.to.plot}{ if \code{TRUE} the boxplot is added to
      the actual plot of the graphics device }
  \item{box.size}{ height of the box (of the boxplot) }
  \item{box.shift}{ shift of boxplot perpendicular to the 
  projection direction }
  \item{angle}{ direction of projection in units defined by 
  angle.type }
  \item{angle.type}{ 
    \code{"0"}: angle in (0,2*pi),
    \code{"1"}: clock-like: angle.typ.0==2*pi*angle.typ.1/12,  
    \code{"2"}: degrees: angle.typ.0==2*pi*angle.typ.2/360, 
    \code{"3"}: by fraction: delta.y/delta.x
 }
  \item{tukey.style}{ if \code{TRUE} outliers are defined as described 
    in Tukey (1977)
 }
  \item{coef.out}{ outliers are values that are more than
     \code{coef.out*boxwidth} away from the box, default: 
     \code{coef.out=1.5}  }
  \item{coef.h.out}{ heavy outliers are values that are more
      than \code{coef.h.out*boxwidth} away from the box,
      default: \code{coef.h.out=3}   }
  \item{design}{ if \code{sl} then parallelogram else box  }
  \item{na.rm}{ if TRUE 'NA' values are removed otherwise exchanged by mean}
  \item{\dots}{ additional graphical parameters }
}
\references{
    Tukey, J.
    \emph{Exploratory Data Analysis.}
    Addison-Wesley, 1977.
    }
\author{Peter Wolf }
\note{ version 08/2003 }
\seealso{ \code{\link[graphics]{boxplot}}}
\examples{
 xy<-cbind(1:100, (1:100)+rnorm(100,,5))
 par(pty="s")
 plot(xy,xlim=c(-50,150),ylim=c(-50,150))
 boxplot2D(xy,box.shift=-30,angle=3,angle.typ=1)
 boxplot2D(xy,box.shift=20,angle=1,angle.typ=1)
 boxplot2D(xy,box.shift=50,angle=5,angle.typ=1)
 par(pty="m")
}
\keyword{misc}

\name{skyline.hist}
\alias{skyline.hist}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
  \code{skyline.hist} computes a skyline plot which is special histogram.
}
\description{
  The function \code{skyline.hist} draws several histograms in one plot. The 
  resulting image may look like a skyline.
}
\usage{
   skyline.hist(x, n.class, n.hist = 1, main, ylab="density", 
                night = FALSE, col.bars = NA, col.border = 4, lwd.border = 2.5,
                n.shading = 6, lwd.shading = 2, col.shading = NA, lty.shading = 3,
                pcol.data = "green", cex.data = 0.3, pch.data = 16, col.data = 1,
                lwd.data = .2, permutation = FALSE, 
                xlab, xlim, ylim, new.plot=TRUE, bty="n", ...)
}
\arguments{
  \item{x}{ one dimensional data set.}
  \item{n.class}{
    number of classes that should be used to find the width of the bars 
    of the histogram(s).}
  \item{n.hist}{
    number of histograms that should be plotted.}
  \item{main}{
    used for call of \code{title}.}
  \item{ylab}{
    text for y axis.}
  \item{night}{
    If \code{TRUE} the background will be colored blue. 
    If \code{FALSE} there will be no colored background. Otherwise 
    \code{night} is used as background color.}
  \item{col.bars}{
    defines the color of the bars. If \code{is.na(col.bars)} and 
    \code{night==TRUE} the bars will be colored gray. }
  \item{col.border}{  color of the borders of the bars.}
  \item{lwd.border}{  line width of the borders of the bars.}
  \item{n.shading}{
    number of vertical lines for filling the bars of the histograms.}
  \item{lwd.shading}{
    line width of the vertical lines for shading the bars. }
  \item{col.shading}{
    color for the vertical lines for shading. If \code{NA} heat colors are used.}
  \item{lty.shading}{
    line type for the vertical lines for shading.}
  \item{pcol.data}{ color of data points.}
  \item{cex.data}{ character size of plotting character.}
  \item{pch.data}{ plotting character of data points.}
  \item{lwd.data}{ line width for segments between data points.}
  \item{col.data}{ color for segments between data points.}
  \item{permutation}{ if not \code{FALSE} a permutation of the data set is erformed.}
  \item{xlab}{     text for y axis. }
  \item{xlim}{     range of x. }
  \item{ylim}{     range of y. }
  \item{new.plot}{    logical. If \code{TRUE} a new plot is constructed.}
  \item{bty}{     box type, used by \code{plot}. }
  \item{\dots}{     further graphical parameters passed to plot. }
}
\details{
  \code{skyline.hist} computes several histograms and plots them one upon
  the other. The histograms differ in the positions of the first cells, 
  but all cells have the same width. The parameters \code{n.class} and
  \code{n.hist} have the greatest effect on the design of the result. 
  \code{col.border} allows to color the border of the rectangular boxes of the 
  histogram bars. \code{col.bars} defines the fill color of the bars. 
  \code{n.shading} defines the number of vertical lines of type
  \code{lty.shading} and width \code{lwd.shading} that are drawn within the boxes. 
  Another feature of \code{skyline.hist} is to represent the data points.
  The data points of a cell are plotted according their x-values and
  their ranks (within the points of the cell). The resulting points are connected
  by line segments and you will see a time series running from bottom to top
  in each cell. The points and lines can be specified by \code{pcol.data},
  \code{cex.data}, \code{pch.data}, \code{lwd.data}, \code{col.data}. To get rid 
  of the original order of the data you can permutated them (\code{permutation=1}).
  The "skyline" of the plot may be similar to the skyline of a town and the 
  vertical lines may look like small windows of buildings.
  In Young et. al. you find "shaded histograms". These histograms have triggered
  the idea of \code{skyline.hist} and the representation of a one dimensional 
  data set by laying histograms on top of otheroverlied histograms.
}
\value{
  The result of a call of hist is returned.
}
\references{
  F.W. Young, R.M. Valero-Mora, M. Friendly (2006): Visual Statistics. 
  Wiley, p207--208.
}
\author{
  Peter Wolf, pwolf@wiwi.uni-bielefeld.de
}
 \seealso{
   \code{\link{hist}}, \code{\link{density}}
}
\examples{
  # dev.off()
print(par())
  par(mfrow=c(1,1))
  for(n.c in c(2,4,8)){  # some values for n.class
    for(n.h in c(2,4,3)){# some values for number of n.hist
        n.s <- 9         # value for number of vertical lines
        skyline.hist(co2, n.shading = n.s, n.hist = n.h ,n.class = n.c, 
                     night = n.h==3, col.border = n.h!=4)
    }
  }
  par(mfrow = c(1,1))
  skyline.hist(x=rivers, n.class=4, n.hist=2, n.shading=0, main="rivers",
             cex.data=.5, lwd.data = .2, col.data = "green", pcol.data = "red",
             col.border=NA, night=FALSE, ylab="density")
  skyline.hist(x=rivers, n.class=4, n.hist=5, n.shading=0, main="rivers",
             cex.data=.5, lwd.data = 1, col.data = "green", pcol.data = "red",
             col.border=NA, night="blue" , ylab="density", col.bars =NA)
  skyline.hist(x=rivers, n.class=10, n.hist=2, n.shading=0, main="rivers",
             cex.data=.5, lwd.data = 1, col.data = "green", pcol.data = "red",
             col.border=NA, night=FALSE , ylab="density", col.bars = "lightblue")
  skyline.hist(x=rivers, n.class=10, n.hist=1, n.shading=0, main="rivers",
             cex.data=1, lwd.data = 0, col.data = "green", pcol.data = "red",
             col.border=NA, night=FALSE , ylab="density", col.bars = "lightblue" )
  skyline.hist(x=rivers, n.class=6, n.hist=1, n.shading=0, main="rivers",
             cex.data=0.1, lwd.data = 2, col.data = "red", pcol.data = "green",
             night="orange" , ylab="density", col.bars = "white", col.border=1 )
  skyline.hist(x=rivers, n.class=6, n.hist=1, n.shading=0, main="rivers",
             cex.data=0.1, lwd.data = 2, col.data = "red", pcol.data = "green",
             col.border=NA, night=FALSE , ylab="density", col.bars = "lightblue")
  skyline.hist(x=rivers, n.class=6, n.hist=1, n.shading=5, col.shading = "blue",
             main="rivers",
             cex.data=0.1, lwd.data = 1, col.data = "black", pcol.data = "green",
             col.border=NA, night=FALSE , ylab="density", col.bars = "green")
  skyline.hist(x=rivers, n.class=6, n.hist=3, n.shading=5, col.shading = "blue",
             main="rivers", col.bars = "green",
             cex.data=0.1, lwd.data = 1, col.data = "black", pcol.data = "green",
             col.border="white", night="magenta" , ylab="density")
  skyline.hist(x=rivers, n.class=6, n.hist=4, n.shading=5, col.shading = "blue",
             main="rivers",
             cex.data=0.8, lwd.data = 1, col.data = "blue", pcol.data = "red",
             col.border=NA, night=FALSE , ylab="density", col.bars = "green")
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ misc }
\keyword{ hplot }

\name{stem.leaf}
\alias{stem.leaf}
\alias{stem.leaf.backback}

\title{stem and leaf display and back to back stem and leaf display}
\description{
  Creates a classical ("Tukey-style") stem and leaf display / back-to-back stem and leaf display.
}

\usage{
stem.leaf(data, unit, m, Min, Max, rule.line = c("Dixon", "Velleman", "Sturges"),
    style = c("Tukey", "bare"), trim.outliers = TRUE, depths = TRUE,
    reverse.negative.leaves = TRUE, na.rm = FALSE, printresult = TRUE)
stem.leaf.backback(x,y, unit, m, Min, Max, rule.line = c("Dixon", "Velleman", 
    "Sturges"), style = c("Tukey", "bare"), trim.outliers = TRUE, 
    depths = TRUE, reverse.negative.leaves = TRUE, na.rm = FALSE,
    printresult=TRUE, show.no.depths = FALSE, add.more.blanks = 0,
    back.to.back = TRUE)
}
\arguments{
  \item{data}{a numeric vector of data}
  \item{x}{first dataset for \code{stem.leaf.backback}}
  \item{y}{first dataset for \code{stem.leaf.backback}}
  \item{unit}{leaf unit, as a power of 10 (e.g., \code{100}, \code{.01});
    if \code{unit} is missing \code{unit} is choosen by \code{stem.leaf}.}
  \item{m}{number of parts (1, 2, or 5) into which each stem will be separated;
  if \code{m} is missing the number of parts/stem 
  (\code{m}) is choosen by \code{stem.leaf}.}
  \item{Min}{smallest non-outlying value; omit for automatic choice.}
  \item{Max}{largest non-outlying value; omit for automatic choice.}
  \item{rule.line}{the rule to use for choosing the desired number of lines
    in the display; \code{"Dixon"} = 10*log10(n); \code{"Velleman"} = 2*sqrt(n);
    \code{"Sturges"} = 1 + log2(n); the default is \code{"Dixon"}.}
  \item{style}{\code{"Tukey"} (the default) for "Tukey-style" divided stems;
    \code{"bare"} for divided stems that simply repeat the stem digits.}
  \item{trim.outliers}{if \code{TRUE} (the default), outliers are placed on \code{LO} and
    \code{HI} stems.}
  \item{depths}{if \code{TRUE} (the default), print a column of "depths" to the left of the
    stems; the depth of the stem containing the median is the stem-count enclosed in
    parentheses.}
  \item{reverse.negative.leaves}{if \code{TRUE} (the default), reverse direction the leaves on negative
    stems (so, e.g., the leaf 9 comes before the leaf 8, etc.).}
  \item{na.rm}{ if TRUE "NA" values are removed otherwise the number of NAs are counted.}
  \item{printresult}{ if TRUE output of the stem and leaf display by \code{cat}.}
  \item{show.no.depths}{ if TRUE no depths are printed.}
  \item{add.more.blanks}{ number of blanks that are added besides the leaves.}
  \item{back.to.back}{ if FALSE two parallel stem and leaf displays are constructed.}
}

\details{
  Unlike the \code{stem} function in the \code{base} package, \code{stem.leaf} produces
  classic stem-and-leaf displays, as described in Tukey's \emph{Exploratory Data Analysis}.
  The function \code{stem.leaf.backback} creates back-to-back stem and leaf displays.
}

\value{
  The computed stem and leaf display is printed out.
  Invisibly \code{stem.leaf} returns the stem and leaf
  display as a list containing the elements
  \code{info} (legend), \code{display} (stem and leaf display as character vecter), 
  \code{lower} (very small values), \code{upper} (very large values), \code{depths} (vector of depths), 
  \code{stem} (stem information as a vector), and \code{leaves} (vector of leaves).
}
\references{
    Tukey, J.
    \emph{Exploratory Data Analysis.}
    Addison-Wesley, 1977.
    }

\author{Peter Wolf, the code has been slightly modified by John Fox \email{jfox@mcmaster.ca}
    with the original author's permission, help page written by John Fox, 
    the help page has been slightly modified by Peter Wolf.}

\seealso{\code{\link[graphics]{stem}}}

\examples{
stem.leaf(co2)
stem.leaf.backback(co2[1:120],co2[121:240])
stem.leaf.backback(co2[1:120],co2[121:240], back.to.back = FALSE)
stem.leaf.backback(co2[1:120],co2[121:240], back.to.back = FALSE,
                   add.more.blanks = 3, show.no.depths = TRUE)
stem.leaf.backback(rivers[-(1:30)],rivers[1:30], back.to.back = FALSE, unit=10, m=5, 
                   Min=200, Max=900, add.more.blanks = 20, show.no.depths = TRUE)
}

\keyword{misc}

\name{slider.brush}
\title{interactive brushing functions}
\alias{slider.brush.pairs}
\alias{slider.brush.plot.xy}

\description{
  These functions compute a pairs plot or a simple xy-plot and
  open a slider control widget for brushing. 

  \code{slider.brush.pairs} computes a pairs plot; the user defines an
  interval for one of the variables and in effect all data points 
  in this interval will be recolored.

  \code{slider.brush.plot.xy} computes an xy-plot; the user defines a
  interval for a third variable \code{z} and all points 
  \code{(x,y)} will be recolored red if the \code{z} value is in the interval.
}
\usage{
  slider.brush.pairs(x, ...)
  slider.brush.plot.xy(x, y, z, ...)
}
\arguments{
  \item{\dots}{ new settings for global graphics parameters }
  \item{x}{ matrix or data frame or vector }
  \item{y}{ vector of y values if \code{x} is not a matrix }
  \item{z}{ vector of z values if \code{x} is not a matrix }
}
\details{
  \code{slider.brush.pairs} draws a pairs plot of the data set \code{x}.
  The first slider defines the lower limit of the interval and the
  second its width. By the third slider a variable is selected.
  All data points for which the selected variable is in the interval
  are recolored red.

  \code{slider.brush.plot.xy} draws an xy-plot of the data set \code{x}.
  The first slider defines the lower limit of the interval of z values 
  and the second one its width. All data points for which the variable z
  is in the interval are recolored red.
}
\value{
  a message about the usage
}
\references{ W. S. Cleveland, R. A. Becker, and G. Weil. The Use of
  Brushing and Rotation for Data Analysis. InW. S. Cleveland
  and M. E. McGill, editors, Dynamic Graphics for
  Statistics. Wadsworth and Brooks/Cole, Pacific Grove,
  CA, 1988. }
\author{ Hans Peter Wolf }
 \seealso{ \code{\link{pairs}}, \code{\link{plot}} }
\examples{
\dontrun{
## This example cannot be run by examples() but should be work in an interactive R session
  slider.brush.pairs(iris)
}
\dontrun{
## This example cannot be run by examples() but should be work in an interactive R session
  slider.brush.plot.xy(iris[,1:3])
}
}
\keyword{ iplot }

 \name{slider.stem.leaf}      
 \alias{slider.stem.leaf}
 \title{                                                                
   construction of stem and leaf display interactively
 }                                                                       
 \description{ 
   'slider.stem.leaf' computes a stem and leaf display within a 
   graphics device. The parameters are controlled by a control widget.
 }                                                                       
 \usage{                                                                
 slider.stem.leaf(x, main = main)                                        
 }                                                                       
\arguments{                                                            
   \item{x}{                                                            
   data set for plotting
 }                                                                       
   \item{main}{                                                         
   main title of the plot
 }                                                                       
 }                                                                       
 \details{                                                              
   The function 'slider.stem.leaf' allows the user to construct
   a stem and leaf display within a graphics device. The main parameters 
   will be set by a Tcl/Tk control widget. The line rule is selected
   by pressing one of the buttons 'Dixon', 'Sturges', 'Velleman'.
   A slider controls the separation of the stem.
   Additionally the character size device could be set. 
 }                                                                       
\value{                                                                
   a short message is returned
 }                                                                       
\author{                                                               
   Peter Wolf, Nov 2009
 }                                                                       
\note{                                                                 
   The function is a function of the package aplpack
 }  
 \seealso{\code{\link[graphics]{stem}}}
 \examples{     
 \dontrun{    
   slider.stem.leaf(islands)
 }
 }
\keyword{misc}                                                      

\name{slider.split.plot.ts}
\title{interactive splitting of time series}
\alias{slider.split.plot.ts}

\description{
  \code{slider.split.plot.ts} plots linear fitted lines or 
  summary statistics in sections of a time series. 
  The sections are controlled by sliders. 
}
\usage{
  slider.split.plot.ts(x, type="l", ...)
}
\arguments{
  \item{x}{ time series or vector}
  \item{type}{ plotting type: \code{type} will be forwarded to function \code{plot}}
  \item{\dots}{ additional graphics parameters }
}
\details{
  \code{slider.split.plot.ts} draws a time series plot and let you define 
  sections of the series by fixing a limit on the time scale as well as 
  a window width.
  The whole range of the series is partitioned in pieces of the same 
  length in a way that the fixed limit will be one of the section limits. 
  Then linear models are fitted and plotted in the sections.
  Alternatively -- by pressing the button \code{fivenum summary} -- 
  summary statistics are drawn instead of the model lines.

  The first slider fixes the width of the sections and 
  the second one the limit between two of them.

  By clicking on button \code{linear model} or \code{fivenum summary}
  the user switches between drawing model curves and five number summary.
}
\value{
  a message about the usage
}
\author{ Hans Peter Wolf }
 \seealso{ \code{\link{plot}} }
\examples{
\dontrun{
## This example cannot be run by examples() but should be work in an interactive R session
  slider.split.plot.ts(as.vector(sunspots)[1:100])
}
}
\keyword{ iplot }

\name{slider.zoom.plot.ts}
\title{interactive zooming of time series}
\alias{slider.zoom.plot.ts}

\description{
  This function shows one or two sections of a time series. The window(s) is 
  (are) controlled by sliders. 
}
\usage{
  slider.zoom.plot.ts(x, n.windows, ...)
}
\arguments{
  \item{x}{ time series }
  \item{n.windows}{ \code{if(n.windows>1} two sections are defined }
  \item{\dots}{ additional graphical parameters }
}
\details{
  \code{slider.zoom.plot.ts} plots the original time series and it lets you 
  select one or two sections of the series by fixing the width(s) and the 
  starting point(s) of the region(s). Then the section(s) of the series is (are)
  plotted separately one below the other.

  The first slider defines the width of the section(s). 
  The second (third) one sets the start of the first (second) section.
}
\value{
  a message about the usage
}
\author{ Hans Peter Wolf }
 \seealso{ \code{\link{plot}} }
\examples{
\dontrun{
## This example cannot be run by examples() but should be work in an interactive R session
  slider.zoom.plot.ts(co2,2)
}
}
\keyword{ iplot }

\name{spin3R}
\alias{spin3R}
\title{ spin3R }
\description{
  Simple spin function to rotate and to inspect 
  a 3-dimensional cloud of points
}
\usage{
  spin3R(x, alpha = 1, delay = 0.015, na.rm=FALSE)
}
\arguments{
  \item{x}{ \code{(nx3)}-matrix of points }
  \item{alpha}{ angle between successive projections }
  \item{delay}{ delay in seconds between two plots }
  \item{na.rm}{ if TRUE 'NA' values are removed otherwise exchanged by mean}
}
\details{
  \code{spin3R} computes two-dimensional projections 
  of \code{(nx3)}-matrix \code{x} and plots them
  on the graphics device. The cloud of points is rotated
  step by step. The rotation is defined by a tcl/tk control 
  widget. \code{spin3R} requires tcl/tk package of R.
}
\references{ 
   Cleveland, W. S. / McGill, M. E. (1988): Dynamic Graphics
   for Statistics. Wadsworth & Brooks/Cole, Belmont, California.
}
\author{ Peter Wolf }
\note{  version 05/2008 }
\seealso{ \code{spin} of S-Plus }
\examples{
  xyz<-matrix(rnorm(300),100,3)
  # now start:     spin3R(xyz) 
}
\keyword{misc}

\name{puticon}
\alias{puticon}
\title{
  Add Icon(s) to a Plot
}
\description{
  \code{puticon()} draws icons at the coordinates given by \code{x} and \code{y}. 
}
\usage{
  puticon(x = 0, y = 0, icon = "", grey.levels = 0.5, icon.cex = 10, 
          color = "red", ..., adj = c(0.5, 0.5), xpd = NA)
}
\arguments{
  \item{x, y}{
   numeric vectors of coordinates where to plot icon(s).
   If \code{x} is missing some information about internal icon 
   generators are printed or plotted. 
}
  \item{icon}{
   icon to use. There are several ways to define an icon:
   If \code{icon} is a file name with one of the extensions
   \code{c(".jpg", ".JPG", ".pnm", ".PNM", ".png", ".PNG")}
   \code{puticon()} tries to use the graphics file to plot the icon(s).
   To read \code{jpeg} and \code{png} files the functions \code{jpeg} 
   and \code{png} of the packages \code{jpeg} and \code{png} are called.
   Note: If an image file is defined by an internet link it is temporarily downloaded
   using \code{tempfile()} and \code{download.file()}.
   
   If \code{icon} is  a number a central symbol is plotted by invoking \code{points}.
   Remark: Usually the width of central symbols are a little bit smaller than
   \code{par()$cin[1]*0.75}. Therefore, it may be necessary to increase 
   \code{icon.cex} to get an icon of a suitable size.
   If \code{icon} is a raster graphics object this object is used as icon.
   If \code{icon} is a string and if it is the name of an in internal 
   icon generator (function) this generator is used to generate the icon(s). 
   In the moment the following generators are implemented:\cr
   \code{BI, TL, cross.simple, cross, circle.simple, circle, car.simple, car, nabla}, 
   \code{walkman, smiley.blueeye, smiley.normal, smiley, smiley.sad, mazz.man, bike},
   \code{bike2, heart, bend.sign, fir.tree, comet, coor.system}.
   If \code{icon} is a function it is used as an icon generating function.
} 
  \item{grey.levels}{
   An image from a file is transformed to a black-and-white picture. \code{grey.levels} 
   defines the grey levels of the black-and-white picture that are replaced 
   by \code{color}.
   If \code{grey.levels} is a single decimal number and is in (0,1) 
   the pixels with a level greater than \code{grey.levels} are recolored by \code{color}.
   If \code{grey.levels} consists of two decimal numbers lower 1 pixels with grey levels 
   lying in the interval are recolored by \code{color}.
   If \code{grey.levels} is an integer a vector of levels is created.
   If \code{grey.levels} is a vector and \code{all(grey.levels < 1)} \code{puticon} tries
   to different intensities of colors of \code{color} for recoloring pixels.
}
  \item{icon.cex}{
   size(s) of icon(s) in mm.  If \code{icon.cex < 1} it is interpreted as ratio 
   (width of icon) / (width of plotting area (\code{par()$pin[1]})) and is transformed to mm.
}
  \item{color}{
   color(s) to be used for the pictogram(s). \code{color} can be a color code or name, 
   for details see section \code{Color Specification} of the help of \code{par}.
}
  \item{\dots}{
   Further parameters to be passed to the icon generating function. 
}
  \item{adj}{
   \code{adj} one or two values usually lying in [0, 1] and which specify the x (and y) 
   adjustment of the icon(s).
}
  \item{xpd}{
   controls clipping. See help of \code{par} for further explainations.
}
}
\details{
   For details concerning icon generating function see the help of
   \code{iconplot()}. 
   If \code{puticon()} is called without argument \code{x} and \code{icon} 
   is an empty string a list of internal generators will be returned.  
   If \code{x} is missing  and \code{icon} is the name of an internal generator 
   a standardized version of the icon is plotted and the arguments 
   of the generator (function) are printed. 
}
\value{
   Usually \code{Null} is returned. However, if no coordinates are set and the name 
   of an internal generator is assigned to \code{icon} \code{puticon} returns the
   definition of the generator function. 
}
\references{
  under construction
}
\author{
  Peter Wolf
}
\note{
  Remark: the version of \code{puticon} of this package is an experimental version. 
  Therefore, in the future some of the features may be changed and it is not sure 
  that the function works as described on all types of graphics devices. 
  In case of errors feel free to write a mail.
  Additional information and examples are found on the web page\cr
  \url{http://www.wiwi.uni-bielefeld.de/lehrbereiche/statoekoinf/comet/wolf/wolf_aplpack}.
}
\seealso{
  \code{points}, \code{rasterImage}, \code{iconplot}
}
\examples{
  # representation of data set "trees" by plotting characters
  x <- trees[,1]; y <- trees[,2]; colors <- rainbow(100)[floor(trees[,3])]
  plot(x, y, type = "n")
  puticon(x, y, icon = 1, color = colors, icon.cex = 15, lwd = 6)
  for(i in seq(along = x)){
    puticon(x[i], y[i], icon = i - 25 * ( i > 25),
            color = "red", icon.cex = 7, lwd = 4)
  }
  # representation of data set "trees" by fir.tree icons
  x <- trees[,1]; y <- trees[,2]; colors <- rainbow(100)[floor(trees[,3])]
  plot(x, y, type = "n")
  puticon(x, y, icon = "fir.tree", icon.cex = 10, color = colors, 
          height = y / 50, width = x / 10)
  # standardized design of icon generator "fir.tree" and its definition
  puticon( icon = "fir.tree" )
  # list of implemented icon generators / generator functions
  puticon()
  # demo of internal icon generator functions
  h <- puticon(); n <- length(h); y <- 1 + ((1:n)-1) %% 12
  plot(1:n, xlim = c(0, n + 4), ylim = c(0, n / 2 + 4), type = "n")
  for(i in 1:n) 
    puticon(i, y[i] + (0:1), h[i], icon.cex = 3 + (1:2) , color = 3:4)
  text(1:n - 0.3, y - 1, h, adj = c(0, 0.5))
  # some smileys and Bielefeld logos of different colors and different sizes
  plot(1:100, type = "n")
  n <- 15; set.seed(26); x <- seq(10, 90, length = n); y <- runif(n, 10, 90)
  sizes <- 5 + (1:n) / 4; my.color = rainbow(n); h <- 2 + (1:n)^0.5
  puticon(x, y, icon = "BI", icon.cex = sizes, color = my.color)
  puticon(x + h, y + h, icon = "smiley", color = my.color, icon.cex = sizes)
  
  # icons with some letters
  n <- 150; plot(1:n, 1:n, type = "n", xlab ="", ylab = "")
  x <- runif(n, 1, n); y <- runif(n, 1, n); colors <- sample(rainbow(n))
  for(i in 1:n) 
    puticon(x[i], y[i], icon = "TL", icon.cex = 20, 
            shiftY = runif(1, -10, 10), color = colors[i],
            L = paste(sample(letters, sample(1:5, size = 1)), collapse = ""))  
  # a modern painting
  plot(1:20, xlim = c(-7,22), ylim = c(-7,22), type = "n", axes = FALSE, 
     xlab ="", ylab = "")
  rect(-7, -7, 22, 22, col = "gray")
  n <- 100; set.seed(13); colors <- sample(rainbow(n)); CEX <- sort(runif(n, 2, 21))
  for(i in 1:n){
    icon <- c("cross.simple", "cross", "circle.simple", "circle")[[sample(1:4, 1)]]
    puticon(runif(1, -5,20),  runif(1, -5, 20), icon, 
            icon.cex = CEX[i], z = runif(1, 0.20, 0.45), 
            whole = runif(1, 0.1, 0.6), color = colors[i])
  }
  
  # Traveller plot proposed by M. Mazziotta and A. Pareto.
  #   M. Mazziotta, A. Pareto (2016): 
  #   Non-compensatory Aggregation of Social Indicaters: An Icon Representation.
  #   url{http://link.springer.com/chapter/10.1007/978-3-319-05552-7_33}
  Mazzi.Pareto <- 
   structure(list(Region = c("Piemonte", "Valle d'Aosta", "Lombardia",  
   "Trentino-Alto Adige", "Veneto", "Friuli-Venezia Giulia", "Liguria", 
   "Emilia-Romagna", "Toscana", "Umbria", "Marche", "Lazio", "Abruzzo", 
   "Molise", "Campania", "Puglia", "Basilicata", "Calabria", "Sicilia", 
   "Sardegna"), Mean = c(98.74, 104.07, 101.38, 106.1, 104.38, 105.55,  
   102.76, 103.62, 101.84, 103.52, 102.05, 97.88, 102.9, 91.43,         
   94.12, 96.78, 93.55, 92.59, 96.29, 100.45), Penalty = c(0.43,        
   4.23, 0.64, 0.63, 0.77, 0.34, 0.29, 0.46, 0.27, 0.22, 0.15, 0.82,    
   1.3, 1.02, 0.37, 0.21, 2.37, 0.51, 0.31, 0.76), MPI = c(98.3,        
   99.84, 100.74, 105.47, 103.61, 105.21, 102.47, 103.16, 101.57,       
   103.3, 101.9, 97.06, 101.6, 90.42, 93.75, 96.58, 91.18, 92.08,       
   95.98, 99.69)), .Names = c("Region", "Mean", "Penalty", "MPI"        
   ), row.names = c(NA, -20L), class = "data.frame")
  plot(0, xlim = c(0.5, 4.5), ylim = c(0.83, 4.9), 
       axes = FALSE,xlab = "", ylab = "" )
  x <- rep(1:4,5) - 1; y <- rep(5:1, each = 4)
  puticon( x, y, "mazz.man", icon.cex = 15, color = 1,
           Mean = Mazzi.Pareto$Mean, Penalty = Mazzi.Pareto$Penalty, 
           Region = Mazzi.Pareto$Region, x.text = 70, y.text = -10 )
  # some cars 
  plot(1:1000, type = "n", axes = FALSE, xlab = "", ylab = "")
  n <- 200; set.seed(13); x <- runif(n, -100, 1100); y <- runif(n, -100, 1100)
  colors <- sample(rainbow(n))
  for( i in 1:n ){
    puticon(x[i], y[i], icon = "car", icon.cex = runif(1, 10, 20),
             width = runif(1, 0, 1), height = runif(1, 0, 1), color = colors[i])
  }
  # fuzzy scatter plots as icons
  plot(-30:120, -30:120, type = "n", axes = FALSE, xlab = "", ylab = "")
  set.seed(13)
  puticon(50, 50, icon = "coor.system", icon.cex = .8, color = "blue", 
          xxx = list(rnorm(20, 50, 15)), yyy = list(rnorm(100, 50, 15)*1000), 
          axes = TRUE)
  puticon(x = c(20, 100, 95), y = c(100, 110, -45), icon = "coor.system", 
          icon.cex = c(20, 30), color = c("green", "red", "magenta"),
          xxx = list(c(30, 50, 70), c(10, 20), c(80, 90, 10)), 
          yyy = list(c(20, 60, 30), c(10, 20), c(10, 80, 90)), pcex = 10)
  # Marilyn Monroe or R icons via internet
  plot(1:20, type = "n",  axes = FALSE, xlab = "", ylab = "")
  f1 <- "http://www.radiopaula.cl/wp-content/uploads/2014/03/marilyn-monroe-3-andrew-fare.jpg"
  \dontrun{puticon(15, 17, icon = f1, icon.cex = 40, color = NA)}
  \dontrun{puticon( c(6, 9, 12, 15), c(15, 13, 11, 9), icon = f1, icon.cex = 20, 
     color = rainbow(4), grey.levels = 20)}
  \dontrun{puticon( 4,  8, icon = f1, icon.cex = 40, color = "green", grey.levels = c(0.5, 0.9))}
  \dontrun{puticon(10,  4, icon = f1, icon.cex = 40, color = "blue",  grey.levels = c(0.0, 0.6))}
  plot(1:20, type = "n",  axes = FALSE, xlab = "", ylab = "")
  f1 <- "https://developer.r-project.org/Logo/Rlogo-4.png"
  \dontrun{puticon(15, 17, icon = f1, icon.cex = 40, color = NA)}
  \dontrun{puticon( c(6, 9, 12, 15), c(15, 13, 11, 9), icon = f1, icon.cex = 20, 
     color = rainbow(4), grey.levels = 20)}
  \dontrun{puticon( 4,  8, icon = f1, icon.cex = 40, color = "green", grey.levels = c(0.5, 0.9))}
  \dontrun{puticon(10,  4, icon = f1, icon.cex = 40, color = "blue",  grey.levels = c(0.0, 0.6))}
  # simple raster graphics 
  plot(1:20, pch = 1:20) 
  puticon(1:20, sample(1:20), icon = 15, icon.cex = 20)
  image1 <- as.raster(  matrix( c(1,1,1,1,0,1,1,1,1), ncol = 3, nrow = 3))
  image2 <- as.raster(  matrix( c(0,1,0,1,0,1,0,1,0), ncol = 3, nrow = 3))
  image3 <- as.raster(  matrix( c(0,0,0,0,1,0,0,0,0), ncol = 3, nrow = 3))
  puticon( 7, 14,            icon = image1, icon.cex = .5, col = "orange")
  puticon( c(5, 10), c(5,5), icon = image2, icon.cex = c(.1, .2), color = 3:4)
  puticon( 17, 10,           icon = image3, icon.cex = .30, col = "yellow") 
  # demo "my.house" of writing a generator function to generate icons
  my.house <- function(col1 = 2, col2 = 3, col3 = 4){
    # initialize result object
    result <- NULL
    # compose object of type "polygon" consisting of 
    # x-, y-values and colors 
    x <- c(0, 1, 1, 0, 0, 1, 0.5,  0, 1) * 55 + 20
    y <- c(0, 0, 1, 1, 0, 1, 1.65, 1, 0) * 55 + 5
    res <- data.frame( x, y, color = col2)
    # add class "polygon" to the object and store it in "result"
    class(res) <- c(class(res), "polygon"); result <- c(result, list(res))
    # compose another object of type "polygon"
    res <- data.frame( x[c(1, 3, 4, 2)], y[c(1, 3, 4, 2)], color = col3)
    # add class "polygon" to the object and store it in "result"
    class(res) <- c(class(res), "polygon"); result <- c(result, list(res))
    n <- length(x)
    # compose object of type "segments" consisting of 
    # x1-, y1-, x2-, y2-values, line widths and colors 
    res <- data.frame( x[-n], y[-n], x[-1], y[-1], lwd.mm = 5, color = col1)
    # add class "segments" to the object and store it in "result"
    class(res) <- c(class(res), "segments"); result <- c(result, list(res))
    # output result object
    result
  }
  plot(1:100, type = "n")
  n <- 50; x <- runif(n, 10, 90); y <- runif(n, 10, 90)
  colors <- rainbow(n); sizes <- 5 + sample(1:n) / 2
  puticon(x, y, icon = my.house, icon.cex = sizes, 
          col1 = sample(colors), col2 = sample(colors), col3 = sample(colors) )
  # demo "my.star" of writing a generator function to generate icons
  my.star <- function(xx = 1:5, max.xx, star.txt = "..."){
    if(missing(max.xx)) max.xx <- max(xx)
    n <- length(xx); xx <- 50 * xx / max.xx
    colors <- rainbow(n); result <- NULL
    # compose object of type "segments" consisting of 
    # x1-, y1-, x2-, y2-values, line widths and colors 
    if( n > 1 ){
      x <- sin(2 * pi * (1:n) / n) * xx + 50
      y <- cos(2 * pi * (1:n) / n) * xx + 50
      res <- data.frame( 50, 50, x, y, lwd.mm = 2, color = colors)
    } else {
      res <- data.frame( 50, 50, x, y, width = 30, color = colors)
    }
    # add class "segments" to the object and store it in "result"
    class(res) <- c(class(res), "segments"); result <- c(result, list(res))
    # compose object of type "text" consisting of 
    # x-, y-values, text, sizes of the text and colors 
    res <- data.frame( 85, 20, txt = star.txt, t.cex.mm = 20, color = "blue")
    # add class "text" to the object and store it in "result"
    class(res) <- c(class(res), "text"); result <- c(result, list(res))
    # output result object
    result  
  }
  plot(1:100, type = "n")
  for(i in 1:10){
    puticon( runif(1, 0, 100), runif(1, 0, 100), icon = my.star, icon.cex = 20, 
             xx = list(runif(14, 2, 10)), max.xx = 10, star.txt = letters[i])
  }
}
\keyword{ graphics }

\name{slider}
\alias{slider}
\alias{gslider}
%- Also NEED an '\alias' for EACH other topic documented here.
%-  cp slider2.Rd /home/pwolf/work/relax/install.dir/relax/man/slider.Rd
\title{slider / button control widgets}
\description{
  \code{slider} and \code{gslider} construct a Tcl/Tk-widget with sliders and buttons to
  demonstrate the effects of variation of parameters on calculations and plots. 
}
\usage{
slider(sl.functions, sl.names, sl.mins, sl.maxs, sl.deltas, sl.defaults, but.functions,
  but.names, no, set.no.value, obj.name, obj.value, reset.function, title, prompt=FALSE,
  sliders.frame.vertical=TRUE)

gslider(sl.functions, sl.names, sl.mins, sl.maxs, sl.deltas, sl.defaults, but.functions,
  but.names, no, set.no.value, obj.name, obj.value, reset.function, title, prompt=FALSE,
  sliders.frame.vertical=TRUE, hscale=1, vscale=1,
  pos.of.panel = c("bottom","top","left","right")[1])
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{sl.functions}{set of functions or function connected to the slider(s)}
  \item{sl.names}{labels of the sliders}
  \item{sl.mins}{minimum values of the sliders' ranges}
  \item{sl.maxs}{maximum values of the sliders' ranges}
  \item{sl.deltas}{change of step per click}
  \item{sl.defaults}{default values for the sliders}
  \item{but.functions}{function or list of functions
          that are assigned to the button(s)}
  \item{but.names}{labels of the buttons}
  \item{no}{\code{slider(no=i)} requests slider \code{i}}
  \item{set.no.value}{\code{slider(set.no.value=c(i,val))} sets slider \code{i} to value \code{val}}
  \item{obj.name}{\code{slider(obj.name=name)} requests the value of 
  variable \code{name} from environment \code{slider.env}}
  \item{obj.value}{\code{slider(obj.name=name,obj.value=value)} assigns \code{value}
  to variable \code{name} in environment \code{slider.env}}
  \item{reset.function}{function that induce a \code{reset.button} and 
        contains the commands of it.}
  \item{title}{title of the control window}
  \item{prompt}{ if TRUE slider functions are called by moving a slider,
                 if FALSE slider functions are called after releasing the mouse button}
  \item{sliders.frame.vertical}{ if TRUE the sliders are stacked one above the other;
                 otherwise they are positioned side by side }
  \item{hscale}{horizontal scale factor for image size; compare tkrplot in package tkrplot}
  \item{vscale}{vertical scale factor for image size; compare tkrplot in package tkrplot}  
  \item{pos.of.panel}{position of the panel field for sliders and buttons. 
                      Value of \code{pos.of.panel}: bottom, top, left or right.}
}
\details{
  \code{slider} constructs a separated panel for controlling the parameters whereas 
  \code{gslider} integrates a graphical device and buttons and sliders within one window. 

  The following actions can be done:
  a) definition of (multiple) sliders and buttons, 
  b) request or specification of slider values, and
  c) request or specification of variables in the environment \code{slider.env}.
  The management takes place in the environment \code{slider.env}. If \code{slider.env}
  is not found it is generated.

  \bold{Definition} ... of sliders: First of all you have to define sliders, buttons and the attributes of them.
  Sliders are established by six arguments:
  \code{sl.functions, sl.names, sl.minima, sl.maxima,sl.deltas}, and \code{sl.defaults}.
  The first argument,
  \code{sl.functions}, is either a list of functions or a single function that 
  contains the commands for the sliders.
  If there are three sliders and slider 2 is moved with the mouse the function stored in
  \code{sl.functions[[2]]} (or in case of one function for all sliders the function \code{sl.functions})
  is called.

  \bold{DEFINITION} ... of buttons: Buttons are defined by a vector of labels \code{but.names} and a list of functions:
  \code{but.functions}. If button \code{i} is pressed the function stored in \code{but.functions[[i]]} is called.

  \bold{REQUESTING} ... a slider: 
  \code{slider(no=1)} returns the actual value of slider 1,
  \code{slider(no=2)} returns the value of slider 2, etc. 
  You are allowed to include expressions of the type
  \code{slider(no=i)} in functions describing the effect of
  sliders or buttons.

  \bold{SETTING} ... a slider: \code{slider(set.no.value=c(2,333))} sets slider \code{2} to value 333.
  \code{slider(set.no.value=c(i,value))} can be included in the functions 
  defining the effects of moving sliders or pushing buttons.

  \bold{VARIABLES} ... of the environment \code{slider.env}: Sometimes information
  has to be trransferred back and forth between functions defining the effects of sliders and buttons.
  Imagine for example two sliders: one to control \code{p} and another one to control \code{q},
  but they should satisfy: \code{p+q=1}. Consequently, you have to correct the value of the first slider
  after the second one was moved. To prevent the creation of  global 
  variables store them in the environment \code{slider.env}.
  Use \code{slider(obj.name="p.save",obj.value=1-slider(no=2))}
  to assign value  \code{1-slider(no=2)} to the variable \code{p.save} .
  \code{slider(obj.name=p.save)} returns the value of variable \code{p.save}.

  \bold{Dependencies} The function \code{gslider} depends on package \code{tkrplot}.
}
\value{
 Using \code{slider} in definition mode \code{slider} returns the value of new created the top level widget. 
  \code{slider(no=i)} returns the actual value of slider \code{i}.
  \code{slider(obj.name=name)} returns the value of variable \code{name} in environment \code{slider.env}.
 \code{gslider} return in definition mode the result of \code{tkrplot} which was called to construct the widget.
}
\author{Hans Peter Wolf}

\examples{

# example 1, sliders only
if(interactive()){
## This example cannot be run by examples() but should work in an interactive R session
plot.sample.norm<-function(){
 refresh.code<-function(...){
   mu<-slider(no=1); sd<-slider(no=2); n<-slider(no=3)
   x<-rnorm(n,mu,sd)
   plot(x)
 }
 slider(refresh.code,sl.names=c("value of mu","value of sd","n number of observations"),
       sl.mins=c(-10,.01,5),sl.maxs=c(+10,50,100),sl.deltas=c(.01,.01,1),sl.defaults=c(0,1,20))
}
plot.sample.norm()
}

# example 2, sliders and buttons
if(interactive()){
## This example cannot be run by examples() but should work in an interactive R session
plot.sample.norm.2<-function(){
 refresh.code<-function(...){
   mu<-slider(no=1); sd<-slider(no=2); n<-slider(no=3)
   type=  slider(obj.name="type")
   x<-rnorm(n,mu,sd)
   plot(seq(x),x,ylim=c(-20,20),type=type)
 }
 slider(obj.name="type",obj.value="l")
 slider(refresh.code,sl.names=c("value of mu","value of sd","n number of observations"),
       sl.mins=c(-10,.01,5),sl.maxs=c(10,10,100),sl.deltas=c(.01,.01,1),sl.defaults=c(0,1,20),
       but.functions=list(
              function(...){slider(obj.name="type",obj.value="l");refresh.code()},
              function(...){slider(obj.name="type",obj.value="p");refresh.code()},
              function(...){slider(obj.name="type",obj.value="b");refresh.code()}
       ),
       but.names=c("lines","points","both"))
}
plot.sample.norm.2()
}

# example 2a, sliders and buttons and graphics in one window
if(interactive()){
## This example cannot be run by examples() but should work in an interactive R session
plot.sample.norm.2<-function(){
 refresh.code<-function(...){
   mu<-slider(no=1); sd<-slider(no=2); n<-slider(no=3)
   type=  slider(obj.name="type")
   x<-rnorm(n,mu,sd)
   plot(seq(x),x,ylim=c(-20,20),type=type)
 }
 slider(obj.name="type",obj.value="l")
 gslider(refresh.code,sl.names=c("value of mu","value of sd","n number of observations"),
       sl.mins=c(-10,.01,5),sl.maxs=c(10,10,100),sl.deltas=c(.01,.01,1),sl.defaults=c(0,1,20),
       but.functions=list(
              function(...){slider(obj.name="type",obj.value="l");refresh.code()},
              function(...){slider(obj.name="type",obj.value="p");refresh.code()},
              function(...){slider(obj.name="type",obj.value="b");refresh.code()}
       ),
       but.names=c("lines","points","both"))
}
plot.sample.norm.2()
}

# example 3, dependent sliders
if(interactive()){
## This example cannot be run by examples() but should work in an interactive R session
print.of.p.and.q<-function(){
 refresh.code<-function(...){
   p.old<-slider(obj.name="p.old")
   p<-slider(no=1); if(abs(p-p.old)>0.001) {slider(set.no.value=c(2,1-p))}
   q<-slider(no=2); if(abs(q-(1-p))>0.001) {slider(set.no.value=c(1,1-q))}
   slider(obj.name="p.old",obj.value=p)
   cat("p=",p,"q=",1-p,"\n")
 }
 slider(refresh.code,sl.names=c("value of p","value of q"),
       sl.mins=c(0,0),sl.maxs=c(1,1),sl.deltas=c(.01,.01),sl.defaults=c(.2,.8))
 slider(obj.name="p.old",obj.value=slider(no=1))
}
print.of.p.and.q()
}

# example 4, rotating a surface
if(interactive()){
## This example cannot be run by examples() but should work in an interactive R session
R.veil.in.the.wind<-function(){
  # Mark Hempelmann / Peter Wolf
  par(bg="blue4", col="white", col.main="white", 
      col.sub="white", font.sub=2, fg="white") # set colors and fonts
  refresh.code<-function(...){
    samp        <- function(N,D) N*(1/4+D)/(1/4+D*N) 
    z<-outer(seq(1, 800, by=10), seq(.0025, 0.2, .0025)^2/1.96^2, samp) # create 3d matrix
    h<-100 
    z[10:70,20:25]<-z[10:70,20:25]+h; z[65:70,26:45]<-z[65:70,26:45]+h
    z[64:45,43:48]<-z[64:45,43:48]+h; z[44:39,26:45]<-z[44:39,26:45]+h
    x<-26:59; y<-11:38; zz<-outer(x,y,"+"); zz<-zz*(65<zz)*(zz<73)
    cz<-10+col(zz)[zz>0];rz<-25+row(zz)[zz>0]; z[cbind(cz,rz)]<-z[cbind(cz,rz)]+h
    theta<-slider(no=1); phi<-slider(no=2)
    persp(x=seq(1,800,by=10),y=seq(.0025,0.2,.0025),z=z,theta=theta,phi=phi, 
          scale=T, shade=.9, box=F, ltheta = 45,
          lphi = 45, col="aquamarine", border="NA",ticktype="detailed")   
  }
  slider(refresh.code, c("theta", "phi"), c(0, 0),c(360, 360),c(.2, .2),c(85, 270)  )
}
R.veil.in.the.wind()
}

}
\keyword{dynamic}% at least one, from doc/KEYWORDS
\keyword{iplot}% __ONLY ONE__ keyword per line

\name{faces}
\alias{faces}
\alias{plot.faces}
\title{    Chernoff Faces    }
\description{
     \code{faces} represent the rows of a data matrix by faces.
     \code{plot.faces} plots faces into a scatterplot.
}
\usage{
faces(xy, which.row, fill = FALSE, face.type = 1, nrow.plot, ncol.plot, 
    scale = TRUE, byrow = FALSE, main, labels, print.info = TRUE, 
    na.rm = FALSE, ncolors = 20, col.nose = rainbow(ncolors), 
    col.eyes = rainbow(ncolors, start = 0.6, end = 0.85), 
    col.hair = terrain.colors(ncolors), col.face = heat.colors(ncolors), 
    col.lips = rainbow(ncolors, start = 0, end = 0.2), 
    col.ears = rainbow(ncolors, start = 0, end = 0.2), plot.faces = TRUE, cex = 2) 
\method{plot}{faces}(x, x.pos, y.pos, face.type = 1, width = 1, height = 1, labels, 
        ncolors = 20, col.nose = rainbow(ncolors), col.eyes = rainbow(ncolors, 
        start = 0.6, end = 0.85), col.hair = terrain.colors(ncolors), 
        col.face = heat.colors(ncolors), col.lips = rainbow(ncolors, 
        start = 0, end = 0.2), col.ears = rainbow(ncolors, start = 0, 
        end = 0.2), cex = 2, \ldots)
}
\arguments{
  \item{xy}{   \code{xy} data matrix, rows represent individuals and columns variables  }
  \item{which.row}{   defines a permutation of the rows of the input matrix   }
  \item{fill}{   \code{if(fill==TRUE)}, only the first \code{nc} attributes of the faces are
                  transformed, \code{nc} is the number of columns of \code{xy}   }
  \item{face.type}{  an integer between 0 and 2 with the meanings: 
                     0 = line drawing faces, 
                     1 = the elements of the faces are painted,
                     2 = Santa Claus faces are drawn }
  \item{nrow.plot}{   number of columns of faces on graphics device   }
  \item{ncol.plot}{   number of rows of faces   }
  \item{scale}{   \code{if(scale==TRUE)}, variables will be normalized   }
  \item{byrow}{   \code{if(byrow==TRUE)}, \code{xy} will be transposed   }
  \item{main}{   title   }
  \item{labels}{   character strings to use as names for the faces   }
  \item{print.info}{   if TRUE information about usage of variables for face elements are printed }
  \item{na.rm}{ if TRUE 'NA' values are removed otherwise exchanged by mean of data}
  \item{plot.faces}{   if \code{FALSE} no face is plotted  }
  \item{cex}{   size of labels of faces }
  \item{x}{ an object of class \code{faces} computed by \code{faces}   }
  \item{x.pos}{ x coordinates of positions of faces  }
  \item{y.pos}{ y coordinates of positions of faces  }
  \item{width}{ width of the faces }
  \item{height}{ height of the faces }
  \item{ncolors}{ number of colors in the palettes for painting the elements of the faces }
  \item{col.nose}{ palette of colors for painting the nose }
  \item{col.eyes}{ palette of colors for painting the eyes }
  \item{col.hair}{ palette of colors for painting the hair }
  \item{col.face}{ palette of colors for painting the face }
  \item{col.lips}{ palette of colors for painting the lips }
  \item{col.ears}{ palette of colors for painting the ears }
  \item{...}{ additional graphical arguments }
}
\details{
Explanation of parameters:
1-height of face,
2-width of face,
3-shape of face,
4-height of mouth,
5-width of mouth,
6-curve of smile,
7-height of eyes,
8-width of eyes,
9-height of hair,
10-width of hair,
11-styling of hair,
12-height of nose,
13-width of nose,
14-width of ears,
15-height of ears. 

For painting elements of a face the colors of are found by 
averaging of sets of variables: 
(7,8)-eyes:iris, (1,2,3)-lips, 
(14,15)-ears, (12,13)-nose, (9,10,11)-hair, (1,2)-face.

Further details can be found in the literate program of \code{faces}.
}
\value{
  list of two elements: The first element \code{out$faces} 
  is a list of standardized faces of \code{class faces},
  this object could be plotted by plot.faces;
  a plot of faces is created on the graphics device if 
  \code{plot.faces=TRUE}.
  The second list is short description of the effects of the variables.
}
\references{  Chernoff, H. (1973): The use of faces to represent statistiscal assoziation,
JASA, 68, pp 361--368.
The smooth curves are computed by an algorithm found in
Ralston, A. and Rabinowitz, P. (1985):
A first course in numerical analysis, McGraw-Hill, pp 76ff.
\url{http://www.wiwi.uni-bielefeld.de/lehrbereiche/statoekoinf/comet/wolf/wolf_aplpack}
   }
\author{   H. P. Wolf    }
\note{ version 01/2009   }

\seealso{   ---    }
\examples{

faces()
faces(face.type=1)

faces(rbind(1:3,5:3,3:5,5:7))

data(longley)
faces(longley[1:9,],face.type=0)
faces(longley[1:9,],face.type=1)

plot(longley[1:16,2:3],bty="n")
a<-faces(longley[1:16,],plot=FALSE)
plot.faces(a,longley[1:16,2],longley[1:16,3],width=35,height=30)

set.seed(17)
faces(matrix(sample(1:1000,128,),16,8),main="random faces")

a<-faces(rbind(1:3,5:3,3:5,5:7),plot.faces=FALSE)
plot(0:5,0:5,type="n")
plot(a,x.pos=1:4,y.pos=1:4,1.5,0.7)
# during Christmastime
faces(face.type=2)
}
\keyword{misc}

\name{iconplot}
\alias{iconplot}
\title{
  Icon Plots for Visualization of Contingency Tables
}
\description{
  An icon plot is a graphical representation of a contingency table.
  \code{iconplot(} computes a icon plot of a data matrix (matrix or data frame) or of 
  an object of class \code{table}. 
  Based on argument \code{grp.xy} the data set is split into groups.  Similarly the 
  graphics region is divided into panels.  Then the elements of the groups are 
  visualized within the associated panels.  
}
\usage{
  iconplot(data
 ,  grp.xy = 2 ~ 1                               
 ,  grp.color = NULL                             
 ,  grp.icon = NULL                               
 ,  colors                                    
 ,  icons                                      
 ,  vars.to.factors
 ,  panel.reverse.y = FALSE                      
 ,  panel.space.factor = 0.05                        
 ,  panel.prop.to.size = c(FALSE, FALSE)  
 ,  panel.margin = 0.03
 ,  panel.frame = TRUE                                   
 ,  panel.adjust = c(0.5, 0.5)
 ,  icon.horizontal = TRUE                        
 ,  icon.stack.type = c("lt", "lb", "rt", "rb")[1]
 ,  icon.cex = NA                                 
 ,  icon.aspect = 1                              
 ,  icon.stack.len = NA                           
 ,  icon.space.factor = 0.3 
 ,  icon.grey.levels = 2 
 ,  icon.frame = TRUE                         
 ,  icon.draft = TRUE                                 
 ,  lab.side = c("bl", "br", "tl", "tr")[1]      
 ,  lab.parallel = c(TRUE, TRUE)           
 ,  lab.cex = 1                                  
 ,  lab.boxes = 2                                
 ,  lab.color = c("#CCCCCC", "white")       
 ,  lab.type = c("expanded", "compact")[2] 
 ,  lab.n.max = c(20, 30)
 ,  lab.legend = c("cols","rows","skewed","horizontal","vertical")[2]
 ,  packer = c("icons", "numbers", "panel.legend", "stars")[1]   
 ,  panel.text =  NULL
 ,  mar = rep(1, 4)                            
 ,  main                                                  
 ,  verbose = !TRUE
 ,  ...)
}
\arguments{
  \item{data}{
    a data matrix, a data frame or an object of class \code{table}. 
    Note: If the column or dimension names are elements of the 
    following set of reserved names: \cr
    \code{.sign, .fraction, .color, .icon, .job.no, .x0, .x1, .y0, .y1}\cr
    strange results may occur; therefore, avoid these variable names. 
}
  \item{grp.xy}{
    a formula specifying how the data set is divided into groups and 
    defines in which panel an element of the data is represented. 
    The formula \code{y1 ~ x1} means that the data set is split
    according to the levels of the variables \code{y1} and \code{x1} into groups. 
    If \code{n.level.y1} and \code{n.level.x1} are the numbers of levels of the 
    two variables the plotting region is divided like a chessboard into 
    \code{n.level.y1} rows and \code{n.level.x1} columns. 
    In this way we get \code{n.level.y1 * n.level.x1} fields that are called panels.
    In each of the panels the elements of the associated group are represented 
    by pictogram elements or icons. 
 
    If the argument \code{grp.xy} hasn't been set by default the first variable 
    of the data set defines the grouping of the data along the x-axis and 
    the second one the grouping along the y-axis.
 
    Instead of variable names the indices of the variables can be used.
 
    The definition of recursive groupings is allowed and is expressed 
    by operator \code{"+"}:
    \code{y ~ 3 + 4} means that the horizontal range of the graphical region 
    is split twice: At first the segmentation of the region is computed 
    according to variable 3, in the second step the subranges of step 1 
    will be divided as a function of the levels of variable 4.
    
    A \code{"0"} on one side of the \code{~} character indicates that 
    no splitting of the correspondent region is desired.
}
  \item{grp.color}{
    defines how the data are grouped with respect to coloring. The name 
    of the variable used for coloring the icons (or pictogram elements) 
    has to be assigned to \code{grp.color}.
    \code{colors[i]} defines the color of the icon belonging to the level \code{i} 
    of the variable fixed by \code{grp.color}.
}
  \item{grp.icon}{
    defines how the data are grouped with respect the associated icon. 
    The name of the variable used for selecting symbols or icons has to be fixed 
    by argument \code{icons}. The symbol (icon) representing an observation 
    depends on its level of the variable specified by \code{grp.icon}. \cr
    If additional variables -- separated by a \code{+} character -- are found 
    the values of these variables will be used in the call of a icon
    generating function. For details see paragraph 'Details'.
}
  \item{colors}{
    set of colors used for pictogram elements.
}
  \item{icons}{
    defines the icons or the set of icons used by \code{iconplot}. 
    If \code{icons} is a vector \code{icons[i]} is used to represent the observations
    whose level of the variable fixed by \code{grp.icon} is \code{i}.
    There are some alternatives to define the icons or pictogram elements: \cr
    * default: 
      the default symbol is a rectangle.\cr
    * vector of numbers: 
      numbers specify plotting characters of the graphics system similar to 
      \code{points(..., pch = 13)}. \cr
    * list of raster images: 
      the images are used as icons. \cr
    * character vector: 
      \code{icons[i]} with an extension indicating a \code{pnm}, \code{ppm}, \code{jpg} or 
      \code{png} image file: \code{iconplot} tries to use the image of the file as icon.\cr
      Otherwise \code{icons[i]} is interpreted as the name of an internal icon generating 
      function.\cr
    * list of functions:
      \code{icons[i]} is interpreted as an icon generating function and is called to 
      compute the icon for level \code{i}.\cr
    * list of icon descriptions. For details see paragraph "Details".\cr
   Note: If an image file is defined by an internet link it is temporarily downloaded
   using \code{tempfile()} and \code{download.file()}.\cr
   Note: Mixtures of these alternative definition don't work usually. Therefore, it is
   recommended to use one type of definition only.
}
  \item{vars.to.factors}{
    controls the transformation of variables to factors. 
    If missing it is set to \code{TRUE} for each of the relevant variables.
    If \code{vars.to.factors} is a vector and if its elements don't have names
    the variables \code{1:length(vars.to.factors)} are transformed. \cr
    If \code{vars.to.factors} consists of named elements the names indicate 
    the variables to be transformed. \cr
    If \code{vars.to.factors[i] == FALSE} variable \code{i} will not be transformed. \cr
    If \code{vars.to.factors[i] == 1} variable \code{i} is transformed to a factor. \cr
    If \code{vars.to.factors[i] < 1} the range of variable \code{i} is cut into groups 
      in a way that we approximately get \code{round(1/vars.to.factors[i])} groups and 
      each of the groups approximately contain \code{100 * vars.to.factors[i]} percent 
      of the data.
    If \code{vars.to.factors[i] > 1} the range of variable \code{i} will be cut into 
      \code{floor(vars.to.factors[i])} subranges of equal size and 
      you get a factor variable with \code{floor(vars.to.factors[i])} levels.
}
  \item{panel.reverse.y}{
    logical, if \code{TRUE} the vertical axis is reversed.
}
  \item{panel.space.factor}{
    relative space inserted between the panels.
}
  \item{panel.prop.to.size}{
    a vector containing two elements which controls the sizes of the panels. 
    The first entry determines the widths of the panels and the second one their heights.\cr
    \code{panel.prop.to.size[1] == 0} means all panels are of the same width.  \cr
    If \code{panel.prop.to.size[2] == 0} the panels are of the same height. 
    A value of 1 indicates that sizes should be computed proportional to the 
    frequencies of the levels. 
    Otherwise the sizes of the panels are fixed proportional to: \cr
    \code{frequencies^panel.prop.to.size}.
}
  \item{panel.margin}{
    controls the margins around the regions of the panels.  If this argument is 
    a vector of length four the elements refer to the four sides of the plot: 
    bottom, left, top, and right. If this argument is set to \code{c(0, 0.1, 0.5, 0)}
    we get no additional margin below the panels and on the right-hand side. 
    However, there will be an upper margin of size \code{100 * 0.5} percent of 
    the height of the area containing the panels and a margin of size code{100 * 0.1} 
    percent of the width on the left-hand is provided. 
}
  \item{panel.frame}{
    logical, if \code{TRUE} a border line is drawn around each of the panels.
}
  \item{panel.adjust}{
    controls the adjustment of the panels within their regions.
    This argument modifies the internal coordinates and do usually not 
    change the appearance of the plot.
}
  \item{panel.text}{
    vector of strings. The text \code{panel.text[i]} is written into \code{panel[i]}. 
    The texts can be used for short describitions of the contents of the panels. 
    To get an idea of the numbering of the panels you can set \code{panel.text = 1:20}.
}
  \item{icon.horizontal}{
    logical, if \code{TRUE} the stacks of icons or pictogram elements are plotted 
    horizontally.  This argument effects the way how icons are put into the panels.
}
  \item{icon.stack.type}{
    defines the method of plotting the stacks of icons: 
    "r" or "l" are shortcuts for "right" or "left".
    "t", "b" correspond to "top" and "bottom", respectively. 
    Note: Fractional parts of frequencies are represented by smaller icons. 
    Adding the letter \code{"s"} (as a abbreviation for "shrinkage") to the argument 
    \code{icon.stack.type} both dimensions of the icons are reduced.
    If \code{icon.stack.type} is a vector its elements define the different types 
    of stacking for the panels.
}
  \item{icon.cex}{
    size of icons; this argument is similar to \code{cex} of \code{points()}.
}
  \item{icon.aspect}{
    aspect ratio of icons: width / height.
}
  \item{icon.stack.len}{
    maximal number of icons gathered to build a stack. If this length is decreased
    the number of stacks (rows or columns of icons) will increase.
} 
  \item{icon.space.factor}{
    relative space between two icons.
}
  \item{icon.grey.levels}{
    controls the coloring of icons of class raster or images. 
    If \code{icon.grey.levels} is of length 1 and if it is an integer 
    the argument defines the number of color- or grey-levels of the icons. 
    If \code{icon.grey.levels} consists of two or more 
    values between 0 and 1 they are interpreted as grey limits. 
    Level 0 represents \code{"black"}, and 1 indicates the maximal brightness.
    The default setting generates one color only (besides black and white).   
} 
  \item{icon.frame}{
    logical, if \code{TRUE} a border is drawn around each of the pictograms.
}
  \item{icon.draft}{
    logical, if \code{TRUE} raster images are generated by calling 
    \code{rasterImage()} with the setting \code{interpolate = TRUE}.
}
  \item{mar}{
    this argument is delivered to the graphics device via \code{par()} and manipulates 
    the margins of the plot.
}
  \item{main}{
    defines the title of the plot.
}
  \item{lab.side}{
    defines one or two sides that are used for margin information: 
    "l" indicates the "left" side, "b" identifies the "bottom"
    as well as "r" the "right" and "t" the "top" side.
}
  \item{lab.parallel}{
    logical, if \code{FALSE} margin labels are perpendicularly constructed to the axes. 
    If \code{lab.parallel} is a vector the first element is used 
    for controlling the labels of the bottom or top side and 
    the second one specifies the orientation of the y-labels. 
    If one elements is set to 0.5 the labels of the last \code{xy} grouping variable 
    are printed perpendicularly only.
}
  \item{lab.legend}{
    a character string indicating the kind of legend out of the vector \cr
    \code{c("cols", "rows", "skewed", "horizontal", "vertical")}. \cr
    Assigning a number of the set \code{1:5} to the argument is interpreted as an
    index of the set of the five types of legends.\cr
    \code{"cols"}: vertical legends, side by side at the bottom side of the plot. \cr
    \code{"rows"}: horizontal legends, line by line at the bottom side of the plot. \cr
    \code{"skewed"}: horizontal legends, line by line and the level names are rotated. \cr
    \code{"horizontal"}: horizontal legends, side by side at the bottom side of the plot.\cr
    \code{"vertical"}: vertical legends, line by line at the right side of the plot.
}
  \item{lab.cex}{
    sets the size of the characters of the labels and the legends.
}
  \item{lab.boxes}{
    defines the types of boxes around the margin labels: 
     \code{lab.boxes == 0}: no boxes are drawn. \cr
     \code{lab.boxes >= 1}: small boxes around the labels are drawn. \cr
     \code{lab.boxes >= 2}: big boxes around the labels are drawn. \cr
     \code{lab.boxes \%\% 1}: defines the size of the separation line 
     between the names of the variables and the names of the levels.
}
  \item{lab.color}{
     The first element defines the color of the box containing the names of variables or 
     levels in the margins. The second element sets the color of the separation line 
     between the variable names and the level names within the margins.
}
  \item{lab.type}{
     defines the design style of margin labeling: 
     "c" or "e" are shortcuts for "compact" or "expanded".
}
  \item{lab.n.max}{
    is an integer vector consisting of three elements. 
    The first element sets the number of characters 
    during printing the labels of the levels. The second element
    defines the maximal number of level names to be plotted in the margins.
    \code{lab.n.max[3]} limits the number of labels of the color- or icon-legend.
}
  \item{packer}{
    defines the packer(s) which are used to fill the panels. 
    If "icons" is an element of \code{packer} the observations will be represented 
    by icons, pictogram elements or symbols. \cr
    If the character string "numbers" is found in \code{packer} in each of the panels
    the numbers of its observations will be printed into the areas of the panels.\cr
    The packer "panel.legend" plots the level combinations into the panels.
    This may be a useful feature as long as the number of the panels is small.
    Otherwise the texts of level combinations will overlap each other. 
    The argument \code{cex} controls the size of the text strings.
}
  \item{verbose}{
    logical, if \code{TRUE} internal information is printed during the computation.
}
  \item{...}{
    arguments that will be passed to the graphics functions and suitable ones to 
    the icon generating functions.
}
} %%% end of arguments
\details{
  \code{iconplot()} constructs an icon plot of a data matrix and a contingency table.
  In an icon plot each observation of the data set is represented by a small symbol 
  or an image called pictogram or icon.  A cell of a contingency table is visualized 
  by a set of icons.  The icons of a cell are plotted within a rectangular region
  which we call panel and an icon plot consists of a lot of panels containing
  the icons of the cells.
 
  Similar to the layout of contingency tables the set of panels are arranged 
  in a grid-like manner.  Considering a high dimensional contingency table you can 
  concentrate on some of the variables and can construct suitable margin tables.
  Equivalently you can build a lot of icon plots to emphasize your viewpoint.
  By varying the actual arguments of \code{iconplot()} a huge set of appearances 
  of plots results and the nicest one for your purpose can be choosen.
  \code{table}, \code{matrix} or \code{data frames} can be used as data input   
  of \code{iconplot()}. Tables are allowed to have fractional or negative entries; 
  these cases may occur by computing the difference of two tables or by changing 
  the units of counting. Internally a table will be expanded to a data matrix. 
  Fractional numbers are coded in a data matrix by the additional column or variable 
  \code{.fraction}, to handle negative numbers the new variable \code{.sign} is added.
  
  The argument \code{grp.xy} of \code{iconplot} defines the variables used for grouping 
  and splitting the data dependent on the levels of the specified variables. 
  Each group is represented within a panel as stated above. Let's have a look at an example:
  Consider you have a 2x3 contigency table and would like to represent it by an icon plot.
  So a plot to be constructed should have 2x3 panels and the number of icons of the panels 
  should be given by the cell entries.  To get an icon plot with desired panel structure 
  you define the xy-grouping by \code{grp.xy = 1 ~ 2}. 
  This means: The data set has to be split according to the two levels of the first variable
  and the y-range of the plot has to be divided in two rows of panels. 
  On the other side the second variable defines the grouping concerning the 
  the x-range and three columns of panels appear.  As a result a icon plot is generated 
  that consists of six panels arranged in two rows and three columns.
  The panels of a fixed level of the first variable are placed side by side, 
  whereas the panels of a fixed level of the second variable are stacked one upon 
  the other and a layout known from a chessboard results. As an example try: 
  \code{x <- as.table(matrix(1:6, 2, 3)); iconplot(x, grp.xy = 1 ~ 2)}
  \code{grp.xy = 0 ~ 1 + 2} leads a double grouping on the
  x-axis and no vertical grouping. \code{grp.xy = 1 + 2 ~ 3 + 4} presums four or more
  variables and splits the graphics region twice along the x- and twice along 
  the y-direction.
  
  Within a panel the entry of one cell is represented. 
  Several arguments control the way how the icons are placed in a panel.
  The absolute size of the icons can be defined by \code{icon.cex}.
  \code{icon.aspect} fixes the aspect ratio of the pictograms (width / height).
  The elements in a panel are assembled into stacks; 
  the maximal length of these stacks can be set by \code{icon.stack.len}; 
  horizontal stacks are plotted if \code{icon.horizontal} is \code{TRUE}. 
  Framing icons and spacing between them is controlled by the arguments
  \code{icon.frame} and \code{icon.space.factor}. 
 
  The icons or pictogram elements may be colored dependent on the levels of a
  variable. The variable has to be established by argument \code{grp.color}. 
  A set of colors can be defined by argument \code{colors}. 
  Accordingly, the symbols or images are determined by \code{grp.icon} and \code{icons}.
 
  An icon or pictogram element can be generated by an icon generating function.
  The result of an icon generating function describes a standardized icon by a
  set of segments, polygons, splines and texts which are combined in a list.
  \code{segments}: \code{segments} are defined by a matrix or a data frame of 5 or 6 columns:
  Columns 1 to 4 keep the coordinates of the starting and ending points of the segments: 
  \code{x.0, y.0, x.1, y.1}.\cr  
  The 5th column contains the widths of the segments. 
  The coordinates and the widths have to be choosen in a way 
  that the icon fits pretty well into a plotting field of size 100mm x 100mm 
  assuming the coordinates of the world window defined by: \code{usr = c(0, 100, 0, 100)}.\cr
  If the 6th column is available it defines the coloring of the segments.  A value of "0" 
  codes the color "white" and the other values are interpreted as usually: "1" means "black" 
  and any other color is processed as \code{col} in \code{points}, for example. 
  An \code{NA} value instead of a color instructs \code{iconplot()} to color the segment 
  dependent on the associated level of the variable fixed by \code{grp.color}.
  Segment objects must have the class attribute \code{"segments"}.
 
  \code{polygon}: Polygons are defined by a matrix or data frame of 2 or 3 columns. 
  Colums 1 and 2 store the coordinates of the vertices of the polygon. 
  A third column fixes the coloring of the polygon. 
  The class attribute of this kind of element has to be set to \code{"polygon"}.
 
  \code{spline}: Splines are defined by a matrix or data frame of 3 or 4 columns. 
  Colums 1 and 2 store the coordinates of the points which form the basis of the spline. 
  The third column keeps the line width of the curve. The optional fourth column shows 
  how to color the spline. Splines are identified by class attribute \code{"spline"}.
 
  \code{text}: Text elements of a generated icon are defined by 
  a data frame of 3, 4 or 5 columns.
  The first two columns of the object store the coordinates of the positions of the text(s). 
  The third element stores the text information and 
  the fourth is used to set the size of the characters. 
  The fifth fixes the coloring of the text. 
  The class attribute of a text element is \code{"text"}.
  There are some internal icon generating functions. Here is a list of them: \cr
  \code{BI, TL, cross.simple, cross, circle.simple, circle, car.simple, car, nabla}, 
  \code{walkman, smiley.blueeye, smiley.normal, smiley, smiley.sad, mazz.man, bike},
  \code{bike2, heart, bend.sign, fir.tree, comet, coor.system}.
}
\value{  
  \code{iconplot()} returns a list consisting of three elements. The first element is 
  the matrix \code{jobs} whose lines show some attributes of the panels. 
  In a row of this matrix you find the number of the panel \code{.job.no} and 
  the location of the panel (in user coordinates: \code{xmins, xmaxs, ymins, ymaxs}).
  The second element is a copy of the modified data matrix which is used for 
  the construction of the icon plot: Besides the data delivered by the user
  there are columns showing the colors, icons and coordinates of the pictogram elements.
  The third element contains the output of \code{par()} and describes the graphics device 
  during the computation; this list differs from the parameter settings after leaving 
  \code{iconplot()} because the state of graphics parameter before calling \code{iconplot()}
  is restored.  These three lists may be helpful if you want to add further graphical elements 
  to the plot.
}
%\references{
%  under construction %% ~put references to the literature/web site here ~
%}
\author{
  Hans Peter Wolf
}
\note{
  Remark: the version of \code{iconplot} of this package is an experimental version. 
  Therefore, in the future some of the features may be changed and it is not sure 
  that the function works as described on all types of graphics devices. 
  In case of errors feel free to write a mail.
  Additional information and examples are found on the web page\cr
  \url{http://www.wiwi.uni-bielefeld.de/lehrbereiche/statoekoinf/comet/wolf/wolf_aplpack}.
}
%% ~Make other sections like Warning with \section{Warning }{....} ~
\seealso{
   \code{mosaicplot}, \code{pairs}, \code{puticon}
}
\examples{
# HairEyeColor data, grouping by color
iconplot(HairEyeColor, 
         grp.color         = 1, 
         grp.xy            = NULL, 
         colors            = c("black", "brown", "red", "gold"),
         icon.space.factor = 0, 
         icon.aspect       = 2,
         main = "grouping by color")
# HairEyeColor data, grouping by color and symbols
iconplot(HairEyeColor, 
         grp.icon          = "Sex", 
         grp.color         = "Hair", 
         grp.xy            = NULL, 
         colors            = c("black", "brown", "red", "gold"),
         icons             = 18:17,
         icon.frame        = FALSE, 
         lab.cex           = 0.8, 
         icon.space.factor = 0, 
         lab.parallel      = !FALSE,
         main = "grouping by color and icons")
# HairEyeColor data, grouping by x and color
iconplot(HairEyeColor, 
         grp.xy            = "0 ~ 1", 
         grp.color         = 2, 
         colors            = c("black", "brown", "red", "gold"),
         icon.stack.type   = "tr", 
         icon.space.factor = c(0, 0.4), 
         lab.cex           =0.7, 
         main = "grouping by x and by colors")
# 2-dim, 1 split in y, 1 split in x, grouping by color
iconplot(HairEyeColor, 
         grp.xy          = "1 ~ 3", 
         grp.color       = 2, 
         colors          = c("brown", "blue", "brown3", "green"),
         panel.frame     = FALSE,
         icon.stack.type = "bl",
         lab.cex         = 0.7, 
         main = "grouping by x and y and by colors")
# 3-dim, 2 splits in x, 1 split in x, margin labs on the right
iconplot(HairEyeColor, 
         grp.xy             = "2 ~ 1 + 3 ", 
         grp.color          = 2, 
         panel.space.factor = c(0, .1), 
         panel.margin       = c(.05,.03,.03,.01),
         icon.stack.type    = "lb", 
         icon.stack.len     = 7, 
         icon.frame         = FALSE,
         icon.space.factor  = .0, 
         lab.parallel       = c(TRUE, FALSE), 
         lab.color          = c("lightblue","green"),
         lab.side           = "br", 
         lab.boxes          = 0.2, 
         lab.type           = "compact", 
         lab.cex            = 0.8, 
         main = "grouping: 2~1+3 and by color, margin labs variations")
# 3-dim, 3 splits in y, icon.aspect = NA
iconplot(HairEyeColor, 
         grp.xy             = "3 + 2 ~ 1", 
         grp.color          = 3, 
         panel.margin       = 0, 
         panel.space.factor = 0.1, 
         icon.stack.type    = "lb", 
         icon.horizontal    = TRUE, 
         icon.stack.len     = 5, 
         icon.space.factor  = c(.1, .3), 
         icon.aspect        = NA, 
         icon.frame         = FALSE,
         lab.boxes          = 0.3, 
         lab.color          = "grey", 
         lab.side           = "tl",
         lab.parallel       = TRUE, 
         lab.cex            = 0.7, 
         lab.type           = "compact", 
         main = "grouping: 3 + 2 ~ 1 and by color")
# 3-dim, plotting characters as icons
data <- as.table(array(0:23, 2:4))
iconplot(data, 
         grp.xy          = 1 + 2 ~ 3, 
         grp.color       = 3, 
         grp.icon        = 2,
         icon.aspect     = 2, 
         icon.horizontal = TRUE, 
         icons           = 15:18,
         icon.stack.type = c("lb", "lt", "rb","rt")[3], 
         icon.frame      = FALSE,
         lab.cex         = .6, 
         lab.type        = "compact", 
         main = "1+2 ~ 3")
# 3-dim contingency table: panels of different sizes, 1 split in y, 2 in x
# packer numbers
\donttest{  ## because of computation time
iconplot(Titanic, 
         grp.xy             = 1~3+2, 
         grp.color          = 1, 
         packer             = c("icons", "numbers"), 
         panel.prop.to.size = 0.5, 
         panel.frame        = !TRUE, 
         panel.margin       = .01, 
         icon.aspect        = 0.15, 
         icon.stack.type    = "lt", 
         icon.space.factor  = 0.0,
         icon.frame         = FALSE,
         lab.side           = c("bl","br","tl","tr")[1], 
         lab.type           = "compact", 
         lab.cex            = 0.8, 
         lab.boxes          = 1.1, 
         lab.color          = "lightgreen",
         lab.parallel       = TRUE, 
         main = "different sizes of panels")
}
# 3-dim contingency table: panels of different sizes, 3 splits in y
\donttest{  ## because of computation time
iconplot(Titanic, 
         grp.xy             = "4 + 3 + 1 ~ 0" , 
         grp.color          = 4, 
         colors             = c("green", "red"), 
         packer             = c("icons", "numbers"), 
         panel.frame        = FALSE, 
         panel.margin       = .01,
         panel.prop.to.size = .3, 
         panel.space.factor = 0.05, 
         panel.reverse.y    = TRUE,
         icon.space.factor  = 0.5, 
         lab.side           = "l", 
         lab.type           = "compact",
         lab.parallel       = c(FALSE, TRUE), 
         lab.cex            = 0.7,
         main = "Titanic data, different sizes of panels")
}
#  3-dim contingency table: panels of different sizes 
\donttest{  ## because of computation time
iconplot(Titanic, 
         grp.xy             = "0 ~ 4 + 3 + 1 " , 
         grp.color          = 4, 
         colors             = c("green", "red"), 
         panel.frame        = FALSE, 
         panel.margin       = .01,
         panel.prop.to.size = .2, 
         panel.space.factor = 0.05, 
         panel.reverse.y    = TRUE,
         icon.space.factor  = 0.5, 
         lab.side           = "b", 
         lab.type           = "compact", 
         lab.boxes          = 0.2, 
         lab.parallel       = c(FALSE, TRUE), 
         lab.cex            = 0.6,
         lab.color          = c("lightblue"),
         main = "Titanic data, different widths of panels")
}
# 3-dim contingency table: panels of different sizes, 3 splits in x 
\donttest{  ## because of computation time
iconplot(Titanic, 
         grp.xy             = 3 + 2 ~ 1, 
         grp.color          = 2, 
         panel.prop.to.size = 0.66,
         icon.space.factor  = 0.4, 
         panel.space.factor = 0.1,
         lab.type           = "c", 
         lab.cex            = 0.7, 
         lab.boxes          = 1.2,
         lab.color          = c("lightblue"),
         main = "Titanic: panel.prop.to.size = 0.66")
}
# comparing iconplot and mosaic plot
# par(mfrow = 2:1)
iconplot(HairEyeColor, 
         grp.xy             = 2 ~ 1 + 3 , 
         lab.parallel       = c(TRUE, TRUE),
         colors             = "red", 
         panel.reverse.y    = TRUE, 
         panel.prop.to.size = TRUE,
         icon.space.factor  = 0.5, 
         icon.aspect        = 2,
         lab.cex            = .6, 
         lab.boxes          = 1, 
         lab.color          = "grey", 
         # lab.side           = "lt", 
         panel.margin       = c(0.00,.035,0.0,.050),
         main = 'HairEyeColor: grp.xy = 2 ~ 1 + 3')
mosaicplot(HairEyeColor)
# par(mfrow = c(1,1))
# relative frequences 
data <- as.table(Titanic / max(Titanic))
iconplot(data, 
         grp.xy             = 1 ~ 2 + 3, 
         grp.color          = 4, 
         panel.frame        = FALSE, 
         panel.space.factor = 0.05, 
         icon.horizontal    = !TRUE, 
         icon.space.factor  = 0.103, 
         icon.stack.type    = "b",
         icon.aspect        = 0.5,
         main = "Titanic: relative frequencies", colors = c("black", "green"))
# negative and fractional cell entries
\donttest{  ## because of computation time
data <- HairEyeColor; Exp <- margin.table(data, 1)
for( d in 2:length(dim(data)) ){
  Exp <- outer( Exp, margin.table(data, d) ) / sum(data)
}
Diff <- Exp - data
cat("observed:\n"); print(data)
cat("expected:\n"); print(round(Exp, 3))
cat("deviation: expected - observed:\n"); print(round(Diff,3))
iconplot(Diff, 
         grp.xy          = 1 + .sign ~ 2 + 3, 
         grp.color       = ".sign", 
         colors          = c( "red", "green"),
         panel.reverse.y = TRUE, 
         panel.frame     = FALSE,
         icon.stack.type = c("t","b"), 
         lab.boxes       = 1.2,  
         lab.color       = "lightgreen",
         main = "deviations from expectation: HairEyeColor")
}
# relative differences of expectations, split according sign
data <- margin.table(Titanic, c(2,1,4)); pT <- prop.table(data)
eT <- outer(outer(margin.table(pT,1), margin.table(pT,2)), margin.table(pT,3))
data <- as.table(pT - eT); data <- data / max(data)
iconplot(data, 
         grp.xy = Survived + Sex + .sign ~ Class, 
         grp.color          = ".sign", 
         panel.frame        = FALSE, 
         panel.reverse.y    = TRUE, 
         panel.space.factor = 0.05, 
         icon.horizontal    = !TRUE, 
         icon.stack.type    = rep(c("t","b"), 2), 
         icon.aspect        = 2, 
         icon.space.factor  = 0.1, 
         lab.boxes          = 1.2, 
         lab.color          = "lightgrey",
         main = "Titanic: difference to expectation")
# using a foto as icon, rentals of flats in Goettingen 2015/12
rentels <- 
 structure(list(Rooms = c(2, 3, 2, 2, 3, 2, 2, 3, 2, NA, 2, 2,            
 3, 4, 4, NA, 3, 2, 3, 2, 4, 2, 1, 2), qm = c(43.13, 86, 48, 66.62,        
 76, 49, 59, 97, 45, 87, 46.39, 71, 65, 100, 75, 178, 94.07, 56,           
 97, 70, 132, 43, 24, 48), Eur = c(365, 480, 480, 660, 500, 410,           
 440, 1200, 450, 696, 420, 710, 747.5, 1300, 450, 990, 900, 520,           
 1020, 1005, 924, 610, 375, 420)), class = "data.frame", 
 row.names = c(NA, 24L)) 
fname <- system.file("src", "tm1.jpg", package="aplpack") # fname <- "tm1.jpg" 
print(fname)
iconplot(rentels, 
         grp.xy              = Eur ~ qm, 
         vars.to.factors     = c(1, .5, .3),
         panel.frame         = FALSE, 
         panel.space.factor  = 0.2,
         panel.prop.to.size  = 0.7,
         icons               = fname, 
         icon.frame          = FALSE, 
         icon.space.factor   = 0.05,
         lab.parallel        = c(TRUE, TRUE), 
         lab.legend          = "cols",
         main = "rentels of flats in Goettingen 2015/12")
# size by .fractions, color by rooms
data <- cbind(rentels, .fraction = (rentels[,3] / max(rentels[,3]))^.5)
iconplot(data, 
         grp.xy             = Eur ~ qm, 
         grp.color          = Rooms, 
         vars.to.factors    = c(1,.5, .3),
         panel.frame        = FALSE,
         panel.space.factor = 0.1,
         panel.prop.to.size = 0.7,
         icons              = fname,
         icon.stack.type    = "s",  
         icon.frame         = FALSE,
         icon.space.factor  = 0.05, 
         lab.cex            = 0.8,
         main               = "size fby .fractions, color by rooms")
# jpg files as icons 
\donttest{  ## because of computation time
data <- as.table(Titanic[2:3,,,,drop=FALSE]) / 10
fname1 <- system.file("src", "walkman-r.jpg", package="aplpack") # fname1 <- "walkman-r.jpg"
fname2 <- system.file("src", "pw-esch.jpg", package="aplpack")   # fname2 <- "pw-esch.jpg"
p.set <- c(fname1, fname2)
iconplot(data, 
         grp.xy             = 2 ~ 3+1, 
         grp.color          = 1, 
         grp.icon           = 3, 
         icons              = p.set, 
         colors             = c("blue", "green"),
         panel.space.factor = 0.05, 
         panel.prop.to.size = c(.5, .5, 1),
         icon.aspect        = 1, 
         icon.space.factor  = .10, 
         icon.horizontal    = TRUE, 
         icon.draft         = FALSE,
         icon.stack.type    = c("lb", "lt", "rb","rt")[1], 
         icon.grey.levels   = list(2, 10), 
         lab.side           = "t", lab.cex = .7, 
         main = "walkman and pw icons, scaled subset of Titanic")
}
# files of different types as icons
\donttest{  ## because of computation time
fname3 <- system.file("src", "pw-esch.ppm", package="aplpack") # fname3 <- "pw-esch.ppm"
fname4 <- system.file("src", "pw-esch.png", package="aplpack") # fname4 <- "pw-esch.png"
p.set <- c(fname2, fname3, fname4)
iconplot(trees, 
         grp.xy             = Girth ~ Height, 
         grp.icon           = Height, 
         grp.color          = Volume, 
         vars.to.factors    = c(Volume = 4, Girth = 3, Height = 3), 
         panel.space.factor = 0.05, 
         panel.prop.to.size = c(.7, .45),
         panel.frame        = FALSE,
         icons              = p.set, 
         icon.cex           = 14,
         icon.grey.levels = 6, icon.space.factor   = 0.05 )
}
# using raster graphics objects as icons
data <- as.table(Titanic[1:2,,,,drop=FALSE])/10
image1 <- as.raster(  matrix( c(1,0,1,1,0,1,1,0,1), ncol = 3, nrow = 3))
image2 <- as.raster(  matrix( c(1,0,1,0,0,0,1,0,1), ncol = 3, nrow = 3))
iconplot(data, 
         grp.xy            = 2 ~ 4+1, 
         grp.color         = 1, 
         grp.icon          = 4, 
         colors            = c("blue", "green"), 
         icons             = list(image1, image2),
         icon.aspect       = 1,    
         icon.space.factor = .10, 
         icon.horizontal   = TRUE, 
         icon.draft        = FALSE,
         icon.stack.type   = c("lb", "lt", "rb","rt")[1], 
         icon.grey.levels  = list(2, 10), 
         lab.side = "t", lab.cex = .7, main = "some Titanic data")
# using internal generator "fir.tree"
\donttest{  ## because of computation time
data <- trees
iconplot(data, 
         grp.color          = 3, 
         grp.xy             = 1 ~ 2, 
         vars.to.factor     = c(5, 5, 8), 
         icons              = "fir.tree", 
         colors             = rainbow(8, start = .1, end = .5), 
         icon.frame         = FALSE, 
         lab.legend         = 2, 
         lab.cex            = 0.7, 
         main = "grouping by vars and by colors")
}
# using different internal generators
data <- trees
iconplot(data, 
         grp.color          = 1, 
         grp.xy             = 1 ~ 2, 
         grp.icon           = 2, 
         colors             = c("orange", "green", "orange", "red"), 
         icons = c("nabla", "BI", "walkman", "car.simple", "bike", "circle"), 
         vars.to.factor     = c(3,6), 
         lab.legend         = 2, 
         lab.cex            = 0.7, 
         main = "grouping by vars, by icons and by colors")
# Traveller plot proposed by M. Mazziotta and A. Pareto
Mazzi.Pareto <- 
 structure(list(Region = c("Piemonte", "Valle d'Aosta", "Lombardia",  
 "Trentino-Alto Adige", "Veneto", "Friuli-Venezia Giulia", "Liguria", 
 "Emilia-Romagna", "Toscana", "Umbria", "Marche", "Lazio", "Abruzzo", 
 "Molise", "Campania", "Puglia", "Basilicata", "Calabria", "Sicilia", 
 "Sardegna"), Mean = c(98.74, 104.07, 101.38, 106.1, 104.38, 105.55,  
 102.76, 103.62, 101.84, 103.52, 102.05, 97.88, 102.9, 91.43,         
 94.12, 96.78, 93.55, 92.59, 96.29, 100.45), Penalty = c(0.43,        
 4.23, 0.64, 0.63, 0.77, 0.34, 0.29, 0.46, 0.27, 0.22, 0.15, 0.82,    
 1.3, 1.02, 0.37, 0.21, 2.37, 0.51, 0.31, 0.76), MPI = c(98.3,        
 99.84, 100.74, 105.47, 103.61, 105.21, 102.47, 103.16, 101.57,       
 103.3, 101.9, 97.06, 101.6, 90.42, 93.75, 96.58, 91.18, 92.08,       
 95.98, 99.69)), .Names = c("Region", "Mean", "Penalty", "MPI"        
 ), row.names = c(NA, -20L), class = "data.frame")
dm <- cbind(Mazzi.Pareto, 
            col = as.factor(rep(1:4, 5)),        # as.factor!! 
            row = as.factor(rep(1:5, each = 4))) # as.factor!!
iconplot(dm, verbose = !TRUE, x.text = 60,  y.text = -10,  #t3s
         grp.xy            = row ~ col,
         grp.icon          = 0 + Mean +  Penalty + Region, 
         vars.to.factor    = FALSE,
         icons             = "mazz.man",
         panel.reverse.y   = TRUE,
         icon.space.factor = 0,
         icon.frame        = FALSE,
         lab.parallel      = TRUE,
         lab.side          = c("",""),
         main = "Traveller plot")
# definition of a check list, tally or 'Krebholz'
check.list <- function(x, colors = rainbow(length(x))){
  num.split <- function(x, div = 5){
    x.name <- as.character(substitute(x))
    xn <- lapply( x, function(x) 
       c(rep(div, x \%/\% div), if( 0 < ( h <- x \%\% div) ) h )
    )
    len <- max(sapply(xn, length))
    xn <- lapply( xn, function(x) c(x, rep(0, len - length(x) )))
    xn <- matrix( unlist(xn), ncol = len, byrow = TRUE )
    xn <- as.table(xn)
    dimnames(xn) <- list( seq( along = x ), 1:len)
    names(dimnames(xn)) <- c(x.name, "Blocks")
    xn
  }
  x.split <- num.split(x)
  rownames(x.split) <- paste(sep = ":", 1:length(x), x)
  iconplot(x.split, 
           grp.xy             = 1 ~ 2,  
           grp.col            = 1, 
           colors             = colors,
           panel.space.factor = c(0.4, 0.3), 
           panel.frame        = FALSE, 
           icon.stack.len     = 5, 
           icon.space.factor  = c(0.4, 0), 
           icon.asp           = NA, 
           icon.frame         = FALSE,
           lab.side           = "l", 
           lab.cex            = 0.7,
           main = paste("score of", substitute(x)))
  x.split
}
set.seed(13); data <- sample(1:50, size = 15)
check.list(data)
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ graphics }
% \keyword{ ~kwd2 }% __ONLY ONE__ keyword per line

\name{plotsummary}                                                                               
\alias{plotsummary}         
\title{  graphical summaries of variables of a data set }                                                                      
\description{                                                         
  \code{plotsummary} shows some important characteristics of the variables of a data set.
  For each variable a plot is computed consisting of a barplot, an ecdf, 
  a density trace and a boxplot. }                                                                      
\usage{ 
 plotsummary(data, trim = 0, types = c("stripes", "ecdf", "density", "boxplot"),
             y.sizes = 4:1, design = "chessboard", main, mycols = "RB")
 }                                                              
\arguments{                                                   
   \item{data}{   Data set for computing a graphical summary. }      
   \item{trim}{   \code{trim} defines the fraction of observation for trimming on both  
                  ends of the data.  }
   \item{types}{  vector of types of representation of the data set. 
                  The elements of the vector will induce small plots which are stacked 
                  in vertical order. The first letter of the types is sufficient for 
                  defining a type. } 
   \item{y.sizes}{defines the relative sizes of the small plots. 
                  The values are divided by their sum to get percentages. }                  
   \item{design}{ if \code{design} is \code{chessboard} the graphics device 
                  is fragmented into rows and cols. Otherwise the images of a variable 
                  build vertical stripes.  }                                                  
   \item{main}{   defines a title for the graphics.  }                                           
   \item{mycols}{ allows to define some colors for the showing the regions separated
                  by the quartils. }              
 }                                    
\details{        \code{plotsummary} can be use for a quick and dirty inspection 
                  of a data matrix or a list of variables. 
                  Without further specification some representation of each of the 
                  variables is built and stacked into a plot. 
                  The sizes of the types of representation can be set as well as the 
                  layout design of the graphics device. It is helpful to trim the data 
                  before processing because outliers will often hide 
                  the interesting characteristics. }                   
\author{                                                       
   Peter Wolf, pwolf@wiwi.uni-bielefeld.de
 }                                                               
 \seealso{                                                         
   \code{\link{pairs}},   \code{\link{summary}},    \code{\link{str}}
 }                                                                  
\examples{                                                        
 ##---- Should be DIRECTLY executable !! ----         
 ##-- ==>  Define data, use random,                      
 ##--\tor do  help(data=index)  for the standard data sets.   
 plotsummary(cars)
 plotsummary(cars, types=c("ecdf", "density", "boxplot"), 
             y.sizes = c(1,1,1), design ="stripes")
 plotsummary(c(list(rivers=rivers, co2=co2), cars), y.sizes=c(10,3,3,1), mycols=3)
 plotsummary(cars, design="chessboard")
 # find all matrices in your R
 ds.of.R <- function(type="vector"){
   dat <- ls(pos=grep("datasets",search()))
   dat.type <- unlist(lapply(dat,function(x) {       
      num <- mode(x<-eval(parse(text=x)))
      num <- ifelse(is.array(x),"array",num)
      num <- ifelse(is.list(x),"list",num)
      num <- ifelse(is.matrix(x),"matrix",num)
      num <- ifelse(is.data.frame(x),"matrix",num)
      num <- ifelse(num=="numeric","vector",num)
      num }))
   return(dat[dat.type==type])
 }
 namelist <- ds.of.R("matrix")
 # inspect the matrices one after the other
 for(i in seq(along=namelist)){
   print(i); print(namelist[i])
   xy <- get(namelist[i])
   # plotsummary(xy,y.sizes=4:1,trim=.05,main=namelist[i]) 
   # Sys.sleep(1)
 }
 }
\keyword{ hplot }
\keyword{ manip }% __ONLY ONE__ keyword per line                                                                           

\name{bagplot.pairs}
\alias{bagplot.pairs}
\title{ \code{pairs} plot with bagplots }
\description{
  \code{bagplot.pairs} calls \code{pairs} and use bagplot() as panel function. 
  It can be used for the inspection of data matrices.
}
\usage{
  bagplot.pairs(dm, trim = 0.0, main, numeric.only = TRUE, 
                factor = 3, approx.limit = 300, pch = 16, 
                cex = 0.8, precision = 1, col.loophull = "#aaccff",
                col.looppoints = "#3355ff", col.baghull = "#7799ff",
                col.bagpoints = "#000088", ...)
}
\arguments{
  \item{dm}{ datamatrix, columns contain values of the variables }
  \item{trim}{ fraction or vector of fractions of data points 
               that should be removed from the variables before computing }
  \item{main}{ title of the plot } 
  \item{numeric.only}{ if TRUE only numerical variables will be used. Otherwise an 
                       transformation to numeric will be performed.} 
  \item{factor}{ see help of bagplot }
  \item{approx.limit}{ see help of bagplot }
  \item{pch}{ see help of bagplot }
  \item{cex}{ see help of bagplot }
  \item{precision}{ see help of bagplot }
  \item{col.loophull}{ see help of bagplot }
  \item{col.looppoints}{ see help of bagplot }
  \item{col.baghull}{ see help of bagplot }
  \item{col.bagpoints}{ see help of bagplot }
  \item{\dots}{ further arguments to be passed to \code{pairs} }
}
\details{
  \code{bagplot.pairs} is a cover function which calls \code{pairs} and uses 
  \code{bagplot} to display the data.
}
\value{
  The data which has been used for the plot.
}
\author{Peter Wolf }
\note{
  Feel free to have a look inside of bagplot.pairs and 
  to improve it according to your ideas.
}
 \seealso{   \code{\link{bagplot}}, \code{\link{pairs}} }
\examples{
 # bagplot.pairs(freeny)
  # bagplot.pairs(trees,col.baghull="green", col.loophull="lightgreen")
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ misc }
\keyword{ hplot }

\name{slider.bootstrap.lm.plot}
\title{interactive bootstapping for lm}
\alias{slider.bootstrap.lm.plot}

\description{
  \code{slider.bootstrap.lm.plot} computes a scatterplot and 
  adds regression curves of samples of the data points. 
  The number of samples and the degree of the model are 
  controlled by sliders. 
}
\usage{
  slider.bootstrap.lm.plot(x, y, ...)
}
\arguments{
  \item{x}{ two column matrix or vector of x values if y is used }
  \item{y}{ y values if x is not a matrix }
  \item{\dots}{ additional graphics parameters }
}
\details{
  \code{slider.bootstrap.lm.plot} draws a scatterplot of the data points
  and fits a linear model to the data set. Regression curves  
  of samples of the data are then added to the plot. Within a Tcl/Tk 
  control widget the degree of the model, the repetitions and the start
  of the random seed are set. After modification of a parameter
  the plot is updated.
}
\value{
  a message about the usage
}
\references{ ~~ }
\author{ Hans Peter Wolf }
 \seealso{ \code{\link{plot}} }
\examples{
\dontrun{
## This example cannot be run by examples() but should be work in an interactive R session
  daten<-iris[,2:3]
  slider.bootstrap.lm.plot(daten)
}
}
\keyword{ iplot }

\name{bagplot}
\alias{bagplot}
\alias{compute.bagplot}
\alias{plot.bagplot}
\title{ bagplot, a bivariate boxplot }
\description{
  \code{compute.bagplot()} computes an object describing a bagplot 
   of a bivariate data set. \code{plot.bagplot()} plots a bagplot object. 
  \code{bagplot()} computes and plots a bagplot.
}
\usage{
bagplot(x, y, factor = 3, na.rm = FALSE, approx.limit = 300,  
       show.outlier = TRUE, show.whiskers = TRUE, 
       show.looppoints = TRUE, show.bagpoints = TRUE,
       show.loophull = TRUE, show.baghull = TRUE, 
       create.plot = TRUE, add = FALSE, pch = 16, cex = 0.4, 
       dkmethod = 2, precision = 1, verbose = FALSE, 
       debug.plots = "no",   col.loophull="#aaccff", 
       col.looppoints="#3355ff", col.baghull="#7799ff", 
       col.bagpoints="#000088", transparency=FALSE, 
       show.center = TRUE, ...
)
compute.bagplot(x, y, factor = 3, na.rm = FALSE, approx.limit = 300, 
       dkmethod=2,precision=1,verbose=FALSE,debug.plots="no")
\method{plot}{bagplot}(x,  
       show.outlier = TRUE, show.whiskers = TRUE, 
       show.looppoints = TRUE, show.bagpoints = TRUE,
       show.loophull = TRUE, show.baghull = TRUE, 
       add = FALSE, pch = 16, cex = 0.4, verbose = FALSE, 
       col.loophull="#aaccff", col.looppoints="#3355ff", 
       col.baghull="#7799ff", col.bagpoints="#000088", 
       transparency=FALSE, 
       show.center = TRUE, ...)
}
\arguments{
  \item{x}{ x values of a data set; 
     in \code{bagplot}: an object of class \code{bagplot}
     computed by \code{compute.bagplot} }
  \item{y}{ y values of the data set } 
  \item{factor}{ factor defining the loop }
  \item{na.rm}{ if TRUE 'NA' values are removed otherwise exchanged by median}
  \item{approx.limit}{ if the number of data points exceeds 
          \code{approx.limit} a sample is used to compute 
          some of the quantities; default: 300 }
  \item{show.outlier}{ if TRUE outlier are shown }
  \item{show.whiskers}{ if TRUE whiskers are shown }
  \item{show.looppoints}{ if TRUE loop points are plottet }
  \item{show.bagpoints}{ if TRUE bag points are plottet }
  \item{show.loophull}{ if TRUE the loop is plotted }
  \item{show.baghull}{ if TRUE the bag is plotted }
  \item{create.plot}{ if FALSE no plot is created }
  \item{add}{ if TRUE the bagplot is added to an existing plot }
  \item{pch}{ sets the plotting character }
  \item{cex}{ sets characters size}
  \item{dkmethod}{ 1 or 2, there are two method of  
     approximating the bag, method 1 is very rough (only based on observations }
  \item{precision}{ precision of approximation, default: 1 }
  \item{verbose}{ automatic commenting of calculations }
  \item{debug.plots}{ if TRUE additional plots describing 
                      intermediate results are constructed }
  \item{col.loophull}{ color of loop hull }
  \item{col.looppoints}{ color of the points of the loop }
  \item{col.baghull}{ color of bag hull }
  \item{col.bagpoints}{ color of the points of the bag }
  \item{transparency}{ see section details }
  \item{show.center}{ if TRUE the center is shown }
  \item{...}{ additional graphical parameters }
}
\details{
A bagplot is a bivariate generalization of the well known
boxplot. It has been proposed by Rousseeuw, Ruts, and Tukey.
In the bivariate case the box of the boxplot changes to a 
convex polygon, the bag of bagplot. In the bag are 50 percent
of all points. The fence separates points within the fence from 
points outside. It is computed by increasing the
the bag. The loop is defined as the convex hull containing 
all points inside the fence. 
If all points are on a straight line you get a classical
boxplot.
\code{bagplot()} plots bagplots that are very similar 
to the one described in Rousseeuw et al. 
Remarks:
The two dimensional median is approximated.
For large data sets the error will be very small.
On the other hand it is not very wise to make a (graphical) 
summary of e.g. 10 bivariate data points.
In case you want to plot multiple (overlapping) bagplots, 
you may want plots that are semi-transparent. For this 
you can use the \code{transparency} flag. 
If \code{transparency==TRUE} the alpha layer is set to '99' (hex).
This causes the bagplots to appear semi-transparent, 
but ONLY if the output device is PDF and opened using:
\code{pdf(file="filename.pdf", version="1.4")}. 
For this reason, the default is \code{transparency==FALSE}. 
This feature as well as the arguments
to specify different colors has been proposed by Wouter Meuleman.
}
\value{
  \code{compute.bagplot} returns an object of class
  \code{bagplot} that could be plotted by 
  \code{plot.bagplot()}.
  An object of the bagplot class is a list with the following 
  elements: \code{center} is a two dimensional vector with 
  the coordinates of the center. \code{hull.center} is a 
  two column matrix, the rows are the coordinates of the
  corners of the center region. \code{hull.bag} and 
  \code{hull.loop} contain the coordinates of the hull of the bag
  and the hull of the loop. \code{pxy.bag} shows you the 
  coordinates of the points of the bag. \code{pxy.outer} is 
  the two column matrix of the points that are within the 
  fence. \code{pxy.outlier} represent the outliers. The vector
  \code{hdepths} shows the depths of data points. \code{is.one.dim}
  is \code{TRUE} if the data set is (nearly) one dimensional. 
  The dimensionality is decided by analysing the result of \code{prcomp}
  which is stored in the element \code{prdata}. \code{xy} shows you 
  the data that are used for the bagplot. In the case of very large
  data sets subsets of the data are used for constructing the 
  bagplot. A data set is very large if there are more data points
  than \code{approx.limit}. \code{xydata} are the input data structured 
  in a two column matrix.
} 
\references{ P. J. Rousseeuw, I. Ruts, J. W. Tukey (1999):
    The bagplot: a bivariate boxplot, The American
    Statistician, vol. 53, no. 4, 382--387 }
\author{ Peter Wolf }
\note{
  Version of bagplot: 10/2012 }
 \seealso{ \code{\link[graphics]{boxplot}} }
\examples{
  # example: 100 random points and one outlier
  dat<-cbind(rnorm(100)+100,rnorm(100)+300)
  dat<-rbind(dat,c(105,295))
  bagplot(dat,factor=2.5,create.plot=TRUE,approx.limit=300,
     show.outlier=TRUE,show.looppoints=TRUE,
     show.bagpoints=TRUE,dkmethod=2,
     show.whiskers=TRUE,show.loophull=TRUE,
     show.baghull=TRUE,verbose=FALSE)
  # example of Rousseeuw et al., see R-package rpart
  cardata <- structure(as.integer( c(2560,2345,1845,2260,2440,
   2285, 2275, 2350, 2295, 1900, 2390, 2075, 2330, 3320, 2885,
   3310, 2695, 2170, 2710, 2775, 2840, 2485, 2670, 2640, 2655,
   3065, 2750, 2920, 2780, 2745, 3110, 2920, 2645, 2575, 2935,
   2920, 2985, 3265, 2880, 2975, 3450, 3145, 3190, 3610, 2885,
   3480, 3200, 2765, 3220, 3480, 3325, 3855, 3850, 3195, 3735,
   3665, 3735, 3415, 3185, 3690, 97, 114, 81, 91, 113, 97, 97,
   98, 109, 73, 97, 89, 109, 305, 153, 302, 133, 97, 125, 146,
   107, 109, 121, 151, 133, 181, 141, 132, 133, 122, 181, 146,
   151, 116, 135, 122, 141, 163, 151, 153, 202, 180, 182, 232,
   143, 180, 180, 151, 189, 180, 231, 305, 302, 151, 202, 182,
   181, 143, 146, 146)), .Dim = as.integer(c(60, 2)), 
   .Dimnames = list(NULL, c("Weight", "Disp.")))
  bagplot(cardata,factor=3,show.baghull=TRUE,
    show.loophull=TRUE,precision=1,dkmethod=2)
  title("car data Chambers/Hastie 1992")
  # points of y=x*x
  bagplot(x=1:30,y=(1:30)^2,verbose=FALSE,dkmethod=2)
  # one dimensional subspace
  bagplot(x=1:100,y=1:100)
}
\keyword{ misc }
\keyword{ hplot }
